<?php

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use App\Models\SubCategory;
use App\Models\Card;
use App\Models\Vcard;
use App\Models\Cryptocard;
use App\Models\Vouchers;
use App\Models\User;
use App\Rules\FileTypeValidate;
use App\Models\GeneralSetting;
use App\Models\EmailTemplate;
use App\Models\Frontend;
use Illuminate\Support\Facades\Artisan;
use Image;
class DebitcardController extends Controller
{

    public function cardsall(){
        $pageTitle = 'All Cards';
        $cards = Vcard::latest()->paginate(getPaginate());
        $emptyMessage  = 'Data Not Found';
        return view('admin.debitcard', compact('pageTitle', 'cards', 'emptyMessage'));
    }
    
     public function cryptocardsall(){
        $pageTitle = 'All Cards';
        $cards = Cryptocard::latest()->paginate(getPaginate());
        $emptyMessage  = 'Data Not Found';
        return view('admin.debitcard', compact('pageTitle', 'cards', 'emptyMessage'));
    }
    
    public function cardsupdate(Request $request, $id){
        $request->validate([
            'cardid'   => 'required|integer',
            'ship_status'          => 'required'
        ]);

        $cardid = $id;
        $ship_status = $request->ship_status;
       
        $card = Vcard::where('id', $cardid)->first();
        $card->ship_status = $ship_status;
        $card->save();
        $user = User::find($card->user_id);
        $subject = "Physical Card Status Update";
        $message = "Your Physical Card Status is now ".$ship_status;
        sendGeneralEmail($user->email, $subject, $message, $user->firstname);
       
        $notify[] = ['success', 'Card Status updated.'];
        return back()->withNotify($notify);        
    }

   
 public function vouchers() {
        
       $pageTitle = "E-Vouchers";
        $general = GeneralSetting::first();
      $user = auth()->user(); 
      $vouchers = Vouchers::where('isadmin',true)->latest()->paginate();
        
        
         return view('admin.vouchers.index', compact('pageTitle','vouchers', 'general'));
    }
    
    
    public function newvouchers(Request $request) {
      $general = GeneralSetting::first();
      $request->validate([
            'amount' => "required|integer|gt:0",
          'qty' => "required|integer|gt:0",
           
        ]);
     for ($i = 0; $i < $request->qty; $i++){
    $vouchercode = rand(100000000, 999999999999999999);
      $amount = $request['amount'];
     
      
      
             
        $update = new Vouchers();
        $update->vouchercode = $vouchercode;
        $update->amount = $amount;
        $update->currency = $general->cur_text;
        $update->status = "open";
        $update->isadmin = true;
        $update->save();
}
     
        $notify[]=['success','E-voucher Issued'];
        return back()->withNotify($notify)->withInput(); 
        
      
      
    }

}
