<?php

namespace App\Http\Controllers;

use Carbon\Carbon;
use App\Models\SubCategory;
use App\Models\Cart;
use App\Models\Countries;
use App\Models\Category;
use Illuminate\Support\Facades\Auth;
use App\Http\Helpers\Helper;
use App\Models\Card;
use App\Lib\GoogleAuthenticator;
use App\Models\AdminNotification;
use App\Models\GeneralSetting;

use App\Models\Transaction;
use App\Models\WithdrawMethod;
use App\Models\Withdrawal;
use App\Rules\FileTypeValidate;
use Illuminate\Http\Request;

use Illuminate\Support\Facades\Hash;
use Illuminate\Validation\Rules\Password;
use Illuminate\Validation\Rule;

use App\Models\GatewayCurrency;
use App\Models\SupportTicket;

use Response;

class CheckOutController extends Controller
{
    public function __construct(){
        $this->activeTemplate = activeTemplate();
    }

     public function getToken(){
        sleep(3);
         $general = GeneralSetting::first();
        $url = "https://api.ezpaypin.com/vendors/v2/auth/token/";
        $curl = curl_init($url);
        curl_setopt($curl, CURLOPT_URL, $url);
        curl_setopt($curl, CURLOPT_POST, true);
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);

        $headers = array(
           "Content-Type: application/json",
        );
        curl_setopt($curl, CURLOPT_HTTPHEADER, $headers);

        $arr = array('client_id' => $general->ezpin_id,
                    'secret_key' => $general->ezpin_secret);


        $data = json_encode($arr);


        curl_setopt($curl, CURLOPT_POSTFIELDS, $data);

        $resp = curl_exec($curl);
        $res = json_decode($resp);
        curl_close($curl);
        return $res->access;

}


public function createOrder($sku,$count,$price,$preorder){

    $token = $this->getToken();

    $url = "https://api.ezpaypin.com/vendors/v2/orders/";
    $curl = curl_init($url);
    curl_setopt($curl, CURLOPT_URL, $url);
    curl_setopt($curl, CURLOPT_POST, true);
    curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);


    $authorisation = "Bearer ".$token;
    $headers = array(
        "Content-Type: application/json",
        "Authorization: $authorisation"
    );

     curl_setopt($curl, CURLOPT_HTTPHEADER, $headers);


    $code = $this->generateUUID();
    $arr = array('sku' => $sku,
        'quantity' => $count,
        'price' => $price,
        'pre_order' => $preorder,
        'reference_code' => $code
        );


    $data = json_encode($arr);

    curl_setopt($curl, CURLOPT_POSTFIELDS, $data);
    $resp = curl_exec($curl);
    // if(curl_error($curl)){
    //     echo 'item Error:' . curl_error($ch);
    // }else{
    //     echo $resp;
    // }

    curl_close($curl);
    return $resp;



}



public function checkAvailability($sku,$count,$price){

    $ch = curl_init();
    $token = $this->getToken();

$url = "https://api.ezpaypin.com/vendors/v2/catalogs/".$sku."/availability/";
$dataArray = ['item_count' => $count,'price' => $price];

$data = http_build_query($dataArray);


$getUrl = $url."?".$data;
$authorisation = "Bearer ".$token;
$headers = array(
    "Content-Type: application/json",
    "Authorization: $authorisation"
 );
 curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);

curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);
curl_setopt($ch, CURLOPT_URL, $getUrl);
curl_setopt($ch, CURLOPT_TIMEOUT, 80);

$response = curl_exec($ch);
curl_close($ch);
return $response;

}
    public function generateUUID() {
     // Generate 16 bytes (128 bits) of random data or use the data passed into the function.
     $data = random_bytes(16);
     assert(strlen($data) == 16);

     // Set version to 0100
     $data[6] = chr(ord($data[6]) & 0x0f | 0x40);
     // Set bits 6-7 to 10
     $data[8] = chr(ord($data[8]) & 0x3f | 0x80);

     // Output the 36 character UUID.
     return vsprintf('%s%s-%s-%s-%s-%s%s%s', str_split(bin2hex($data), 4));
}

public function purchasecards(){

    $user = Auth::user();
    $cartItems = Cart::where('user_id',$user->id)->get();


    foreach ($cartItems as $item){
        $result = $this->processCartItem($item);
       

        if($result == "success"){
        $delete = $this->deleteCartItem($item->id);
        $notify[] = ['success','Your cards were purchased successfully'];
        return redirect()->route('user.card')->withNotify($notify);
        exit;

        } else {

            $notify[] = ['error', json_encode($result)];
            return redirect()->route('user.checkout')->withNotify($notify);
            exit;
        }
    }


    return redirect()->route('user.card')->withNotify($notify);

}

public function deleteCartItem($cartid){

        $cartItem = Cart::where(['user_id' => Auth::user()->id ,'id' => $cartid])->delete();

    }


public function processCartItem(Cart $item){

//    $item->validate([
//        'subcategory_id'=> 'required|exists:sub_categories,id',
//        'qty'=> 'required|gt:0|integer'
//    ]);

    $user = Auth::user();
    $quantity = $item->qty;
    $api = $item->api;
     $general = GeneralSetting::first();

if(!$api){
    $findSubCat = SubCategory::where('id', $item->subcategory_id)->whereHas('category', function($q){
                                    $q->where('status', 1);
                                })
                                ->whereHas('card', function($q){
                                    $q->where('user_id', 0);
                                })
                                ->first();

    if(!$findSubCat){
        $notify[] = ['error', 'Sorry, We Do Not Have The itemed Card.'];
        return $notify;

    }

    if($findSubCat->card()->count() < $quantity){
        $notify[] = ['error', 'Sorry, Please Check Stock Available, We Do Not Have Enough Cards Available to Process Your Order.'];
        return $notify;
    }
} else {
 //call API to check Availability if not available return back()->withNotify

 $subCat = SubCategory::where('id', $item->subcategory_id)->first();

 if(!$subCat){

        $notify[] = 'Sorry, We Do Not Have The itemed Card.';

        return $notify;
          }

 $response = $this->checkAvailability($subCat->sku,$quantity,$item->price);
 $res = json_decode($response);

 if(!$res->availability){
    $notify = 'Sorry, The card is not available';
    return $notify;
 }

  $findSubCat = SubCategory::where('id', $item->subcategory_id)->whereHas('category', function($q){
                                    $q->where('status', 1);
                                })
                                ->first();
}

    $price = ($item->usdprice ? $item->usdprice : $findSubCat->price) * $quantity;


    if($price > $user->balance){
        $notify[] = 'Sorry, Insufficient Balance to process this order. Required Balance USD'.$price;
        return $notify;
    }



    $trx = getTrx();

    $user->balance -= $price;
    $user->save();

if(!$api){
    $card = Card::where('sub_category_id', $item->subcategory_id)
                ->where('user_id', 0)
                ->orderBy('id', 'ASC')
                ->take($quantity)
                ->update([
                    'user_id' => $user->id,
                    'trx' => $trx,
                    'status' => 1,
                    'purchase_at' => Carbon::now()
                ]);

    notify($user, 'CARD_BUY', [
        'trx' => $trx,
        'price' => showAmount($price, 2),
        'currency' => $general->cur_text,
        'purchase_at' => $findSubCat->purchase_at,
        'category' => $findSubCat->category->name,
        'sub_category' => $findSubCat->name,
        'quantity' => $quantity,
        'post_balance' => showAmount($transaction->post_balance, 2),
    ]);
    $notify = "success";
    return $notify;
}

else {
//call API for Order and pass in details response of success, incase of failuer $user->balance += $price; $user->save();

   $subCat = SubCategory::where('id', $item->subcategory_id)->first();

   $response = $this->createOrder($subCat->sku,$quantity,$item->price,$subCat->pre_order);
   $decodedResponse = json_decode($response);

   if(isset($decodedResponse->status) && $decodedResponse->status == "0"){
    $newCard = new Card();
   $newCard->sub_category_id = $findSubCat->id;
   $newCard->details = "Your order is queued admin shall update details in 24-48hours" ; // pass response of success
   $newCard->image = $findSubCat->image;
   $newCard->user_id = $user->id;
   $newCard->trx = $trx;
   $newCard->status = $decodedResponse->status;
   $newCard->purchase_at = Carbon::now();
   $newCard->save();


    $transaction = new Transaction();
    $transaction->user_id = $user->id;
    $transaction->amount = $price;
    $transaction->post_balance = $user->balance;
    $transaction->charge = 00;
    $transaction->trx_type = '-';
    $transaction->details = 'Card Purchase '.$quantity.'nos '.$findSubCat->name.' successful';
    $transaction->trx =  $trx;
    $transaction->save();

    $adminNotification = new AdminNotification();
    $adminNotification->user_id = $user->id;
    $adminNotification->title = $user->username.' purchased '.$findSubCat->name.' transaction id '.$trx.' and is pending check orderid '.$decodedResponse->order_id;
    $adminNotification->click_url = urlPath('admin.users.card',$user->id);
    $adminNotification->save();

    $general = GeneralSetting::first();

    notify($user, 'CARD_BUY', [
        'trx' => $trx,
        'price' => showAmount($price, 2),
        'currency' => $general->cur_text,
        'purchase_at' => $findSubCat->purchase_at,
        'category' => $findSubCat->category->name,
        'sub_category' => $findSubCat->name,
        'quantity' => $quantity,
        'post_balance' => showAmount($transaction->post_balance, 2),
    ]);

    $notify = "success";
    return $notify;
   }
   $share_link = (isset($decodedResponse->share_link) ? $decodedResponse->share_link : null);
   if($share_link != null && $decodedResponse->status == "1"){

   $newCard = new Card();
   $newCard->sub_category_id = $findSubCat->id;
   $newCard->details = "You can find redemption for the ".$quantity." card purchased at this link: ".$decodedResponse->share_link ; // pass response of success
   $newCard->image = $findSubCat->image;
   $newCard->user_id = $user->id;
   $newCard->trx = $trx;
   $newCard->status = $decodedResponse->status;
   $newCard->purchase_at = Carbon::now();
   $newCard->save();


    $transaction = new Transaction();
    $transaction->user_id = $user->id;
    $transaction->amount = $price;
    $transaction->post_balance = $user->balance;
    $transaction->charge = 00;
    $transaction->trx_type = '-';
    $transaction->details = 'Card Purchase '.$quantity.'nos '.$findSubCat->name.' successful';
    $transaction->trx =  $trx;
    $transaction->save();

    $adminNotification = new AdminNotification();
    $adminNotification->user_id = $user->id;
    $adminNotification->title = $user->username.' has purchased '.$findSubCat->name;
    $adminNotification->click_url = urlPath('admin.users.card',$user->id);
    $adminNotification->save();

    $general = GeneralSetting::first();

    notify($user, 'CARD_BUY', [
        'trx' => $trx,
        'price' => showAmount($price, 2),
        'currency' => $general->cur_text,
        'purchase_at' => $findSubCat->purchase_at,
        'category' => $findSubCat->category->name,
        'sub_category' => $findSubCat->name,
        'quantity' => $quantity,
        'post_balance' => showAmount($transaction->post_balance, 2),
    ]);

    $notify = "success";
    return $notify;
   }else{
        $user->balance += $price;
        $user->save();
        $notify = 'Error Processing Card Purchase';
        return $notify;

   }

    }
}


public function airtime(){
    $pageTitle = 'Airtime';
        $countries = Countries::all();
        $emptyMessage = 'No data found';

        return view($this->activeTemplate . 'user.airtime.reloadly', compact('pageTitle', 'countries', 'emptyMessage'));
    
}
public function process_recharge_request(Request $request) {
    $request_data = $request->input();
    if (
            empty($request_data) ||
            empty($request_data['operator_id']) ||
            empty($request_data['recharge_amount']) ||
            empty($request_data['phone_number']) ||
            empty($request_data['country']) 
        ) {
			$result_set = array(
				"status" => 'error',
				"code" => 400,
				"message" => 'Bad Request',
				"data" => array()
			); 
			echo json_encode($result_set);
			return;
		}
    
    $user = Auth::user();
    
 if($request_data['recharge_amount'] > $user->balance){
        $notify[] = 'Sorry, Insufficient Balance to process this order. Required Balance USD'.$price;
        return $notify;
    }

$trx = getTrx();

    $user->balance -= $request_data['recharge_amount'];
    $user->save();

$transaction = new Transaction();
    $transaction->user_id = $user->id;
    $transaction->amount = $request_data['recharge_amount'];
    $transaction->post_balance = $user->balance;
    $transaction->charge = 00;
    $transaction->trx_type = '-';
    $transaction->details = 'Airtime Recharge for '.$request_data['phone_number'].' amount '.$request_data['recharge_amount'].' successful';
    $transaction->trx =  $trx;
    $transaction->save();
    
     $request_parameters = array(
            "operatorId" => $request_data['operator_id'],
            "amount" => $request_data['recharge_amount'],
            "useLocalAmount" => false,
            "customIdentifier"=> $trx,
            "recipientPhone" => array(
                "countryCode" => $request_data['country'],
		        "number" => $request_data['phone_number']
            )
       
        );
     $oauth_token_response = $this->generate_oauth_token();
            $oauth_token_response = json_decode($oauth_token_response, true);
		$make_a_topup_api_response = $this->make_a_topup($oauth_token_response['access_token'], $request_parameters);
		$make_a_topup_response = json_decode($make_a_topup_api_response, true);
               
                
		if (
            empty($make_a_topup_api_response) ||
            empty($make_a_topup_response) ||
          array_key_exists("errorCode", $make_a_topup_response)     
        ) {
			$result_set = array(
				"status" => 'error',
				"code" => 400,
				"message" => $make_a_topup_response["message"] ? $make_a_topup_response["message"] : 'Something went wrong while processing Request.',
				"data" => array(
                    "error_code" => $make_a_topup_response["errorCode"],
					"error_message" => $make_a_topup_response["message"],
					"error" => $make_a_topup_response["errorCode"]
                )
			);
                        $rtrx = getTrx();
                        $user->balance += $request_data['recharge_amount'];
                        $user->save();
                        
                        $transaction = new Transaction();
    $transaction->user_id = $user->id;
    $transaction->amount = $request_data['recharge_amount'];
    $transaction->post_balance = $user->balance;
    $transaction->charge = 00;
    $transaction->trx_type = '+';
    $transaction->details = 'Airtime Reversal for failure '.$request_data['phone_number'].' amount '.$request_data['recharge_amount'].' successful';
    $transaction->trx =  $rtrx;
    $transaction->save();
                        
			echo json_encode($result_set);
			return; 
		}
                if(isset($make_a_topup_response['pinDetail'])){
                $pin = $make_a_topup_response['pinDetail'];
                } else {
                    $pin = "None";
                }

$result_set = array(           
			"status" => 'success',
			"code" => 200,
			"message" => 'Recharge Done successfully',
                        "pindetail" => $pin,
			"data" => array(
				"response" => $make_a_topup_response,
                "phone_number" => $request_data['phone_number'],
                "country" => $request_data['country']
			)                
		);
		echo json_encode($result_set);
		return;
}

public function get_operator_by_iso(Request $request) {
		$request_data = $request->input();
      	if (
            empty($request_data) ||
            empty($request_data['country'])
        ) {
			$result_set = array(
				"status" => 'error',
				"code" => 400,
				"message" => 'Bad Request',
				"data" => array()
			); 
			echo json_encode($result_set);
			return;
		}

		
            $oauth_token_response = $this->generate_oauth_token();
            $oauth_token_response = json_decode($oauth_token_response, true);
      
        	$fetch_operator_by_iso_code_api_response = $this->fetch_operators_by_country_iso_code($oauth_token_response['access_token'], $request_data['country']);
		$fetch_operator_by_iso_code_response = json_decode($fetch_operator_by_iso_code_api_response, true);
               
		if (
            empty($fetch_operator_by_iso_code_api_response) ||
            empty($fetch_operator_by_iso_code_response) ||
           
			array_key_exists("errorCode", $fetch_operator_by_iso_code_response) ||
            array_key_exists("message", $fetch_operator_by_iso_code_response)
        ) {
			$result_set = array(
				"status" => 'error',
				"code" => 400,
				"message" => $fetch_operator_by_iso_code_response["message"] ? $fetch_operator_by_iso_code_response["message"] : 'Something went wrong while processing Request.',
				"data" => array(
                    "error_code" => $fetch_operator_by_iso_code_response["errorCode"],
					"error_message" => $fetch_operator_by_iso_code_response["message"],
					"error" => $fetch_operator_by_iso_code_response["errorCode"]
                )
			); 
			echo json_encode($result_set);
			return; 
		}

		$result_set = array(           
			"status" => 'success',
			"code" => 200,
			"message" => 'Operator Details Fetched successfully',
			"data" => array(
				"response" => $fetch_operator_by_iso_code_response,
                "country" => $request_data['country']
			)                
		);
		echo json_encode($result_set);
		return;
	}
        
 public function get_operator_by_operator_id(Request $request) {
		$request_data = $request->input();
      	if (
            empty($request_data) ||
            empty($request_data['operator'])
        ) {
			$result_set = array(
				"status" => 'error',
				"code" => 400,
				"message" => 'Bad Request',
				"data" => array()
			); 
			echo json_encode($result_set);
			return;
		}

		
          $oauth_token_response = $this->generate_oauth_token();
          
            $oauth_token_response = json_decode($oauth_token_response, true);
        
		$fetch_operator_by_operator_id_api_response = $this->fetch_operator_by_operator_id($oauth_token_response['access_token'], $request_data['operator']);
		$fetch_operator_by_operator_id_response = json_decode($fetch_operator_by_operator_id_api_response, true);
		
		if (
            empty($fetch_operator_by_operator_id_api_response) ||
            empty($fetch_operator_by_operator_id_response) ||
           
			array_key_exists("error", $fetch_operator_by_operator_id_response) ||
            array_key_exists("message", $fetch_operator_by_operator_id_response)
        ) {
			$result_set = array(
				"status" => 'error',
				"code" => 400,
				"message" => $fetch_operator_by_operator_id_response["message"] ? $fetch_operator_by_operator_id_response["message"] : 'Something went wrong while processing Request.',
				"data" => array(
                    "error_code" => $fetch_operator_by_operator_id_response["status"],
					"error_message" => $fetch_operator_by_operator_id_response["message"],
					"error" => $fetch_operator_by_operator_id_response["error"]
                )
			); 
			echo json_encode($result_set);
			return; 
		}

		$result_set = array(           
			"status" => 'success',
			"code" => 200,
			"message" => 'Recharge Denominations Fetched successfully',
			"data" => array(
				"response" => $fetch_operator_by_operator_id_response,
                "country" => $request_data['operator']
			)                
		);
		echo json_encode($result_set);
		return;
	}       

public function generate_oauth_token(){
    $curl = curl_init();
    $general      = GeneralSetting::first();
    $client_id = $general->reloadly_id;
    $client_secret = $general->reloadly_secret;
    $mode = $general->reloadly;
    if($mode == "live"){
        $audience = "https://topups.reloadly.com";
    } else {
        $audience = "https://topups-sandbox.reloadly.com";
    }
        
curl_setopt_array($curl, array(
  CURLOPT_URL => 'https://auth.reloadly.com/oauth/token',
  CURLOPT_RETURNTRANSFER => true,
  CURLOPT_ENCODING => '',
  CURLOPT_MAXREDIRS => 10,
  CURLOPT_TIMEOUT => 0,
  CURLOPT_FOLLOWLOCATION => true,
  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
  CURLOPT_CUSTOMREQUEST => 'POST',
  CURLOPT_POSTFIELDS =>'{
	"client_id":"'.$client_id.'",
	"client_secret":"'.$client_secret.'",
	"grant_type":"client_credentials",
	"audience":"'.$audience.'"}',
  CURLOPT_HTTPHEADER => array(
    'Content-Type: application/json'
  ),
));

$response = curl_exec($curl);

curl_close($curl);
return $response;
}

public function fetch_operators_by_country_iso_code($token, $country){
    $curl = curl_init();
$general      = GeneralSetting::first();
    $client_id = $general->reloadly_id;
    $client_secret = $general->reloadly_secret;
    $mode = $general->reloadly;
    if($mode == "live"){
        $audience = "https://topups.reloadly.com";
    } else {
        $audience = "https://topups-sandbox.reloadly.com";
    }
curl_setopt_array($curl, array(
  CURLOPT_URL => $audience.'/operators/countries/'.$country,
  CURLOPT_RETURNTRANSFER => true,
  CURLOPT_ENCODING => '',
  CURLOPT_MAXREDIRS => 10,
  CURLOPT_TIMEOUT => 0,
  CURLOPT_FOLLOWLOCATION => true,
  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
  CURLOPT_CUSTOMREQUEST => 'GET',
  CURLOPT_HTTPHEADER => array(
    'Authorization: Bearer '.$token,
    'Accept: application/com.reloadly.topups-v1+json'
  ),
));

$response = curl_exec($curl);

curl_close($curl);
return $response;
}

public function fetch_operator_by_operator_id($token, $operator){
    $curl = curl_init();
$general      = GeneralSetting::first();
    $client_id = $general->reloadly_id;
    $client_secret = $general->reloadly_secret;
    $mode = $general->reloadly;
    if($mode == "live"){
        $audience = "https://topups.reloadly.com";
    } else {
        $audience = "https://topups-sandbox.reloadly.com";
    }
curl_setopt_array($curl, array(
  CURLOPT_URL => $audience.'/operators/'.$operator."?suggestedAmounts=true&suggestedAmountsMap=true",
  CURLOPT_RETURNTRANSFER => true,
  CURLOPT_ENCODING => '',
  CURLOPT_MAXREDIRS => 10,
  CURLOPT_TIMEOUT => 0,
  CURLOPT_FOLLOWLOCATION => true,
  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
  CURLOPT_CUSTOMREQUEST => 'GET',
  CURLOPT_HTTPHEADER => array(
    'Authorization: Bearer '.$token,
    'Accept: application/com.reloadly.topups-v1+json'
  ),
));

$response = curl_exec($curl);

curl_close($curl);
return $response;
}

public function make_a_topup($token, $request_parameters){
    $curl = curl_init();
    $general      = GeneralSetting::first();
    $client_id = $general->reloadly_id;
    $client_secret = $general->reloadly_secret;
    $mode = $general->reloadly;
    if($mode == "live"){
        $audience = "https://topups.reloadly.com";
    } else {
        $audience = "https://topups-sandbox.reloadly.com";
    }
$data = json_encode($request_parameters);
curl_setopt_array($curl, array(
  CURLOPT_URL => $audience.'/topups',
  CURLOPT_RETURNTRANSFER => true,
  CURLOPT_ENCODING => '',
  CURLOPT_MAXREDIRS => 10,
  CURLOPT_TIMEOUT => 0,
  CURLOPT_FOLLOWLOCATION => true,
  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
  CURLOPT_CUSTOMREQUEST => 'POST',
  CURLOPT_POSTFIELDS =>$data,
  CURLOPT_HTTPHEADER => array(
    'Authorization: Bearer '.$token,
    'Accept: application/com.reloadly.topups-v1+json',
    'Content-Type: application/json'
  ),
));

$response = curl_exec($curl);

curl_close($curl);
return $response;
}

}
