<?php

namespace App\Http\Controllers;

use App\Models\Crypto;
use App\Models\Fiat;
use App\Models\Banklist;
use App\Lib\Kudalib;
use App\Models\User;
use App\Models\Transaction;
use App\Models\GatewayCurrency;
use App\Models\GeneralSetting;
use App\Models\WithdrawMethod;
use Carbon\Carbon;
use App\Models\InstallmentLog;
use App\Models\GameLog;
use App\Models\UserDps;
use App\Models\UserFdr;
use App\Models\UserLoan;
use App\Models\AdminNotification;
use App\Models\Holiday;
use App\Models\Invest;
use Illuminate\Http\Request;
use App\Models\Accountingrates;
use App\Models\Virtualnumber;
use App\Models\Vnplans;
use App\Models\Incomingsms;
use App\Models\Incomingcalls;
use App\Lib\Vonage;

class CronController extends Controller
{
    
    public function gamescron(){
        $games = GameLog::where('status',0)->cursor();
        $general = GeneralSetting::first();
        $general->last_cron = now();
        $general->save();
        foreach ($games as $game) {
            $user = $game->user;
            $user->balance += $game->invest;
            $user->save();


            Transaction::create([
                'user_id' => $user->id,
                'amount' => $game->invest,
                'charge' => 0,
                'trx_type' => '+',
                'details' => 'In-complete game invest return',
                'remark' => 'invest_return',
                'trx' => getTrx(),
                'post_balance' => $user->balance,

            ]);

            $game->status = 2;
            $game->save();
            echo "done";
        }
    }
    
    public function monthlyfee(){
         $general = GeneralSetting::first();
           $general->last_cron = Carbon::now();
        $general->save();
        $users = User::where('livit_card','!=',null)->get();
        foreach($users as $user){
          if($user->livit_card != "requested" || $user->livit_card != null || $user->livit_card != "reqcancel"){
              $user->balance -= $general->fiat_monthly;
              $user->save();
               $user->save();
            $itransaction = new Transaction();
            $itransaction->user_id = $user->id;
            $itransaction->amount = $general->fiat_monthly;
            $itransaction->charge = 0;
            $itransaction->trx_type = '-';
            $itransaction->trx = getTrx();
            $itransaction->details = 'MasterCard Monthly Fee';
            $itransaction->post_balance = $user->balance;
            $itransaction->save();
          }  
        }
        
        $users = User::where('cryptolivit_card','!=',null)->get();
        foreach($users as $user){
          if($user->cryptolivit_card != "requested" || $user->cryptolivit_card != null || $user->cryptolivit_card != "reqcancel"){
              $user->balance -= $general->crypto_monthly;
              $user->save();
              $itransaction = new Transaction();
            $itransaction->user_id = $user->id;
            $itransaction->amount = $general->crypto_monthly;
            $itransaction->charge = 0;
            $itransaction->trx_type = '-';
            $itransaction->trx = getTrx();
            $itransaction->details = 'Crypto MasterCard Monthly Fee';
            $itransaction->post_balance = $user->balance;
            $itransaction->save();
          }  
        }
        echo "executed";
    }
    
     
     public function vpcallreport(){
         
        $r = new Vonage();
        $v = $r->voncallreport();
        
        $records = isset($v->records) ? $v->records : array();
         foreach($records as $s){
         if($s->direction == "inbound"){
             $vn = Virtualnumber::where('msisdn', $s->to)->with('plan')->first();
               if (isset($vn->user_id)) {
                $created = $vn->created_at;
        $start = $vn->created_at->subDays(30);
        $smscount = Incomingcalls::where('user_id', $vn->user_id)->where('tonumber', $s->to)->whereBetween('created_at', [$start,$created])->sum('duration');
        $today = date_format(Carbon::now(), "Y-m-d H:i:s");
         if ($today > $vn->created_at) {
                http_response_code(400);
                echo "error";

            }else {
                if ($smscount > $vn->plan->voicecalls) {
                $user = User::where('id', $vn->user_id)->first();
                $user->balance -= $vn->plan->addvoicecalls;
                $user->save();
            }
            
            $update = Incomingcalls::where('call_id',$s->call_id)->firstorNew();
            $update->fromnumber = $s->from;
            $update->tonumber = $s->to;
            $update->duration = $s->duration;
            $update->user_id = $vn->user_id;
            $update->timestamp = $s->date_end;
            $update->json = json_encode($s);
            $update->call_id = $s->call_id;
            $update->save();

            print_r(json_encode($update->json));
            
            }   
               }
         }   
             if($s->direction == "outbound"){
             $vn = Virtualnumber::where('voicenumber', $s->to)->with('plan')->first();
               if (isset($vn->user_id)) {
                $created = $vn->created_at;
        $start = $vn->created_at->subDays(30);
        $smscount = Incomingcalls::where('user_id', $vn->user_id)->where('tonumber', $vn->msisdn)->whereBetween('created_at', [$start,$created])->sum('duration');
        $today = date_format(Carbon::now(), "Y-m-d H:i:s");
         if ($today > $vn->created_at) {
                http_response_code(400);
                echo "error";

            }else {
                if ($smscount > $vn->plan->voicecalls) {
                $user = User::where('id', $vn->user_id)->first();
                $user->balance -= $vn->plan->addvoicecalls;
                $user->save();
            }
            
            $update = Incomingcalls::where('call_id',$s->call_id)->firstorNew();
            $update->fromnumber = $s->from;
            $update->tonumber = $vn->msisdn;
            $update->duration = $s->duration;
            $update->user_id = $vn->user_id;
            $update->timestamp = $s->date_end;
            $update->json = json_encode($s);
            $update->call_id = $s->call_id;
            $update->save();

            print_r(json_encode($update->json));
            
            }   
               }
         }   
        
        
         }
         echo "no records";
    }
    public function vpreport(){
        $r = new Vonage();
        $v = $r->vonreport();
         $records = isset($v->records) ? $v->records : array();

        foreach($records as $s){
        
        $vn = Virtualnumber::where('msisdn', $s->to)->with('plan')->first();

        if (isset($vn->user_id)) {
            $created = $vn->created_at;
        $start = $vn->created_at->subDays(30);
        $smscount = Incomingsms::where('user_id', $vn->user_id)->where('tonumber', $s->to)->whereBetween('created_at', [$start,$created])->count();
            $today = date_format(Carbon::now(), "Y-m-d H:i:s");
            if ($today > $vn->created_at) {
                http_response_code(400);
                echo "error";

            }else {

            if ($smscount > $vn->plan->messages) {
                $user = User::where('id', $vn->user_id)->first();
                $user->balance -= $vn->plan->addmessages;
                $user->save();
            }

            $update = Incomingsms::where('message_id',$s->id)->firstorNew();
            $update->fromnumber = $s->from;
            $update->tonumber = $s->to;
            $update->text = $s->message_body;
            $update->user_id = $vn->user_id;
            $update->timestamp = $s->date_received;
            $update->json = json_encode($s);
            $update->message_id = $s->id;
            $update->save();

            print_r(json_encode($update->json));
        }
        }
        }
        
        echo "no records";

    }
    
      public function vpautorenew(){

        $general = GeneralSetting::first();
          $general->last_cron = Carbon::now();
        $general->save();
        $vnplans = Virtualnumber::with('plan')->get();
        foreach($vnplans as $v){
            $user = User::where('id',$v->user_id)->first();
        $plandate = $v->created_at;
        $today = date_format(Carbon::now(),"Y-m-d H:i:s");
        if($today > $v->created_at){
            if($v->plan->price > $user->balance){
                $v = new Vonage();
                $cancel = $v->cancelnumbers($v->msisdn,$v->country);
                Virtualnumber::where('user_id', $user->id)->where('msisdn',$v->msisdn)->delete();
                Incomingsms::where('user_id', $user->id)->where('msisdn',$v->msisdn)->delete();
                Incomingcalls::where('user_id', $user->id)->where('msisdn',$v->msisdn)->delete();
               echo "renewal failed";
               exit;
            }
            $user->balance -= $vnplans->plan->price;
            $user->save();
            $itransaction = new Transaction();
            $itransaction->user_id = $user->id;
            $itransaction->amount = $v->plan->price;
            $itransaction->charge = 0;
            $itransaction->trx_type = '-';
            $itransaction->trx = getTrx();
            $itransaction->details = 'Virtual Phone Number Purchase '.$v->msisdn;
            $itransaction->post_balance = $user->balance;
            $itransaction->save();
            $v->created_at = $plandate->addDays(30);
            $v->save();
            echo "success";
        }
        echo "Renewal not required";

        }

    }

    
    public function fiatRate()
    {
        $general      = GeneralSetting::first();
        $general->last_cron = Carbon::now();
        $general->save();

        $endpoint     = 'live';
        $access_key   = $general->fiat_api_key;
        $baseCurrency = 'USD';

        
        $ch = curl_init();

curl_setopt_array($ch, array(
  CURLOPT_URL => "https://api.apilayer.com/currency_data/".$endpoint."?source=".$baseCurrency,
  CURLOPT_HTTPHEADER => array(
    "Content-Type: text/plain",
    "apikey: ".$general->fiat_api_key
  ),
  CURLOPT_RETURNTRANSFER => true,
  CURLOPT_ENCODING => "",
  CURLOPT_MAXREDIRS => 10,
  CURLOPT_TIMEOUT => 0,
  CURLOPT_FOLLOWLOCATION => true,
  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
  CURLOPT_CUSTOMREQUEST => "GET"
));
        $json = curl_exec($ch);
        print_r($json);
        curl_close($ch);
        $exchangeRates = json_decode($json);
      
     
        if ($exchangeRates->success == false) {
            $errorMsg = $exchangeRates->error->info;
            echo "$errorMsg";
        } else {
            foreach ($exchangeRates->quotes as $key => $rate) {

                $curcode  = substr($key, -3);

                $currency = Fiat::where('code', $curcode)->first();
                if ($currency) {
                    $currency->rate = $rate;
                   $currency->save();
                }
                $gateway = GatewayCurrency::where('currency', $curcode)->first();
                if($gateway){
                    $gateway->rate = $rate;
                    $gateway->save();
                }
                $withdraw = WithdrawMethod::where('currency', $curcode)->first();
                if($withdraw){
                    $withdraw->rate = $rate;
                    $withdraw->save();
                }
                $someModel = new Accountingrates(); 
                $someModel->setConnection('mysql_acc'); // non-static method
                 $something = $someModel::where('code', $curcode)->first();
                 
                if($something){
                    $something->rate = $rate;
                    $something->save();
                }
            }
            echo "EXECUTED";
        }
    }

    public function cryptoRate()
    {
        $general = GeneralSetting::first();
        $general->last_cron = Carbon::now();
        $general->save();

        $url = 'https://pro-api.coinmarketcap.com/v1/cryptocurrency/quotes/latest';
        $cryptos = Crypto::pluck('code')->toArray();
        $cryptos = implode(',',$cryptos);

        $parameters = [
            'symbol' => $cryptos,
            'convert' => 'USD',
        ];
        $headers = [
            'Accepts: application/json',
            'X-CMC_PRO_API_KEY:' . trim($general->crypto_api_key),
        ];
        $qs      = http_build_query($parameters); // query string encode the parameters
        $request = "{$url}?{$qs}"; // create the request URL
        $curl    = curl_init(); // Get cURL resource
        // Set cURL options
        curl_setopt_array($curl, array(
            CURLOPT_URL            => $request, // set the request URL
            CURLOPT_HTTPHEADER     => $headers, // set the headers
            CURLOPT_RETURNTRANSFER => 1, // ask for raw response instead of bool
        ));
        $response = curl_exec($curl); // Send the request, save the response
        curl_close($curl); // Close request

        $a = json_decode($response);
        

        if (!isset($a->data)) {
            return 'error';
        }

        $coins = $a->data;

        foreach ($coins as $coin) {

            $currency = Crypto::where('code', $coin->symbol)->first();
            if ($currency) {
                $defaultCurrency = 'USD';
                $currency->rate = $coin->quote->$defaultCurrency->price;
                $currency->save();
            }
        }
       echo "EXECUTED";
    }
    
     public function cron()
    {
        $now = Carbon::now();
        $gnl = GeneralSetting::first();
        $gnl->last_cron = $now;
        $gnl->save();

        $day = strtolower(date('D'));
        $offDay = (array)$gnl->off_day;
        if(array_key_exists($day, $offDay)){
            echo "Holiday";
            exit;
        }

        $holiday = Holiday::where('date',Date('Y-m-d'))->count();
        if($holiday){
            exit;
        }

        $invest = Invest::whereStatus(1)->where('next_time', '<=', $now)->get();
        foreach ($invest as $data) {

            $now = Carbon::now();
            while(0==0){
                $nextPossible = Carbon::parse($now)->addHours($data->hours)->toDateTimeString();
                 $dayName = strtolower(date('D',strtotime($nextPossible)));
                $holiday = Holiday::where('date',date('Y-m-d',strtotime($nextPossible)))->count();
                if(!array_key_exists($dayName, $offDay)){
                     if($holiday == 0){
                         $next = $nextPossible;
                         break;
                     }
                }
                $now = $nextPossible;
            }


            $user = User::find($data->user_id);


            $in = Invest::find($data->id);
            $in->return_rec_time = $data->return_rec_time + 1; // Increase Return Count
            $in->next_time = $next; // When he will get again
            $in->last_time = now(); // Last Return time

            // Add Return Amount to user's Interest Balance
            $new_balance = getAmount($user->interest_wallet + $data->interest);
            $user->interest_wallet = $new_balance;
            $user->save();

                // Create The Transaction for Interest Back
                $transaction = new Transaction();
                $transaction->user_id = $user->id;
                $transaction->amount = getAmount($data->interest);
                $transaction->charge = 0;
                $transaction->post_balance = getAmount($new_balance);
                $transaction->trx_type = '+';
                $transaction->trx = getTrx();
                $transaction->wallet_type = 'interest_wallet';
                $transaction->details = getAmount($data->interest) . ' ' . $gnl->cur_text . ' Interest From '.@$in->plan->name;
                $transaction->save();

                // Give Referral Comission if Enabled
                if ($gnl->invest_return_commission == 1) {
                    $commissionType = 'interest';
                    levelCommission($user->id, $data->interest, $commissionType);
                }



            // Complete the investment if user get full amount as plan
            if ($in->return_rec_time >= $data->period && $data->period != '-1') {
                $in->status = 0; // Change Status so he do not get any more return


                // Give the capital back if plan says the same
                if ($data->capital_status == 1) {
                    $capital =  $data->amount;
                    $new_balance = getAmount($user->interest_wallet + $capital);
                    $user->interest_wallet = $new_balance;
                    $user->save();

                    $transaction = new Transaction();
                    $transaction->user_id = $user->id;
                    $transaction->amount = getAmount($capital);
                    $transaction->charge = 0;
                    $transaction->post_balance = getAmount($new_balance);
                    $transaction->trx_type = '+';
                    $transaction->trx = getTrx();
                    $transaction->wallet_type = 'interest_wallet';
                    $transaction->details = getAmount($capital) . ' ' . $gnl->cur_text . ' Capital Back From '.@$in->plan->name;
                    $transaction->save();


                }

            }

            // Lifetime Plan will run Lifetime
            if ($data->period == '-1') {
                $in->status = 1;
            }

            $in->save();

         
        }

echo "EXECUTED";

    }
    
     public function dps()
    {
        $general = GeneralSetting::first();
        $general->last_cron = Carbon::now();
        $general->save();

        $now    = Carbon::now()->format('y-m-d');

        $allDps = UserDps::where('status', 1)
                ->whereDate('next_installment_date', '<=', $now)
                ->whereColumn('total_installment', '>', 'given_installment')
                ->with('user', 'plan')
                ->get();

        foreach ($allDps as $dps) {
            $installmentAmount  = $dps->per_installment;
            $user               = $dps->user;

            if($user->balance < $installmentAmount){
                $adminNotification = new AdminNotification();
                $adminNotification->user_id = $user->id;
                $adminNotification->title = 'DPS Installment Due';
                $adminNotification->click_url = urlPath('admin.dps.unpaid');
                $adminNotification->save();

                notify($user, 'DPS_INSTALLMENT_DUE', [
                    "currency"              => $general->site_currency,
                    "plan_name"             => $dps->plan->name,
                    "plan_trx"              => $dps->plan->trx,
                    "due_installment"       => $dps->due_installment,
                    "per_installment"       => $dps->per_installment,
                    "given_installment"     => $dps->per_installment,
                    "installment_interval"  => $dps->isntallment_interval,
                    "total_installment"     => $dps->total_installment,
                ]);

            }else{

                $dps->given_installment   += 1;

                $dps->next_installment_date	= $dps->next_installment_date->addDays($dps->installment_interval+1);
                $dps->save();

                $user->balance -= $installmentAmount;
                $user->save();
                $this->createLog($dps->id, 'DPS', $installmentAmount);
                $transaction = new Transaction();
                $transaction->user_id       = $user->id;
                $transaction->amount        = $installmentAmount;
                $transaction->post_balance  = $user->balance;
                $transaction->charge        = 0;
                $transaction->trx_type      = '-';
                $transaction->details       = 'DPS Installment Given';
                $transaction->trx           =  $dps->trx;
                $transaction->save();
            }

            if($dps->given_installment >= $dps->total_installment){
                $dps->status = 2;
                $dps->save();

                notify($user, 'DPS_MATURED', [
                    "currency"              => $general->site_currency,
                    "plan_name"             => $dps->plan->name,
                    "plan_trx"              => $dps->plan->trx,
                    "due_installment"       => $dps->due_installment,
                    "per_installment"       => $dps->per_installment,
                    "given_installment"     => $dps->per_installment,
                    "installment_interval"  => $dps->isntallment_interval,
                    "total_installment"     => $dps->total_installment,
                ]);
            }
        }
        echo "EXECUTED";
    }

    public function loan()
    {
        $general = GeneralSetting::first();
        $general->last_cron = Carbon::now();
        $general->save();

        $now    = Carbon::now()->format('y-m-d');
        $loans  = UserLoan::whereDate('next_installment_date', '<=', $now)
                    ->whereColumn('total_installment', '>', 'given_installment')
                    ->where('status', 1)
                    ->with('user', 'plan')
                    ->get();

        foreach ($loans as $loan) {
            $installmentAmount  = $loan->per_installment;
            $user               = $loan->user;
            if($user->balance < $installmentAmount){

                if(!$loan->due_count_date || $loan->due_count_date != $loan->next_installment_date){

                    $adminNotification = new AdminNotification();
                    $adminNotification->user_id = $user->id;
                    $adminNotification->title = 'Loan Installment Due';
                    $adminNotification->click_url = urlPath('admin.loan.due');
                    $adminNotification->save();

                    notify($user, 'LOAN_INSTALLMENT_DUE', [
                        "currency"              => $general->site_currency,
                        "plan_name"             => $loan->plan->name,
                        "plan_trx"              => $loan->plan->trx,
                        "due_installment"       => $loan->due_installment,
                        "per_installment"       => $loan->per_installment,
                        "given_installment"     => $loan->per_installment,
                        "installment_interval"  => $loan->isntallment_interval,
                        "total_installment"     => $loan->total_installment,
                    ]);
                }

            }else{
                if($loan->due_installment){
                    $loan->due_installment     -= 1;
                }else{
                    $loan->given_installment   += 1;
                }
                $loan->next_installment_date	= $loan->next_installment_date->addDays($loan->installment_interval);
                $loan->paid_amount += $installmentAmount;
                $loan->save();
                $user->balance -= $installmentAmount;
                $user->save();
                $this->createLog($loan->id, 'LOAN', $installmentAmount);
                $transaction = new Transaction();
                $transaction->user_id       = $user->id;
                $transaction->amount        = $installmentAmount;
                $transaction->post_balance  = $user->balance;
                $transaction->charge        = 0;
                $transaction->trx_type      = '-';
                $transaction->details       = 'Loan Installment Given';
                $transaction->trx           =  $loan->trx;
                $transaction->save();
            }


            if( $loan->given_installment >= $loan->total_installment){
                $loan->status = 2;
                $loan->save();

                notify($user, 'LOAN_COMPLETED', [
                    "currency"              => $general->site_currency,
                    "plan_name"             => $loan->plan->name,
                    "plan_trx"              => $loan->plan->trx,
                    "due_installment"       => $loan->due_installment,
                    "per_installment"       => $loan->per_installment,
                    "given_installment"     => $loan->per_installment,
                    "installment_interval"  => $loan->isntallment_interval,
                    "total_installment"     => $loan->total_installment,
                ]);
            }
        }
        echo "EXECUTED";
    }

    public function fdr()
    {
        $general = GeneralSetting::first();
        $general->last_cron = Carbon::now();
        $general->save();

        $now    = Carbon::now()->format('y-m-d');

        $allFdr = UserFdr::whereDate('next_return_date', '<=', $now)
                            ->where('status', 1)
                            ->with('user', 'plan')
                            ->get();

        foreach ($allFdr as $fdr) {
            $interest = $fdr->interest;
            $user = $fdr->user;
            $fdr->next_return_date	= $fdr->next_return_date->addDays($fdr->interest_interval+1);
            $fdr->profit	        += $interest;
            $fdr->save();

            $user->balance += $interest;
            $user->save();
            $this->createLog($fdr->id, 'FDR', $interest);

            $transaction = new Transaction();
            $transaction->user_id       = $user->id;
            $transaction->amount        = $interest;
            $transaction->post_balance  = $user->balance;
            $transaction->charge        = 0;
            $transaction->trx_type      = '+';
            $transaction->details       = 'Received FDR Interest';
            $transaction->trx           =  $fdr->trx;
            $transaction->save();
        }
        echo "EXECUTED";
    }

    public function createLog($id, $type, $amount)
    {
        $log            = new InstallmentLog();
        $log->f_id      = $id;
        $log->type      = $type;
        $log->amount    = $amount;
        $log->save();
    }
    
    public function banklist(){
         $general      = GeneralSetting::first();
         $list = new Kudalib();
         $data = array(
                  
        "servicetype"=> "BANK_LIST",
        "requestref" => getTrx()
         );
         
         $banklist = $list->kudapost($data);
         Banklist::truncate();
         foreach($banklist->data->banks as $b){
            $update = new Banklist();
            $update->bankCode = $b->bankCode;
            $update->bankName = $b->bankName;
            $update->save();
            print_r($b);
         }
         
    }
    
}
