<?php

namespace App\Http\Controllers;

use App\Lib\GoogleAuthenticator;
use App\Models\AdminNotification;
use App\Models\GeneralSetting;
use App\Models\SubCategory;
use App\Models\Transaction;
use App\Models\Points;
use App\Models\Cart;
use App\Models\Plan;
use App\Models\Deposit;
use App\Models\Fluttercard;
use App\Lib\Flutterwave;
use App\Lib\Fincralib;
use App\Models\WithdrawMethod;
use App\Models\Withdrawal;
use App\Models\Advertisement;
use App\Models\Holiday;
use App\Models\PromotionTool;
use App\Models\Invest;
use App\Models\Crypto;
use App\Models\TimeSetting;
use App\Models\TradeRequest;
use App\Models\Fiat;
use App\Models\User;
use App\Models\Wallet;
use App\Models\Vcard;
use App\Rules\FileTypeValidate;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Hash;
use Illuminate\Validation\Rules\Password;
use Illuminate\Validation\Rule;
use App\Models\Card;
use App\Models\Fincra;
use App\Models\GatewayCurrency;
use App\Models\SupportTicket;
use Carbon\Carbon;
use App\Models\Cryptocard;
use Response;
 
class FincraController extends Controller
{
    public function __construct()
    {
        $this->activeTemplate = activeTemplate();
    }
    
    public function getaccountngn(){
         $pageTitle = "NGN Bank Account";
        
        $user = auth()->user(); 
        $fincra = Fincra::where('user_id',Auth::user()->id)->where('currency','=','NGN')->first();
          
         return view($this->activeTemplate.'user.fincra.indexngn', compact('pageTitle','fincra','user'));
    }
     public function getaccountusd($currency){
         $pageTitle = $currency." Bank Account";
        
        $user = auth()->user(); 
        $cur = strtoupper($currency);
       
               $c = new Fincralib();
               $cur = $c->getcurrency($cur);
                $create=array();      
              foreach($cur->data->results as $a){
                  
               if(isset($a->KYCInformation->email) && $a->KYCInformation->email == $user->email){
            
        $create['accounts'] = array(
            "status" => $a->status,
            "info" => $a->accountInformation,
        );
   
               }
               
              }
       
         return view($this->activeTemplate.'user.fincra.indexusd', compact('pageTitle','create','user','currency'));
    }
    public function getaccounteur(){
         $pageTitle = "EUR Bank Accounts";
        
        $user = auth()->user(); 
        $fincra = Fincra::where('user_id',Auth::user()->id)->where('currency','=','EUR')->first();
          
         return view($this->activeTemplate.'user.fincra.indexeur', compact('pageTitle','fincra'));
    }
    
    public function getaccountgbp(){
         $pageTitle = "GBP Bank Accounts";
        
        $user = auth()->user(); 
        
        
        $fincra = Fincra::where('user_id',Auth::user()->id)->where('currency','=','GBP')->first();
          
         return view($this->activeTemplate.'user.fincra.indexgbp', compact('pageTitle','fincra'));
    }
    
    
    public function createaccountngn(Request $request){
          $user = auth()->user(); 
          $general = GeneralSetting::first();
          $this->validate($request, [
            'bvn' => 'required|min:11|max:11',
            
        ]);
          $data = array(
              
     "currency"=> "NGN",
     "channel"=> "wema",
     "KYCInformation"=> [
          "firstName"=> $user->firstname,
          "lastName"=> $user->lastname,
          "bvn"=> $request->bvn
     ],
     "accountType"=> "individual"
          );
          
         
        $c = new Fincralib();
        $create = $c->createaccount($data);
        if(isset($create->success) && $create->success == true){
        $fin = new Fincra();
        $fin->user_id = $user->id;
        $fin->user_email = $user->email;
        $fin->currency = "NGN";
        $fin->accountNumber = $create->data->accountInformation->accountNumber;
        $fin->bankName = $create->data->accountInformation->bankName;
        $fin->accountName = $create->data->accountInformation->accountName;
        $fin->reference = $create->data->accountInformation->reference;
        $fin->fincraid = $create->data->_id;
        $fin->save();
        $notify[] = ['success','Your Bank Account Has Been Created'];
        return back()->withNotify($notify);
    }
    else {
    $error = isset($create->error) ? $create->error : "Check Your Details or contact Admin";
        $notify[] = ['error','Error Creating Bank Account '.$error ];
        return back()->withNotify($notify)->withInput();
    }
}


 public function createaccountusd(Request $request){
          $user = auth()->user(); 
          $general = GeneralSetting::first();
          $this->validate($request, [
               'currency' => 'required',
            'line_1' => 'required',
              'line_2' => 'required',
            'state' => 'required',
            'city' => 'required',
            'country' => 'required',  
            'zip' => 'required',
            'passport' => ['required','image',new FileTypeValidate(['jpg','jpeg','png'])],
              
               'utilityBill' => ['required','image',new FileTypeValidate(['jpg','jpeg','png'])],
              
        ]);
          if ($request->hasFile('passport')) {
              $location = imagePath()['fincra']['path'];
              $passport = uploadImage($request->passport, $location);
          }
          if ($request->hasFile('nationalId')) {
              $location = imagePath()['fincra']['path'];
              $nationalId = uploadImage($request->nationalId, $location);
          }
          
           if ($request->hasFile('utilityBill')) {
              $location = imagePath()['fincra']['path'];
              $utilityBill = uploadImage($request->utilityBill, $location);
          }
          $passportlink = getImage(imagePath()['fincra']['path'].'/'. @$passport);
          $nationalIdlink = getImage(imagePath()['fincra']['path'].'/'. @$nationalId);
          $utilityBilllink = getImage(imagePath()['fincra']['path'].'/'. @$utilityBill);
          
          $data = array(
              
     "currency"=> $request->currency,
      "meansOfId"=>[$passportlink],
            "utilityBill"=>$utilityBilllink,
            
            "accountType"=>"individual",
 "KYCInformation"=> [
            "firstName"=> $user->firstname,
            "lastName"=> $user->lastname,
            "email"=> $user->email,
            "birthDate"=> date("Y-m-d", strtotime($request->dob)),
            "nationality"=> "NG",
            "incomeBand"=> "0-100000",
            "phone"=> $user->mobile,
            "address"=> [
                "countryOfResidence"=> "NG",
                "zip"=> $request->zip,
                "street"=> $request->line_1,
                "number"=> $request->line_2,
                "state"=> $request->state,
                "city"=> $request->city
            ],
            "document"=> [
                "type"=> "passport",
                "number"=> $request->passportnumber,
                "issuedCountryCode"=> "NG",
                "issuedBy"=> "government",
                "issuedDate"=> date("m-d-Y", strtotime($request->issuedate)),
                "expirationDate"=> date("m-d-Y", strtotime($request->expiration)) 
            ],
            "occupation"=> $request->occupation,
            "sourceOfIncome"=> $request->soi,
            "accountDesignation"=> "personal",
            "employmentStatus"=> "Employed"
     ]
          );
          
         
        $c = new Fincralib();
        $create = $c->createaccount($data);
      
        if(isset($create->success) && $create->success == true){
        $fin = new Fincra();
        $fin->user_id = $user->id;
        $fin->user_email = $user->email;
        $fin->currency = $request->currency;
       
        $fin->fincraid = $create->data->_id;
        $fin->save();
        $notify[] = ['success','Your Bank Account Has Been Created'];
        return back()->withNotify($notify);
    }
    else {
    $error = isset($create->error) ? $create->error : "Check Your Details or contact Admin";
        $notify[] = ['error','Error Creating Bank Account '.$error ];
        return back()->withNotify($notify)->withInput();
    }
}


}