<?php

namespace App\Http\Controllers\Gateway\Jazzcash;

use App\Models\Deposit;
use App\Models\GatewayCurrency;
use App\Http\Controllers\Controller;
use App\Http\Controllers\Gateway\PaymentController;
use Auth;
use Illuminate\Http\Request;
use Carbon\Carbon;
use App\Models\User;

class ProcessController extends Controller
{
    /*
     * Cashmaal
     */

    public static function process($deposit)
    {
    	$jazzcash = json_decode($deposit->gatewayCurrency());
    	$param = json_decode($jazzcash->gateway_parameter);
        $val['pp_Version'] = "1.1";
        $val['pp_TxnType'] = "MWALLET";
        $val['pp_Language'] = "EN";
        $val['pp_SubMerchantID'] = "";
        $val['pp_BankID'] = "TBANK";
        $val['pp_ProductID'] = "RETL";
        $val['pp_MerchantID'] = $param->public_key;
        $val['pp_Password'] = $param->secret_key;
        $val['ppmpf_1'] = "1";
        $val['ppmpf_2'] = "2";
        $val['ppmpf_3'] = "3";
        $val['ppmpf_4'] = "4";
        $val['ppmpf_5'] = $deposit->dp;
        $val['pp_TxnRefNo'] = $deposit->trx;
        $val['pp_Amount'] = getAmount($deposit->final_amo) * 100;
   //     $val['pp_Amount'] = "100";
        $val['pp_TxnCurrency'] = "PKR";
        $val['pp_TxnDateTime'] = date_format(Carbon::now(),"YmdHis");
        $val['pp_BillReference'] = $deposit->trx;
        $val['pp_Description'] = $deposit->trx;

        $newDateTime = date_format(Carbon::now()->addDays(1),"YmdHis");
        $val['pp_TxnExpiryDateTime'] = $newDateTime;
        $val['pp_ReturnURL'] = route('ipn.'.$deposit->gateway->alias);

        ksort($val);

		$str = '';
		foreach($val as $key => $value){
			if(!empty($value)){
				$str = $str . '&' . $value;
			}
		}

		$str = $param->encryption_key.$str;

		$pp_SecureHash = hash_hmac('sha256', $str, $param->encryption_key);

        $val['pp_SecureHash'] = $pp_SecureHash;

        $send['url'] = 'https://jazzcash.com.pk/CustomerPortal/transactionmanagement/merchantform/';
        $send['method'] = 'post';
        $send['view'] = 'user.payment.redirect';
        $send['val'] = $val;


        return json_encode($send,JSON_UNESCAPED_SLASHES);
    }
    
     public static function newprocess($deposit)
    {
    	$jazzcash = json_decode($deposit->gatewayCurrency());
    	$param = json_decode($jazzcash->gateway_parameter);
        $val['pp_Version'] = "1.1";
        $val['pp_TxnType'] = "MWALLET";
        $val['pp_Language'] = "EN";
        $val['pp_SubMerchantID'] = "";
        $val['pp_BankID'] = "TBANK";
        $val['pp_ProductID'] = "RETL";
        $val['pp_MerchantID'] = $param->public_key;
        $val['pp_Password'] = $param->secret_key;
        $val['ppmpf_1'] = "1";
        $val['ppmpf_2'] = "2";
        $val['ppmpf_3'] = "3";
        $val['ppmpf_4'] = "4";
        $val['ppmpf_5'] = $deposit->dp;
        $val['pp_TxnRefNo'] = $deposit->trx;
        $val['pp_Amount'] = getAmount($deposit->final_amo) * 100;
   //     $val['pp_Amount'] = "100";
        $val['pp_TxnCurrency'] = "PKR";
        $val['pp_TxnDateTime'] = date_format(Carbon::now(),"YmdHis");
        $val['pp_BillReference'] = $deposit->trx;
        $val['pp_Description'] = $deposit->trx;

        $newDateTime = date_format(Carbon::now()->addDays(1),"YmdHis");
        $val['pp_TxnExpiryDateTime'] = $newDateTime;
        $val['pp_ReturnURL'] = route('ipn.'.$deposit->gateway->alias);

        ksort($val);

		$str = '';
		foreach($val as $key => $value){
			if(!empty($value)){
				$str = $str . '&' . $value;
			}
		}

		$str = $param->encryption_key.$str;

		$pp_SecureHash = hash_hmac('sha256', $str, $param->encryption_key);

        $val['pp_SecureHash'] = $pp_SecureHash;

        $send['url'] = 'https://jazzcash.com.pk/CustomerPortal/transactionmanagement/merchantform/';
        $send['method'] = 'post';
        $send['view'] = 'user.pg.payment.redirect';
        $send['val'] = $val;


        return json_encode($send,JSON_UNESCAPED_SLASHES);
    }

    public function ipn(Request $request)
    {
        $r['response'] =  $request->pp_ResponseMessage;
        $r['code'] = $request->pp_ResponseCode;
        $r['pp_TxnRefNo'] = $request->pp_TxnRefNo;
        $deposit = Deposit::where('trx', $r['pp_TxnRefNo'])->orderBy('id', 'DESC')->first();



   		if($r['code'] == "000" && $request->pp_TxnRefNo == $deposit->trx ){
        if($request->ppmpf_5 == "dp"){
              PaymentController::userDataUpdate($deposit->trx);
                $notify[] = ['success', 'Deposit is successful'];
                return redirect()->route('user.deposit.history')->withNotify($notify);
        } else {
                    PaymentController::userDataUpdate($deposit->trx);
                    $notify[] = ['success', 'Transaction is successful, you can proceed with purchase'];
			return redirect()->route('user.checkout')->withNotify($notify);
                } } else{
			$notify[] = ['error','Payment failed'];
        	return redirect()->route('user.deposit.history')->withNotify($notify);
		}
		return redirect()->route(gatewayRedirectUrl(true))->withNotify($notify);
    }
}
