<?php

namespace App\Http\Controllers;

use Carbon\Carbon;
use App\Models\SubCategory;
use App\Models\Cart;
use App\Models\Fluttercard;
use App\Models\Vcard;
use App\Models\Cryptocard;
use App\Models\User;
use App\Models\Prepaid;
use App\Models\Weavrprepaid;
use App\Models\Aptocard;
use App\Models\Fiat;
use App\Models\Countries;
use App\Models\Category;
use App\Models\Wallet;
use App\Models\WalletCrypto;
use App\Models\Crypto;
use Illuminate\Support\Facades\Auth;
use App\Http\Helpers\Helper;
use App\Models\Card;
use App\Lib\GoogleAuthenticator;
use App\Lib\Tremendous;
use App\Models\AdminNotification;
use App\Models\GeneralSetting;
use App\Lib\Flutterwave;
use App\Models\Transaction;
use App\Models\WithdrawMethod;
use App\Models\Withdrawal;
use App\Rules\FileTypeValidate;
use Illuminate\Http\Request;
use App\Lib\PHPJWT;
use App\Models\Livitcard;
use Illuminate\Support\Facades\Hash;
use Illuminate\Validation\Rules\Password;
use Illuminate\Validation\Rule;
use App\Lib\Aphelp;
use App\Models\GatewayCurrency;
use App\Models\SupportTicket;

use Response;

class MastercardController extends Controller
{
    
    public function __construct(){
        $this->activeTemplate = activeTemplate();
    }
    
      
    public function getprepaidcards(){
         $general = GeneralSetting::first();
        $publickey = $general->livitpay_public; 
        $privatekey = $general->livitpay_private; 
        $uri = env("APP_URL");
      $pageTitle = "Buy Prepaid Cards";
         $user = auth()->user(); 
          $curl = curl_init();
         curl_setopt_array($curl, array(
  CURLOPT_URL => 'https://cards.livitpay.com/api/getprepaid',
  CURLOPT_RETURNTRANSFER => true,
  CURLOPT_ENCODING => '',
  CURLOPT_MAXREDIRS => 10,
  CURLOPT_TIMEOUT => 0,
  CURLOPT_FOLLOWLOCATION => true,
  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
  CURLOPT_CUSTOMREQUEST => 'GET',
  
  CURLOPT_HTTPHEADER => array(
    'public-key: '.$publickey,
    'private-key: '.$privatekey,
    'url: '.env('APP_URL'),
    'Content-Type: application/json'
  ),
));

$response = curl_exec($curl);

curl_close($curl);
$cards = json_decode($response);
return view($this->activeTemplate.'user.vcard.buyprepaid', compact('pageTitle','cards', 'user'));
    }
    
    public function livitpayindex($id){
        $general = GeneralSetting::first();
        $publickey = $general->livitpay_public; 
        $privatekey = $general->livitpay_private; 
        $uri = env("APP_URL");
      $pageTitle = "Mastercard Prepaid Card";
         $user = auth()->user(); 
         $card = Weavrprepaid::where('id',$id)->first();
         $cardid = $card->weavr_cardid;
        $curl = curl_init();
$post = array(
    "email" => $user->email,
     "cardid" => $cardid,
    "url" => $uri,
);
curl_setopt_array($curl, array(
  CURLOPT_URL => 'https://cards.livitpay.com/api/getprepaidid',
  CURLOPT_RETURNTRANSFER => true,
  CURLOPT_ENCODING => '',
  CURLOPT_MAXREDIRS => 10,
  CURLOPT_TIMEOUT => 0,
  CURLOPT_FOLLOWLOCATION => true,
  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
  CURLOPT_CUSTOMREQUEST => 'POST',
  CURLOPT_POSTFIELDS =>json_encode($post),
  CURLOPT_HTTPHEADER => array(
    'public-key: '.$publickey,
    'private-key: '.$privatekey,
    'url: '.env('APP_URL'),
    'Content-Type: application/json'
  ),
));

$response = curl_exec($curl);

curl_close($curl);
$cards = json_decode($response);

     if(!isset($cards->weavrtoken)){
        $notify[]=['error','Unable To Retrieve card information at this time, please try again later.'];
            return back()->withNotify($notify)->withInput();  
     }

 return view($this->activeTemplate.'user.vcard.prepaidlivitpayindex', compact('pageTitle','cards', 'user'));
        
    }
    
    public function prepaidlist(){
          $general = GeneralSetting::first();
          $pageTitle = "Mastercard Prepaid List";
           $user = auth()->user(); 
           $cards = Weavrprepaid::where('user_id', $user->id)->get();
           return view($this->activeTemplate.'user.cards.mpindex', compact('pageTitle','cards', 'user'));
    }
    
    
    public function buyprepaidcards(Request $request){
        $general = GeneralSetting::first();
        $publickey = $general->livitpay_public; 
        $privatekey = $general->livitpay_private; 
        $uri = env("APP_URL");
        $user = auth()->user(); 
        $cardid = $request->id;
        $amount = $request->amount;
        $loadfees = $amount * $general->prepaidload_fee / 100 ;
        $issuefees = $general->prepaidissue_fee;
        $totalamount = $amount + $issuefees + $loadfees;
        
        if($user->balance < $totalamount){
            $notify[]=['error','Insufficient Balance To Issue Crypto MasterCard'];
return back()->withNotify($notify)->withInput(); 
        }
         $trx = getTrx();
     $user->balance -= $totalamount;
    $user->save();        
        $curl = curl_init();
        
        $phone = str_replace("+", "", $user->mobile); 
        
        
$post = array(
    "email" => $user->email,
    "cardid" => $cardid,
    "url" => $uri,
    "friendlyname" =>$user->firstname." ".$user->lastname,
    "phone" =>$phone,
);
curl_setopt_array($curl, array(
  CURLOPT_URL => 'https://cards.livitpay.com/api/assignprepaid',
  CURLOPT_RETURNTRANSFER => true,
  CURLOPT_ENCODING => '',
  CURLOPT_MAXREDIRS => 10,
  CURLOPT_TIMEOUT => 0,
  CURLOPT_FOLLOWLOCATION => true,
  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
  CURLOPT_CUSTOMREQUEST => 'POST',
  CURLOPT_POSTFIELDS =>json_encode($post),
  CURLOPT_HTTPHEADER => array(
    'public-key: '.$publickey,
    'private-key: '.$privatekey,
    'url: '.env('APP_URL'),
    'Content-Type: application/json'
  ),
));

$response = curl_exec($curl);

curl_close($curl);
$cards = json_decode($response);

if(isset($cards->cardid)){

$update = new Weavrprepaid();
$update->user_id = $user->id;
$update->name = $user->firstname." ".$user->lastname;
$update->email = $user->email;
$update->weavr_cardid = $cards->cardid;
$update->save();
 $transaction = new Transaction();
    $transaction->user_id = $user->id;
    $transaction->amount = $totalamount;
    $transaction->post_balance = $user->balance;
    $transaction->charge = 00;
    $transaction->trx_type = '-';
    $transaction->details = 'Prepaid MasterCard Purchased';
    $transaction->trx =  $trx;
    $transaction->save();
    $notify[]=['error','Card Issued Successfully'];
return redirect()->route('user.prepaid.list')->withInput(); 
     } else {
         $user->balance += $totalamount;
    $user->save(); 
      $notify[]=['error','Error Issuing card, contact admin'];
return back()->withNotify($notify)->withInput(); 
    }
}
}