<?php

namespace App\Http\Controllers;

use Carbon\Carbon;
use App\Models\SubCategory;
use App\Models\Cart;
use App\Models\Fluttercard;
use App\Models\User;
use App\Models\Fiat;
use App\Models\Crypto;
use App\Models\Vcard;
use App\Models\Paylink;
use App\Models\Countries;
use App\Models\Category;
use App\Models\Bank;
use App\Models\Banktrans;
use Illuminate\Support\Facades\Auth;
use App\Http\Helpers\Helper;
use App\Models\Card;
use App\Lib\GoogleAuthenticator;
use App\Models\AdminNotification;
use App\Models\GeneralSetting;
use App\Lib\Flutterwave;
use App\Models\Transaction;
use App\Models\WithdrawMethod;
use App\Models\Withdrawal;
use App\Rules\FileTypeValidate;
use Illuminate\Http\Request;
use App\Models\Cryptocard;
use App\Models\Deposit;
use Illuminate\Support\Facades\Hash;
use Illuminate\Validation\Rules\Password;
use Illuminate\Validation\Rule;
use App\Lib\ProcessSendMoney;
use App\Models\GatewayCurrency;
use App\Models\SupportTicket;
use App\Models\SendMoney;
use App\Models\Country;
use App\Models\SendingPurpose;

use App\Models\SourceOfFund;
use Response;
use App\Models\Extension;
use App\Models\UserLogin;
use Illuminate\Foundation\Auth\AuthenticatesUsers;

class PgController extends Controller
{
    use AuthenticatesUsers;

    /**
     * Where to redirect users after login.
     *
     * @var string
     */

    protected $username;
    
    public function __construct(){
         
        $this->activeTemplate = activeTemplate();
        $this->username = $this->findUsername();
    }
    
    public function agentremit()
    {
        $pageTitle = 'Remittance Collection';
       
        return view($this->activeTemplate.'user.merchant.agentremit', compact('pageTitle'));
    }
    
    
    public  function gettoken(Request $request){
      $apikey = $request->header('API-KEY');
      $merchant_email = $request['merchant_email'] ? $request['merchant_email'] :  $request->header('email');
      $general      = GeneralSetting::first();
      if($general->merchant_key != $apikey){
          $result = array(
             "code" => 409,
             "status" => "error",
             "message" => "API KEY ERROR"
         );
            http_response_code(409);
         echo json_encode($result);
         exit;
      }
      
      $exist = User::where('username',$merchant_email)->orWhere('email',$merchant_email)->first();
      if(!$exist){
         $result = array(
             "code" => 401,
             "status" => "error",
             "message" => "No Merchant Found" .$merchant_email
         );
           http_response_code(401);
         echo json_encode($result);
          exit;
      }
      
      $trx = getTrx();
      $token = base64_encode($trx);
      
      $update = new Paylink();
      $update->merchant_id =  $exist->id;
      $update->merchant_email = $exist->email;
      $update->token = $token;
      $update->trx = $trx;
      $update->save();
      $result = array(
             "code" => 200,
             "status" => "success",
             "message" => "Auth Token Generated",
             "data" => array(
                 
                 "token" => $token,
                 "merchant_id" => $exist->id
                 
                 )
         );
         echo json_encode($result);
          exit;
      
    }
    
    public function ref (Request $request){
        $ref = request()->headers->all();
        print_r(json_encode($ref)); 
    }
    
     public  function payrequest(Request $request){
      $apikey = $request->header('API-KEY');
      $token = base64_decode($request->header('token'));
      
      $req = request()->input();
      $merchant_email = $request['merchant_email'] ? $request['merchant_email'] : $req['merchant_email'];
      
      $amount = $request['amount'] ? $request['amount'] : $req['amount'];
      $currency = $request['currency'] ? $request['currency'] : $req['currency'];
      $return_url = $request['return_url'] ? $request['return_url'] : $req['return_url'];
      $cancel_url = $request['cancel_url'] ? $request['cancel_url'] : $req['cancel_url'];
      $order_ref = $request['merchant_ref'] ? $request['merchant_ref'] : $req['merchant_ref'];
      
       if($amount < 0){
          
           $result = array(
             "code" => 409,
             "status" => "error",
             "message" => "amount must be greater than 0"
         );
          http_response_code(409);
         echo json_encode($result);
         exit;
      }
      
      
      $general = GeneralSetting::first();
      if($general->merchant_key != $apikey){
          $result = array(
             "code" => 409,
             "status" => "error",
             "message" => "API KEY ERROR"
         );
          http_response_code(409);
         echo json_encode($result);
         exit;
      }
      
      $exist = User::where('username',$merchant_email)->orWhere('email',$merchant_email)->first();
      if(!$exist){
         $result = array(
             "code" => 401,
             "status" => "error",
             "message" => "No Merchant Found"
         );
         http_response_code(401);
         echo json_encode($result);
          exit;
      }
       $trx = Paylink::where('trx',$token)->first();
       if(!$trx){
         $result = array(
             "code" => 409,
             "status" => "error",
             "message" => "Invalid Token"
         );
         http_response_code(409);
         echo json_encode($result);
          exit;
      }
      if(isset($trx) && $trx->status == "completed"){
         $result = array(
             "code" => 402,
             "status" => "error",
             "message" => "Payment Completed already"
         );
         http_response_code(402);
         echo json_encode($result);
          exit;
      }
      
      $ord = Paylink::where('merchant_ref',$order_ref)->first();
       if($ord){
         $result = array(
             "code" => 409,
             "status" => "error",
             "message" => "Merchant Ref Not Unique"
         );
         http_response_code(409);
         echo json_encode($result);
          exit;
      }
    $paylink = getTrx();
    $trx->paylink = $paylink;
    $trx->amount = $amount;
    $trx->currency =$currency;
    $trx->return_url =$return_url;
    $trx->cancel_url =$cancel_url;
    $trx->merchant_ref =$order_ref;
    $trx->status = "initiated";
    $trx->save();
    
    $result = array(
             "code" => 200,
             "status" => "Success",
             "message" => "Redirect URL Generated",
             "data" => array (
             "redirect_url" => url('pay')."?paylink=".$paylink,
                 "trx" => $trx->trx,
                 "amount" => $amount,
                 "currency" => $currency
             )
         );
    http_response_code(200);
     echo json_encode($result, JSON_UNESCAPED_SLASHES);
    
    
     
      
      
     }
    
     public  function pay(Request $request){
         $paylink = $request['paylink'];
         $paylink = Paylink::where('paylink',$paylink)->first();
         if(!$paylink){
              $result = array(
             "code" => 409,
             "status" => "error",
             "message" => "Payment link is invalid"
         );
              http_response_code(409);
         echo json_encode($result);
          exit;
             
         }
         
         if(isset($paylink) && $paylink->status == "completed"){
              $result = array(
             "code" => 400,
             "status" => "error",
             "message" => "Payment already completed"
         );
              http_response_code(400);
         echo json_encode($result);
          exit;
             
         }
         
         
     }
     public function processpayment(Request $request){
         $pageTitle = "Payment Confirmation";
        $user = $request->user();
        $paylink = $request->paylink;
       $general = GeneralSetting::first();
        $paylinks = Paylink::where('paylink',$paylink)->first();
        $general = GeneralSetting::first();
        $pgfee = $general->pg_fee;
        if($paylinks->currency != $general->cur_text){
        $frate = Fiat::where('code',$paylinks->currency)->first();
         
        $rate = $frate->rate;
        $debitamount = showAmount($paylinks->amount / $rate);
        $fees = $debitamount * $pgfee / 100;
        
        } else {
            
        $debitamount = showAmount($paylinks->amount);
        $fees = $debitamount * $pgfee / 100;
        }
          if($debitamount < 0){
          
           $notify[]=['error','Sorry! Amout must be greater than 0'];
            return back()->withNotify($notify)->withInput(); 
      }
        
        if($debitamount > $user->balance){
            $notify[]=['error','Sorry! insufficient balance in this wallet'];
            return back()->withNotify($notify)->withInput(); 
        }
        
        $merchant_id = $paylinks->merchant_id;
        $receiver = User::where('id',$paylinks->merchant_id)->first();
        $trx = getTrx();

    $user->balance -= $debitamount;
    $user->save();

    $transaction = new Transaction();
    $transaction->user_id = $user->id;
    $transaction->amount = $debitamount;
    $transaction->post_balance = $user->balance;
    $transaction->charge = 00;
    $transaction->trx_type = '-';
    $transaction->details = 'Payment To '.$paylinks->merchant_email.' amount '.$debitamount.' successful';
    $transaction->trx =  $trx;
    $transaction->save();
    
    $rtrx = getTrx();
     $receiver->balance += $debitamount;
    $receiver->save();

    $transaction = new Transaction();
    $transaction->user_id = $receiver->id;
    $transaction->amount = $debitamount;
    $transaction->post_balance = $receiver->balance;
    $transaction->charge = 00;
    $transaction->trx_type = '+';
    $transaction->details = 'Payment from '.$user->email.' amount '.$debitamount.' successful';
    $transaction->trx =  $rtrx;
    $transaction->save();
    
    $rftrx = getTrx();
     $receiver->balance -= $fees;
    $receiver->save();

    $transaction = new Transaction();
    $transaction->user_id = $receiver->id;
    $transaction->amount = $fees;
    $transaction->post_balance = $receiver->balance;
    $transaction->charge = 00;
    $transaction->trx_type = '-';
    $transaction->details = 'Fee for payment from'.$user->email.' transaction id '.$rtrx;
    $transaction->trx =  $rftrx;
    $transaction->save();
    
    
    $paylinks->status = "completed";
    $paylinks->user_id = $user->id;
    $paylinks->updated_at = date_format(Carbon::now(),"Y-m-d H:i:s");
    $paylinks->save();
    
    $params=array(
        "code" => 200,
        "status" => "success",
        "txn_ref" => $paylinks->trx,
        "merchant_ref" => $paylinks->merchant_ref,
    );
    $params = http_build_query($params) . "\n";
   return redirect()->away($paylinks->return_url."?".$params);
   
        
     }
     
     public function sendotp(Request $request){
        
                $otp = Vcard::where('card_hash', $request->card_hash)->first();
               
                if($otp){
                $user = User::where('id',$otp->user_id)->first();
                $otp->ver_code = verificationCode(6);
                $otp->ver_code_send_at = Carbon::now();
                $otp->save();
                sendEmail($user, 'CRD_CODE', [
                    'code' => $otp->ver_code
                ]);
                $result = array(
                    "status" => "success"
                );
                } else {
                   $result = array(
                    "status" => "error"
                ); 
                }
                echo json_encode($result);
     }
     
      public function remitsendotp(Request $request){
        
                $otp = SendMoney::where('trx', $request->mtcn)->where('status', 1)->first();
               
                if($otp){
               
                $result = array(
                    "status" => "success",
                    "data" => [
                        'amount' => showAmount($otp->recipient_amount),
                        'currency' => $otp->recipient_currency,
                        'name' => $otp->recipient->name,
                        'email' => $otp->recipient->email,
                        'mobile' => $otp->recipient->mobile,
                        'address' => $otp->recipient->address,
                        'additional' => $otp->recipient->additional,
                        ]
                );
                } else {
                   $result = array(
                    "status" => "error"
                ); 
                }
                echo json_encode($result);
     }
     
     public function remitverifyotp(Request $request){
         $user = auth()->user();
         $general = GeneralSetting::first();
          $otp = SendMoney::where('trx', $request->mtcn)->where('status', 1)->first();
          if(isset($otp->otp) && $otp->otp == $request->ver_code){
              
        $sendMoney = SendMoney::where('trx', $request->mtcn)->where('status', 1)->first();
         
        $this->sendingCountry   = Country::where('name',$sendMoney->sending_country)->first();
        $this->recipientCountry = Country::where('name',$sendMoney->recipient_country)->first();
        $this->sourceOfFunds    = SourceOfFund::where('name',$sendMoney->source_of_funds)->first();
        $this->sendingPurpose   = SendingPurpose::where('name',$sendMoney->sending_purpose)->first();
        $this->sendingAmount    = $sendMoney->sending_amount;
        
       
        
        
        $conversionRate              = $this->recipientCountry->rate / $this->sendingCountry->rate;
        $receivableAmount            = $conversionRate * $this->sendingAmount;  //In Recipient's currency
        $percentCharge               = $receivableAmount * $this->recipientCountry->percent_charge / 100;
        $chargeInRecipientCurrency   = $this->recipientCountry->fixed_charge + $percentCharge;
        $chargeInSendingCurrency     = $chargeInRecipientCurrency / $conversionRate;

        $this->chargeInBaseCurrency        = $chargeInSendingCurrency / $this->sendingCountry->rate;
        $this->sendingAmountInBaseCurrency = $this->sendingAmount / $this->sendingCountry->rate;
        $this->chargeInSendingCurrency     = $chargeInSendingCurrency;
        $this->receivableAmount            = $receivableAmount;
        $this->amountWithCharge            = $this->sendingAmountInBaseCurrency + $this->chargeInBaseCurrency;
        $this->amountNoCharge            = $this->sendingAmountInBaseCurrency;
        
        
       $user->balance += $this->amountNoCharge;
        $user->save();

        
        $transaction                  = new Transaction();
        $transaction->user_id        = $user->id;
        $transaction->amount          = $this->amountNoCharge;
        $transaction->post_balance    = $user->balance;
        $transaction->charge          = 0;
        $transaction->trx_type        = '+';
        $transaction->details         = 'Remittance Cash Payment ' . $request->mtcn;
        $transaction->remark          = 'send_money_payment';
        $transaction->trx             = getTrx();
        $transaction->save();
        
        $agentcommission = $general->agent_cashpay;
        $commissionamt = round($this->amountNoCharge * $general->agent_cashpay/100);
        $user = auth()->user();
        $user->balance += $commissionamt;
        $user->save();
        $transactions                  = new Transaction();
        $transactions->user_id        = $user->id;
        $transactions->amount          = $commissionamt;
        $transactions->post_balance    = $user->balance;
        $transactions->charge          = 0;
        $transactions->trx_type        = '+';
        $transactions->details         = 'Commission for remittance cash payment ' . $request->mtcn;
        $transactions->remark          = 'send_money_payment';
        $transactions->trx             = getTrx();
        $transactions->save();
        
         $sendMoney->status         = 2;
         $sendMoney->payout_by         = $user->username;
        $sendMoney->admin_feedback = "Money Collected at agent";
        $sendMoney->agent_id = $user->id;
        $sendMoney->save();
         notify($user, 'SEND_MONEY_RECEIVED', [
            'trx'                => $sendMoney->trx,
            'sending_country'    => $sendMoney->sending_country,
            'sending_amount'     => showAmount($sendMoney->sending_amount),
            'sending_currency'   => $sendMoney->sending_currency,
            'recipient_country' => $sendMoney->recipient_country,
            'recipient_amount'   => showAmount($sendMoney->recipient_amount),
            'recipient_currency' => $sendMoney->recipient_currency,
        ]);
              
              $result = array(
                    "status" => "success"
                );
          } else {
              $result = array(
                    "status" => "error"
                );
          }
            echo json_encode($result);
          
     }
     
     
     
     public function verifyotp(Request $request){
          $otp = Vcard::where('card_hash', $request->card_hash)->first();
          if($otp->ver_code == $request->ver_code){
              $result = array(
                    "status" => "success"
                );
          } else {
              $result = array(
                    "status" => "error"
                );
          }
            echo json_encode($result);
          
     }
     
     public function processcard(Request $request){
         $general = GeneralSetting::first();
         $card = Vcard::where('card_pan', $request->card_pan)->first();
         $exp = $request->month.$request->year;
         if(!$card){
             $notify[]=['error','Sorry! Invalid Card Number'];
            return back()->withNotify($notify)->withInput(); 
         }
         if($card->cvv != $request->cvv){
              $notify[]=['error','Sorry! Security code invalid'];
            return back()->withNotify($notify)->withInput(); 
         }
         if($card->expiration != $exp){
              $notify[]=['error','Sorry! Invalid Expiration Date'];
            return back()->withNotify($notify)->withInput(); 
         }
         
        $user = User::where('id',$card->user_id)->first();
       
        $paylink = $request->paylink;
        $paylinks = Paylink::where('paylink',$paylink)->first();
         $general = GeneralSetting::first();
         $pgfee = $general->pg_fee;
         
        if($paylinks->currency != $general->cur_text){
        $frate = Fiat::where('code',$paylinks->currency)->first();
         
        $rate = $frate->rate;
        $debitamount = showAmount($paylinks->amount / $rate);
        $fees = $debitamount * $pgfee / 100;
        
        } else {
            
        $debitamount = showAmount($paylinks->amount);
        $fees = $debitamount * $pgfee / 100;
        }
        
         if($debitamount < 0){
          
           $notify[]=['error','Sorry! Amout must be greater than 0'];
            return back()->withNotify($notify)->withInput(); 
      }
        if($debitamount > $user->balance){
            $notify[]=['error','Sorry! insufficient balance in this wallet'];
            return back()->withNotify($notify)->withInput(); 
        }
        $merchant_id = $paylinks->merchant_id;
        $receiver = User::where('id',$paylinks->merchant_id)->first();
        $trx = getTrx();
        $merchant = $receiver->company ? $receiver->company :  $receiver->firstname.$receiver->lastname;
    $user->balance -= $debitamount;
    $user->save();

    $transaction = new Transaction();
    $transaction->user_id = $user->id;
    $transaction->amount = $debitamount;
    $transaction->post_balance = $user->balance;
    $transaction->charge = 00;
    $transaction->trx_type = '-';
    $transaction->merchantid = $receiver->ewallet_id;
    $transaction->category = "card";
    $transaction->merchant = $merchant;
    $transaction->mcc = $receiver->mcc ? $receiver->mcc : 0;
    $transaction->details = 'Card Payment To '.$paylinks->merchant_email.' amount '.$debitamount.' successful';
    $transaction->trx =  $trx;
    $transaction->save();
    
    $rtrx = getTrx();
    $receiver->balance += $debitamount;
    $receiver->save();

    $transaction = new Transaction();
    $transaction->user_id = $receiver->id;
    $transaction->amount = $debitamount;
    $transaction->post_balance = $receiver->balance;
    $transaction->charge = 00;
    $transaction->trx_type = '+';
    $transaction->details = 'Card Payment from '.$user->email.' amount '.$debitamount.' successful';
    $transaction->trx =  $rtrx;
    $transaction->save();
    
    $rftrx = getTrx();
     $receiver->balance -= $fees;
    $receiver->save();

    $transaction = new Transaction();
    $transaction->user_id = $receiver->id;
    $transaction->amount = $fees;
    $transaction->post_balance = $receiver->balance;
    $transaction->charge = 00;
    $transaction->trx_type = '-';
    $transaction->details = 'Fee for card payment from'.$user->email.' transaction id '.$rtrx;
    $transaction->trx =  $rftrx;
    $transaction->save();
    
    
    $paylinks->status = "completed";
    $paylinks->user_id = $user->id;
    $paylinks->updated_at = date_format(Carbon::now(),"Y-m-d H:i:s");
    $paylinks->save();
    
    $params=array(
        "code" => 200,
        "status" => "success",
        "txn_ref" => $paylinks->trx,
        "merchant_ref" => $paylinks->merchant_ref,
    );
    $params = http_build_query($params) . "\n";
   return redirect()->away($paylinks->return_url."?".$params);
        
         
     }
     
      public function poscard(Request $request){
         $general = GeneralSetting::first();
         $card = Vcard::where('card_pan', $request->card_pan)->first();
         $exp = $request->month.$request->year;
         if(!$card){
             $notify[]=['error','Sorry! Invalid Card Number'];
            return back()->withNotify($notify)->withInput(); 
         }
         if($card->cvv != $request->cvv){
              $notify[]=['error','Sorry! Security code invalid'];
            return back()->withNotify($notify)->withInput(); 
         }
         if($card->expiration != $exp){
              $notify[]=['error','Sorry! Invalid Expiration Date'];
            return back()->withNotify($notify)->withInput(); 
         }
         
        $user = User::where('id',$card->user_id)->first();
       
        
         $general = GeneralSetting::first();
         $pgfee = $general->pg_fee;
         
       
        $debitamount = round($request->amount);
        $fees = round($debitamount * $pgfee / 100);
       
         if($debitamount < 0){
          
           $notify[]=['error','Sorry! Amout must be greater than 0'];
            return back()->withNotify($notify)->withInput(); 
      }
        
        
        if($debitamount > $user->balance){
            $notify[]=['error','Sorry! insufficient balance in this wallet'];
            return back()->withNotify($notify)->withInput(); 
        }
      
        $receiver = auth()->user();
        $merchant_id = $receiver->id;
        $trx = getTrx();
        $merchant = $receiver->company ? $receiver->company :  $receiver->firstname.$receiver->lastname;
    $user->balance -= $debitamount;
    $user->save();

    $transaction = new Transaction();
    $transaction->user_id = $user->id;
    $transaction->amount = $debitamount;
    $transaction->post_balance = $user->balance;
    $transaction->charge = 00;
    $transaction->trx_type = '-';
    $transaction->merchantid = $receiver->ewallet_id;
    $transaction->category = "card";
    $transaction->merchant = $merchant;
    $transaction->mcc = $receiver->mcc ? $receiver->mcc : 0;
    $transaction->details = 'Card Payment To '.$receiver->email.' amount '.$debitamount.' successful';
    $transaction->trx =  $trx;
    $transaction->save();
    
    $rtrx = getTrx();
    $receiver->balance += $debitamount;
    $receiver->save();

    $transaction = new Transaction();
    $transaction->user_id = $receiver->id;
    $transaction->amount = $debitamount;
    $transaction->post_balance = $receiver->balance;
    $transaction->charge = 00;
    $transaction->trx_type = '+';
    $transaction->details = 'Card Payment from '.$user->email.' amount '.$debitamount.' successful';
    $transaction->trx =  $rtrx;
    $transaction->save();
    
    $rftrx = getTrx();
     $receiver->balance -= $fees;
    $receiver->save();

    $transaction = new Transaction();
    $transaction->user_id = $receiver->id;
    $transaction->amount = $fees;
    $transaction->post_balance = $receiver->balance;
    $transaction->charge = 00;
    $transaction->trx_type = '-';
    $transaction->details = 'Fee for card payment from'.$user->email.' transaction id '.$rtrx;
    $transaction->trx =  $rftrx;
    $transaction->save();
    
     $notify[] = ['Success','Card Transaction Processed'];
     return back()->withNotify($notify);
        
         
     }
     
     public function gettrx(Request $request){
      $apikey = $request->header('API-KEY');
      $merchant_email = $request['merchant_email'];
      $order_ref = $request['merchant_ref'];
      $token = base64_decode($request->header('token'));
      $trxss = $request['trx'];
      $general = GeneralSetting::first();
      if($general->merchant_key != $apikey){
          $result = array(
             "code" => 409,
             "status" => "error",
             "message" => "API KEY ERROR"
         );
            http_response_code(409);
         echo json_encode($result);
         exit;
      }
     
      $exist = User::where('username',$merchant_email)->orWhere('email',$merchant_email)->first();
      if(!$exist){
         $result = array(
             "code" => 401,
             "status" => "error",
             "message" => "No Merchant Found"
         );
           http_response_code(401);
         echo json_encode($result);
          exit;
      }
       $trx = Paylink::where('trx',$token)->first();
       if(!$trx){
         $result = array(
             "code" => 409,
             "status" => "error",
             "message" => "Invalid Token"
         );
           http_response_code(409);
         echo json_encode($result);
          exit;
      }
      
      $trxs = Paylink::where('trx',$trxss)->where('merchant_email',$merchant_email)->where('merchant_ref',$order_ref)->first();
     if(!$trxs){
         $result = array(
             "code" => 409,
             "status" => "error",
             "message" => "Transaction Not Found"
         );
           http_response_code(409);
         echo json_encode($result);
          exit;
      }
 $receiver = User::where('id',$trxs->user_id)->first();       
    if(isset($receiver->email)){ 
        $user = $receiver->email; 
        
    } else { 
        $user = null;
        
    }
    $params=array(
        "code" => 200,
        "status" => $trxs->status,
        "data" => array(
            "txn_ref" => $trxs->trx,
            "merchant_ref" => $trxs->merchant_ref,
            "amount" => $trxs->amount,
            "currency" => $trxs->currency,
            "user" => $user,
            "paylink" => "https://gammer.xenio.in/pay?paylink=".$trxs->paylink
        )
    );
      http_response_code(200);
   echo json_encode($params, JSON_UNESCAPED_SLASHES);
        
     }
     
     public function payconfirm(Request $request){
         $pageTitle = "Payment Confirmation";
         $user = $request->user();
         $paylink = $request->paylink;
        $paylink = Paylink::where('paylink',$paylink)->first();
         $general = GeneralSetting::first();
        if($paylink->currency != $general->cur_text){
        $frate = Fiat::where('code',$paylink->currency)->first();
       
        $rate = $frate->rate;
        $debitamount = $paylink->amount / $rate;
        
        } else {
            
        $debitamount = $paylink->amount;
        }
        
        return view(activeTemplate() . 'user.pg.confirm', compact('pageTitle','paylink','debitamount', 'user', 'general'));
     }
     
     public function linkpay(Request $request){
     $pageTitle = "Process Payment";
        $paylink = $request->paylink;
        $general = GeneralSetting::first();
        $paylinks = Paylink::where('paylink',$paylink)->first();
        if($paylinks->currency != $general->cur_text){
        $frate = Fiat::where('code',$paylinks->currency)->first();
        
        if(isset($frate->rate)){
        $rate = $frate->rate;
        $debitamount = showAmount($paylinks->amount / $rate);
        } else {
         $frate = Crypto::where('code',$paylinks->currency)->first();
         $rate = $frate->rate;
        $debitamount = $paylinks->amount / $rate;
        }
        
        } else {
            
        $debitamount = showAmount($paylinks->amount);
        
        }
        
//        if($paylinks->status == "completed"){
//            echo "<h2>Payment Already Completed. Check Link</h2>";
//            exit;
//        }
        
        $gatewayCurrency = GatewayCurrency::whereHas('method', function ($gate) {
            $gate->where('status', 1)->where('code','<',500);
            
        })->where('currency', $paylinks->currency)->with('method')->orderby('method_code')->get();
        return view(activeTemplate() . 'user.pg.payment.deposit', compact('pageTitle','paylinks','debitamount', 'gatewayCurrency'));    
     }
   
     public function deposit(Request $request){
         {
         
        $request->validate([
            'amount' => 'required|numeric|gt:0',
            'method_code' => 'required',
            'currency' => 'required',
        ]);
        $merchant_id = $request->merchant_id;
        $user = User::where('id',$request->merchant_id)->first();

        
        $gate = GatewayCurrency::whereHas('method', function ($gate) {
            $gate->where('status', 1);
        })->where('method_code', $request->method_code)->where('currency', $request->currency)->first();
        if (!$gate) {
            $notify[] = ['error', 'Invalid gateway'];
            return back()->withNotify($notify);
        }

        if ($gate->min_amount > $request->amount || $gate->max_amount < $request->amount) {
            $notify[] = ['error', 'Please follow deposit limit'];
            return back()->withNotify($notify);
        }

        $charge = $gate->fixed_charge + ($request->amount * $gate->percent_charge / 100);
        $payable = $request->amount + $charge;
        $final_amo = $payable * $gate->rate;

        $data = new Deposit();
        $data->user_id = $user->id;
        $data->method_code = $gate->method_code;
        $data->method_currency = strtoupper($gate->currency);
        $data->amount = $request->amount;
        $data->charge = $charge;
        $data->rate = $gate->rate;
        $data->final_amo = $final_amo;
        $data->btc_amo = 0;
        $data->btc_wallet = "";
        $data->trx = getTrx();
        $data->try = 0;
        $data->status = 0;
        $data->dp = $request->dp;
        $data->save();
        session()->put('Track', $data->trx);
        return redirect()->route('pg.deposit.preview');
    }
     }
     public function depositPreview()
    {

        $track = session()->get('Track');
        $data = Deposit::where('trx', $track)->where('status',0)->orderBy('id', 'DESC')->firstOrFail();
        $pageTitle = 'Payment Preview';
        return view($this->activeTemplate . 'user.pg.payment.preview', compact('data', 'pageTitle'));
    }
    
    public function depositConfirm()
    {
        $track = session()->get('Track');
        $deposit = Deposit::where('trx', $track)->where('status',0)->orderBy('id', 'DESC')->with('gateway')->firstOrFail();
        
        if ($deposit->method_code >= 1000) {
            $this->userDataUpdate($deposit);
            $notify[] = ['success', 'Your deposit request is queued for approval.'];
            return back()->withNotify($notify);
        }


        $dirName = $deposit->gateway->alias;
        $new = __NAMESPACE__ . '\\Gateway\\' . $dirName . '\\ProcessController';

        $data = $new::newprocess($deposit);
        $data = json_decode($data);
        $user = User::where('id',$deposit->user_id)->first();
        
        if (isset($data->error)) {
            $notify[] = ['error', $data->message];
            return redirect()->route(gatewayRedirectUrl())->withNotify($notify);
        }
        if (isset($data->redirect)) {
            return redirect($data->redirect_url);
        }

        // for Stripe V3
        if(@$data->session){
            $deposit->btc_wallet = $data->session->id;
            $deposit->save();
        }

        $pageTitle = 'Payment Confirm';
        return view($this->activeTemplate . $data->view, compact('data','user', 'pageTitle', 'deposit'));
    }
    
    public static function userDataUpdate($trx)
    {
        $general = GeneralSetting::first();
        $data = Deposit::where('trx', $trx)->first();
        if ($data->status == 0) {
            $data->status = 1;
            $data->save();

            $user = User::find($data->user_id);
            $user->balance += $data->amount;
            $user->save();

            $transaction = new Transaction();
            $transaction->user_id = $data->user_id;
            $transaction->amount = $data->amount;
            $transaction->post_balance = $user->balance;
            $transaction->charge = $data->charge;
            $transaction->trx_type = '+';
            $transaction->details = 'Deposit Via ' . $data->gatewayCurrency()->name;
            $transaction->trx = $data->trx;
            $transaction->save();

            $adminNotification = new AdminNotification();
            $adminNotification->user_id = $user->id;
            $adminNotification->title = 'Deposit successful via '.$data->gatewayCurrency()->name;
            $adminNotification->click_url = urlPath('admin.deposit.successful');
            $adminNotification->save();

            notify($user, 'DEPOSIT_COMPLETE', [
                'method_name' => $data->gatewayCurrency()->name,
                'method_currency' => $data->method_currency,
                'method_amount' => showAmount($data->final_amo),
                'amount' => showAmount($data->amount),
                'charge' => showAmount($data->charge),
                'currency' => $general->cur_text,
                'rate' => showAmount($data->rate),
                'trx' => $data->trx,
                'post_balance' => showAmount($user->balance)
            ]);


        }
    }
    
     //Login validation
      public function showLoginForm(Request $request)
    {

        $pageTitle = "Sign In";
        $paylink = $request->paylink;
        $paylinks = Paylink::where('paylink',$paylink)->first();
        if($paylinks->status == "completed"){
            echo "<h2>Payment Already Completed. Check Link</h2>";
            exit;
        }
        return view(activeTemplate() . 'user.pg.login', compact('pageTitle','paylink'));
    }
    
    
    public function login(Request $request)
    {
 
       

        $credentials = request([$this->username, 'password']);
        if(!Auth::attempt($credentials)){
             $notify[] = ['error', 'Invalid Username / Password'];
            return back()->withNotify($notify);
            exit;
        }

        $user = $request->user();
        $tokenResult = $user->createToken('auth_token')->plainTextToken;
        $this->authenticated($request,$user);
        $notify[] = ['success', 'Login Successful'];
        $id = array(
            "paylink" => $request->paylink
        );
        return redirect()->route('user.pg.confirm',$id)->withNotify($notify);
        
    }
    
   
    
     protected function validateLogin(Request $request)
    {
        $customRecaptcha = Extension::where('act', 'custom-captcha')->where('status', 1)->first();
        $validation_rule = [
            $this->username() => 'required|string',
            'password' => 'required|string',
        ];

        if ($customRecaptcha) {
            $validation_rule['captcha'] = 'required';
        }

        $request->validate($validation_rule);

    }
      public function findUsername()
    {
        $login = request()->input('username');

        $fieldType = filter_var($login, FILTER_VALIDATE_EMAIL) ? 'email' : 'username';
        request()->merge([$fieldType => $login]);
        return $fieldType;
    }
     
     public function manualDepositConfirm()
    {
        $track = session()->get('Track');
        $data = Deposit::with('gateway')->where('status', 0)->where('trx', $track)->first();
        if (!$data) {
            return redirect()->route(gatewayRedirectUrl());
        }
        if ($data->method_code > 999) {

            $pageTitle = 'Deposit Confirm';
            $method = $data->gatewayCurrency();
            return view($this->activeTemplate . 'user.pg.manual_confirm', compact('data', 'pageTitle', 'method'));
        }
        abort(404);
    }

    public function manualDepositUpdate(Request $request)
    {
        $track = session()->get('Track');
        $data = Deposit::with('gateway')->where('status', 0)->where('trx', $track)->first();
        if (!$data) {
            return redirect()->route(gatewayRedirectUrl());
        }

        $params = json_decode($data->gatewayCurrency()->gateway_parameter);

        $rules = [];
        $inputField = [];
        $verifyImages = [];

        if ($params != null) {
            foreach ($params as $key => $custom) {
                $rules[$key] = [$custom->validation];
                if ($custom->type == 'file') {
                    array_push($rules[$key], 'image');
                    array_push($rules[$key], new FileTypeValidate(['jpg','jpeg','png']));
                    array_push($rules[$key], 'max:2048');

                    array_push($verifyImages, $key);
                }
                if ($custom->type == 'text') {
                    array_push($rules[$key], 'max:191');
                }
                if ($custom->type == 'textarea') {
                    array_push($rules[$key], 'max:300');
                }
                $inputField[] = $key;
            }
        }
        $this->validate($request, $rules);


        $directory = date("Y")."/".date("m")."/".date("d");
        $path = imagePath()['verify']['deposit']['path'].'/'.$directory;
        $collection = collect($request);
        $reqField = [];
        if ($params != null) {
            foreach ($collection as $k => $v) {
                foreach ($params as $inKey => $inVal) {
                    if ($k != $inKey) {
                        continue;
                    } else {
                        if ($inVal->type == 'file') {
                            if ($request->hasFile($inKey)) {
                                try {
                                    $reqField[$inKey] = [
                                        'field_name' => $directory.'/'.uploadImage($request[$inKey], $path),
                                        'type' => $inVal->type,
                                    ];
                                } catch (\Exception $exp) {
                                    $notify[] = ['error', 'Could not upload your ' . $inKey];
                                    return back()->withNotify($notify)->withInput();
                                }
                            }
                        } else {
                            $reqField[$inKey] = $v;
                            $reqField[$inKey] = [
                                'field_name' => $v,
                                'type' => $inVal->type,
                            ];
                        }
                    }
                }
            }
            $data->detail = $reqField;
        } else {
            $data->detail = null;
        }



        $data->status = 2; // pending
        $data->save();


        $adminNotification = new AdminNotification();
        $adminNotification->user_id = $data->user->id;
        $adminNotification->title = 'Deposit request from '.$data->user->username;
        $adminNotification->click_url = urlPath('admin.deposit.details',$data->id);
        $adminNotification->save();

        $general = GeneralSetting::first();
        notify($data->user, 'DEPOSIT_REQUEST', [
            'method_name' => $data->gatewayCurrency()->name,
            'method_currency' => $data->method_currency,
            'method_amount' => showAmount($data->final_amo),
            'amount' => showAmount($data->amount),
            'charge' => showAmount($data->charge),
            'currency' => $general->cur_text,
            'rate' => showAmount($data->rate),
            'trx' => $data->trx
        ]);

        $notify[] = ['success', 'You have deposit request has been taken.'];
        return redirect()->route('user.deposit.history')->withNotify($notify);
    }
    
}