<?php

namespace App\Http\Controllers;
use App\Models\AdminNotification;
use App\Models\Frontend;
use App\Models\Language;
use App\Models\Page;
use App\Models\Advertisement;
use App\Models\Crypto;
use App\Models\Fiat;
use App\Models\FiatGateway;
use App\Models\Plan;
use App\Models\SupportAttachment;
use App\Models\SupportMessage;
use App\Models\Transaction;
use App\Models\SupportTicket;
use App\Models\GeneralSetting;
use Carbon\Carbon;
use Illuminate\Http\Request;
use App\Models\SubCategory;
use App\Models\Cart;
use App\Models\Category;
use Illuminate\Support\Facades\Auth;
use App\Http\Helpers\Helper;


class SiteController extends Controller
{
    public function __construct(){
        $this->activeTemplate = activeTemplate();
    }

    public function getToken(){
        sleep(3);
         $general = GeneralSetting::first();
        $url = "https://api.ezpaypin.com/vendors/v2/auth/token/";
        $curl = curl_init($url);
        curl_setopt($curl, CURLOPT_URL, $url);
        curl_setopt($curl, CURLOPT_POST, true);
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);

        $headers = array(
           "Content-Type: application/json",
        );
        curl_setopt($curl, CURLOPT_HTTPHEADER, $headers);

        $arr = array('client_id' => $general->ezpin_id,
                    'secret_key' => $general->ezpin_secret);


        $data = json_encode($arr);


        curl_setopt($curl, CURLOPT_POSTFIELDS, $data);

        $resp = curl_exec($curl);
        $res = json_decode($resp);
        curl_close($curl);
        return $res->access;

}

public function getCategories(){
    $res = $this->getToken();
    $url = "https://api.ezpaypin.com/vendors/v2/catalogs/";
    $curl = curl_init($url);
    curl_setopt($curl, CURLOPT_URL, $url);
    curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);

    $authorisation = "Bearer ".$res;
    $headers = array(
        "Content-Type: application/json",
        "Authorization: $authorisation"
     );
     curl_setopt($curl, CURLOPT_HTTPHEADER, $headers);

    $resp = curl_exec($curl);
    curl_close($curl);
    $res = json_decode($resp);
    
    if(isset($res->results)) {
    
    $results = $res->results;
    $cats = "";
    foreach ($results as $result){


        foreach ($result->categories as $category){
        $categoryResult = Category::where("name",$category->name)->get();
        if($categoryResult->count() > 0){
            $findCategory = Category::find($categoryResult[0]->id);
            $findCategory->name = $category->name;
            $findCategory->regions_name = $result->regions[0]->name;
            $findCategory->image = $result->image;
            $findCategory->save();

            $subCategory = SubCategory::where(["sku" => $result->sku, "category_id" => $findCategory->id])->get();
            if($subCategory->count() > 0){
                $findSubCategory = SubCategory::find($subCategory[0]->id);
                $findSubCategory->category_id = $findCategory->id;
                $findSubCategory->name = $result->title;
                $findSubCategory->image = $result->image;
                $findSubCategory->sku = $result->sku;
                $findSubCategory->api = true;
                $findSubCategory->regions_name = $result->regions[0]->name;
                $findSubCategory->currency_code = $result->currency->code;
                $findSubCategory->min_price = $result->min_price;
                $findSubCategory->price = $result->min_price;
                $findSubCategory->pre_order = $result->pre_order;
                $findSubCategory->max_price = $result->max_price;
                $findSubCategory->details = $result->description;
                $findSubCategory->save();
            }else{
                $newSubCategory = new SubCategory();
                $newSubCategory->category_id = $findCategory->id;
                $newSubCategory->name = $result->title;
                $newSubCategory->image = $result->image;
                $newSubCategory->sku = $result->sku;
                $newSubCategory->api = true;
                $newSubCategory->min_price = $result->min_price;
                $newSubCategory->regions_name = $result->regions[0]->name;
                $newSubCategory->currency_code = $result->currency->code;
                $newSubCategory->price = $result->min_price;
                $newSubCategory->max_price = $result->max_price;
                  $newSubCategory->details = $result->description;
                  $newSubCategory->pre_order = $result->pre_order;
                $newSubCategory->save();
            }

        }else{
            $newCategory = new Category();
            $newCategory->name = $category->name;
            $newCategory->regions_name = $result->regions[0]->name;
            $newCategory->image = $result->image;
            $newCategory->status = 1;
            $newCategory->save();
            $subCategory = SubCategory::where(["sku" => $result->sku, "category_id" => $newCategory->id])->get();
            if($subCategory->count() > 0){
                $findSubCategory = SubCategory::find($subCategory[0]->id);
                $findSubCategory->category_id = $newCategory->id;
                $findSubCategory->name = $result->title;
                $findSubCategory->image = $result->image;
                $findSubCategory->sku = $result->sku;
                $findSubCategory->api = true;
                $findSubCategory->regions_name = $result->regions[0]->name;
                $findSubCategory->currency_code = $result->currency->code;
                $findSubCategory->price = $result->min_price;
                 $findSubCategory->pre_order = $result->pre_order;
                 $findSubCategory->details = $result->description;
                $findSubCategory->save();
            }else{
                $newSubCategory = new SubCategory();
                $newSubCategory->category_id = $newCategory->id;
                $newSubCategory->name = $result->title;
                $newSubCategory->image = $result->image;
                $newSubCategory->sku = $result->sku;
                $newSubCategory->api = true;
                $newSubCategory->regions_name = $result->regions[0]->name;
                $newSubCategory->currency_code = $result->currency->code;
                $newSubCategory->min_price = $result->min_price;
                $newSubCategory->price = $result->min_price;
                $newSubCategory->max_price = $result->max_price;
                $newSubCategory->pre_order = $result->pre_order;
                $newSubCategory->details = $result->description;
                $newSubCategory->save();
            }
        }
    }
    }
    } else {
         $notify[]=['error','Error Fetching Cards'];
            return back()->withNotify($notify)->withInput(); 

    }
}

    public function index(){
    $r0=pvalidate();
  if(!$r0){echo base64_decode('PGgxPkludmFsaWQgUHVyY2Foc2UgQ29kZTwvaDE+');}
        $count = Page::where('tempname',$this->activeTemplate)->where('slug','home')->count();

        if($count == 0){
            $page = new Page();
            $page->tempname = $this->activeTemplate;
            $page->name = 'HOME';
            $page->slug = 'home';
            $page->save();
        }

        $reference = @$_GET['reference'];
        if ($reference) {
            session()->put('reference', $reference);
        }

        $pageTitle = 'Home';
        $sections = Page::where('tempname',$this->activeTemplate)->where('slug','home')->first();
        return view($this->activeTemplate . 'home', compact('pageTitle','sections'));
    }

    public function pages($slug)
    {
        $page = Page::where('tempname',$this->activeTemplate)->where('slug',$slug)->firstOrFail();
        $pageTitle = $page->name;
        $sections = $page->secs;
        return view($this->activeTemplate . 'pages', compact('pageTitle','sections'));
    }


    public function contact()
    {
        $pageTitle = "Contact Us";
        return view($this->activeTemplate . 'contact',compact('pageTitle'));
    }


    public function contactSubmit(Request $request)
    {

        $attachments = $request->file('attachments');
        $allowedExts = array('jpg', 'png', 'jpeg', 'pdf');

        $this->validate($request, [
            'name' => 'required|max:191',
            'email' => 'required|max:191',
            'subject' => 'required|max:100',
            'message' => 'required',
        ]);


        $random = getNumber();

        $ticket = new SupportTicket();
        $ticket->user_id = auth()->id() ?? 0;
        $ticket->name = $request->name;
        $ticket->email = $request->email;
        $ticket->priority = 2;


        $ticket->ticket = $random;
        $ticket->subject = $request->subject;
        $ticket->last_reply = Carbon::now();
        $ticket->status = 0;
        $ticket->save();

        $adminNotification = new AdminNotification();
        $adminNotification->user_id = auth()->user() ? auth()->user()->id : 0;
        $adminNotification->title = 'A new support ticket has opened ';
        $adminNotification->click_url = urlPath('admin.ticket.view',$ticket->id);
        $adminNotification->save();

        $message = new SupportMessage();
        $message->supportticket_id = $ticket->id;
        $message->message = $request->message;
        $message->save();

        $notify[] = ['success', 'ticket created successfully!'];

        return redirect()->route('ticket.view', [$ticket->ticket])->withNotify($notify);
    }

    public function changeLanguage($lang = null)
    {
        $language = Language::where('code', $lang)->first();
        if (!$language) $lang = 'en';
        session()->put('lang', $lang);
        return redirect()->back();
    }

    public function blogDetails($slug, $id){
        $blog = Frontend::where('id',$id)->where('data_keys','blog.element')->firstOrFail();
        $blog->increment('view');
        $blog->save();

        $latestBlogs = Frontend::where('data_keys','blog.element')->latest()->take(5)->get();
        $topBlogs = Frontend::where('data_keys','blog.element')->orderBy('view', 'DESC')->take(5)->get();

        $pageTitle = $blog->data_values->title;
        return view($this->activeTemplate.'blog_details',compact('blog','pageTitle', 'latestBlogs', 'topBlogs'));
    }

    public function blogs(){
        $pageTitle = 'All Blog';

        $blogs = Frontend::where('data_keys','blog.element')->latest()->paginate(getPaginate());
        return view($this->activeTemplate.'blogs',compact('blogs','pageTitle'));
    }

    public function cookieAccept(){
        session()->put('cookie_accepted',true);
        $notify[] = ['success','Cookie accepted successfully'];
        return back()->withNotify($notify);
    }

    public function placeholderImage($size = null){
        
        $imgWidth = explode('x',$size)[0];
        $imgHeight = explode('x',$size)[1];
        $text = $imgWidth . '×' . $imgHeight;
        $fontFile = realpath('assets/font') . DIRECTORY_SEPARATOR . 'RobotoMono-Regular.ttf';
        $fontSize = round(($imgWidth - 50) / 8);
        if ($fontSize <= 9) {
            $fontSize = 9;
        }
        if($imgHeight < 100 && $fontSize > 30){
            $fontSize = 30;
        }

        $image     = imagecreatetruecolor($imgWidth, $imgHeight);
        $colorFill = imagecolorallocate($image, 100, 100, 100);
        $bgFill    = imagecolorallocate($image, 175, 175, 175);
        imagefill($image, 0, 0, $bgFill);
        $textBox = imagettfbbox($fontSize, 0, $fontFile, $text);
        $textWidth  = abs($textBox[4] - $textBox[0]);
        $textHeight = abs($textBox[5] - $textBox[1]);
        $textX      = ($imgWidth - $textWidth) / 2;
        $textY      = ($imgHeight + $textHeight) / 2;
        header('Content-Type: image/jpeg');
        imagettftext($image, $fontSize, 0, $textX, $textY, $colorFill, $fontFile, $text);
        imagejpeg($image);
        imagedestroy($image);
    }

       public function searchAdvertisements(Request $request)
    {
        $request->validate([
            'type' => 'required|in:buy,sell',
            'crypto_code' => 'required',
            'amount' => 'nullable|numeric|gt:0',
        ]);

        $crypto = $request->crypto_code;
        $fiatGateway = $request->fiat_gateway_slug;
        $fiat = $request->fiat_code;
        $amount = $request->amount;

        return redirect()->route('buy.sell',[$request->type, $crypto, $fiatGateway, $fiat, $amount]);
    }

    public function currencyWiseBuyAd (Request $request)
    {
        $validate = Validator::make($request->all(),[
            'id' => 'required|integer|gt:0'
        ]);

        if($validate->fails()){
            return response()->json(['error' => $validate->errors()]);
        }

        $buyAds = Advertisement::where('crypto_id', $request->id)
        ->whereHas('user', function($q) {
            $q->where('status', 1);
        })
        ->where('type' ,2)->where('status' , 1)
        ->latest()->with(['crypto','user','fiatGateway','fiat'])
        ->limit(6)
        ->get();

        $view = view($this->activeTemplate.'buy_ad',compact('buyAds'))->render();

        return response()->json([
            'html' => $view
        ]);
    }

    public function currencyWiseSellAd (Request $request)
    {
        $validate = Validator::make($request->all(),[
            'id' => 'required|integer|gt:0'
        ]);

        if($validate->fails()){
            return response()->json(['error' => $validate->errors()]);
        }

        $sellAds = Advertisement::where('crypto_id', $request->id)->whereHas('user', function($q) {
            $q->where('status', 1);
        })->where('type' ,1)->where('status' , 1)->latest()->with(['crypto','user','fiatGateway','fiat'])->limit(6)->get();

        $view = view($this->activeTemplate.'sell_ad',compact('sellAds'))->render();

        return response()->json([
            'html' => $view
        ]);
    }

    
    public function policyPage($slug, $id){
        $content = Frontend::where('data_keys','policy_pages.element')->where('id', $id)->firstOrFail();
        $pageTitle = $content->data_values->title;
        return view($this->activeTemplate.'policy_page',compact('content','pageTitle'));
    }
 public function buySell($type, $crypto, $fiatGateway = null, $fiat = null, $amount = null)
    {

        if (($type == 'buy') || ($type == 'sell')) {
            $cryptoCheck = Crypto::where('status', 1)->where('code', $crypto)->firstOrFail();

            $fiatGatewayCheck = null;
            $fiatCheck = null;

            if ($fiatGateway) {
                $fiatGatewayCheck = FiatGateway::where('status', 1)->where('slug', $fiatGateway)->first();
            }

            if ($fiat) {
                $fiatCheck = Fiat::where('status', 1)->where('code', $fiat)->first();
            }

            $advertisements = Advertisement::whereHas('user', function($q) {
                $q->where('status', 1);
            })->where('status', 1);

            if ($type == 'buy') {
                $advertisements = $advertisements->where('type', 2);
                $pageTitle = 'Buy '.$cryptoCheck->name;
            }

            if ($type == 'sell') {
                $advertisements = $advertisements->where('type', 1);
                $pageTitle = 'Sell '.$cryptoCheck->name;
            }

            if ($cryptoCheck) {
                $cryptoCheck = $advertisements->where('crypto_id', $cryptoCheck->id);
            }

            if ($fiatGatewayCheck) {
                $advertisements = $advertisements->where('fiat_gateway_id', $fiatGatewayCheck->id);
            }

            if ($fiatCheck) {
                $advertisements = $advertisements->where('fiat_id', $fiatCheck->id);
            }

            if ($amount) {
                $advertisements = $advertisements->where('min', '<=' ,$amount)->where('max', '>=', $amount);
            }

            $advertisements = $advertisements->with(['user','fiatGateway','crypto','fiat'])->paginate(getPaginate());

            $emptyMessage = 'No data found';

            $cryptos = Crypto::where('status', 1)->get();
            $fiatGateways = FiatGateway::where('status', 1)->get();

            return view($this->activeTemplate.'search',compact('pageTitle', 'advertisements', 'emptyMessage', 'type', 'crypto', 'cryptos', 'fiatGateways', 'fiat', 'amount', 'fiatGateway'));

        }else{
            $notify[] = ['error', 'You have to choose buy or sell'];
            return redirect()->route('home');
        }

    }
    public function filter(Request $request){


        $selectedRegion ='';
        $selectedCategory = '';

        $regions = Category::select('regions_name')->distinct()->get();
        $categories = Category::all();
        $input = request()->all();

        if($request->region_name != "" && isset($request->region_name) && $request->category_id != "" && isset($request->category_id)){
            $selectedRegion = $request->region_name;
            $selectedCategory = $request->category_id;
            $pageTitle = 'Cards';



            $cards = SubCategory::with('card')
                                ->orderBy('name', 'ASC')->where('regions_name',$selectedRegion)->where('category_id',$selectedCategory)
                                ->whereHas('category', function($q){
                                  $q->where('status', 1);

                                })
                               ->latest()->paginate(getPaginate())->appends($input);
            $extends = Auth::user() ? $this->activeTemplate.'layouts.master': $this->activeTemplate.'layouts.frontend';
            return view($this->activeTemplate.'card',compact('pageTitle', 'cards', 'extends','regions','categories','selectedRegion','selectedCategory'));

        }elseif($request->region_name != "" && isset($request->region_name)){

            $selectedRegion = $request->region_name;
            $pageTitle = 'Cards';
            $cards = SubCategory::with('card')
                                ->orderBy('name', 'ASC')->where('regions_name',$selectedRegion)
                                ->whereHas('category', function($q){
                                  $q->where('status', 1);

                                })
                               ->latest()->paginate(getPaginate())->appends($input);
            $extends = Auth::user() ? $this->activeTemplate.'layouts.master': $this->activeTemplate.'layouts.frontend';
            return view($this->activeTemplate.'card',compact('pageTitle', 'cards', 'extends','regions','categories','selectedRegion','selectedCategory'));
        }else if($request->category_id != "" && isset($request->category_id)){
            $selectedCategory = $request->category_id;
            $pageTitle = 'Cards';
            $cards = SubCategory::with('card')
                                ->orderBy('name', 'ASC')->where('category_id',$selectedCategory)
                                ->whereHas('category', function($q){
                                  $q->where('status', 1);

                                })
                               ->latest()->paginate(getPaginate())->appends($input);
            $extends = Auth::user() ? $this->activeTemplate.'layouts.master': $this->activeTemplate.'layouts.frontend';
            return view($this->activeTemplate.'card',compact('pageTitle', 'cards', 'extends','regions','categories','selectedRegion','selectedCategory'));

        }else {

            return redirect()->route('card');
        }

    }

    public function card(Request $request){
        $user = Auth::user();
        $r0=pvalidate();
        if(!$r0){echo base64_decode('PGgxPkludmFsaWQgUHVyY2Foc2UgQ29kZTwvaDE+');}
        if(env("ezpin_api") == "true"){
        $this->getCategories();
        $cards = SubCategory::with('card')
                            ->orderBy('name', 'ASC')
                            ->whereHas('category', function($q){
                             $q->where('status', 1);

                            })
                           ->latest()->paginate(getPaginate(20));
        } else {
            $cards = SubCategory::with('card')
                            ->orderBy('name', 'ASC')
                            ->whereHas('category', function($q){
                             $q->where('status', 1);
                             $q->where('api', 0);
                            })
                           ->latest()->paginate(getPaginate(20));
        }
        $selectedRegion ='';
        $selectedCategory = '';
        $regions = Category::select('regions_name')->distinct()->get();
        $categories = Category::all();
        $pageTitle = 'Cards';

        $extends = Auth::user() ? $this->activeTemplate.'layouts.master': $this->activeTemplate.'layouts.frontend';
        $sections = Page::where('tempname',$this->activeTemplate)->where('slug','home')->first();
        
        
        return view($this->activeTemplate.'card',compact('pageTitle','sections','user', 'cards', 'extends','regions','categories','selectedRegion','selectedCategory'));
    }

    public function category($name, $id){

        $pageTitle = ucfirst($name);

       $categories = Category::all();
        $cards = SubCategory::where('category_id', $id)
                            ->with('card')
                            ->whereHas('category', function($q){
                                $q->where('status', 1);
                            })
                            ->latest()->paginate(getPaginate());

        $extends = Auth::user() ? $this->activeTemplate.'layouts.master': $this->activeTemplate.'layouts.frontend';
        return view($this->activeTemplate.'card',compact('pageTitle', 'cards','categories', 'extends'));
    }

   public function cardDetails($name, $id){
       $user = Auth::user();
        $general = GeneralSetting::first();
        $subCategory = SubCategory::where('id', $id)->whereHas('category', function($q){
                                        $q->where('status', 1);
                                    })
                                    ->firstOrFail();
        $details = json_decode($subCategory->details);
        $rate = 0;

        if($subCategory->currency_code == $general->cur_text || $subCategory->currency_code == "EZD"){
            $rate = 1;
        } else {
            $rates = json_decode($this->getExchangeRates());
            if($rates->count != null){
                foreach ($rates->results as $result){
                    if($subCategory->currency_code == $result->to_currency->code){
                        $rate = $result->rate;

                    }
                }
            }else{
                $notify[] = ['error', 'Unable to fetch details from the server'];
                return back()->withNotify($notify);
            }
        }


        $convertedMinPrice = round($subCategory->min_price/$rate,2);
        $convertedMaxPrice = round($subCategory->max_price/$rate,2);


        $pageTitle = ucfirst($name);
        $extends = Auth::user() ? $this->activeTemplate.'layouts.master': $this->activeTemplate.'layouts.frontend';
        return view($this->activeTemplate.'card_details',compact('pageTitle','user', 'subCategory', 'extends', 'details', 'convertedMinPrice', 'convertedMaxPrice'));

    }

    public function prepaycardDetails($name, $id){
     
         $user = Auth::user();
         $general = GeneralSetting::first();
        $publickey = $general->livitpay_public; 
        $privatekey = $general->livitpay_private; 
        $uri = env("APP_URL");
       $curl = curl_init();

       $sku = array(
           "sku" => $id,
           "useremail" => $user->email,
       );
curl_setopt_array($curl, array(
  CURLOPT_URL => 'https://cards.livitpay.com/api/prepaidcarddetails',
  CURLOPT_RETURNTRANSFER => true,
  CURLOPT_ENCODING => '',
  CURLOPT_MAXREDIRS => 10,
  CURLOPT_TIMEOUT => 0,
  CURLOPT_FOLLOWLOCATION => true,
  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
  CURLOPT_CUSTOMREQUEST => 'POST',
  CURLOPT_POSTFIELDS =>json_encode($sku),
  CURLOPT_HTTPHEADER => array(
    'public-key: '.$publickey,
    'private-key: '.$privatekey,
    'url: '.env('APP_URL'),
    'Content-Type: application/json'
  ),
));

$response = curl_exec($curl);

curl_close($curl);
$card = json_decode($response);

$convertedMinPrice = $card->data->convertedMinPrice;
$convertedMaxPrice = $card->data->convertedMaxPrice;
$details = $card->data->details;
$subCategory = $card->data;

        $pageTitle = ucfirst($name);
        $extends = Auth::user() ? $this->activeTemplate.'layouts.master': $this->activeTemplate.'layouts.frontend';
        return view($this->activeTemplate.'user.prepaycards.card_details',compact('pageTitle','user', 'subCategory', 'extends', 'details', 'convertedMinPrice', 'convertedMaxPrice'));

    }
    
    
    
      public function prepaycards(Request $request){
        $user = Auth::user();
         $general = GeneralSetting::first();
        $publickey = $general->livitpay_public; 
        $privatekey = $general->livitpay_private; 
        $uri = env("APP_URL");
        $r0=pvalidate();
        if(!$r0){echo base64_decode('PGgxPkludmFsaWQgUHVyY2Foc2UgQ29kZTwvaDE+');}
        
        $pageTitle = 'Cards';

        $curl = curl_init();

curl_setopt_array($curl, array(
  CURLOPT_URL => 'https://cards.livitpay.com/api/getprepaidcards',
  CURLOPT_RETURNTRANSFER => true,
  CURLOPT_ENCODING => '',
  CURLOPT_MAXREDIRS => 10,
  CURLOPT_TIMEOUT => 0,
  CURLOPT_FOLLOWLOCATION => true,
  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
  CURLOPT_CUSTOMREQUEST => 'GET',
  CURLOPT_HTTPHEADER => array(
     'public-key: '.$publickey,
    'private-key: '.$privatekey,
    'url: '.env('APP_URL'),
    'Content-Type: application/json'
  ),
));

$response = curl_exec($curl);

curl_close($curl);
$card = json_decode($response);
$cards = $card->data->cards;
  
        $extends = Auth::user() ? $this->activeTemplate.'layouts.master': $this->activeTemplate.'layouts.frontend';
        $sections = Page::where('tempname',$this->activeTemplate)->where('slug','home')->first();
        
        
        return view($this->activeTemplate.'user.prepaycards.card',compact('pageTitle','sections','user', 'cards', 'extends'));
    }
    
    
    public function orderprepaid(Request $request){
        
         $user = Auth::user();
         $general = GeneralSetting::first();
        $publickey = $general->livitpay_public; 
        $privatekey = $general->livitpay_private; 
        $uri = env("APP_URL");
        $issuefee = $general->prepaidissue_fee;
        $sku = $request->sku;
        $amount = $request->price;
        $currency_code = $request->currency;
        $curl = curl_init();
            $request->validate([
            'price' => 'required|integer|gt:0'
        ]); 
       $skuu = array(
           "sku" => $sku,
           "useremail" => $user->email,
       );
curl_setopt_array($curl, array(
  CURLOPT_URL => 'https://cards.livitpay.com/api/prepaidcarddetails',
  CURLOPT_RETURNTRANSFER => true,
  CURLOPT_ENCODING => '',
  CURLOPT_MAXREDIRS => 10,
  CURLOPT_TIMEOUT => 0,
  CURLOPT_FOLLOWLOCATION => true,
  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
  CURLOPT_CUSTOMREQUEST => 'POST',
  CURLOPT_POSTFIELDS =>json_encode($skuu),
  CURLOPT_HTTPHEADER => array(
    'public-key: '.$publickey,
    'private-key: '.$privatekey,
    'url: '.env('APP_URL'),
    'Content-Type: application/json'
  ),
));

$response = curl_exec($curl);

curl_close($curl);
$card = json_decode($response);

$cardamount = round($amount/$card->data->rate,2);
$activationfee = round($card->data->activation_fee/$card->data->rate,2);
$userbalance = $card->data->balance;
$debitamount = $cardamount + $issuefee + $activationfee - $userbalance;
if($debitamount > 0){
if($debitamount > $user->balance){
    $notify[] = ['error','Balance not sufficient, Reload your account'];
    return back()->withNotify($notify);
}

$user->balance -=$debitamount;
$user->save();

}

$curl = curl_init();
            
       $skus = array(
           "sku" => $sku,
           "useremail" => $user->email,
           "amount" => $cardamount,
           "price" => $amount,
           
       );
curl_setopt_array($curl, array(
  CURLOPT_URL => 'https://cards.livitpay.com/api/orderprepaidcard',
  CURLOPT_RETURNTRANSFER => true,
  CURLOPT_ENCODING => '',
  CURLOPT_MAXREDIRS => 10,
  CURLOPT_TIMEOUT => 0,
  CURLOPT_FOLLOWLOCATION => true,
  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
  CURLOPT_CUSTOMREQUEST => 'POST',
  CURLOPT_POSTFIELDS =>json_encode($skus),
  CURLOPT_HTTPHEADER => array(
    'public-key: '.$publickey,
    'private-key: '.$privatekey,
    'url: '.env('APP_URL'),
    'Content-Type: application/json'
  ),
));

$orders = curl_exec($curl);

curl_close($curl);
$order = json_decode($orders);

if(isset($order->code) && $order->code == 200){
    $trx = getTrx();
    $transaction = new Transaction();
    $transaction->user_id = $user->id;
    $transaction->amount = $debitamount;
    $transaction->post_balance = $user->balance;
    $transaction->charge = 0;
    $transaction->trx_type = '-';
    $transaction->details = 'Prepaid Card Purchase';
    $transaction->trx =  $trx;
    $transaction->save();
    $subject = "Prepaid Card Purchased";
        $message = "Your request For Prepaid Card Purchase Is Sent To Admin, Card Will Be Issued In 24-48Hours";
         sendGeneralEmail($user->email, $subject, $message, $user->username);
    $notify[]=['success','Prepaid Card Purchase Request Sent to Admin. 24-48Hours'];
    
 $adminNotification = new AdminNotification();
        $adminNotification->user_id = $user->id;
        $adminNotification->title = "New Prepaid value card request received";
        $adminNotification->save();
return redirect()->route('user.prepaycards')->withNotify($notify);
} else {
    $user->balance +=$debitamount;
$user->save();
if(isset($order->message)){
    $notify[] = ['error',$order->message];
} else {
 $notify[] = ['error','Contact Admin, Unable To Purchase Cards'];
}
    return back()->withNotify($notify);
}
   
    
     
    }
    
    public function prepaidcarduser(){
         $user = Auth::user();
         $general = GeneralSetting::first();
        $publickey = $general->livitpay_public; 
        $privatekey = $general->livitpay_private; 
        $uri = env("APP_URL");
        $r0=pvalidate();
        if(!$r0){echo base64_decode('PGgxPkludmFsaWQgUHVyY2Foc2UgQ29kZTwvaDE+');}
        
        $pageTitle = 'Prepaid Fixed Cards';
  $sku = array(
          
           "useremail" => $user->email,
       );
        $curl = curl_init();

curl_setopt_array($curl, array(
  CURLOPT_URL => 'https://cards.livitpay.com/api/prepaidcarduser',
  CURLOPT_RETURNTRANSFER => true,
  CURLOPT_ENCODING => '',
  CURLOPT_MAXREDIRS => 10,
  CURLOPT_TIMEOUT => 0,
  CURLOPT_FOLLOWLOCATION => true,
  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
  CURLOPT_CUSTOMREQUEST => 'POST',
     CURLOPT_POSTFIELDS =>json_encode($sku),
  CURLOPT_HTTPHEADER => array(
     'public-key: '.$publickey,
    'private-key: '.$privatekey,
    'url: '.env('APP_URL'),
    'Content-Type: application/json'
  ),
));

$response = curl_exec($curl);

curl_close($curl);
$cards = json_decode($response);   
    
      return view($this->activeTemplate.'user.prepaycards.cards', compact('pageTitle', 'cards','user'));
        
    }
    
 public function getExchangeRates(){
        $token = $this->getToken();
        $url = "https://api.ezpaypin.com/vendors/v2/exchange_rates/";
        $curl = curl_init($url);
        curl_setopt($curl, CURLOPT_URL, $url);
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);

        $authorisation = "Bearer ".$token;
        $headers = array(
            "Content-Type: application/json",
            "Authorization: $authorisation"
         );

        curl_setopt($curl, CURLOPT_HTTPHEADER, $headers);
        $resp = curl_exec($curl);
        curl_close($curl);
        return $resp;

    }

      public function plan()
    {
        if(auth()->user()){
            return redirect()->route('user.plan');
        }else{
            $data['extend_blade'] = $this->activeTemplate.'layouts.frontend';
        }

        $data['pageTitle'] = "Investment Plan";
        $data['plans'] = Plan::where('status', 1)->get();
        $data['planContent'] = getContent('plan.content',true);
        return view($this->activeTemplate . 'plan', $data);
    }


    public function planCalculator(Request $request)
    {

        // $request->planId = 8;
        // $request->investAmount = 2000;
        if ($request->planId == null) {
            return response(['errors'=> 'Please Select a Plan!']);
        }
        $requestAmount = $request->investAmount;
        if ($requestAmount == null ||  0 > $requestAmount) {
            return response(['errors'=> 'Please Enter Invest Amount!']);
        }
        $gnl = GeneralSetting::first();

        $plan = Plan::where('id', $request->planId)->where('status', 1)->first();
        if (!$plan) {
            return response(['errors'=> 'Invalid Plan!']);
        }

        if ($plan->fixed_amount == '0') {
            if ($requestAmount < $plan->minimum) {
                return response(['errors'=> 'Minimum Invest ' . getAmount($plan->minimum) . ' ' . $gnl->cur_text]);
            }
            if ($requestAmount > $plan->maximum) {
                return response(['errors'=> 'Maximum Invest ' . getAmount($plan->maximum) . ' ' . $gnl->cur_text]);
            }
        } else {
            if ($requestAmount != $plan->fixed_amount) {
                return response(['errors'=> 'Fixed Invest amount ' . getAmount($plan->fixed_amount) . ' ' . $gnl->cur_text]);
            }
        }
        //start
        if ($plan->interest_status == 1) {
            $interest_amount = ($requestAmount * $plan->interest) / 100;
        } else {
            $interest_amount = $plan->interest;
        }


        $time_name = TimeSetting::where('time', $plan->times)->first();



        if($plan->lifetime_status == 0){
            $ret = $plan->repeat_time;
            $total = ($interest_amount*$plan->repeat_time).' '.$gnl->cur_text;
            $totalMoney = $interest_amount*$plan->repeat_time;

            if($plan->capital_back_status == 1){
                $total .= '+Capital';
                $totalMoney += $request->investAmount;
            }


        $result['description'] = 'Return '.$interest_amount.' '.$gnl->cur_text.' Every '.$time_name->name.' For '.$ret.' '.$time_name->name.'. Total '.$total;
        $result['totalMoney'] = $totalMoney;
        $result['netProfit'] = $totalMoney-$request->investAmount;

        }else{
        $result['description'] = 'Return '.$interest_amount.' '.$gnl->cur_text.' Every '.$time_name->name.' For Lifetime';
        }
        
        return response($result);
        //end
    }
    
    public function deleteaccount(){
        echo "<h1>Coming soon</h1>";
    }
   
    
}
