<?php

namespace App\Http\Controllers;

use Carbon\Carbon;
use App\Models\SubCategory;
use App\Models\Cart;
use App\Models\User;
use App\Models\Countries;
use App\Models\Category;
use Illuminate\Support\Facades\Auth;
use App\Http\Helpers\Helper;
use App\Models\Card;
use App\Lib\GoogleAuthenticator;
use App\Models\AdminNotification;
use App\Models\GeneralSetting;
use App\Models\Paylink;
use App\Models\Transaction;
use App\Models\WithdrawMethod;
use App\Models\Withdrawal;
use App\Rules\FileTypeValidate;
use Illuminate\Http\Request;

use Illuminate\Support\Facades\Hash;
use Illuminate\Validation\Rules\Password;
use Illuminate\Validation\Rule;

use App\Models\GatewayCurrency;
use App\Models\SupportTicket;

use Response;

class TransferController extends Controller
{
    public function __construct(){
        $this->activeTemplate = activeTemplate();
    }

   public function checkUser(Request $request){
        $exist['data'] = User::where('username',$request->user)->orWhere('email',$request->user)->orWhere('ewallet_id',$request->user)->orWhere('mobile',$request->user)->first();
        
        $user = auth()->user(); 
        if(@$exist['data'] && $user->username == @$exist['data']->username || $user->email == @$exist['data']->email || $user->ewallet_id == @$exist['data']->ewallet_id || $user->mobile == @$exist['data']->mobile){
            return response()->json(['own'=>'Transfers are not permitted to self']);
        }
        return response($exist);
    }

    public function transfer()
    {
        $pageTitle = "Transfer Money";
        $general      = GeneralSetting::first();
        
//        $transferCharge = TransactionCharge::where('slug','money_transfer')->first();
//        $wallets = Wallet::checkWallet(['user'=>auth()->user(),'type'=>'USER'])->with('currency')->where('balance','>',0)->orderBy('balance','DESC')->get();
        return view($this->activeTemplate.'user.operations.transfer_money',compact('pageTitle', 'general'));
    }

    public function transferconfirm(Request $request)
    {
      
      $user = auth()->user();
       $general      = GeneralSetting::first();
       
      if($user->username == $request->user || $user->email == $request->user || $user->ewallet_id == $request->user || $user->mobile == $request->user){
            $notify[] = ['error', 'Can\'t transfer balance to your own'];
            return back()->withNotify($notify)->withInput();
       }
      $receiver = User::where('username',$request->user)->orWhere('email',$request->user)->orWhere('ewallet_id',$request->user)->orWhere('mobile',$request->user)->first();
       if(!$receiver){
           $notify[]=['error','Sorry! Receiver Not Found'];
           return back()->withNotify($notify)->withInput();
       } 
       
       $request->validate([
            'amount' => 'required|integer|gt:0'
        ]);
        $totalAmount = $request->amount;
       $fee = $general->tx_fee;
        $feeamount = showAmount($totalAmount * $fee / 100);
       
        $ftotalAmount = $request->amount + $feeamount;
        if($ftotalAmount > $user->balance){
            $notify[]=['error','Sorry! insufficient balance in this wallet'];
            return back()->withNotify($notify)->withInput(); 
        }
        $ftrx = getTrx();

    $user->balance -= $feeamount;
    $user->save();

    $transaction = new Transaction();
    $transaction->user_id = $user->id;
    $transaction->amount = $feeamount;
    $transaction->post_balance = $user->balance;
    $transaction->charge = 00;
    $transaction->trx_type = '-';
    $transaction->details = 'Fees for money transfer to '.$receiver->email.' amount '.$totalAmount.' successful';
    $transaction->trx =  $ftrx;
    $transaction->save();
    
    $trx = getTrx();

    $user->balance -= $totalAmount;
    $user->save();

    $transaction = new Transaction();
    $transaction->user_id = $user->id;
    $transaction->amount = $totalAmount;
    $transaction->post_balance = $user->balance;
    $transaction->charge = 00;
    $transaction->trx_type = '-';
    $transaction->details = 'Money Transfer to '.$receiver->email.' amount '.$totalAmount.' successful';
    $transaction->trx =  $trx;
    $transaction->save();
    
    
    
    $rtrx = getTrx();
     $receiver->balance += $totalAmount;
    $receiver->save();

    $transaction = new Transaction();
    $transaction->user_id = $receiver->id;
    $transaction->amount = $totalAmount;
    $transaction->post_balance = $receiver->balance;
    $transaction->charge = 00;
    $transaction->trx_type = '+';
    $transaction->details = 'Money Transfer from '.$user->email.' amount '.$totalAmount.' successful';
    $transaction->trx =  $rtrx;
    $transaction->save();
    $notify[] = ['success', 'Transfer Successful'];
    return back()->withNotify($notify)->withInput();
     
        
    }
    
    public function receivelink(){
        $pageTitle = "Receive Payment";
       $user = auth()->user();
       $general      = GeneralSetting::first();
        $gatewayCurrency = GatewayCurrency::whereHas('method', function ($gate) {
            $gate->where('status', 1)->where('code','<',500);
            
        })->with('method')->orderby('method_code')->get();
        $link = Paylink::where('user_id',$user->id)->where('merchant_id',$user->id)->get();
        return view($this->activeTemplate.'user.operations.receivelink',compact('pageTitle', 'general','gatewayCurrency','link'));
        
    }
    
     public function donatelink(){
        $pageTitle = "Donations";
       $user = auth()->user();
       $general      = GeneralSetting::first();
        $gatewayCurrency = GatewayCurrency::whereHas('method', function ($gate) {
            $gate->where('status', 1);
            
        })->with('method')->orderby('method_code')->get();
        $link = Paylink::where('user_id',$user->id)->where('merchant_id',$user->id)->where('isdonate',true)->get();
        return view($this->activeTemplate.'user.operations.donatelink',compact('pageTitle', 'general','gatewayCurrency','link'));
        
    }
    
     public function adddonatelink(Request $request){
      
          $user = auth()->user();
      
            if ($request->hasFile('image')) {
            $location = imagePath()['donation']['path'];
            $size = imagePath()['donation']['size'];
            $filename = uploadImage($request->image, $location, $size, $user->image);
            
        }
       
          
          
        $amount = $request['amount'];
        $currency = $request['currency'];
        $paylink = getTrx();
        $token = base64_encode($paylink);
        $trx = new Paylink();
    $trx->paylink = $paylink;
    $trx->amount = $amount;
    $trx->currency =$currency;
    $trx->merchant_ref =$paylink;
    $trx->status = "initiated";
    $trx->user_id = $user->id;
    $trx->merchant_id = $user->id;
    $trx->merchant_email = $user->email;
    $trx->token = $token;
    $trx->trx = $paylink;
    $trx->isdonate = true;
    $trx->description = $request['description'];
    $trx->image = isset($filename) ? $filename : null;
    $trx->save();
    
    $notify[] = ['success', 'Payment link Creation Successful'];
    return back()->withNotify($notify)->withInput();
    
    }
    
    public function addlink(Request $request){
      
          $user = auth()->user();
      
        $amount = $request['amount'];
        $currency = $request['currency'];
        $paylink = getTrx();
        $token = base64_encode($paylink);
        $trx = new Paylink();
    $trx->paylink = $paylink;
    $trx->amount = $amount;
    $trx->currency =$currency;
    $trx->merchant_ref =$paylink;
    $trx->status = "initiated";
    $trx->user_id = $user->id;
    $trx->merchant_id = $user->id;
    $trx->merchant_email = $user->email;
    $trx->token = $token;
    $trx->trx = $paylink;
    $trx->save();
    
    $notify[] = ['success', 'Payment link Creation Successful'];
    return back()->withNotify($notify)->withInput();
    
    }
    
    public function deletelink(Request $request){
        $linkid = $request['linkid'];
        $link = Paylink::where('paylink',$linkid)->delete();
        $notify[] = ['success', 'Payment Link Deleted'];
    return back()->withNotify($notify)->withInput();
        
    }
    
    public function donate(){
        $pageTitle = "Donations";
      
       $general      = GeneralSetting::first();
         $link = Paylink::where('isdonate',true)->latest()->paginate(getPaginate());
        return view($this->activeTemplate.'donate',compact('pageTitle', 'general','link'));
        
    }
}
