<?php
namespace App\Http\Controllers;

use App\Http\Controllers\Controller;
use App\Models\GeneralSetting;
use App\Models\Language;
use Illuminate\Http\Request;
use App\Http\Controllers\PgController;
use Carbon\Carbon;
use App\Models\SubCategory;
use App\Models\Cart;
use App\Models\Fluttercard;
use App\Models\User;
use App\Models\Fiat;
use App\Models\Fincra;
use App\Models\Apirequest;
use App\Models\Wallet;
use App\Models\Crypto;
use App\Models\Points;
use App\Models\Vcard;
use App\Models\Cryptocard;
use App\Models\Paylink;
use App\Models\Countries;
use App\Models\Category;
use App\Models\Bank;
use App\Models\Banktrans;
use App\Models\Wipe;
use App\Models\Stripeupdate;
use Illuminate\Auth\Events\Registered;
use Illuminate\Foundation\Auth\RegistersUsers;
use App\Models\Plan;
use App\Models\TimeSetting;
use App\Models\Invest;
use App\Models\Holiday;
use App\Models\PromotionTool;
use Illuminate\Support\Facades\Validator;
use App\Models\Incomingsms;
use App\Models\Virtualnumber;
use App\Models\Vnplans;
use App\Models\WalletCrypto;
use Illuminate\Support\Facades\Auth;
use App\Http\Helpers\Helper;
use App\Models\Card;
use App\Lib\GoogleAuthenticator;
use App\Lib\Fincralib;
use App\Models\AdminNotification;
use App\Lib\Flutterwave;
use App\Models\Transaction;
use App\Models\WithdrawMethod;
use App\Models\Withdrawal;
use App\Rules\FileTypeValidate;
use App\Http\Controllers\Gateway\Coinpayments\CoinPaymentHosted;
use App\Models\Deposit;
use Illuminate\Support\Facades\Hash;
use Illuminate\Validation\Rules\Password;
use Illuminate\Validation\Rule;
use App\Models\GatewayCurrency;
use App\Models\SupportTicket;
use Response;
use App\Models\Extension;
use App\Models\UserLogin;
use Illuminate\Foundation\Auth\AuthenticatesUsers;
use Illuminate\Support\Facades\Route;
use App\Models\InstallmentLog;
use App\Models\FdrPlan;
use App\Models\DpsPlan;
use App\Models\LoanPlan;
use App\Models\UserDps;
use App\Models\UserFdr;
use App\Models\UserLoan;
use App\Models\UserAction;
use App\Lib\Vonage;

class VirtualphoneController extends Controller {
    public function __construct()
    {
        $this->activeTemplate = activeTemplate();
    }

public function vpplans() {
    $user = Auth::user();
    $general = GeneralSetting::first();
    $pageTitle = 'Buy Virtual Numbers';
    $emptyMessage = 'No data found';

    $vnplans = Vnplans::get();

    return view($this->activeTemplate.'user.virtualnumber.index',compact('pageTitle', 'emptyMessage', 'vnplans'));
}

public function callforward(Request $request){
    $msisdn = $request->id;
    $country = $request->country;
    $voicenumber = $request->voicenumber;
     $vnplans = Virtualnumber::where('msisdn', $msisdn)->with('plan')->first();
    
     $v = new Vonage();
    $t = $v->update($msisdn,$country,$voicenumber);
  
     $errorcode = $t->error_code;


   if(isset($errorcode) && $errorcode == "200"){
       $vnplans->voicenumber = str_replace("+", "", $request->voicenumber);
       $vnplans->save();
       $notify[] = ['success', 'Call Forwarding Number Updated'];
    return redirect()->route('user.vpviewsms')->withNotify($notify);
   }
   
   $notify[] = ['error', 'Error updating Number'];
    return redirect()->route('user.vpviewsms')->withNotify($notify);
}
public function vpchoose(Request $request){

    $user = Auth::user();
    $general = GeneralSetting::first();
    $request->validate([
        'country'          => 'required',

    ]);
    $country = $request->country;


    $v = new Vonage();
    $numbers = $v->getnumbers($country);
    
    return $numbers->numbers;


}

public function vpbuy(Request $request){
    $request->validate([
        'country'          => 'required',
        'id'          => 'required',
        'msisdn'          => 'required',

    ]);
    $id = $request->id;
    $country = $request->country;
    $user = Auth::user();
    $general = GeneralSetting::first();
    $msisdn = $request->msisdn;
    $vnplans = Vnplans::where('id',$id)->first();
    $notify[] = ['success', 'In Demo Mode, Cannot make an actual purchase'];
    return redirect()->route('user.vpviewsms')->withNotify($notify);
    exit;
    $v = new Vonage();
    if($vnplans->price > $user->balance){
        $notify[] = ['error', 'Insufficient balance to complete purchase'];
        return back()->withNotify($notify);
    }
    $user->balance -= $vnplans->price;
    $user->save();
    $b = $v->buynumbers($msisdn,$country);

    $errorcode = $b->error_code;


   if(isset($errorcode) && $errorcode == "200"){

    $itransaction = new Transaction();
    $itransaction->user_id = $user->id;
    $itransaction->amount = $vnplans->price;
    $itransaction->charge = 0;
    $itransaction->trx_type = '-';
    $itransaction->trx = getTrx();
    $itransaction->details = 'Virtual Phone Number Purchase '.$msisdn;
    $itransaction->post_balance = $user->balance;
    $itransaction->save();

    $update = new Virtualnumber();
    $update->user_id = $user->id;
    $update->msisdn = $msisdn;
    $update->country = $country;
    $update->plan_id = $vnplans->id;
    $update->created_at = Carbon::now()->addDays(30);
    $update->save();

    $notify[] = ['success', 'Virtual Phone Number Purchase Success'];
    return redirect()->route('user.vpviewsms')->withNotify($notify);
    } else {

        $user->balance += $vnplans->price;
        $user->save();
        $itransaction = new Transaction();
        $itransaction->user_id = $user->id;
        $itransaction->amount = $vnplans->price;
        $itransaction->charge = 0;
        $itransaction->trx_type = '+';
        $itransaction->trx = getTrx();
        $itransaction->details = 'Reversal For Virtual Phone Number Purchase '.$msisdn;
        $itransaction->post_balance = $user->balance;
        $itransaction->save();


        $notify[] = ['error', 'Error Completing Purchase at this time, Try later'];
        return back()->withNotify($notify);

    }


}

public function vpviewsms(){
    $user = Auth::user();
    $general = GeneralSetting::first();
    $pageTitle = 'My Vitrual Numbers';
    $emptyMessage = 'No data found';

    $vnplans = Virtualnumber::where('user_id', $user->id)->with('plan')->get();
    $sms = Incomingsms::where('user_id', $user->id)->latest()->get();

    return view($this->activeTemplate.'user.virtualnumber.sms',compact('pageTitle', 'emptyMessage', 'vnplans','sms'));

}



public function vpcancel($msisdn){

    $user = Auth::user();
    $general = GeneralSetting::first();
    $vnplans = Virtualnumber::where('user_id', $user->id)->where('msisdn',$msisdn)->first();
    $v = new Vonage();
    $cancel = $v->cancelnumbers($msisdn,$vnplans->country);
    $errorcode = $cancel->error_code;
    if(isset($errorcode) && $errorcode == "200"){
        Virtualnumber::where('user_id', $user->id)->where('msisdn',$msisdn)->delete();
        Incomingsms::where('user_id', $user->id)->where('tonumber',$msisdn)->delete();

        $notify[] = ['success', 'Virtual Phone Number Cancelled'];
        return redirect()->route('user.vpviewsms')->withNotify($notify);
    }
    $notify[] = ['error', 'Error Cancelling Number, Try later'];
    return back()->withNotify($notify);

}

public function vprenew($msisdn){
    $user = Auth::user();
    $general = GeneralSetting::first();
    $vnplans = Virtualnumber::where('user_id', $user->id)->where('msisdn',$msisdn)->with('plan')->first();
    $plandate = $vnplans->created_at;
    if($vnplans->plan->price > $user->balance){
        $notify[] = ['error', 'Insufficient balance to complete purchase'];
        return back()->withNotify($notify);
    }
    $user->balance -= $vnplans->plan->price;
    $user->save();
    $itransaction = new Transaction();
    $itransaction->user_id = $user->id;
    $itransaction->amount = $vnplans->plan->price;
    $itransaction->charge = 0;
    $itransaction->trx_type = '-';
    $itransaction->trx = getTrx();
    $itransaction->details = 'Virtual Phone Number Purchase '.$msisdn;
    $itransaction->post_balance = $user->balance;
    $itransaction->save();

    $vnplans->created_at = $plandate->addDays(30);
    $vnplans->save();

    $notify[] = ['success', 'Virtual Phone Number renewed'];
    return back()->withNotify($notify);
}

}

?>
