<?php

namespace App\Http\Controllers;

use Carbon\Carbon;
use App\Models\SubCategory;
use App\Models\Cart;
use App\Models\Fluttercard;
use App\Models\User;
use App\Models\Fiat;
use App\Models\Vouchers;
use App\Models\Countries;
use App\Models\Category;
use Illuminate\Support\Facades\Auth;
use App\Http\Helpers\Helper;
use App\Models\Card;
use App\Lib\GoogleAuthenticator;
use App\Models\AdminNotification;
use App\Models\GeneralSetting;
use App\Lib\Flutterwave;
use App\Models\Transaction;
use App\Models\WithdrawMethod;
use App\Models\Withdrawal;
use App\Rules\FileTypeValidate;
use Illuminate\Http\Request;

use Illuminate\Support\Facades\Hash;
use Illuminate\Validation\Rules\Password;
use Illuminate\Validation\Rule;

use App\Models\GatewayCurrency;
use App\Models\SupportTicket;

use Response;

class VouchersController extends Controller
{
    
    public function __construct(){
        $this->activeTemplate = activeTemplate();
    }

    public function index() {
        
       $pageTitle = "E-Vouchers";
        $general = GeneralSetting::first();
      $user = auth()->user(); 
      $vouchers = Vouchers::where('seller_id',$user->id)->latest()->paginate();
        
        
         return view($this->activeTemplate.'user.vouchers.index', compact('pageTitle','vouchers', 'general'));
    }

    public function redeem(Request $request) {
       $vouchercode = $request['voucher'];
      $general = GeneralSetting::first();
      $user = auth()->user(); 
      $vouchers = Vouchers::where('vouchercode',$vouchercode)->where('status',"open")->first();
      if(!$vouchers){
           $notify[]=['error','Sorry! Voucher Not Found or Already Redeemed'];
           return back()->withNotify($notify)->withInput(); 
           exit;
      }
      
      $amount = $vouchers->amount;
      
         if($vouchers->amount < 0){
           $notify[]=['error','Voucher amount must be greater than 0'];
           return back()->withNotify($notify)->withInput(); 
           exit;
      }
      
      $trx = getTrx();
         $user->balance += $amount;
    $user->save();
    $transaction = new Transaction();
    $transaction->user_id = $user->id;
    $transaction->amount = $amount;
    $transaction->post_balance = $user->balance;
    $transaction->charge = 00;
    $transaction->trx_type = '+';
    $transaction->details = 'E-Voucher Amount Credited '.$vouchercode;
    $transaction->trx =  $trx;
    $transaction->save();
    
    $vouchers->status = "Utilized";
    $vouchers->user_id = $user->id;
    $vouchers->email_id = $user->email;
    $vouchers->ewallet_id = $user->ewallet_id;
    $vouchers->save();
    $notify[]=['success','E-voucher Credited'];
        return back()->withNotify($notify)->withInput(); 
    }

    public function buyvoucher(Request $request) {
      $general = GeneralSetting::first();
      $user = auth()->user(); 
      $vouchercode = $general->sitename.rand(100000000, 999999999999999999);
      $amount = $request['amount'];
     
      $request->validate([
            'amount' => "required|integer|gt:0",
           
        ]);
      
      if($amount > $user->balance){
            $notify[]=['error','Sorry! insufficient balance in this wallet'];
            return back()->withNotify($notify)->withInput(); 
            exit;
        }
        $trx = getTrx();
         $user->balance -= $amount;
    $user->save();
    $transaction = new Transaction();
    $transaction->user_id = $user->id;
    $transaction->amount = $amount;
    $transaction->post_balance = $user->balance;
    $transaction->charge = 00;
    $transaction->trx_type = '-';
    $transaction->details = 'E-Voucher Issuance '.$vouchercode;
    $transaction->trx =  $trx;
    $transaction->save();
        
        
        $update = new Vouchers();
        $update->vouchercode = $vouchercode;
        $update->amount = $amount;
        $update->currency = $general->cur_text;
        $update->status = "open";
        $update->seller_id = $user->id;                
        $update->seller_email = $user->email;
        $update->seller_ewalletid = $user->ewallet_id;
        $update->save();
        $notify[]=['success','E-voucher Issued'];
        return back()->withNotify($notify)->withInput(); 
        
      
      
    }
    
}