<?php

namespace App\Lib;
use App\Models\GeneralSetting;
use Illuminate\Http\Request;
use App\Lib\Apto;
 define('START_VERIFICATION_PROCESS', '/v1/verifications/start');
    define('CREATE_USER', '/v1/user');
    define('COMPLETE_VERIFICATION', '/v1/verifications');
    define('LIST_CARD_PROGRAMS', '/v1/config/cardproducts');
    define('APPLY_FOR_CARD', '/v1/user/accounts/apply');
    define('ACCEPT_AGREEMENT', '/v1/disclaimers/accept');
    define('SET_AGREEMENT_STATUS', '/v1/agreements');
    define('RETRIEVE_APPLICATION_STATUS', '/v1/user/accounts/applications');
    define('USER_ISSUE_CARD', '/v1/user/accounts/issuecard');
    define('ENABLE_ISSUED_CARD', '/v1/user/accounts');
	define('DISABLE_ISSUED_CARD', '/v1/user/accounts');
	define('LOAD_CARD_BALANCE', '/cards');
	define('RETRIEVE_ISSUED_CARD', '/v1/user/accounts');
class Aphelp{
    public function start_verification_process($request_parameters) {
        
       $general = GeneralSetting::first();
        $new = new Apto();
    
            $parameters = !is_null($request_parameters) ? json_encode($request_parameters, JSON_UNESCAPED_SLASHES) : '';

            $response = $new->apto_api_request('POST', START_VERIFICATION_PROCESS, $parameters);
            
         
            if (!empty($response)) {
                return $response;
                exit;
            }
            return false;
        
    }

  public function complete_verification_process($verification_id, $request_parameters) {
       
        $response = false;

        try {
            $parameters = !is_null($request_parameters) ? json_encode($request_parameters, JSON_UNESCAPED_SLASHES) : '';
            $new = new Apto();
            $response = $new->apto_api_request('POST', COMPLETE_VERIFICATION."/{$verification_id}/finish", $parameters);

            if (!empty($response)) {
                return $response;
            }
            return false;
        } catch (Exception $e) {
            //log_message('error', "Exception in complete_verification_process: ".$e->getMessage());
            return false;
        }
    }

    public function create_user($request_parameters) {
       
        $response = false;

        try {
            $parameters = !is_null($request_parameters) ? json_encode($request_parameters, JSON_UNESCAPED_SLASHES) : '';

            $response = Apto::apto_api_request('POST', CREATE_USER, $parameters);

            if (!empty($response)) {
                return $response;
            }
            return false;
        } catch (Exception $e) {
            //log_message('error', "Exception in create_user: ".$e->getMessage());
            return false;
        }
    }

    public function list_all_card_programs($user_token) {
       
        $response = false;

        try {
            $apto = new Apto();
            $response = $apto->apto_api_request('GET', LIST_CARD_PROGRAMS, null, true, $user_token);

            if (!empty($response)) {
                return $response;
            }
            return false;
        } catch (Exception $e) {
            //log_message('error', "Exception in list_all_card_programs: ".$e->getMessage());
            return false;
        }
    }

    public function apply_for_card($user_token, $request_parameters) {
        
        $response = false;

        try {
            $parameters = !is_null($request_parameters) ? json_encode($request_parameters, JSON_UNESCAPED_SLASHES) : '';
$apto = new Apto();
            $response = $apto->apto_api_request('POST', APPLY_FOR_CARD, $parameters, true, $user_token);

            if (!empty($response)) {
                return $response;
            }
            return false;
        } catch (Exception $e) {
            //log_message('error', "Exception in apply_for_card: ".$e->getMessage());
            return false;
        }
    }

    public function accept_card_agreement($user_token, $request_parameters) {
        
        $response = false;

        try {
            $parameters = !is_null($request_parameters) ? json_encode($request_parameters, JSON_UNESCAPED_SLASHES) : '';
            $apto = new Apto();
            $response = $apto->apto_api_request('POST', ACCEPT_AGREEMENT, $parameters, true, $user_token);

            if (!empty($response)) {
                return $response;
            }
            return false;
        } catch (Exception $e) {
            //log_message('error', "Exception in accept_card_agreement: ".$e->getMessage());
            return false;
        }
    }

    public function set_agreement_status($user_token, $request_parameters) {
        
        $response = false;

        try {
            $parameters = !is_null($request_parameters) ? json_encode($request_parameters, JSON_UNESCAPED_SLASHES) : '';
            $new = new Apto();
            $response = $new->apto_api_request('POST', SET_AGREEMENT_STATUS, $parameters, true, $user_token);

            if (!empty($response)) {
                return $response;
            }
            return false;
        } catch (Exception $e) {
            //log_message('error', "Exception in accept_card_agreement: ".$e->getMessage());
            return false;
        }
    }

    public function retrieve_card_application_status($user_token, $application_id) {
       
        $response = false;

        try {
            $apto = new Apto();
            $response = $apto->apto_api_request('GET', RETRIEVE_APPLICATION_STATUS."/{$application_id}/status", null, true, $user_token);

            if (!empty($response)) {
                return $response;
            }
            return false;
        } catch (Exception $e) {
            //log_message('error', "Exception in complete_verification_process: ".$e->getMessage());
            return false;
        }
    }

    public function issue_card($user_token, $request_parameters) {
       
        $response = false;

        try {
            $parameters = !is_null($request_parameters) ? json_encode($request_parameters, JSON_UNESCAPED_SLASHES) : '';
            $request = new Apto();
            $response = $request->apto_api_request('POST', USER_ISSUE_CARD, $parameters, true, $user_token);

            if (!empty($response)) {
                return $response;
            }
            return false;
        } catch (Exception $e) {
            //log_message('error', "Exception in issue_card: ".$e->getMessage());
            return false;
        }
    }

    public function enable_card($user_token, $account_id) {
      
        $response = false;

        try {
            $apto = new Apto();
            $response =$apto->apto_api_request('POST', ENABLE_ISSUED_CARD."/{$account_id}/enable", null, true, $user_token);
			#//log_message('error', "Exception in enable_card: ".$response);
            if (!empty($response)) {
                return $response;
            }
            return false;
        } catch (Exception $e) {
          //  //log_message('error', "Exception in enable_card: ".$e->getMessage());
            return false;
        }
    }

	function disable_card($user_token, $account_id) {
        
        $response = false;

        try {
            $apto = new Apto();
            $response = $apto->apto_api_request('POST', DISABLE_ISSUED_CARD."/{$account_id}/disable", null, true, $user_token);

            if (!empty($response)) {
                return $response;
            }
            return false;
        } catch (Exception $e) {
        //    //log_message('error', "Exception in disable_card: ".$e->getMessage());
            return false;
        }
    }

   public function retrieve_card($user_token, $account_id) {
       
        $response = false;

        try {
            $apto = new Apto();
            $response = $apto->apto_api_request('GET', RETRIEVE_ISSUED_CARD."/{$account_id}", null, true, $user_token);

          	if (!empty($response)) {
                return $response;
            }
            return false;
        } catch (Exception $e) {
            //log_message('error', "Exception in retrieve_card: ".$e->getMessage());
            return false;
        }
    }

	function load_fund_to_card($card_id, $request_parameters) {
       
        $response = false;

        try {
            $apto = new Apto();
            $parameters = !is_null($request_parameters) ? json_encode($request_parameters, JSON_UNESCAPED_SLASHES) : '';
            $response = $apto->apto_core_request('POST', LOAD_CARD_BALANCE."/{$card_id}/load_funds", $parameters, false, null);

            if (!empty($response)) {
                return $response;
            }
            return false;
        } catch (Exception $e) {
          //  //log_message('error', "Exception in enable_card: ".$e->getMessage());
            return false;
        }
    }
    
     public function start_verification_process_jwt($request_parameters) {
    
        $response = false;

        try {
            $new = new Apto();
            $response = $new->apto_api_request_jwt('POST', START_VERIFICATION_PROCESS, $request_parameters);

            if (!empty($response)) {
                return $response;
            }
            return false;
        } catch (Exception $e) {
            //log_message('error', "Exception in start_verification_process: ".$e->getMessage());
            return false;
        }
    }

    public function create_user_jwt($request_parameters) {
      
        $response = false;

        try {
            $new = new Apto();
            $response = $new->apto_api_request_jwt('POST', CREATE_USER, $request_parameters);

            if (!empty($response)) {
                return $response;
            }
            return false;
        } catch (Exception $e) {
            ////log_message('error', "Exception in create_user: ".$e->getMessage());
            return false;
        }
    }
}