<?php

namespace App\Lib;
use App\Models\GeneralSetting;
use Illuminate\Http\Request;

Class Apto {
    
     public function apto_api_request($method, $path, $body = null, $user_auth = false, $user_token = null) {
         
          $general = GeneralSetting::first();
        
                $api_url = $general->apto_url.$path;
                $apto_mobile_key = $general->apto_mobile_key;
                $apto_public_key = $general->apto_public_key;
                $apto_secretkey = $general->apto_secret_key;
           

            if ($user_auth && !empty($user_token) && empty($body) && $method == "POST") {
                $http_header = array(
                    "Api-Key: Bearer ".$apto_mobile_key,
                    "Authorization: Bearer ".$user_token,
                );
              	$response = curl_request_empty_body($api_url, $http_header);
              	
              	return $response;
            } else if ($user_auth && !empty($user_token)) {
                $http_header = array(
                    "Content-Type: application/json",
                    "Api-Key: Bearer ".$apto_mobile_key,
                    "Authorization: Bearer ".$user_token,
                );
              	
              	$response = curl_request_form($api_url, $body, null, 30, $http_header, $method);
              
              	return $response;
            } else {
                $http_header = array(
                    "Content-Type: application/json",
                    "Api-Key: Bearer ".$apto_mobile_key,
                );
              	$response = curl_request_form($api_url, $body, null, 30, $http_header, $method);
              
              	return $response;
            }
        
    }
  
  	public function apto_core_request($method, $path, $body = null, $user_auth = false, $user_token = null) {
  $general = GeneralSetting::first();
        ////log_message('error', json_encode(array($method, $path, $body, $user_auth, $user_token)));
        try {
                $api_url = $general->apto_url.$path;
                $apto_mobile_key = $general->apto_mobile_key;
                $apto_public_key = $general->apto_public_key;
                $apto_secretkey = $general->apto_secret_key;

          	$http_header = array(
            	"Content-Type: application/json",
            	"Authorization: Basic ".base64_encode($apto_public_key.':'.$apto_secretkey),
          	);
           
            return curl_request_form($api_url, $body, null, 30, $http_header, $method);

        } catch (Exception $e) {
            //log_message('error', $e->getMessage());
            return false;
        }   
    }
    
    public function apto_api_request_jwt($method, $path, $body = null, $user_auth = false, $user_token = null) {
         $general = GeneralSetting::first();
    //    //log_message('error', json_encode(array($method, $path, $body, $user_auth, $user_token)));
        try {
             $api_url = $general->apto_url.$path;
                $apto_mobile_key = $general->apto_mobile_key;
                $apto_public_key = $general->apto_public_key;
                $apto_secretkey = $general->apto_secret_key;

            if ($user_auth && !empty($user_token) && empty($body) && $method == "POST") {
                $http_header = array(
                    "Api-Key: Bearer ".$apto_mobile_key,
                    "Authorization: Bearer ".$user_token,
                );
                
              	$response = curl_request_empty_body($api_url, $http_header);
              	////log_message('error', "Log for APTO Library 1: ".$response);
              	return $response;
            } else if ($user_auth && !empty($user_token)) {
                $http_header = array(
                    "Content-Type: application/json",
                    "Api-Key: Bearer ".$apto_mobile_key,
                    "Authorization: Bearer ".$user_token,
                );
              	
              	$response = curl_request_form($api_url, $body, null, 30, $http_header, $method);
              	////log_message('error', "Log for APTO Library 2: ".$response);
              	return $response;
            } else {
                $http_header = array(
                    "Content-Type: application/jwt",
                    "Api-Key: Bearer ".$apto_mobile_key,
                );
              
              	$response = curl_request_form($api_url, $body, null, 30, $http_header, $method);
                
               
              	//log_message('error', "Log for APTO Library 3: ".$response);
              	return $response;
            }
        } catch (Exception $e) {
            //log_message('error', $e->getMessage());
            return false;
        }   
    }
}