<?php

namespace App\Lib;
use App\Models\GeneralSetting;
use Illuminate\Http\Request;

class Tatum
{
 public function createwallet($asset){
   $general = GeneralSetting::first();
    if($general->tatum_mode == "sandbox"){ 
   $testnet =   "?type=testnet";
    } else {
        $testnet = null;
    }
     $url = "https://api-us-west1.tatum.io/v3/".$asset."/wallet".$testnet;
     
     $request = $this->getcurl($url);
     return $request;
 }   
 
 public function erc20connect($req,$chain){
   $general = GeneralSetting::first();
    if($general->tatum_mode == "sandbox"){ 
   $testnet =   "?type=testnet";
    } else {
        $testnet = null;
    }
     $url = "https://api.tatum.io/v3/offchain/token/".$chain.$testnet;
     
     $data = array(
    "symbol"=> $req['token'],
    "supply"=> "1000000",
    "description"=> $req['name'],
    "basePair"=> "USD",
    "decimals"=> 18,
    "address"=> $req['intsupply'] 
         
     );
     
     $request = $this->postcurl($data,$url);
     return $request;
 }   
 
 
  public function addcontract($req){
   $general = GeneralSetting::first();
    if($general->tatum_mode == "sandbox"){ 
   $testnet =   "?type=testnet";
    } else {
        $testnet = null;
    }
     $url = "https://api.tatum.io/v3/offchain/token/".$req['token']."/.".$req['contractaddress'].$testnet;
     
    $data = array();    
     $request = $this->postcurl($data,$url);
     return $request;
 }   
 
 
 public function blockamount($va,$amount){
   $general = GeneralSetting::first();
    if($general->tatum_mode == "sandbox"){ 
   $testnet =   "?type=testnet";
    } else {
        $testnet = null;
    }
     $url = "https://api.tatum.io/v3/ledger/account/block/".$va.$testnet;
     
    $data = array(
  "amount" =>  strval($amount),
  "type" => "P2P Trade Block"
);
     $request = $this->postcurl($data,$url);
     return $request;
 }   
 
 public function releaseamount($id){
   $general = GeneralSetting::first();
    if($general->tatum_mode == "sandbox"){ 
   $testnet =   "?type=testnet";
    } else {
        $testnet = null;
    }
     $url = "https://api.tatum.io/v3/ledger/account/block/".$id.$testnet;
     
    $data = array(
  );
     $request = $this->deletecurl($data,$url);
     return $request;
 }   
 
 
 public function unblockamount($blockid,$recepient,$amount){
    $general = GeneralSetting::first();
    if($general->tatum_mode == "sandbox"){ 
   $testnet =   "?type=testnet";
    } else {
        $testnet = null;
    }
     $url = "https://api.tatum.io/v3/ledger/account/block/".$blockid.$testnet;
     
     
     $data = array(
          "recipientAccountId" => $recepient,
  "amount" =>  strval($amount)
         
     );
     
     $request = $this->putcurl($data,$url);
     return $request;
 }
 
 public function sendpayment($sender,$receiver,$amount){
   $general = GeneralSetting::first();
    if($general->tatum_mode == "sandbox"){ 
   $testnet =   "?type=testnet";
    } else {
        $testnet = null;
    }
     $url = "https://api.tatum.io/v3/ledger/transaction".$testnet;
     
    $data = array(
  "senderAccountId" => $sender,
  "recipientAccountId" => $receiver,
  "amount" => strval($amount)
);


     $request = $this->postcurl($data,$url);
     return $request;
 }  
 
  public function sendaddress($sender,$receiver,$amount,$key){
   $general = GeneralSetting::first();
    if($general->tatum_mode == "sandbox"){ 
   $testnet =   "?type=testnet";
    } else {
        $testnet = null;
    }
     $url = "https://api.tatum.io/v3/offchain/ethereum/erc20/transfer".$testnet;
     
    $data = array(
"senderAccountId" => $sender,
  "address" => $receiver,
  "amount" => strval($amount),
  "privateKey" => $key,
  
        
 
);


     $request = $this->postcurl($data,$url);
     return $request;
 }  
 

 public function generateaddress($xpub){
      $general = GeneralSetting::first();
    if($general->tatum_mode == "sandbox"){ 
   $testnet =   "?type=testnet";
    } else {
        $testnet = null;
    }
     $url = "https://api-eu1.tatum.io/v3/bitcoin/address/".$xpub."/1".$testnet;
     
     $request =  $this->getcurl($url);
     return $request;
 }
 
 public function createipn($id,$ipn){
     $general = GeneralSetting::first();
    $user = auth()->user(); 
    if($general->tatum_mode == "sandbox"){ 
   $testnet =   "?type=testnet";
    } else {
        $testnet = null;
    }
     $url = "https://api-eu1.tatum.io/v3/subscription".$testnet;
     
    $data = array(
  "type" => "ACCOUNT_INCOMING_BLOCKCHAIN_TRANSACTION",
  
  "attr" => [
   "id" => $id,
  
    "url" => $ipn
  ]
); 
     
     $request = $this->postcurl($data,$url);
     return $request;
 }
 
 public function balance($asset,$address){
   $general = GeneralSetting::first();
   if($general->tatum_mode == "sandbox"){ 
   $testnet =   "?type=testnet";
    } else {
        $testnet = null;
    }
     $url = "https://api-us-west1.tatum.io/v3/".$asset."/account/balance/".$address.$testnet;
     
     $request = $this->getcurl($url);
     return $request;
 }
 
 public function createva($asset,$address){
   $general = GeneralSetting::first();
    $user = auth()->user(); 
    if($general->tatum_mode == "sandbox"){ 
   $testnet =   "?type=testnet";
    } else {
        $testnet = null;
    }
     $url = "https://api-us-west1.tatum.io/v3/ledger/account".$testnet;
     
    $data = array(
  "currency" => $asset,
  "xpub" => isset($address) ? $address : null,
  "accountNumber" => isset($user->ewallet_id) ? $user->ewallet_id : "admin",
  "customer" => [
   "accountingCurrency" => "USD",
   "externalId"=> isset($user->ewallet_id) ? $user->ewallet_id : "admin",
  ]
); 
     
     $request = $this->postcurl($data,$url);
     return $request;
 }
 
  public function createcurrency($name,$basepair,$supply){
   $general = GeneralSetting::first();
     if($general->tatum_mode == "sandbox"){ 
   $testnet =   "?type=testnet";
    } else {
        $testnet = null;
    }
     $url = "https://api-us-west1.tatum.io/v3/ledger/virtualCurrency".$testnet;
     
    $data = array(
    "name" => $name,
  "supply" => $supply,
  "basePair" => $basepair,
  "accountingCurrency" => "USD"
); 
     
     $request = $this->postcurl($data,$url);
     return $request;
 }
 
 public function getcurrency($name){
   $general = GeneralSetting::first();
     if($general->tatum_mode == "sandbox"){ 
   $testnet =   "?type=testnet";
    } else {
        $testnet = null;
    }
     $url = "https://api-us-west1.tatum.io/v3/ledger/virtualCurrency/".$name.$testnet;
     
   
     $request = $this->getcurl($url);
     return $request;
 }
 
public function privatekey($req){
    $general = GeneralSetting::first();
    if($general->tatum_mode == "sandbox"){ 
   $testnet =   "?type=testnet";
    } else {
        $testnet = null;
    }
     $url = "https://api.tatum.io/v3/ethereum/wallet/priv".$testnet;
     $data = array(
        
"index" => 0,
"mnemonic"=> $req

     ); 
     $request = $this->postcurl($data,$url);
     return $request;
     
 }
 
 public function vadeposit($accountid,$index = null){
    $general = GeneralSetting::first();
    if($general->tatum_mode == "sandbox"){ 
   $testnet =   "?type=testnet&index=".$index;
    } else {
        $testnet = "?index=".$index;;
    }
     $url = "https://api-us-west1.tatum.io/v3/offchain/account/".$accountid."/address".$testnet;
     
     
     $data = array();
     
       $request = $this->postcurl($data,$url);
     return $request;
 }
 
 public function getallvadeposit($accountid){
   $general = GeneralSetting::first();
      if($general->tatum_mode == "sandbox"){ 
   $testnet =   "?type=testnet";
    } else {
        $testnet = null;
    }
     $url = "https://api-us-west1.tatum.io/v3/offchain/account/".$accountid."/address".$testnet;
     
     
     $data = array();
    
     $request = $this->getcurl($url);
     return $request;
 }
 

 public function sendva($senderAccountId, $recipientAccountId, $amount, $recipientNote){
   $general = GeneralSetting::first();
      if($general->tatum_mode == "sandbox"){ 
   $testnet =   "?type=testnet";
    } else {
        $testnet = null;
    }
     $url = "https://api-us-west1.tatum.io/v3/ledger/transaction".$testnet;
     
     $data = array(
         "senderAccountId" => $senderAccountId,
         "recipientAccountId" => $recipientAccountId,
         "amount" => (string)$amount,
         "recipientNote" => $recipientNote,
         "senderNote" => $recipientNote,
     );
    
     $request = $this->postcurl($data,$url);
     return $request;  
 }
 
 public function findtx($reference){
  $general = GeneralSetting::first();
     if($general->tatum_mode == "sandbox"){ 
   $testnet =   "?type=testnet";
    } else {
        $testnet = null;
    }
     $url = "https://api-us-west1.tatum.io/v3/ledger/transaction/reference/".$reference.$testnet;
     
     $request = $this->getcurl($url);
     return $request;
 }
 
 public function withdrawal($senderAccountId,$address,$amount,$fee){
   $general = GeneralSetting::first();   
     if($general->tatum_mode == "sandbox"){ 
   $testnet =   "?type=testnet";
    } else {
        $testnet = null;
    }
     $url = "https://api-us-west1.tatum.io/v3/offchain/withdrawal".$testnet;
     
     
     $data = array(
  "senderAccountId" => $senderAccountId,
  "address" => $address,
  "amount" => $amount,
  "fee" => $fee
);
     
       $request = $this->postcurl($data,$url);
     return $request;
 }
 
 public function getwithdrawals(){
 $general = GeneralSetting::first();  
     if($general->tatum_mode == "sandbox"){ 
   $testnet =   "?type=testnet&pageSize=50";
    } else {
         $testnet =   "?pageSize=50";
    }
     $url = "https://api-us-west1.tatum.io/v3/offchain/withdrawal".$testnet;
     
     $request = $this->getcurl($url);
     return $request;
 }
 
 public function completewithdrawl($id, $txId){
   $general = GeneralSetting::first();
 if($general->tatum_mode == "sandbox"){ 
   $testnet =   "?type=testnet";
    } else {
        $testnet = null;
    }   
   $curl = curl_init();

curl_setopt_array($curl, [
  CURLOPT_HTTPHEADER => [
    "x-api-key: ".$general->tatum_key,
  ],
  CURLOPT_URL => "https://api-eu1.tatum.io/v3/offchain/withdrawal/" .$id. "/" .$txId.$testnet,
  CURLOPT_RETURNTRANSFER => true,
  CURLOPT_CUSTOMREQUEST => "PUT",
]);

$response = curl_exec($curl);  
curl_close($curl);
return json_decode($response);  
 }
 
  public function deletewithdrawl($id){
 $general = GeneralSetting::first();
 if($general->tatum_mode == "sandbox"){ 
   $testnet =   "?type=testnet";
    } else {
        $testnet = null;
    }   
   $curl = curl_init();

curl_setopt_array($curl, [
  CURLOPT_HTTPHEADER => [
    "x-api-key: ".$general->tatum_key,
  ],
  CURLOPT_URL => "https://api-eu1.tatum.io/v3/offchain/withdrawal/" .$id.$testnet,
  CURLOPT_RETURNTRANSFER => true,
  CURLOPT_CUSTOMREQUEST => "DELETE",
]);

$response = curl_exec($curl);  
curl_close($curl);
return json_decode($response);  
 }
 
 
 public function getrateusd($currency){
 $general = GeneralSetting::first();  
     if($general->tatum_mode == "sandbox"){ 
   $testnet =   "?type=testnet&basePair=USD";
    } else {
         $testnet =   "?basePair=USD";
    }
     $url = "https://api-us-west1.tatum.io/v3/tatum/rate/".$currency."?basePair=USD";
     
     $request = $this->getcurl($url);
     return $request;
     
    
 }
 
 public function vabalance($id){
   $general = GeneralSetting::first();
   if($general->tatum_mode == "sandbox"){ 
   $testnet =   "?type=testnet";
    } else {
        $testnet = null;
    }
     $url = "https://api.tatum.io/v3/ledger/account/".$id.$testnet;
     
     $request = $this->getcurl($url);
     return $request;
 }
 
 
  public function postcurl($data,$url){
   $general = GeneralSetting::first();    
 $request = json_encode($data);     
 
 $curl = curl_init();

curl_setopt_array($curl, array(
  CURLOPT_URL => $url,
  CURLOPT_RETURNTRANSFER => true,
  CURLOPT_ENCODING => "",
  CURLOPT_MAXREDIRS => 10,
  CURLOPT_TIMEOUT => 0,
  CURLOPT_FOLLOWLOCATION => true,
  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
  CURLOPT_CUSTOMREQUEST => "POST",
  CURLOPT_POSTFIELDS =>$request,
  CURLOPT_HTTPHEADER => array(
   "x-api-key: ".$general->tatum_key,
    'Content-Type: application/json',
    'Accept: application/json'
  ),
));

$response = curl_exec($curl);

curl_close($curl);
return json_decode($response);
      
  }
  public function getcurl($url){
  $general = GeneralSetting::first();     
  $curl = curl_init();

  curl_setopt_array($curl, array(
  CURLOPT_URL => $url,
  CURLOPT_RETURNTRANSFER => true,
  CURLOPT_ENCODING => "",
  CURLOPT_MAXREDIRS => 10,
  CURLOPT_TIMEOUT => 0,
  CURLOPT_FOLLOWLOCATION => true,
  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
  CURLOPT_CUSTOMREQUEST => "GET",
  CURLOPT_HTTPHEADER => array(
    "x-api-key: ".$general->tatum_key,
    'Content-Type: application/json'
  ),
));

$response = curl_exec($curl);

curl_close($curl);
return json_decode($response);
      
  }
  
  public function putcurl($data,$url){
   $general = GeneralSetting::first();    
 $request = json_encode($data);     
 
 $curl = curl_init();

curl_setopt_array($curl, array(
  CURLOPT_URL => $url,
  CURLOPT_RETURNTRANSFER => true,
  CURLOPT_ENCODING => "",
  CURLOPT_MAXREDIRS => 10,
  CURLOPT_TIMEOUT => 0,
  CURLOPT_FOLLOWLOCATION => true,
  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
  CURLOPT_CUSTOMREQUEST => "PUT",
  CURLOPT_POSTFIELDS =>$request,
  CURLOPT_HTTPHEADER => array(
   "x-api-key: ".$general->tatum_key,
    'Content-Type: application/json',
    'Accept: application/json'
  ),
));

$response = curl_exec($curl);

curl_close($curl);
return json_decode($response);
      
  }
  
  
  public function deletecurl($data,$url){
   $general = GeneralSetting::first();    
 $request = json_encode($data);     
 
 $curl = curl_init();

curl_setopt_array($curl, array(
  CURLOPT_URL => $url,
  CURLOPT_RETURNTRANSFER => true,
  CURLOPT_ENCODING => "",
  CURLOPT_MAXREDIRS => 10,
  CURLOPT_TIMEOUT => 0,
  CURLOPT_FOLLOWLOCATION => true,
  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
  CURLOPT_CUSTOMREQUEST => "DELETE",
  CURLOPT_POSTFIELDS =>$request,
  CURLOPT_HTTPHEADER => array(
   "x-api-key: ".$general->tatum_key,
    'Content-Type: application/json',
    'Accept: application/json'
  ),
));

$response = curl_exec($curl);

curl_close($curl);
return json_decode($response);
      
  }
    
}