<?php

namespace App\Lib;

use Illuminate\Http\Request;
use App\Models\GeneralSetting;
use App\Models\User;
use Carbon\Carbon;
class Vonage
{
    public function __construct(){
        $general = GeneralSetting::first();
        $this->apikey = $general->vonageapikey;
        $this->apisecret = $general->vonagesecret;
    }
     public function voncallreport(){
    $today = Carbon::now()->subMinutes(7)->toISOString();

    $data = array(
        "account_id"=> $this->apikey,
        "date_start"=>$today,
        
        "product"=> "VOICE-CALL",
       
        

    );
    $key = base64_encode($this->apikey.':'.$this->apisecret);
    $body = http_build_query( $data );
    $curl = curl_init();

    curl_setopt_array($curl, array(
      CURLOPT_URL => 'https://api.nexmo.com/v2/reports/records?'.$body,
      CURLOPT_RETURNTRANSFER => true,
      CURLOPT_ENCODING => '',
      CURLOPT_MAXREDIRS => 10,
      CURLOPT_TIMEOUT => 0,
      CURLOPT_FOLLOWLOCATION => true,
      CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
      CURLOPT_CUSTOMREQUEST => 'GET',
      CURLOPT_HTTPHEADER     => array(
        "Authorization: Basic $key",
        "Content-Type: application/json"
    )
    ));

    $response = curl_exec($curl);

    curl_close($curl);
    return json_decode($response);
}
    public function vonreport(){
    $today = Carbon::now()->subMinutes(3)->toISOString();

    $data = array(
        "account_id"=> $this->apikey,
        "date_start"=>$today,
        "direction"=> "inbound",
        "product"=> "SMS",
        "include_message"=>"true",

    );
    $key = base64_encode($this->apikey.':'.$this->apisecret);
    $body = http_build_query( $data );
    $curl = curl_init();

    curl_setopt_array($curl, array(
      CURLOPT_URL => 'https://api.nexmo.com/v2/reports/records?'.$body,
      CURLOPT_RETURNTRANSFER => true,
      CURLOPT_ENCODING => '',
      CURLOPT_MAXREDIRS => 10,
      CURLOPT_TIMEOUT => 0,
      CURLOPT_FOLLOWLOCATION => true,
      CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
      CURLOPT_CUSTOMREQUEST => 'GET',
      CURLOPT_HTTPHEADER     => array(
        "Authorization: Basic $key",
        "Content-Type: application/json"
    )
    ));

    $response = curl_exec($curl);

    curl_close($curl);
    return json_decode($response);
}

    public function getnumbers($country){
$data = array(
    "api_key"=>$this->apikey,
    "api_secret"=>$this->apisecret,
    "country"=> $country,
    "features"=> "SMS",
    "size"=>100,
    'type'=>'mobile-lvn'
    

);
$body = http_build_query( $data );
$curl = curl_init();

curl_setopt_array($curl, array(
  CURLOPT_URL => 'https://rest.nexmo.com/number/search?'.$body,
  CURLOPT_RETURNTRANSFER => true,
  CURLOPT_ENCODING => '',
  CURLOPT_MAXREDIRS => 10,
  CURLOPT_TIMEOUT => 0,
  CURLOPT_FOLLOWLOCATION => true,
  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
  CURLOPT_CUSTOMREQUEST => 'GET',
));

$response = curl_exec($curl);

curl_close($curl);
return json_decode($response);

    }

    public function buynumbers($msisdn,$country){
        $data = array(
            "api_key"=>$this->apikey,
            "api_secret"=>$this->apisecret,
            "country"=> $country,
            "msisdn"=> $msisdn

        );
        $body = http_build_query( $data );
        $curl = curl_init();

        curl_setopt_array($curl, array(
          CURLOPT_URL => 'https://rest.nexmo.com/number/buy?'.$body,
          CURLOPT_RETURNTRANSFER => true,
          CURLOPT_ENCODING => '',
          CURLOPT_MAXREDIRS => 10,
          CURLOPT_TIMEOUT => 0,
          CURLOPT_FOLLOWLOCATION => true,
          CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
          CURLOPT_CUSTOMREQUEST => 'POST',
        ));

        $response = curl_exec($curl);

        curl_close($curl);
        return json_decode(str_replace("-","_",$response));

            }


            public function cancelnumbers($msisdn,$country){
                $data = array(
                    "api_key"=>$this->apikey,
                    "api_secret"=>$this->apisecret,
                    "country"=> $country,
                    "msisdn"=> $msisdn

                );
                $body = http_build_query( $data );
                $curl = curl_init();

                curl_setopt_array($curl, array(
                  CURLOPT_URL => 'https://rest.nexmo.com/number/cancel?'.$body,
                  CURLOPT_RETURNTRANSFER => true,
                  CURLOPT_ENCODING => '',
                  CURLOPT_MAXREDIRS => 10,
                  CURLOPT_TIMEOUT => 0,
                  CURLOPT_FOLLOWLOCATION => true,
                  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
                  CURLOPT_CUSTOMREQUEST => 'POST',
                ));

                $response = curl_exec($curl);

                curl_close($curl);
                return json_decode(str_replace("-","_",$response));

                    }
                    
                    public function update($msisdn,$country,$voicenumber){
                $data = array(
                    "api_key"=>$this->apikey,
                    "api_secret"=>$this->apisecret,
                    "country"=> $country,
                    "msisdn"=> $msisdn,
                    "voiceCallbackType"=> "tel",
                    "voiceCallbackValue"=> $voicenumber

                );
                $body = http_build_query( $data );
                $curl = curl_init();

                curl_setopt_array($curl, array(
                  CURLOPT_URL => 'https://rest.nexmo.com/number/update?'.$body,
                  CURLOPT_RETURNTRANSFER => true,
                  CURLOPT_ENCODING => '',
                  CURLOPT_MAXREDIRS => 10,
                  CURLOPT_TIMEOUT => 0,
                  CURLOPT_FOLLOWLOCATION => true,
                  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
                  CURLOPT_CUSTOMREQUEST => 'POST',
                ));

                $response = curl_exec($curl);

                curl_close($curl);
                return json_decode(str_replace("-","_",$response));

                    }

}

?>
