@extends('admin.layouts.app')
@section('panel')

<div class="row mb-none-30">
    <div class="col-lg-12 col-md-12 mb-30">
        <h4>@lang('Setup the cron jobs') - Last Cron Run: {{$general->last_cron}}</h4>
    </div>
    <div class="col-md-12 mb-4">

        <div class="card">
            <div class="card-header">
                <h4>Cron Settings Required</h4>
            </div>
            <div class="card-body">
                <li style="display:block"><strong>Fiat Rate Update:</strong> curl -s {{route('cron.fiat.rate')}}  - Once a day</li>
                <li style="display:block"><strong>Crypto Rate Update:</strong> curl -s {{route('cron.crypto.rate')}} - Once every 2hours</li>
                <li style="display:block"><strong>Investment Interest:</strong> curl -s {{route('cron.cron.interest')}} - Every 10 mins</li>
                <li style="display:block"><strong>Loans:</strong> curl -s {{route('cron.loan')}} - Every 10 mins</li>
                <li style="display:block"><strong>DPS:</strong> curl -s {{route('cron.dps')}} - Every 10 mins</li>
                <li style="display:block"><strong>FDR:</strong> curl -s {{route('cron.fdr')}} - Every 10 mins</li>
                <li style="display:block"><strong>Vonage Virtual Number AutoRenew:</strong> curl -s {{route('cron.vpautorenew')}} - Once a day</li>
                <li style="display:block"><strong>Vonage Retrieve SMS:</strong> curl -s {{route('cron.vpreport')}} - Every Minute</li>
                <li style="display:block"><strong>Vonage Retrieve Calls:</strong> curl -s {{route('cron.vpcallreport')}} - Every Minute</li>
                <li style="display:block"><strong>Monthly Card Fee:</strong> curl -s {{route('cron.monthlyfee')}} - 1st Of Every Month</li>


            </div>
        </div>
    </div>
</div>
<div class="row mb-none-30">
    <div class="col-lg-12 col-md-12 mb-30">
        <div class="card">
            <div class="card-body">
                <form action="" method="POST">
                    @csrf
                    <div class="row">
                        <div class="col-md-12 mb-4">
                            <h4>@lang('API Settings')</h4>
                        </div>
                        <div class="col-md-6">
                            <div class="form-group ">
                                <label class="form-control-label font-weight-bold"> @lang('Fiat Currency Rate Api Key') </label>
                                ( <small>@lang('For the api key please visit :')
                                    <a target="_blank" class="text--info" href="https://currencylayer.com/signup">@lang('Currency Layer')</a>
                                </small> )
                                <input class="form-control form-control-lg" type="text" placeholder="@lang('Fiat Currency Rate Api Key')" name="fiat_api_key" value="{{$general->fiat_api_key}}">

                                <div class="form-group">
                                    <small class="font-weight-bold">@lang('Set up cron job for update fiat price rate :')</small>
                                    <small class="text--danger">{{route('cron.fiat.rate')}}</small>
                                </div>
                            </div>
                        </div>
                        <div class="col-md-6">
                            <div class="form-group ">
                                <label class="form-control-label font-weight-bold"> @lang('Crypto Currency Rate Api Key') </label>
                                ( <small>@lang('For the api key please visit :')
                                    <a target="_blank" class="text--info" href="https://coinmarketcap.com/">@lang('CoinMarketCap')</a>
                                </small> )
                                <input class="form-control form-control-lg" type="text" placeholder="@lang('Crypto Currency Rate Api Key')" name="crypto_api_key" value="{{$general->crypto_api_key}}">

                                <div class="form-group">
                                    <small class="font-weight-bold">@lang('Set up cron job for update crypto price rate :')</small>
                                    <small class="text--danger">{{route('cron.crypto.rate')}}</small>
                                </div>
                            </div>
                        </div>

                        <div class="col-md-6">
                            <div class="form-group ">
                                <label class="form-control-label font-weight-bold"> @lang('Onramper Api Key') </label>
                                ( <small>@lang('For the api key please visit :')
                                    <a target="_blank" class="text--info" href="https://onramper.com/">@lang('Onramper')</a>
                                </small> )
                                <input class="form-control form-control-lg" type="text" placeholder="@lang('onramper Api Key')" name="onramper" value="{{$general->onramper}}">


                            </div>
                        </div>

                    </div>

                    <div class="row">
                        <div class="col-md-12 mb-4 mt-4">
                            <h4>@lang('Verifai KYC for Merchant / Agent')</h4>
                        </div>

                        <div class="col-md-12">
                            <div class="form-group ">
                                <label class="form-control-label font-weight-bold"> @lang('WebKey') <span class="text-danger">*</span></label>
                                ( <small>@lang('For the api key please visit :')
                                    <a target="_blank" class="text--info" href="https://verifai.com/">@lang('Verifai')</a>
                                </small> )

                                <input type="text" class="form-control form-control-lg" name="verifai" value="{{$general->verifai}}" required>
                            </div>
                        </div>

                    </div>
                    <div class="row">
                        <div class="col-md-12 mb-4 mt-4">
                            <h4>@lang('BSICards MasterCard Keys')</h4>
                        </div>

                        <div class="col-md-6">
                            <div class="form-group ">
                                <label class="form-control-label font-weight-bold"> @lang('Public Key') <span class="text-danger">*</span></label>
                                ( <small>@lang('For the api key please visit :')
                                    <a target="_blank" class="text--info" href="https://bsigroup.tech/">@lang('BSICards')</a>
                                </small> )

                                <input type="text" class="form-control form-control-lg" name="bsi_publickey" value="{{$general->bsi_publickey}}" required>
                            </div>
                        </div>

                        <div class="col-md-6">
                            <div class="form-group ">
                                <label class="form-control-label font-weight-bold"> @lang('Secret Key') <span class="text-danger">*</span></label>



                                <input type="text" class="form-control form-control-lg" name="bsi_secretkey" value="{{$general->bsi_secretkey}}" required>
                            </div>
                        </div>

                    </div>

                    <div class="row">
                        <div class="col-md-12 mb-4 mt-4">
                            <h4>@lang('Coin Payment Settings')</h4>
                        </div>

                        <div class="col-md-6">
                            <div class="form-group ">
                                <label class="form-control-label font-weight-bold"> @lang('Public Key') <span class="text-danger">*</span></label>
                                ( <small>@lang('For the api key please visit :')
                                    <a target="_blank" class="text--info" href="https://coinpayments.net/">@lang('Coinpayment')</a>
                                </small> )

                                <input type="text" class="form-control form-control-lg" name="public_key" value="{{$general->public_key}}" required>
                            </div>
                        </div>
                        <div class="col-md-6">
                            <div class="form-group ">
                                <label class="form-control-label font-weight-bold"> @lang('Private Key') <span class="text-danger">*</span></label>
                                <input type="text" class="form-control form-control-lg" name="private_key" value="{{$general->private_key}}" required>
                            </div>
                        </div>
                        <div class="col-md-12">
                            <div class="form-group ">
                                <label class="form-control-label font-weight-bold"> @lang('Merchant ID') <span class="text-danger">*</span></label>
                                <input type="text" class="form-control form-control-lg" name="merchant_id" value="{{$general->merchant_id}}" required>
                            </div>
                        </div>
                    </div>
                    <div class="row">
                        <div class="col-md-12 mb-4 mt-4">
                            <h4>@lang('Reloadly Settings')</h4>
                        </div>

                        <div class="col-md-6">
                            <div class="form-group ">
                                <label class="form-control-label font-weight-bold"> @lang('Reloadly Client Id') <span class="text-danger">*</span></label>
                                ( <small>@lang('For the api key please visit :')
                                    <a target="_blank" class="text--info" href="https://reloadly.com/">@lang('Reloadly')</a>
                                </small> )

                                <input type="text" class="form-control form-control-lg" name="reloadly_id" value="{{$general->reloadly_id}}" required>
                            </div>
                        </div>
                        <div class="col-md-6">
                            <div class="form-group ">
                                <label class="form-control-label font-weight-bold"> @lang('Reloadly Client Secret') <span class="text-danger">*</span></label>
                                <input type="text" class="form-control form-control-lg" name="reloadly_secret" value="{{$general->reloadly_secret}}" required>
                            </div>
                        </div>
                        <div class="col-md-12">
                            <div class="form-group ">
                                <label class="form-control-label font-weight-bold"> @lang('Reloadly Mode') <span class="text-danger">*</span></label>
                                <select class="select2-basic" name="reloadly" required><option value="{{$general->reloadly}}">{{ __($general->reloadly)}}</option><option value="sandbox">@lang('sandbox')</option><option value="live">@lang('live')</option></select>
                            </div>
                        </div>
                    </div>

                    <div class="row">
                        <div class="col-md-12 mb-4 mt-4">
                            <h4>@lang('Flutterwave Settings')</h4>
                        </div>

                        <div class="col-md-6">
                            <div class="form-group ">
                                <label class="form-control-label font-weight-bold"> @lang('Flutterwave Public Key') <span class="text-danger">*</span></label>
                                ( <small>@lang('For the api key please visit :')
                                    <a target="_blank" class="text--info" href="https://flutterwave.com/">@lang('Flutterwave')</a>
                                </small> )

                                <input type="text" class="form-control form-control-lg" name="flutterwave_public" value="{{$general->flutterwave_public}}" required>
                            </div>
                        </div>
                        <div class="col-md-6">
                            <div class="form-group ">
                                <label class="form-control-label font-weight-bold"> @lang('Flutterwave Secret Key') <span class="text-danger">*</span></label>
                                <input type="text" class="form-control form-control-lg" name="flutterwave_secret" value="{{$general->flutterwave_secret}}" required>
                            </div>
                        </div>
                        <div class="col-md-12">
                            <div class="form-group ">
                                <label class="form-control-label font-weight-bold"> @lang('Encryption Key') <span class="text-danger">*</span></label>
                                <input type="text" class="form-control form-control-lg" name="flutterwave_merchant" value="{{$general->flutterwave_merchant}}" required>
                            </div>
                        </div>
                    </div>






                    <div class="row">
                        <div class="col-md-12 mb-4 mt-4">
                            <h4>@lang('Livitpay Prepaidcard')</h4>
                        </div>

                        <div class="col-md-6">
                            <div class="form-group ">
                                <label class="form-control-label font-weight-bold"> @lang('Livitpay Public Key') <span class="text-danger">*</span></label>
                                ( <small>@lang('For the api key please visit :')
                                    <a target="_blank" class="text--info" href="https://livitpay.com/">@lang('Livitpay')</a>
                                </small> )

                                <input type="text" class="form-control form-control-lg" name="livitpay_public" value="{{$general->livitpay_public}}" required>
                            </div>
                        </div>

                        <div class="col-md-6">
                            <div class="form-group ">
                                <label class="form-control-label font-weight-bold"> @lang('Livitpay Private Key') <span class="text-danger">*</span></label>
                                <input type="text" class="form-control form-control-lg" name="livitpay_private" value="{{$general->livitpay_private}}" required>
                            </div>
                        </div>


                    </div>

                    <div class="row">
                        <div class="col-md-12 mb-4 mt-4">
                            <h4>@lang('Merchant Stripe')</h4>
                        </div>

                        <div class="col-md-6">
                            <div class="form-group ">
                                <label class="form-control-label font-weight-bold"> @lang('Stripe Publishable Key') <span class="text-danger">*</span></label>
                                ( <small>@lang('For the api key please visit :')
                                    <a target="_blank" class="text--info" href="https://stripe.com/">@lang('Stripe')</a>
                                </small> )

                                <input type="text" class="form-control form-control-lg" name="stripePublishableKey" value="{{$general->stripePublishableKey}}" required>
                            </div>
                        </div>

                        <div class="col-md-6">
                            <div class="form-group ">
                                <label class="form-control-label font-weight-bold"> @lang('Stripe Secret Key') <span class="text-danger">*</span></label>
                                <input type="text" class="form-control form-control-lg" name="stripeSecretKey" value="{{$general->stripeSecretKey}}" required>
                            </div>
                        </div>

                        <div class="col-md-6">
                            <div class="form-group ">
                                <label class="form-control-label font-weight-bold"> @lang('Stripe Fees %') <span class="text-danger">*</span></label>
                                <input type="number" class="form-control form-control-lg" name="stripefee" value="{{$general->stripefee}}" required>
                            </div>
                        </div>


                    </div>
                    <div class="row">
                        <div class="col-md-12 mb-4 mt-4">
                            <h4>@lang('Vonage Virtual Numbers')</h4>
                        </div>

                        <div class="col-md-6">
                            <div class="form-group ">
                                <label class="form-control-label font-weight-bold"> @lang('API Key') <span class="text-danger">*</span></label>
                                ( <small>@lang('For the api key please visit :')
                                    <a target="_blank" class="text--info" href="https://vonage.com/">@lang('Vonage')</a>
                                </small> )

                                <input type="text" class="form-control form-control-lg" name="vonageapikey" value="{{$general->vonageapikey}}" required>
                            </div>
                        </div>
                        <div class="col-md-6">
                            <div class="form-group ">
                                <label class="form-control-label font-weight-bold"> @lang('API Secret') <span class="text-danger">*</span></label>
                                <input type="text" class="form-control form-control-lg" name="vonagesecret" value="{{$general->vonagesecret}}" required>
                            </div>
                        </div>
                    </div>

            </div>




            <div class="form-group">
                <button type="submit" class="btn btn--primary btn-block btn-lg">@lang('Update')</button>
            </div>
            </form>
        </div>
    </div>
</div>
</div>
@endsection

