@extends('admin.layouts.app')
@section('panel')
<style>
    .toggle.ios, .toggle-on.ios, .toggle-off.ios {
        border-radius: 20px;
    }
    .toggle.ios .toggle-handle {
        border-radius: 20px;
    }
</style>
<div class="row mb-none-30">
    <div class="col-lg-12 col-md-12 mb-30">
        <div class="card">
            <div class="card-body">
                <form action="" method="POST">
                    @csrf
                    <div class="row">
                        <div class="col-md-3">
                            <div class="form-group ">
                                <label class="form-control-label font-weight-bold"> @lang('Site Title') </label>
                                <input class="form-control form-control-lg" type="text" name="sitename" value="{{$general->sitename}}">
                            </div>
                        </div>
                        <div class="col-md-3">
                            <div class="form-group ">
                                <label class="form-control-label font-weight-bold">@lang('Currency')</label>
                                <input readonly class="form-control form-control-lg" type="text" name="cur_text" value="{{$general->cur_text}}">
                            </div>
                        </div>

                        <div class="col-md-3">
                            <div class="form-group ">
                                <label class="form-control-label font-weight-bold">@lang('Currency Symbol') </label>
                                <input readonly class="form-control form-control-lg" type="text" name="cur_sym" value="{{$general->cur_sym}}">
                            </div>
                        </div>

                        <div class="form-group col-md-3">
                            <label class="form-control-label font-weight-bold"> @lang('Timezone')</label>
                            <select class="select2-basic" name="timezone">
                                @foreach($timezones as $timezone)
                                <option value="'{{ @$timezone}}'" @if(config('app.timezone') == $timezone) selected @endif>{{ __($timezone) }}</option>
                                @endforeach
                            </select>
                        </div>
                        <div class="col-md-3">
                            <div class="form-group ">
                                <label class="form-control-label font-weight-bold">@lang('Closed Loop ISSUE FEE - Amount') </label>
                                <input class="form-control form-control-lg" type="number" step="0.01" name="ngn_fee" value="{{$general->ngn_fee}}">
                            </div>
                        </div>
                        <div class="col-md-3">
                            <div class="form-group ">
                                <label class="form-control-label font-weight-bold">@lang('Crypto Closed Loop ISSUE FEE - Amount') </label>
                                <input class="form-control form-control-lg" type="number" step="0.01" name="ccard_fee" value="{{$general->ccard_fee}}">
                            </div>
                        </div>

                        <div class="col-md-3">
                            <div class="form-group ">
                                <label class="form-control-label font-weight-bold">@lang('Fixed Value ISSUE FEE - Amount') </label>
                                <input class="form-control form-control-lg" type="number" step="0.01" name="prepaidissue_fee" value="{{$general->prepaidissue_fee}}">
                            </div>
                        </div>



                        <div class="col-md-3">
                            <div class="form-group ">
                                <label class="form-control-label font-weight-bold">@lang('MASTERCARD USD CARD ISSUE FEE - Amount') </label>
                                <input class="form-control form-control-lg" type="number" step="0.01" name="usd_fee" value="{{$general->usd_fee}}">
                            </div>
                        </div>
                        <div class="col-md-3">
                            <div class="form-group ">
                                <label class="form-control-label font-weight-bold">@lang('MASTERCARD LOAD CARD FEE - %') </label>
                                <input class="form-control form-control-lg" type="number" step="0.01" name="load_fee" value="{{$general->load_fee}}">
                            </div>
                        </div>


                        <div class="col-md-3">
                            <div class="form-group ">
                                <label class="form-control-label font-weight-bold">@lang('BSIMASTERCARD USD CARD ISSUE FEE - Amount') </label>
                                <input class="form-control form-control-lg" type="number" step="0.01" name="bsiissue_fee" value="{{$general->bsiissue_fee}}">
                            </div>
                        </div>
                        <div class="col-md-3">
                            <div class="form-group ">
                                <label class="form-control-label font-weight-bold">@lang('BSIMASTERCARD LOAD CARD FEE - %') </label>
                                <input class="form-control form-control-lg" type="number" step="0.01" name="bsiload_fee" value="{{$general->bsiload_fee}}">
                            </div>
                        </div>


                        <div class="col-md-3">
                            <div class="form-group ">
                                <label class="form-control-label font-weight-bold">@lang('VISA EUR CARD ISSUE FEE - Amount in USD') </label>
                                <input class="form-control form-control-lg" type="number" step="0.01" name="visa_fee" value="{{$general->visa_fee}}">
                            </div>
                        </div>
                        <div class="col-md-3">
                            <div class="form-group ">
                                <label class="form-control-label font-weight-bold">@lang('VISA EUR CARD LOAD FEE - %') </label>
                                <input class="form-control form-control-lg" type="number" step="0.01" name="visa_loadfee" value="{{$general->visa_loadfee}}">
                            </div>
                        </div>

                        <div class="col-md-3">
                            <div class="form-group ">
                                <label class="form-control-label font-weight-bold">@lang('VISA USD CARD ISSUE FEE - Amount in USD') </label>
                                <input class="form-control form-control-lg" type="number" step="0.01" name="usdvisa_fee" value="{{$general->usdvisa_fee}}">
                            </div>
                        </div>
                        <div class="col-md-3">
                            <div class="form-group ">
                                <label class="form-control-label font-weight-bold">@lang('VISA USD CARD LOAD FEE - %') </label>
                                <input class="form-control form-control-lg" type="number" step="0.01" name="usdvisa_loadfee" value="{{$general->usdvisa_loadfee}}">
                            </div>
                        </div>

                        <div class="col-md-3">
                            <div class="form-group ">
                                <label class="form-control-label font-weight-bold">@lang('MASTERCARD MONTHLY FEE - Amount') </label>
                                <input class="form-control form-control-lg" type="number" step="0.01" name="fiat_monthly" value="{{$general->fiat_monthly}}">
                            </div>
                        </div>

                        <div class="col-md-3">
                            <div class="form-group ">
                                <label class="form-control-label font-weight-bold">@lang('Card BIN SERIES') </label>
                                <input class="form-control form-control-lg" type="text" name="card_bin" value="{{$general->card_bin}}" minlength="4" maxlength="4">
                            </div>
                        </div>
                        <div class="col-md-3">
                            <div class="form-group ">
                                <label class="form-control-label font-weight-bold">@lang('MERCHANT PAYMENT GATEWAY/LINK FEE - %') </label>
                                <input class="form-control form-control-lg" type="number" step="0.01" name="pg_fee" value="{{$general->pg_fee}}">
                            </div>
                        </div>
                        <div class="col-md-3">
                            <div class="form-group ">
                                <label class="form-control-label font-weight-bold">@lang('TRANSFER FEE - %') </label>
                                <input class="form-control form-control-lg" type="number" step="0.01" name="tx_fee" value="{{$general->tx_fee}}">
                            </div>
                        </div>
                        <div class="col-md-3">
                            <div class="form-group ">
                                <label class="form-control-label font-weight-bold">@lang('E-VOUCHER REDEEM FEE - %') </label>
                                <input class="form-control form-control-lg" type="number" step="0.01" name="ev_fee" value="{{$general->ev_fee}}">
                            </div>
                        </div>
                        <div class="col-md-3">
                            <div class="form-group ">
                                <label class="form-control-label font-weight-bold">@lang('USER CASHOUT FEE - %') </label>
                                <input class="form-control form-control-lg" type="number" step="0.01" name="user_cashout" value="{{$general->user_cashout}}">
                            </div>
                        </div>
                        <div class="col-md-3">
                            <div class="form-group ">
                                <label class="form-control-label font-weight-bold">@lang('USER CASHIN FEE - %') </label>
                                <input class="form-control form-control-lg" type="number" step="0.01" name="user_cashin" value="{{$general->user_cashin}}">
                            </div>
                        </div>
                        <div class="col-md-3">
                            <div class="form-group ">
                                <label class="form-control-label font-weight-bold">@lang('AGENT CASH PAY FEE - %') </label>
                                <input class="form-control form-control-lg" type="number" step="0.01" name="agent_cashpay" value="{{$general->agent_cashpay}}">
                            </div>
                        </div>
                        <div class="col-md-3">
                            <div class="form-group ">
                                <label class="form-control-label font-weight-bold">@lang('AGENT CASH RECEIVE FEE - %') </label>
                                <input class="form-control form-control-lg" type="number" step="0.01" name="agent_cashrcv" value="{{$general->agent_cashrcv}}">
                            </div>
                        </div>
                        <div class="col-md-3">
                            <div class="form-group ">
                                <label class="form-control-label font-weight-bold">@lang('Physical Card Fees - Amount') </label>
                                <input class="form-control form-control-lg" type="number" step="0.01" name="physical_fee" value="{{$general->physical_fee}}">
                            </div>
                        </div>
                        <div class="col-md-3">
                            <div class="form-group ">
                                <label class="form-control-label font-weight-bold">@lang('Crypto MasterCard Fees - Amount') </label>
                                <input class="form-control form-control-lg" type="number" step="0.01" name="crypto_masterfee" value="{{$general->crypto_masterfee}}">
                            </div>
                        </div>
                        <div class="col-md-3">
                            <div class="form-group ">
                                <label class="form-control-label font-weight-bold">@lang('Crypto MasterCard Load Fees - %') </label>
                                <input class="form-control form-control-lg" type="number" step="0.01" name="cryptoload_fee" value="{{$general->cryptoload_fee}}">
                            </div>
                        </div>
                        <div class="col-md-3">
                            <div class="form-group ">
                                <label class="form-control-label font-weight-bold">@lang('Crypto MasterCard Monthly Fees - Amount') </label>
                                <input class="form-control form-control-lg" type="number" step="0.01" name="crypto_monthly" value="{{$general->crypto_monthly}}">
                            </div>
                        </div>
                        <div class="col-md-3">
                            <div class="form-group ">
                                <label class="form-control-label font-weight-bold">@lang('Gift Card Fees') </label>
                                <input class="form-control form-control-lg" type="number" step="0.01" name="reloadly_fee" value="{{$general->reloadly_fee}}">
                            </div>
                        </div>
                        <div class="col-md-3">
                            <div class="form-group ">
                                <label class="form-control-label font-weight-bold">@lang('Virtual Card Issue Fees') </label>
                                <input class="form-control form-control-lg" type="number" step="0.01" name="flutter_issue" value="{{$general->flutter_issue}}">
                            </div>
                        </div>
                        <div class="col-md-3">
                            <div class="form-group ">
                                <label class="form-control-label font-weight-bold">@lang('Virtual  load Card Fees') </label>
                                <input class="form-control form-control-lg" type="number" step="0.01" name="flutter_load" value="{{$general->flutter_load}}">
                            </div>
                        </div>
                        <div class="form-group col-md-3">
                            <label class="form-control-label font-weight-bold"> @lang('Dashboard Color - Works on Finance Theme only')</label>
                            <div class="input-group">
                                <span class="input-group-addon ">
                                    <input type='text' class="form-control form-control-lg colorPicker" value="{{$general->base_color}}"/>
                                </span>
                                <input type="text" class="form-control form-control-lg colorCode" name="base_color" value="{{ $general->base_color }}"/>
                            </div>
                        </div>
                        <!--                             <div class="form-group col-md-3">
                                                        <label class="form-control-label font-weight-bold"> @lang('Site Secondary Color')</label>
                                                        <div class="input-group">
                                                        <span class="input-group-addon">
                                                            <input type='text' class="form-control form-control-lg colorPicker" value="{{$general->secondary_color}}"/>
                                                        </span>
                                                            <input type="text" class="form-control form-control-lg colorCode" name="secondary_color" value="{{ $general->secondary_color }}"/>
                                                        </div>
                                                    </div>-->
                        <div class="col-md-6">
                            <div class="form-group ">
                                <label class="form-control-label font-weight-bold">@lang('API Doc Link') </label>
                                <input class="form-control form-control-lg" type="text" name="doc" value="{{ $general->doc }}">
                            </div>
                        </div>

                    </div>
                    <hr>


                    <div class="form-group">
                        <button type="submit" class="btn btn--primary btn-block btn-lg">@lang('Update')</button>
                    </div>
                    <p class="mt-4">Note: Crypto functions only disable all menu options, will not remove any existing crypto balances, enabled gateways, etc.</p>
                </form>
            </div>
        </div>
    </div>
</div>
@endsection

@push('script-lib')
<script src="{{ asset('assets/admin/js/spectrum.js') }}"></script>
@endpush

@push('style-lib')
<link rel="stylesheet" href="{{ asset('assets/admin/css/spectrum.css') }}">
@endpush


@push('style')
<style>
    .sp-replacer {
        padding: 0;
        border: 1px solid rgba(0, 0, 0, .125);
        border-radius: 5px 0 0 5px;
        border-right: none;
    }

    .sp-preview {
        width: 100px;
        height: 46px;
        border: 0;
    }

    .sp-preview-inner {
        width: 110px;
    }

    .sp-dd {
        display: none;
    }
    .select2-container .select2-selection--single {
        height: 44px;
    }
    .select2-container--default .select2-selection--single .select2-selection__rendered {
        line-height: 43px;
    }
    .select2-container--default .select2-selection--single .select2-selection__arrow {
        height: 43px;
    }
</style>
@endpush

@push('script')
<script>
(function ($) {
    "use strict";
    $('.colorPicker').spectrum({
        color: $(this).data('color'),
        change: function (color) {
            $(this).parent().siblings('.colorCode').val(color.toHexString().replace(/^#?/, ''));
        }
    });

    $('.colorCode').on('input', function () {
        var clr = $(this).val();
        $(this).parents('.input-group').find('.colorPicker').spectrum({
            color: clr,
        });
    });

    $('.select2-basic').select2({
        dropdownParent: $('.card-body')
    });

    $('select[name=timezone]').val();
})(jQuery);

</script>
@endpush

