@extends($activeTemplate.'layouts.master')

@php
$carddesign = getContent('carddesign.content', true);

if(isset($virtualcard)){
$qr = array(
"card_hash" => $virtualcard->card_hash,
"cvv" => $virtualcard->cvv,
"expiration" => $virtualcard->expiration,
"name_on_card" => $virtualcard->name_on_card

);
$qrimg = json_encode($qr);
} else {
$qrimg = "No Card Found";
}
@endphp
@section('content')

@include($activeTemplate.'partials.breadcrumb')


<section class="pt-120 pb-120 section--bg">
    <div class="container">
        <div class="card mb-4">
            <div class="card-header ">
                <div class="row">
                    <div class="col-12 col-sm">
                        <h5 class="title my-2">@lang('Virtual MasterCard')</h5>
                    </div>
                    <div class="col-12 col-sm-auto">

                    </div>
                </div>
            </div>

            <div class="row m-4">
                <!-- master card preview -->
                <div class="col-12 col-md-auto">
                    <div class="creditcard-wrap ">
                        <div class="card border-0 creditcard shadow-sm">
                            <div class="card-body z-2">
                                <div class="row">
                                    <div class="col"></div>
                                    <div class="col-auto">
                                        <img src="{{getImage(imagePath()['logoIcon']['path'] .'/logo.png')}}" alt="" class="logo-image">
                                    </div>
                                </div>
                                <h5 class="text-center my-3">{{ $virtualcards->data->card_number}}</h5>
                                <div class="row mb-3">
                                    <div class="col">
                                        <p class="text-mute small mb-0">Card Holder</p>
                                        <p>{{ $user->firstname }} {{ $user->lastname }}</p>
                                    </div>
                                    <div class="col-auto text-right">
                                        <p class="text-mute small mb-0">Expires</p>
                                        <p>{{ $virtualcards->data->expiry_month}}/{{ $virtualcards->data->expiry_year}}</p>
                                    </div>
                                </div>
                                <p class="text-uppercase small">Virtual MasterCard</p>
                            </div>
                        </div>
                        <div class="card border-0 creditcard back shadow-sm">
                            <div class="card-body z-2">
                                <div class="row">
                                    <div class="col"></div>
                                    <div class="col-auto">
                                        <img src="{{getImage(imagePath()['logoIcon']['path'] .'/logo.png')}}" alt="" class="logo-image">
                                    </div>
                                </div>

                                <div class="row align-items-center my-4">
                                    <div class="col">
                                        <div class="stripes-card">
                                            <p class="text-mute small mb-0">CVV</p>
                                            <p>{{ $virtualcards->data->cvv}}</p>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>

                </div>
                <div class="col">
                    <div class="row m-4">

                        <div class="col-12  mb-3">
                            <p class="text-mute mb-1">Balance (USD)</p>
                            <h5>{{showAmount($virtualcards->data->available_balance / 100) }}</h5>
                        </div>
                        <div class="col-12  mb-3">
                            <p class="text-mute mb-1">Billing Address</p>
                            <h5>{{ $virtualcards->data->billing_address->billing_address1  }}, {{ $virtualcards->data->billing_address->billing_city  }}, {{ $virtualcards->data->billing_address->state  }},
                                {{ $virtualcards->data->billing_address->billing_country  }}, {{ $virtualcards->data->billing_address->billing_zip_code  }} </h5>
                        </div>
                        <div class="col-auto mb-3">
                            <p class="text-mute mb-1">Status</p>
                            @if($virtualcards->data->is_active == true)
                            <h5><i class="bi bi-patch-check mr-1 text-success"></i> Active</h5>
                            @else
                            <h5><i class="bi bi-patch-exclamation mr-1 text-danger"></i> Blocked</h5>
                            @endif
                        </div>
                        <div class="col-auto mb-3">
                            <p class="text-mute mb-1">Network</p>
                            <h5>{{ __($virtualcards->data->brand) }}</h5>
                        </div>
                        <div class="col-auto mb-3">
                            <div class="row">
                                <!-- <div class="col-auto mb-3">
                                    <button class="btn btn-primary mt-3" data-toggle="modal" data-target="#instore">InStore</button>
                                </div> -->

                                <div class="col-auto mb-3">
                                    <button class="btn btn-primary mt-3" id="fund" data-toggle="modal" data-target="#loadfunds">Load Funds</button>
                                </div>
                                <div class="col-auto mb-3">

                                    <?php if ($virtualcards->data->is_active == false) { ?>
                                        <a href="{{ route('user.mastervirtualunblock',$virtualcards->data->cardid) }}" class="btn btn-primary mt-3 un_block_card">@lang('UnBlock')</a>
                                    <?php } else { ?>
                                        <a href="{{ route('user.mastervirtualblock',$virtualcards->data->cardid) }}" class="btn btn-primary mt-3 block_card " onclick="return confirm('Are you sure you want to block the card?')">@lang('Block')</a>

                                    <?php } ?>
                                </div>

                            </div>
                        </div>
                    </div>

                </div>

            </div>
        </div>
        <div class="card mb-4">
            <div class="card-header">
                <div class="row">
                    <div class="col-12 col-sm">
                        <h5 class="title my-2">@lang('Card Transaction History')</h5>
                    </div>
                    <div class="col-12 col-sm-auto">

                    </div>
                </div>
            </div>
            <div class="card-body">
                <table class="table custom--table">
                    <thead class="">

                        <tr>
                            <th class="desktop tablet mobile">@lang('Type')</th>
                            <th class="desktop tablet mobile">@lang('Date')</th>

                            <th class="desktop tablet">@lang('Description')</th>
                            <th class="desktop tablet mobile">@lang('Amount')</th>


                        </tr>
                    </thead>
                    <tbody>
                        @if(isset($decodedTransactions->data))
                        @foreach($decodedTransactions->data->response->data->transactions as $transaction)
                        <tr>
                            <td><img src="{{ $transaction->enriched_data->merchant_logo }}" style="height: 25px;"></td>
                            <td>{{ \Carbon\Carbon::parse($transaction->transaction_date)->format('F d, Y H:i') }}<br>{{ $transaction->bridgecard_transaction_reference }}</td>

                            <td>{{ $transaction->description }}</td>
                            <td>@if($transaction->card_transaction_type == "CREDIT") <span class="text-success">USD {{ number_format($transaction->amount / 100, 2) }}</span>@else <span class="text-danger">USD {{ number_format($transaction->amount / 100, 2) }}</span>@endif<br>
                                @php
                                if(isset($transaction->partner_interchange_fee)){
                                $partnerfee = $transaction->partner_interchange_fee / 100;
                                } else {
                                $partnerfee = 0;
                                }
                                if(isset($transaction->interchange_revenue)){
                                $interchangefee = $transaction->interchange_revenue / 100;
                                } else {
                                $interchangefee = 0;
                                }
                                if(isset($transaction->foreign_exchange_fee)){
                                $fxfee = $transaction->foreign_exchange_fee / 100;
                                } else {
                                $fxfee = 0;
                                }

                                $fees = $partnerfee + $interchangefee + $fxfee;
                                @endphp
                                @if($fees != 0)
                                <small>Total Fees: ${{ showAmount($fees ?? "") }}</small>
                                @endif
                            </td>
                        </tr>
                        @endforeach
                        @else
                        <tr>
                            <td colspan="5">No transactions found</td>
                        </tr>
                        @endif

                    </tbody>
                </table>
            </div>
        </div>


    </div>

    <div class="modal fade" id="loadfunds">
        <div class="modal-dialog" role="document">
            <div class="modal-content">
                <div class="modal-header d-block">
                    <h3 class="modal-title">@lang('Load Funds')</h3>
                    <p class="fs-12">@lang('Load funds to your card')</p>
                </div>

                <div class="modal-body">
                    <form class="form-group" method="POST" action="{{ route('user.mastervirtualloadfunds') }}">
                        @csrf
                        <input type='hidden' name='cardid' value='{{ $virtualcards->data->cardid }}'>


                        <div class="form-group col-md-12">
                            <label class="mb-1"><strong>@lang('Enter Amount') (USD)</strong></label>
                            <input type="text" class="form-control" name="amount" id="amount" step='0.01' min='10' required />

                        </div>


                        <div class="form-group">

                            <input type="submit" value="submit" class="btn btn-primary">

                        </div>

                    </form>

                </div>
                <div class="modal-footer">
                    <p class="text-danger text-left">{{$general->bsiload_fee}}% Load Fund Fees apply. Minimum $10 can be loaded</p>


                </div>

            </div>
        </div>
    </div>

    <script>
        $(document).ready(function () {
            $('#fund').on('click', function () {
                $('#loadfunds').modal('show');
            })
        })


    </script>

</section>

@endsection