@php
$header = getContent('header.content', true);
$advert = getContent('dashboardadverts.content', true);
$socialMedias = getContent('social_icon.element');
$user = Auth::user();
$general = App\Models\GeneralSetting::first();
$games = App\Models\Game::where('status',1)->get(['image','name','id','max_limit','min_limit','win','invest_back','alias']);
@endphp
@auth
@php
$runningTradeCount = App\Models\TradeRequest::where([['status', '!=', 1],['status', '!=', 9]])->where(function ($q){
$q->where('buyer_id', auth()->user()->id)->orWhere('seller_id', auth()->user()->id);
})->count();
@endphp
@endauth

@php
$cryptos = App\Models\Crypto::where('status', 1)->get();
@endphp

<!-- Sidebar  -->
<div class="iq-sidebar">
    <div class="iq-navbar-logo d-flex justify-content-between">
        @auth
        <a href="{{ route('user.home') }}" class="header-logo">

            @else
            <a href="{{ route('home') }}" class="header-logo">
                @endauth
                <img src="{{ getImage(imagePath()['logoIcon']['path'] .'/favicon.png') }}" class="img-fluid rounded" alt="">
                <span>{{ $general->sitename }}</span>
            </a>
            @auth
            <div class="iq-menu-bt align-self-center">
                <div class="wrapper-menu">
                    <div class="main-circle"><i class="ri-menu-line"></i></div>
                    <div class="hover-circle"><i class="ri-close-fill"></i></div>
                </div>
            </div>
            @endauth
    </div>
    @auth
    @if($user->profile == "merchant")
    <p class="text-center" style="
       font-weight: 600;
       text-transform: uppercase;
       color: #0d6efd !important;
       font-size:12px;
       ">@lang('Business Banking')</p>                           
    @else
    <p class="text-center text-primary" style="
       font-weight: 600;
       text-transform: uppercase;
       font-size:12px;
       ">@lang('Personal Banking')</p>                               
    @endif
    <div id="sidebar-scrollbar">
        <nav class="iq-sidebar-menu">
            <ul id="iq-sidebar-toggle" class="iq-menu">
                <li>
                    <a href="#dashboard" class="iq-waves-effect" data-toggle="collapse" aria-expanded="true"><span class="ripple rippleEffect"></span><i class="las la-home iq-arrow-left"></i><span>Dashboard</span><i class="ri-arrow-right-s-line iq-arrow-right"></i></a>
                    <ul id="dashboard" class="iq-submenu collapse" data-parent="#iq-sidebar-toggle">
                        <li><a href="{{ route('user.home') }}"><i class="las la-laptop-code"></i>@lang('Dashboard')</a></li>
                         @if($general->livitpay)<li><a href = "{{ route('user.debit.master') }}" ><i class="ri-record-circle-line"></i>@lang('MasterCard Prepaid')</a></li>@endif                        
                          @if($general->crypto)<li><a href = "{{route('user.debit.cryptomaster')}}" ><i class="ri-record-circle-line"></i>@lang('Crypto Mastercard')</a></li>@endif
                         <li><a href = "{{route('user.deposit')}}" ><i class="ri-record-circle-line"></i>@lang('Add Balance')</a></li>
                          <li><a href = "{{ route('airtime') }}" ><i class="ri-record-circle-line"></i>@lang('Airtime')</a></li>
                    </ul>
                </li>


                <li>
                    <a href="#userinfo" class="iq-waves-effect" data-toggle="collapse" aria-expanded="false"><span class="ripple rippleEffect"></span><i class="fa fa-money iq-arrow-left"></i><span>@lang('Fiat')</span><i class="ri-arrow-right-s-line iq-arrow-right"></i></a>
                    <ul id="userinfo" class="iq-submenu collapse" data-parent="#iq-sidebar-toggle" style="">
                        <li><a href = "{{route('user.deposit')}}" ><i class="ri-record-circle-line"></i>@lang('Add Balance')</a></li>
                        @if($general->cd)<li><a href = "{{ route('user.debit.index') }}" ><i class="ri-record-circle-line"></i>@lang('Closed Loop Cards')</a></li>@endif
                        @if($general->livitpay)<li><a href = "{{ route('user.debit.master') }}" ><i class="ri-record-circle-line"></i>@lang('MasterCard Prepaid')</a></li>@endif                        
                        <li><a href = "{{route('user.transfer.receivelink')}}" ><i class="ri-record-circle-line"></i>@lang('Receive Payments')</a></li>
                        <li><a href = "{{route('user.transfer.donatelink')}}" ><i class="ri-record-circle-line"></i>@lang('Donation Links')</a></li>
                        <li><a href = "{{route('user.transfer')}}" ><i class="ri-record-circle-line"></i>@lang('Fund Transfer')</a></li>
                        <li><a href='{{route('user.withdraw')}}'><i class="ri-record-circle-line"></i>@lang('Withdraw Request')</a></li>
                        <li>  <a href='{{route('user.withdraw.history')}}'><i class="ri-record-circle-line"></i>@lang('Withdraw History')</a></li>
                        <li><a href = "{{route('user.deposit.history')}}" ><i class="ri-record-circle-line"></i>@lang('Deposits')</a></li>
                        <li><a href="{{ route('user.trx.log') }}"><i class="ri-record-circle-line"></i>@lang('All Transactions')</a></li>



                    </ul>
                </li>
               
                @if($general->crypto) <li>
                    <a href="#ui-elements" class="iq-waves-effect collapsed" data-toggle="collapse" aria-expanded="false"><i class="fa fa-bitcoin iq-arrow-left"></i><span>@lang('Crypto')</span><i class="ri-arrow-right-s-line iq-arrow-right"></i></a>
                    <ul id="ui-elements" class="iq-submenu collapse" data-parent="#iq-sidebar-toggle">
                        <li><a href = "{{ route('user.debit.cryptocardindex') }}" ><i class="ri-record-circle-line"></i>@lang('Closed Loop Cards')</a></li>
                         
                         <li><a href = "{{route('user.debit.cryptomaster')}}" ><i class="ri-record-circle-line"></i>Crypto Mastercard</a></li>
                        
                        <li><a href = "{{route('user.wallets')}}" ><i class="ri-record-circle-line"></i>Wallets</a></li>
                        <li><a href = "{{route('user.ctrx.log')}}" ><i class="ri-record-circle-line"></i>Transactions</a></li>
                        <li><a href = "{{route('user.advertisement.index')}}" ><i class="ri-record-circle-line"></i>Advertisements</a></li>
                        <li><a href="{{ route('user.trade.requests') }}"><i class="ri-record-circle-line"></i>@lang('TradeRequest') <span class="badge bg-primary text-white p-1">{{__($runningTradeCount)}}</span></a></li>
                        <li><a href = "{{route('user.withdraw.historyc')}}" ><i class="ri-record-circle-line"></i>Withdrawals</a></li>
                        <li><a href = "{{route('user.cryptodeposits.log')}}" ><i class="ri-record-circle-line"></i>Deposits</a></li>
                        <ul>
                            <li class="menu-level">
                                <a href="#sub-menu" class="iq-waves-effect collapsed" data-toggle="collapse" aria-expanded="false"><i class="ri-play-circle-line"></i><span>@lang('Buy Crypto')</span><i class="ri-arrow-right-s-line iq-arrow-right"></i></a>
                                <ul id="sub-menu" class="iq-submenu iq-submenu-data collapse">
                                    @foreach ($cryptos as $item)
                                    <li><a href="{{route('buy.sell',['buy',$item->code])}}"><i class="ri-record-circle-line"></i>{{$item->code}}</a></li>
                                    @endforeach
                                    <li><a href = "{{route('user.withdraw.historyc')}}" ><i class="ri-record-circle-line"></i>@lang('History')</a></li>
                                </ul>
                            </li>
                        </ul>
                        <ul>
                            <li class="menu-level">
                                <a href="#sub-menu" class="iq-waves-effect collapsed" data-toggle="collapse" aria-expanded="false"><i class="ri-play-circle-line"></i><span>@lang('Sell Crypto')</span><i class="ri-arrow-right-s-line iq-arrow-right"></i></a>
                                <ul id="sub-menu" class="iq-submenu iq-submenu-data collapse">
                                    @foreach ($cryptos as $item)
                                    <li><a href="{{route('buy.sell',['sell',$item->code])}}">{{$item->code}}</a></li>
                                    @endforeach
                                    <li><a href = "{{route('user.withdraw.historyc')}}" ><i class="ri-record-circle-line"></i>@lang('History')</a></li>
                                </ul>
                            </li>
                        </ul>

                    </ul>
                </li>
                @endif
                 @if($general->remittance) 
                <li>
                    <a href="#remittance" class="iq-waves-effect" data-toggle="collapse" aria-expanded="false"><span class="ripple rippleEffect"></span><i class="fa fa-exchange iq-arrow-left"></i><span>@lang('Money Transfer')</span><i class="ri-arrow-right-s-line iq-arrow-right"></i></a>
                    <ul id="remittance" class="iq-submenu collapse" data-parent="#iq-sidebar-toggle" style="">
                        <li>
                            <a href="{{ route('user.send.money.now') }}"><i class="ri-record-circle-line"></i>@lang('Send Remittance')</a>
                        </li>
                        <li>
                            <a href="{{ route('user.send.money.history') }}"><i class="ri-record-circle-line"></i>@lang('Remittance History')</a>
                        </li>



                    </ul>
                </li>
                @endif 
                @if($general->investments)
                <li>
                    <a href="#forms" class="iq-waves-effect collapsed" data-toggle="collapse" aria-expanded="false"><i class="las la-coins iq-arrow-left"></i><span>@lang('Investments')</span><i class="ri-arrow-right-s-line iq-arrow-right"></i></a>
                    <ul id="forms" class="iq-submenu collapse" data-parent="#iq-sidebar-toggle">
                        <li><a href = "{{route('user.plan')}}" ><i class="ri-record-circle-line"></i>@lang('Investment Plans')</a></li>
                        <li><a href = "{{route('user.interest.log')}}" ><i class="ri-record-circle-line"></i>@lang('My Investments')</a></li>
                        <li><a href = "{{route('user.transactions.interest')}}" ><i class="ri-record-circle-line"></i>@lang('Interest Details')</a></li>
                    </ul>
                </li>
                @endif
                @if($general->fdr)
                <li>
                    <a href="#wizard-form" class="iq-waves-effect collapsed" data-toggle="collapse" aria-expanded="false"><i class="las la-piggy-bank iq-arrow-left"></i><span>@lang('Fixed Deposits')</span><i class="ri-arrow-right-s-line iq-arrow-right"></i></a>
                    <ul id="wizard-form" class="iq-submenu collapse" data-parent="#iq-sidebar-toggle">
                        <li>
                            <a href="{{ route('user.fdr.plans') }}"><i class="ri-record-circle-line"></i>@lang('Fixed Deposits')</a>
                        </li>
                    </ul>
                </li>
                @endif

                @if($general->dps)
                <li>
                    <a href="#wizard-form1" class="iq-waves-effect collapsed" data-toggle="collapse" aria-expanded="false"><i class="las la-money-check-alt iq-arrow-left"></i><span>@lang('Deposit Pension')</span><i class="ri-arrow-right-s-line iq-arrow-right"></i></a>
                    <ul id="wizard-form1" class="iq-submenu collapse" data-parent="#iq-sidebar-toggle">
                        <li>
                            <a href="{{ route('user.dps.plans') }}"><i class="ri-record-circle-line"></i>@lang('Deposit Pension')</a>
                        </li>
                    </ul>
                </li>
                @endif
                @if($general->loan)
                <li>
                    <a href="#tables" class="iq-waves-effect collapsed" data-toggle="collapse" aria-expanded="false"><i class="las la-cash-register iq-arrow-left"></i><span>@lang('Credit')</span><i class="ri-arrow-right-s-line iq-arrow-right"></i></a>
                    <ul id="tables" class="iq-submenu collapse" data-parent="#iq-sidebar-toggle">
                        <li>  <a href="{{ route('user.loan.plans') }}"><i class="ri-record-circle-line"></i>@lang('Loans')</a></li>

                    </ul>
                </li>
                @endif

                @if($general->games)
                <li>
                    <a href="#games" class="iq-waves-effect collapsed" data-toggle="collapse" aria-expanded="false"><i class="las la-gamepad iq-arrow-left"></i><span>@lang('Games')</span><i class="ri-arrow-right-s-line iq-arrow-right"></i></a>
                    <ul id="games" class="iq-submenu collapse" data-parent="#iq-sidebar-toggle">
                        @foreach($games as $game)
                         <li>  <a href="{{ route('user.play.'.$game->alias) }}"><i class="ri-record-circle-line"></i>{{ __($game->name) }}</a></li>
                          @endforeach
                        
                        

                    </ul>
                </li>
                @endif
                @if($general->points)

                <li>
                    <a href="#points" class="iq-waves-effect collapsed" data-toggle="collapse" aria-expanded="false"><i class="las la-hand-holding-heart iq-arrow-left"></i><span>@lang('Loyalty Points')</span><i class="ri-arrow-right-s-line iq-arrow-right"></i></a>
                    <ul id="points" class="iq-submenu collapse" data-parent="#iq-sidebar-toggle">
                        <li>  <a href="{{ route('user.ptrx.log') }}"><i class="ri-record-circle-line"></i>@lang('Points Transactions')</a></li>

                    </ul>
                </li>
                @endif
                @if($user->profile == "merchant")
                <li>
                    <a href="#charts" class="iq-waves-effect collapsed" data-toggle="collapse" aria-expanded="false"><i class="las la-store iq-arrow-left"></i><span>@lang('Merchants')</span><i class="ri-arrow-right-s-line iq-arrow-right"></i></a>
                    <ul id="charts" class="iq-submenu collapse" data-parent="#iq-sidebar-toggle">

                        <li><a href = "{{ route('user.pos') }}" ><i class="ri-record-circle-line"></i>@lang('Point of Sale')</a></li>
                        <li><a href = "{{ route('user.transfer.receivelink') }}" ><i class="ri-record-circle-line"></i>@lang('Payment Links')</a></li>
                        <li><a href="{{ route('user.mtrx.log') }}"><i class="ri-record-circle-line"></i>@lang('Transactions')</a></li>
                        <li><a href='{{route('user.withdraw')}}'><i class="ri-record-circle-line"></i>Withdraw Request</a></li>

                        <li><a href = "{{ route('user.developers.index') }}" ><i class="ri-record-circle-line"></i>@lang('Developers')</a></li>
                    </ul>
                </li>

                @endif
                @if($general->cd)
                <li>
                    <a href="#icons" class="iq-waves-effect collapsed" data-toggle="collapse" aria-expanded="false"><i class="las la-landmark iq-arrow-left"></i><span>@lang('Banking')</span><i class="ri-arrow-right-s-line iq-arrow-right"></i></a>
                    <ul id="icons" class="iq-submenu collapse" data-parent="#iq-sidebar-toggle">
                        @if($general->livitpay)<li><a href = "{{ route('user.debit.master') }}" ><i class="ri-record-circle-line"></i>@lang('Master Debit Card')</a></li>@endif                        
                        @if($general->cd)<li><a href = "{{ route('user.debit.index') }}" ><i class="ri-record-circle-line"></i>@lang('Closed Loop Cards')</a></li>@endif

                        

                    </ul>
                </li>
                @endif
                <li>
                    <a href="#authentication" class="iq-waves-effect collapsed" data-toggle="collapse" aria-expanded="false"><i class="las la-concierge-bell iq-arrow-left"></i><span>@lang('Services')</span><i class="ri-arrow-right-s-line iq-arrow-right"></i></a>
                    <ul id="authentication" class="iq-submenu collapse" data-parent="#iq-sidebar-toggle">
                        <li><a href = "{{ route('donate') }}" ><i class="ri-record-circle-line"></i>@lang('Donate')</a></li>
                        <li><a href="{{ url('accounts/auth') }}/autologin?user_name={{ base64_encode($user->email) }}"><i class="ri-record-circle-line"></i>@lang('Accounting')</a></li>
                        <li><a href = "{{ url('cards') }}" ><i class="ri-record-circle-line"></i>@lang('Buy GiftCards')</a></li>
                        <li><a href = "{{route('user.vouchers.index')}}" ><i class="ri-record-circle-line"></i>@lang('E-Vouchers')</a></li>
                        <li><a href = "{{route('user.card')}}" ><i class="ri-record-circle-line"></i>@lang('Purchased GiftCards')</a></li>
                        <li><a href = "{{ route('airtime') }}" ><i class="ri-record-circle-line"></i>@lang('Airtime')</a></li>
                        <li><a href = "{{ route('user.meetings') }}" ><i class="ri-record-circle-line"></i>@lang('Meetings')</a></li>
                        <li><a href = "{{ route('user.fxtrader') }}" ><i class="ri-record-circle-line"></i>@lang('FX Trader')</a></li>
                        <li><a href='{{route('user.agentlist')}}'><i class="ri-record-circle-line"></i>@lang('Agent List')</a></li>
                    </ul>
                </li>

                <li>
                    <a href="#extra-pages" class="iq-waves-effect collapsed" data-toggle="collapse" aria-expanded="false"><i class="las la-headset iq-arrow-left"></i><span>@lang('Support')</span><i class="ri-arrow-right-s-line iq-arrow-right"></i></a>
                    <ul id="extra-pages" class="iq-submenu collapse" data-parent="#iq-sidebar-toggle">
                        <li><a href="{{route('ticket.open')}}" ><i class="ri-record-circle-line"></i>@lang('New Ticket')</a></li>
                        <li><a href="{{route('ticket')}}"><i class="ri-record-circle-line"></i>@lang('My Tickets')</a></li>
                    </ul>
                </li>

            </ul>
        </nav>
        <div class="p-3"></div>
    </div>
    @endauth
</div>
<!-- TOP Nav Bar -->
<div class="iq-top-navbar">
    <div class="iq-navbar-custom">
        <nav class="navbar navbar-expand-lg navbar-light p-0">
            <div class="iq-menu-bt d-flex align-items-center">
                @auth
                <div class="wrapper-menu">
                    <div class="main-circle"><i class="ri-menu-line"></i></div>
                    <div class="hover-circle"><i class="ri-close-fill"></i></div>
                </div>
                @endauth
                <div class="iq-navbar-logo d-flex justify-content-between ml-3">
                    @auth
                    <a href="{{ route('user.home') }}" class="header-logo">
                        @else
                        <a href="{{ route('home') }}" class="header-logo">
                            @endauth
                            <img src="{{ getImage(imagePath()['logoIcon']['path'] .'/favicon.png') }}" class="img-fluid rounded" alt="">
                            <span>{{ $general->sitename }}</span>
                        </a>
                </div>
            </div>
            @auth
            <div class="iq-search-bar">
                <marquee class="text-primary">{{ $advert->data_values->scroll }}</marquee>
            </div>
            <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarSupportedContent" aria-controls="navbarSupportedContent"  aria-label="Toggle navigation">
                <i class="ri-menu-3-line"></i>
            </button>
            @endauth

            <div class="collapse navbar-collapse" id="navbarSupportedContent">
                <ul class="navbar-nav ml-auto navbar-list">
                    <li class="nav-item">

                        <select class="select select-sm form-control style--trans w-auto ms-3 langSel mt-3" style="">
                            @foreach($language as $item)
                            <option class="iq-sub-card" value="{{$item->code}}" @if(session('lang') == $item->code) selected  @endif>{{ __($item->name) }}</option>
                            @endforeach
                        </select>


                    </li>
                    @auth
                    <li class="nav-item nav-icon">
                        <a href="{{ route('user.checkout') }}" class="iq-waves-effect bg-primary rounded"><span class="ripple rippleEffect"></span><i class="ri-shopping-cart-2-line"></i></a>
                    </li>
                    @endauth
                </ul>
            </div>
            @auth
            <ul class="navbar-list">
                <li class="line-height">
                    <a href="#" class="search-toggle iq-waves-effect d-flex align-items-center">
                        <img src="{{ getImage(imagePath()['profile']['user']['path'].'/'. @$user->image,imagePath()['profile']['user']['size']) }}" class="img-fluid rounded mr-3" alt="user">
                        <div class="caption">
                            <h6 class="mb-0 line-height">{{ $user->firstname }}</h6>
                            <p class="mb-0">Balance {{ __($general->cur_text) }} {{ showAmount($user->balance) }}</p>
                        </div>
                    </a>
                    <div class="iq-sub-dropdown iq-user-dropdown">
                        <div class="iq-card shadow-none m-0">
                            <div class="iq-card-body p-0 ">
                                <div class="bg-primary p-3">
                                    <h5 class="mb-0 text-white line-height">Hello {{ $user->firstname }}</h5>
                                    <span class="text-white font-size-12">Balance {{ __($general->cur_text) }} {{ showAmount($user->balance) }}</span>
                                </div>
                                <a href="{{ route('user.profile.setting') }}" class="iq-sub-card iq-bg-primary-hover">
                                    <div class="media align-items-center">
                                        <div class="rounded iq-card-icon iq-bg-primary">
                                            <i class="ri-file-user-line"></i>
                                        </div>
                                        <div class="media-body ml-3">
                                            <h6 class="mb-0 ">@lang('My Profile')</h6>
                                            <p class="mb-0 font-size-12">@lang('View personal profile details.')</p>
                                        </div>
                                    </div>
                                </a>
                                <a href="{{ route('user.kyc.index') }}" class="iq-sub-card iq-bg-primary-hover">
                                    <div class="media align-items-center">
                                        <div class="rounded iq-card-icon iq-bg-primary">
                                            <i class="ri-profile-line"></i>
                                        </div>
                                        <div class="media-body ml-3">
                                            <h6 class="mb-0 ">@lang('KYC')</h6>
                                            <p class="mb-0 font-size-12">@lang('My KYC Details.')</p>
                                        </div>
                                    </div>
                                </a>
                                <a href="{{ route('user.twofactor') }}" class="iq-sub-card iq-bg-primary-hover">
                                    <div class="media align-items-center">
                                        <div class="rounded iq-card-icon iq-bg-primary">
                                            <i class="ri-account-box-line"></i>
                                        </div>
                                        <div class="media-body ml-3">
                                            <h6 class="mb-0 ">@lang('2FA')</h6>
                                            <p class="mb-0 font-size-12">@lang('Manage two factor authentication.')</p>
                                        </div>
                                    </div>
                                </a>
                                <a href="{{ route('user.change.password') }}" class="iq-sub-card iq-bg-primary-hover">
                                    <div class="media align-items-center">
                                        <div class="rounded iq-card-icon iq-bg-primary">
                                            <i class="ri-lock-line"></i>
                                        </div>
                                        <div class="media-body ml-3">
                                            <h6 class="mb-0 ">@lang('Password Settings')</h6>
                                            <p class="mb-0 font-size-12">@lang('Change login password.')</p>
                                        </div>
                                    </div>
                                </a>
                                <div class="d-inline-block w-100 text-center p-3">
                                    <a class="bg-primary iq-sign-btn" href="{{ route('user.logout') }}" role="button">Sign out<i class="ri-login-box-line ml-2"></i></a>
                                </div>
                            </div>
                        </div>
                    </div>
                </li>
            </ul>
            @endauth
        </nav>
    </div>
</div>
<!-- TOP Nav Bar END -->




<script src="{{asset($activeTemplateTrue.'js/jquery-3.3.1.min.js')}}"></script>
<script>

$(document).ready(function () {
    $(".langSel").on("change", function () {
        window.location.href = "{{route('home')}}/change/" + $(this).val();
    });


    $("#sidebar-toggle").click(function () {
        if ($('#wrapper').hasClass('.toggled')) {
            $("#wrapper").removeClass(".toggled");
        } else {
            $("#wrapper").addClass(".toggled");
        }

    });


});



</script>