@php
$header = getContent('header.content', true);
$advert = getContent('dashboardadverts.content', true);
$socialMedias = getContent('social_icon.element');
$user = Auth::user();
$general = App\Models\GeneralSetting::first();
$games = App\Models\Game::where('status',1)->get(['image','name','id','max_limit','min_limit','win','invest_back','alias']);
@endphp
@auth
@php
$runningTradeCount = App\Models\TradeRequest::where([['status', '!=', 1],['status', '!=', 9]])->where(function ($q){
$q->where('buyer_id', auth()->user()->id)->orWhere('seller_id', auth()->user()->id);
})->count();
@endphp
@endauth

@php
$cryptos = App\Models\Crypto::where('status', 1)->get();
@endphp

<!-- Sidebar starts -->
<div class="sidebar">
    <!-- Logo sidebar -->
    @auth
    <a href="{{ route('user.home') }}" class="logo p-0 text-center">
        <img src="{{getImage(imagePath()['logoIcon']['path'] .'/logo.png')}}" width="150px" alt="" class="mx-auto">
    </a>
    @else
    <a href="{{ route('home') }}" class="logo p-0 text-center">
        <img src="{{getImage(imagePath()['logoIcon']['path'] .'/logo.png')}}" width="150px" alt="" class="mx-auto">
    </a>
    @endauth
    <!-- Logo sidebar ends -->
    @auth
    <!-- Navigation menu sidebar-->
    @if($user->profile == "merchant")
    <h6 class="subtitle fs11">@lang('BUSINESS BANKING')</h6>
    @else
    <h6 class="subtitle fs11">@lang('PERSONAL BANKING')</h6>
    @endif
    <ul class="nav flex-column">
        <li class="nav-item dropdown">
            <a class="nav-link dropdown-toggle" href="javascript:void(0)"><i class="material-icons icon">dashboard</i><span>Home</span> <i class="material-icons arrow">expand_more</i></a>
            <div class="nav flex-column">
                <div class="nav-item"><a class="nav-link" href="{{ route('user.home') }}"><span>@lang('Dashboard')</span></a></div>

                <div class="nav-item"><a class="nav-link" href="{{ route('user.mastervirtual') }}"><span>@lang('MasterCard')</span></a></div>


                @if($general->livitpay)

                <div class="nav-item"><a class="nav-link" href="{{route('user.prepaycards')}}"><span>@lang('Prepaid Fix Value')</span></a></div>
                <div class="nav-item"><a class="nav-link" href="{{route('user.prepaycard.prepaidcarduser')}}"><span>@lang('My Cards')</span></a></div>
                @endif
                <div class="nav-item"><a class="nav-link" href="{{route('user.deposit')}}"><span>@lang('Add Balance')</span></a></div>
                <div class="nav-item"><a class="nav-link" href="{{ route('airtime') }}"><span>@lang('Airtime')</span></a></div>

            </div>
        </li>
    </ul>

    <ul class="nav flex-column">
        <li class="nav-item dropdown">
            <a class="nav-link dropdown-toggle" href="javascript:void(0)"><i class="material-icons icon">local_atm</i><span>Fiat</span> <i class="material-icons arrow">expand_more</i></a>
            <div class="nav flex-column">
                <div class="nav-item"><a class="nav-link" href="{{route('user.deposit')}}"><span>Add Balance</span></a></div>
                @if($general->cd)<div class="nav-item"><a class="nav-link" href="{{ route('user.debit.index') }}"><span>ClosedLoop cards</span></a></div>@endif
                <div class="nav-item"><a class="nav-link" href="{{ route('user.mastervirtual') }}"><span>@lang('MasterCard')</span></a></div>
                <div class="nav-item"><a class="nav-link" href="{{route('user.transfer.receivelink')}}"><span>Receive Payment</span></a></div>
                <div class="nav-item"><a class="nav-link" href="{{route('user.transfer.donatelink')}}"><span>Donation Lnk</span></a></div>
                <div class="nav-item"><a class="nav-link" href="{{route('user.transfer')}}"><span>Fund Transfer</span></a></div>
                <div class="nav-item"><a class="nav-link" href="{{route('user.withdraw')}}"><span>Withdraw Request</span></a></div>
                <div class="nav-item"><a class="nav-link" href="{{route('user.withdraw.history')}}"><span>Withdraw History</span></a></div>
                <div class="nav-item"><a class="nav-link" href="{{route('user.deposit.history')}}"><span>Deposits</span></a></div>
                <div class="nav-item"><a class="nav-link" href="{{ route('user.trx.log') }}"><span>All Transaction</span></a></div>
            </div>
        </li>
    </ul>
    @if($general->crypto)
    <ul class="nav flex-column">
        <li class="nav-item dropdown">
            <a class="nav-link dropdown-toggle" href="javascript:void(0)"><span class="bi bi-currency-bitcoin icon"></span><span>Crypto</span> <i class="material-icons arrow">expand_more</i></a>
            <div class="nav flex-column">
                <div class="nav-item"><a class="nav-link" href="{{ route('user.debit.cryptocardindex') }}"><span>Closed Loop Cards</span></a></div>

                <div class="nav-item"><a class="nav-link" href="{{route('user.wallets')}}"><span>Wallets</span></a></div>
                <div class="nav-item"><a class="nav-link" href="{{route('user.ctrx.log')}}"><span>Transactions</span></a></div>
                <div class="nav-item"><a class="nav-link" href="{{route('user.advertisement.index')}}"><span>Advertisements</span></a></div>
                <div class="nav-item"><a class="nav-link" href="{{ route('user.trade.requests') }}"><span>Trade request</span> <span class="badge bg-primary text-white vm ml-1">0</span></a></div>
                <div class=" nav-item"><a class="nav-link" href="{{route('user.withdraw.historyc')}}"><span>Withdrawals</span></a></div>
                <div class="nav-item"><a class="nav-link" href="{{route('user.cryptodeposits.log')}}"><span>Deposits</span></a></div>
                <div class="nav-item dropdown">
                    <a class="nav-link dropdown-toggle" href="javascript:void(0)"><span>Buy Crypto</span> <i class="material-icons arrow">expand_more</i></a>
                    <div class="nav flex-column">
                        @foreach ($cryptos as $item)
                        <div class="nav-item"><a class="nav-link" href="{{route('buy.sell',['buy',$item->code])}}"><span>{{$item->code}}</span></a></div>
                        @endforeach
                        <div class="nav-item"><a class="nav-link" href="{{route('user.withdraw.historyc')}}"><span>@lang('History')</span></a></div>

                    </div>
                </div>
                <div class="nav-item dropdown">
                    <a class="nav-link dropdown-toggle" href="javascript:void(0)"><span>Sell Crypto</span> <i class="material-icons arrow">expand_more</i></a>
                    <div class="nav flex-column">
                        @foreach ($cryptos as $item)
                        <div class="nav-item"><a class="nav-link" href="{{route('buy.sell',['sell',$item->code])}}"><span>{{$item->code}}</span></a></div>

                        @endforeach
                        <div class="nav-item"><a class="nav-link" href="{{route('user.withdraw.historyc')}}"><span>@lang('History')</span></a></div>
                    </div>
                </div>
            </div>
        </li>
    </ul>
    @endif
    @if($user->isagent)
    <ul class="nav flex-column">
        <li class="nav-item dropdown">
            <a class="nav-link dropdown-toggle" href="javascript:void(0)"><i class="bi bi-cash-stack icon"></i><span>Agent Remittance</span> <i class="material-icons arrow">expand_more</i></a>
            <div class="nav flex-column">
                <div class="nav-item"><a class="nav-link" href="{{ route('user.agentremit') }}"><span>MTCN Payout</span></a></div>

            </div>
        </li>
    </ul>
    @endif

    @if($general->remittance)
    <ul class="nav flex-column">
        <li class="nav-item dropdown">
            <a class="nav-link dropdown-toggle" href="javascript:void(0)"><i class="bi bi-arrow-left-right icon"></i><span>Money Transfer</span> <i class="material-icons arrow">expand_more</i></a>
            <div class="nav flex-column">
                <div class="nav-item"><a class="nav-link" href="{{ route('user.send.money.now') }}"><span>Send Remittance</span></a></div>
                <div class="nav-item"><a class="nav-link" href="{{ route('user.send.money.history') }}"><span>Remittance History</span></a></div>
            </div>
        </li>
    </ul>
    @endif @if($general->vonage)
    <ul class="nav flex-column">
        <li class="nav-item dropdown">
            <a class="nav-link dropdown-toggle" href="javascript:void(0)"><i class="bi bi-phone-vibrate icon"></i><span>Virtual GlobalPhone</span> <i class="material-icons arrow">expand_more</i></a>
            <div class="nav flex-column">
                <div class="nav-item"><a class="nav-link" href="{{route('user.vpplans')}}"><span>Buy Number</span></a></div>
                <div class="nav-item"><a class="nav-link" href="{{route('user.vpviewsms')}}"><span>My Numbers</span></a></div>

            </div>
        </li>
    </ul>
    @endif
    @if($general->investments)
    <ul class="nav flex-column">
        <li class="nav-item dropdown">
            <a class="nav-link dropdown-toggle" href="javascript:void(0)"><i class="bi bi-cash-coin icon"></i><span>Investment</span> <i class="material-icons arrow">expand_more</i></a>
            <div class="nav flex-column">
                <div class="nav-item"><a class="nav-link" href="{{route('user.plan')}}"><span>Investment Plans</span></a></div>
                <div class="nav-item"><a class="nav-link" href="{{route('user.interest.log')}}"><span>My Investment</span></a></div>
                <div class="nav-item"><a class="nav-link" href="{{route('user.transactions.interest')}}"><span>Interest Details</span></a></div>
            </div>
        </li>
    </ul>
    @endif
    @if($general->fdr)
    <ul class="nav flex-column">
        <li class="nav-item dropdown">
            <a class="nav-link dropdown-toggle" href="javascript:void(0)"><i class="bi bi-piggy-bank icon"></i><span>Fixed Deposits</span> <i class="material-icons arrow">expand_more</i></a>
            <div class="nav flex-column">
                <div class="nav-item"><a class="nav-link" href="{{ route('user.fdr.plans') }}"><span>All Fixed Deposits</span></a></div>
            </div>
        </li>
    </ul>
    @endif
    @if($general->dps)
    <ul class="nav flex-column">
        <li class="nav-item dropdown">
            <a class="nav-link dropdown-toggle" href="javascript:void(0)"><i class="material-icons icon">account_balance</i><span>Deposit Pension</span> <i class="material-icons arrow">expand_more</i></a>
            <div class="nav flex-column">
                <div class="nav-item"><a class="nav-link" href="{{ route('user.dps.plans') }}"><span>Deposit Pension</span></a></div>
            </div>
        </li>
    </ul>
    @endif

    @if($general->loan)
    <ul class="nav flex-column">
        <li class="nav-item dropdown">
            <a class="nav-link dropdown-toggle" href="javascript:void(0)"><i class="material-icons icon">credit_card</i><span>Credit</span> <i class="material-icons arrow">expand_more</i></a>
            <div class="nav flex-column">
                <div class="nav-item"><a class="nav-link" href="{{ route('user.loan.plans') }}"><span>Loans</span></a></div>
            </div>
        </li>
    </ul>
    @endif

    @if($general->games)
    <ul class="nav flex-column">
        <li class="nav-item dropdown">
            <a class="nav-link dropdown-toggle" href="javascript:void(0)"><i class="bi bi-controller icon"></i><span>Games</span> <i class="material-icons arrow">expand_more</i></a>
            <div class="nav flex-column">
                @foreach($games as $game)
                <div class="nav-item"><a class="nav-link" href="{{ route('user.play.'.$game->alias) }}"><span>{{ __($game->name) }}</span></a></div>
                @endforeach
            </div>
        </li>
    </ul>
    @endif
    @if($general->points)
    <ul class="nav flex-column">
        <li class="nav-item dropdown">
            <a class="nav-link dropdown-toggle" href="javascript:void(0)"><i class="bi bi-award icon"></i><span>Loyalty Points</span> <i class="material-icons arrow">expand_more</i></a>
            <div class="nav flex-column">
                <div class="nav-item"><a class="nav-link" href="{{ route('user.ptrx.log') }}"><span>Points Transactions</span></a></div>
            </div>
        </li>
    </ul>
    @endif

    @if($user->profile == "merchant")
    <ul class="nav flex-column">
        <li class="nav-item dropdown">
            <a class="nav-link dropdown-toggle" href="javascript:void(0)"><i class="bi bi-shop icon"></i><span>Merchants</span> <i class="material-icons arrow">expand_more</i></a>
            <div class="nav flex-column">
                <div class="nav-item"><a class="nav-link" href="{{ route('user.pos') }}"><span>@lang('Point of Sale')</span></a></div>
                <div class="nav-item"><a class="nav-link" href="{{ route('user.transfer.receivelink') }}"><span>@lang('Payment Links')</span></a></div>
                <div class="nav-item"><a class="nav-link" href="{{ route('user.mtrx.log') }}"><span>@lang('Transactions')</span></a></div>
                <div class="nav-item"><a class="nav-link" href="{{route('user.withdraw')}}"><span>Withdraw Request</span></a></div>
                <div class="nav-item"><a class="nav-link" href="{{ route('user.developers.index') }}"><span>@lang('Developers')</span></a></div>
            </div>
        </li>
    </ul>
    <!--@endif-->



    <ul class="nav flex-column">
        <li class="nav-item dropdown">
            <a class="nav-link dropdown-toggle" href="javascript:void(0)"><i class="bi bi-menu-button-wide-fill icon"></i><span>Services</span> <i class="material-icons arrow">expand_more</i></a>
            <div class="nav flex-column">
                <div class="nav-item"><a class="nav-link" href="{{ route('donate') }}"><span>Donate</span></a></div>
                <div class="nav-item"><a class="nav-link" href="{{ url('accounts/auth') }}/autologin?user_name={{ base64_encode($user->email) }}"><span>Accounting</span></a></div>
<!--                <div class="nav-item"><a class="nav-link" href="{{ url('cards') }}"><span>Buy Gift Cards</span></a></div>-->
                <div class="nav-item"><a class="nav-link" href="{{route('user.vouchers.index')}}"><span>E-Vouchers</span></a></div>
<!--                <div class="nav-item"><a class="nav-link" href="{{route('user.card')}}"><span>Purchased Gift Cards</span></a></div>-->
                <div class="nav-item"><a class="nav-link" href="{{ route('airtime') }}"><span>Airtime</span></a></div>
                <div class="nav-item"><a class="nav-link" href="{{ route('user.meetings') }}"><span>Meetings</span></a></div>
                <div class="nav-item"><a class="nav-link" href="{{ route('user.fxtrader') }}"><span>FX Traders</span></a></div>
                <div class="nav-item"><a class="nav-link" href="{{route('user.agentlist')}}"><span>Agent List</span></a></div>
            </div>
        </li>
    </ul>

    <ul class="nav flex-column">
        <li class="nav-item dropdown">
            <a class="nav-link dropdown-toggle" href="javascript:void(0)"><i class="bi bi-life-preserver icon"></i><span>Support</span> <i class="material-icons arrow">expand_more</i></a>
            <div class="nav flex-column">
                <div class="nav-item"><a class="nav-link" href="{{route('ticket.open')}}"><span>New Ticket</span></a></div>
                <div class="nav-item"><a class="nav-link" href="{{route('ticket')}}"><span>My Ticket</span></a></div>
            </div>
        </li>
    </ul>


    <!-- Navigation menu sidebar ends -->
    <br>
    <!-- Upgrade notification -->
    <div class="row mx-0 upgrad-box">
        <div class="col-12">
            <div class="card mb-4">
                <div class="card-body">
                    <h4 class="fs15 font-weight-light mb-3">Important <a class="close-btn"><i class="material-icons">close</i></a></h4>
                    <p class="text-mute">{{ $advert->data_values->scroll2 ?? "" }}</p>
                </div>
            </div>
        </div>
    </div>
    <!-- Upgrade notification ends -->
    @endauth
</div>
<!-- Sidebar ends -->





