@extends($activeTemplate.'layouts.auth_master')
@section('content')

<div class="container main-container" id="main-container">
    <form action="{{ route('user.send.money.save') }}" method="post" class="card-body container-fluid register">
        @csrf
    <div class="row">

        <div class="col-12 col-md-5 col-lg-4 col-xl-4">
            <div class="card border-0 shadow-sm mb-4">
                <div class="card-header">
                    <h5>Payment Information</h5>
                </div>

                <div class="card-body">
                    <div class="row">
                        <div class="col">
                            <div class="form-group">
                                <label for="sendmoney">Send</label>
                                <input id="from" type="number" step="any" class="form-control form--control text--right sending-amount" value="{{ $sendingAmount }}" placeholder="0.00" name="sending_amount" required>

                            </div>
                        </div>

                        <div class="col-auto">
                            <div class="form-group">
                                <label for="sendmoney">&nbsp;</label>
                                <div class="sending-parent">
                                    <select name="sending_country" id="sending-country" class="form-control form--control country-picker sending-countries">
                                        @foreach ($countries as $country)
                                        <option value="{{ $country->id }}" data-id="{{ $country->id }}" data-rate="{{ $country->rate }}" data-currency="{{ $country->currency }}" data-image="{{ asset(getFilePath('country') . '/' . $country->image) }}" data-name="{{ $country->name }}">
                                            {{ $country->currency }}
                                        </option>
                                        @endforeach
                                    </select>
                                </div>
                            </div>
                        </div>
                    </div>
                    <div class="row">
                        <div class="col">
                            <div class="form-group">
                                <label for="sendmoney">Recipient will receive</label>
                                <input id="to" type="number" step="any" class="form-control form--control text--right recipient-amount" placeholder="0.00" value="{{ $recipientAmount }}" name="recipient_amount" required>
                            </div>
                        </div>

                        <div class="col-auto">
                            <div class="form-group">
                                <label for="sendmoney">&nbsp;</label>
                                <div class="recipient-parent">
                                    <select name="recipient_country" id="recipient-country" class="form-control form--control country-picker recipient-countries">
                                        @foreach ($countries as $country)
                                        <option value="{{ $country->id }}" data-id="{{ $country->id }}" data-currency="{{ $country->currency }}" data-rate="{{ $country->rate }}" data-dial_code="{{ $country->dial_code }}" data-fixed_charge="{{ $country->fixed_charge }}" data-percent_charge="{{ $country->percent_charge }}" data-image="{{ asset(getFilePath('country') . '/' . $country->image) }}" data-name="{{ $country->name }}">
                                            {{ $country->currency }}
                                        </option>
                                        @endforeach
                                    </select>
                                </div>
                            </div>
                        </div>
                    </div>
                    <div class="row">
                        <div class="col-12">
                            <div class="form-group">
                                <label for="source_of_funds">Source fund</label>
                                <select class="form-control" name="source_of_funds" id="source_of_funds" required="">
                                    <option value="">@lang('Select One')</option>
                                    @foreach ($sources as $source)
                                    <option value="{{ $source->id }}">{{ __($source->name) }}</option>
                                    @endforeach
                                </select>
                            </div>
                        </div>
                        <div class="col-12">
                            <div class="form-group">
                                <label for="source_purpose">Sending Purpose</label>
                                <select class="form-control" name="sending_purpose" id="source_purpose">
                                    <option value="">@lang('Select One')</option>
                                    @foreach ($purposes as $purpose)
                                    <option value="{{ $purpose->id }}">{{ __($purpose->name) }}</option>
                                    @endforeach
                                </select>
                            </div>
                        </div>
                    </div>

                    <!-- charges and payable-->
                    <div class="border-top">
                        <div class="row mt-3">
                            <div class="col-4">
                                <p class="text-mute mb-2">Charge <span class="sending-currency"></span></p>
                                <h6 class="mb-0"><span class="charge-amount-text"></span></h6>
                            </div>
                            <div class="col-4 px-0 text-center">
                                <p class="text-mute mb-2">Payable <span class="sending-currency"></span></p>
                                <h6 class="mb-0"><span class="final-amount-text"></span></h6>
                            </div>
                            <div class="col-4 text-right">
                                <p class="text-mute mb-2">Payable {{ __($general->cur_text) }}</p>
                                <h6 class="mb-0"><span class="base-amount-text"></span> {{ __($general->cur_text) }}</h6>
                            </div>
                        </div>
                    </div>
                </div>
            </div>

        </div>
        <div class="col">

            <div class="accordion" id="accordionExample">
                <div class="card mb-2">
                    <div class="card-header p-0" id="headingOne">
                        <h2 class="mb-0">
                            <button class="btn btn-primary btn-block text-left" type="button" data-toggle="collapse" data-target="#collapseOne" aria-expanded="true" aria-controls="collapseOne">
                                <span class="h6">Recipient Personal</span>
                            </button>
                        </h2>
                    </div>
                    <div id="collapseOne" class="collapse show" aria-labelledby="headingOne" data-parent="#accordionExample">
                        <div class="card-body">
                            <div class="row">
                                <div class="col-12 col-lg-6">
                                    <div class="form-group">
                                        <label for="fullname">Full Name</label>
                                        <input id="recipient_name" type="text" class="form-control" name="recipient[name]" value="{{ old('recipient')['name'] ?? null }}" required placeholder="Full Name">
                                    </div>
                                </div>
                                <div class="col-12 col-lg-6">
                                    <div class="form-group">
                                        <label for="email">Email</label>
                                        <input id="recipient_email" type="email" class="form-control" name="recipient[email]" value="{{ old('recipient')['email'] ?? null }}" required placeholder="Email Address">
                                    </div>
                                </div>
                            </div>
                            <div class="row">

                                <div class="col-12 col-lg-6">
                                    <div class="form-group">
                                        <label for="mobilecode">Mobile</label>
                                        <div class="input-group ">
                                            <span class="input-group-text dial-code">
                                            </span>

                                            <input type="text" id="recipient_mobile" value="{{ old('recipient')['mobile'] ?? null }}" name="recipient[mobile]" class="form-control" required>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="card-footer">
                            <div class="row">
                                <div class="col">

                                </div>
                                <div class="col-auto">
                                    <a href="javascript:void(0)" data-toggle="collapse" data-target="#collapseTwo" class="btn btn-primary">Next <i class="bi bi-arrow-right ml-1"></i></a>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
                <div class="card mb-2">
                    <div class="card-header p-0" id="headingTwo">
                        <h2 class="mb-0">
                            <button class="btn btn-primary btn-block text-left collapsed" type="button" data-toggle="collapse" data-target="#collapseTwo" aria-expanded="false" aria-controls="collapseTwo">
                                <span class="h6">Recipient Bank</span>
                            </button>
                        </h2>
                    </div>
                    <div id="collapseTwo" class="collapse" aria-labelledby="headingTwo" data-parent="#accordionExample">
                        <div class="card-body">
                            <div class="row">
                                <div class="col-12 col-md-6">
                                    <div class="form-group">
                                        <label for="agentbank">Agent or Bank Transfer</label>
                                        <select id="select_id" name="type" class="form-control" required onchange="ifbankselect(this)">
                                            <option value="">Please Select</option>
                                            <option value="agent">Agent</option>
                                            <option value="banktransfer">Bank Transfer</option>
                                        </select>
                                    </div>
                                </div>
                            </div> 
                            
                            <div class="row " id="ifbank">
                                <div class="col-12 col-md-6">
                                    <div class="form-group">
                                        <label for="recipient_bank">Agent/Bank Name</label>
                                        <input type="text" name="recipient[bank]" value="{{ old('recipient')['bank'] ?? null }}" id="recipient_bank" class="form-control" required>
                                    </div>
                                </div>
                                <div class=" col-12 col-md-6">
                                    <div class="form-group">
                                        <label for="iban">IBAN/AC/ACH Number</label>
                                        <input type="text" class="form-control" name="recipient[account]" value="{{ old('recipient')['account'] ?? null }}" id="recipient_account" required>
                                    </div>
                                </div>
                                <div class="col-12 col-md-6">
                                    <div class="form-group">
                                        <label for="recipient_routing">Routing/IFSC/BIC/SwiftCode</label>
                                        <input type="text" class="form-control" nname="recipient[routing]" value="{{ old('recipient')['routing'] ?? null }}" id="recipient_routing" required>
                                    </div>
                                </div>
                                <div class="col-12 col-md-6">
                                    <div class="form-group">
                                        <label for="recipient_additional">Additional Info</label>
                                        <input type="text" class="form-control" name="recipient[additional]" value="{{ old('recipient')['additional'] ?? null }}" id="recipient_additional" required placeholder="Payment Reference">
                                    </div>
                                </div>
                            </div>

                        </div>
                        <div class="card-footer">
                            <div class="row">
                                <div class="col">
                                    <a href="javascript:void(0)" data-toggle="collapse" data-target="#collapseOne" class="btn btn-outline-primary"><i class=" bi bi-arrow-left mr-1"></i> Previous</a>
                                </div>
                                <div class="col-auto">
                                    <a href="javascript:void(0)" data-toggle="collapse" data-target="#collapseThree" class="btn btn-primary">Make Payment <i class="bi bi-arrow-right ml-1"></i></a>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
                <div class="card mb-2">
                    <div class="card-header p-0" id="headingThree">
                        <h2 class="mb-0">
                            <button class="btn btn-primary btn-block text-left collapsed" type="button" data-toggle="collapse" data-target="#collapseThree" aria-expanded="false" aria-controls="collapseThree">
                                <span class="h6">Recipient Address</span>
                            </button>
                        </h2>
                    </div>
                    <div id="collapseThree" class="collapse" aria-labelledby="headingThree" data-parent="#accordionExample">
                        <div class="card-body">
                            <div class="row">
                                <div class="col-12 col-lg-12">
                                    <div class="form-group">
                                        <label for="recipient_address1">Address Line 1</label>
                                        <input type="text" name="recipient[address]" value="{{ old('recipient')['address'] ?? null }}" id="recipient_address" class="form-control" required>
                                    </div>
                                </div>


                        </div>
                        <div class="card-footer">
                            <div class="row">
                                <div class="col">
                                    <a href="javascript:void(0)" data-toggle="collapse" data-target="#collapseTwo" class="btn btn-outline-primary"><i class=" bi bi-arrow-left mr-1"></i> Previous</a>
                                </div>
                                <div class="col-auto">
                                    <a href="javascript:void(0)" data-toggle="collapse" data-target="#collapseFour" class="btn btn-primary">Make Payment <i class="bi bi-arrow-right ml-1"></i></a>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>

                <div class="card mb-3">
                    <div class="card-header p-0" id="headingFour">
                        <h2 class="mb-0">
                            <button class="btn btn-primary btn-block text-left collapsed" type="button" data-toggle="collapse" data-target="#collapseFour" aria-expanded="false" aria-controls="collapseFour">
                                <span class="h6">Payment Information</span>
                            </button>
                        </h2>
                    </div>
                    <div id="collapseFour" class="collapse" aria-labelledby="headingFour" data-parent="#accordionExample">
                        <div class="card-body pb-0">
                            <div class="row text-center">

                                <div class="col-6 col-sm-4 col-md-6 col-lg-4 col-xl-3 mb-4">
                                    <div class="mb-3 mt-4">
                                        <h5 class="">@lang('Payment Via')</h5>
                                        <div class="d-flex flex-wrap gap-3">
                                            <label for="walletBtn" class="btn-selected__label flex-grow-1" data-value="1">
                                                <input type="radio" name="payment_type" value="1" id="walletBtn" data-balance="{{ auth()->user()->balance }}" class="btn-selected__input walletPayment" required>
                                                <span class="btn-selected btn-selected--primary">
                                                    <span class="btn-selected__icon">
                                                        <img src="{{ getImage($activeTemplateTrue . 'images/wallet-icon.png') }}" alt="" class="mr-2" height="35px" style=" height: 35px !important;">
                                                    </span>
                                                    <span class="btn-selected__text ">
                                                        {{ __($general->cur_text) }} @lang('Wallet')
                                                    </span>
                                                </span>
                                            </label>

                                        </div>
                                        <small class="text-danger insufficientBalanceError d-none">@lang('You don\'t have sufficient balance. Your current balance is') {{ showAmount(auth()->user()->balance) }} {{ $general->cur_text }}</small>
                                    </div>
                                </div>

                            </div>
                        </div>
                        <div class="card-footer">
                            <div class="row">
                                <div class="col">
                                    <a href="javascript:void(0)" data-toggle="collapse" data-target="#collapseThree" class="btn btn-outline-primary"><i class=" bi bi-arrow-left mr-1"></i> Previous</a>
                                </div>
                                <div class="col-auto">
                                <button type="submit" class="btn btn-primary">Make Payment <i class="bi bi-arrow-right ml-1"></i></button>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>



        </div>

    </div>
</form>
</div>



@endsection
@push('script')
<script>
    (function($) {
        "use strict";

        $('#select_id').on('change', function() {
            var type = this.value;
            if (type == "agent") {
                $("#recipient_bank").val('Agent Collection');
                $("#recipient_account").val('Agent Collection');
                $("#recipient_routing").val('Agent Collection');
                $("#recipient_additional").val('Agent Collection');

                $("#recipient_bank").prop('readonly', true);
                $("#recipient_account").prop('readonly', true);
                $("#recipient_routing").prop('readonly', true);
                $("#recipient_additional").prop('readonly', true);



            }
            if (type == "banktransfer") {
                $("#recipient_bank").prop('readonly', false);
                $("#recipient_account").prop('readonly', false);
                $("#recipient_routing").prop('readonly', false);
                $("#recipient_additional").prop('readonly', false);
                $("#recipient_bank").val('');
                $("#recipient_account").val('');
                $("#recipient_routing").val('');
                $("#recipient_additional").val('');
            }

        });

        let sender = $('.sending-parent').find('select');
        let receiver = $('.recipient-parent').find('select');

        let sendingAmount = `{{ $sendingAmount }}`;
        let recipientAmount = `{{ $recipientAmount }}`;

        var sendingCountry = sender.find(":selected");
        var recipientCountry = receiver.find(":selected");
        let displayError = false;
        let senderInput = false;
        let recipientInput = false;

        let charge = 0;
        var finalAmount = 0;
        var baseCurrencyAmount = 0;

        resetValues();
        seDialCode();

        function seDialCode() {
            console.log(receiver.find(':selected'));
            $('.dial-code').text('+' + receiver.find(':selected').data('dial_code'))
        }

        displayError = true;

        sender.on('change', function() {
            sendingCountry = $(this).find(":selected");
            resetValues();
        });

        receiver.on('change', function() {
            seDialCode();
            recipientCountry = $(this).find(":selected");
            resetValues();
        });

        $(".sending-amount").on('input', function() {
            sendingAmount = $(this).val();
            recipientAmount = 0;
            senderInput = true;
            recipientInput = false;
            resetValues();
        });

        $(".recipient-amount").on('input', function() {
            recipientAmount = $(this).val();
            sendingAmount = 0;
            senderInput = false;
            recipientInput = true;
            resetValues();
        });

        function getCharge() {
            var fixedCharge = recipientCountry.data('fixed_charge');
            var percentCharge = recipientCountry.data('percent_charge');

            var sendingRate = sendingCountry.data('rate');
            var recipientRate = recipientCountry.data('rate');
            var conversionRate = recipientRate / sendingRate;

            if (sendingAmount) {
                recipientAmount = (conversionRate * sendingAmount).toFixed(2);
            } else if (recipientAmount) {
                sendingAmount = (recipientAmount / conversionRate).toFixed(2);
            } else {
                sendingAmount = 0;
                recipientAmount = 0;
                return 0
            }
            return (((fixedCharge * 1) + ((recipientAmount * percentCharge) / 100)) * (sendingRate / recipientRate)).toFixed(2);
        }

        function resetValues() {
            charge = getCharge() * 1;
            finalAmount = charge + parseFloat(sendingAmount);
            baseCurrencyAmount = finalAmount / sendingCountry.data('rate');
            updateDom();

            if (!sendingAmount && !recipientAmount) {
                $('.sending-amount').val('');
                $('.recipient-amount').val('');

                if (displayError) {
                    showError();
                }

                sendingAmount = 0;
                recipientAmount = 0;
            }
        }

        function updateDom() {
            $('.error-section').addClass('d-none');
            if (recipientInput) {
                $('.sending-amount').val(sendingAmount ? sendingAmount : null);
            } else if (senderInput) {
                $('.recipient-amount').val(recipientAmount ? recipientAmount : null);
            }
            $('.sending-currency').text(sendingCountry.data('currency'));
            $('.recipient-currency').text(recipientCountry.data('currency'));
            $('.charge-amount-text').text(charge);
            $('.base-amount-text').text(baseCurrencyAmount.toFixed(2));
            $('.final-amount-text').text(finalAmount.toFixed(2));
        }

        function showError() {
            $('.error-text').text('Please Enter an amount');
            $('.error-section').removeClass('d-none');
        }

        disableSelectedCountry();

        $('.sending-currency').text(sender.find(":selected").data('currency'));
        $('.recipient-currency').text(receiver.find(":selected").data('currency'));

        function disableSelectedCountry() {
            sender.find(':disabled').removeAttr('disabled')
            receiver.find(':disabled').removeAttr('disabled')
            let selectedSenderID = sender.find(':selected').data('id');
            let selectedReceiverID = receiver.find(':selected').data('id');
            sender.find(`[data-id=${selectedReceiverID}]`).attr('disabled', 'disabled');
            receiver.find(`[data-id=${selectedSenderID}]`).attr('disabled', 'disabled');
        }

        // Change Flags on load
        function formatState(state) {
            if (!state.id) return state.text;
            return $('<img  src="' + $(state.element).data('image') + '"/> <span >' + state.text + '</span>');
        }

        $('.country-picker').select2({
            templateResult: formatState
        });

        $('.country-picker').on('change', function() {
            disableSelectedCountry();
            changeSelectedCountryFlag();
        });

        // Change Flags on load
        changeSelectedCountryFlag();

        function changeSelectedCountryFlag() {
            $('.sending-parent .select2-selection__rendered').html(flagImageHtml(sender.find(':selected')));
            $('.recipient-parent .select2-selection__rendered').html(flagImageHtml(receiver.find(':selected')));
        }

        function flagImageHtml(data) {
            return `<img style="height:15px !important;width:15px !important;" class="exchange-form__flags" src="${data.data('image')}" class="state-flags"/> ${data.text()}`
        }

        $('.walletPayment').on('click', function() {
            var balance = $(this).data('balance');
            console.log(balance);
            var finalAmount = parseInt($('.final-amount-text').text());
            if (finalAmount > balance) {
                $('.insufficientBalanceError').removeClass('d-none').fadeIn();
            } else {
                $('.insufficientBalanceError').fadeOut().addClass('d-none');
            }
        });
        $('.directPayment').on('click', function() {
            $('.insufficientBalanceError').fadeOut().addClass('d-none');
        });
        $('.formSubmitButton').on('click', function() {
            var paymentType = $('[name=payment_type]:checked').val();
            console.log(paymentType);
            if (!paymentType) {
                notify('error', 'Please select a payment type')
            }
        });

    })(jQuery);
</script>
@endpush
@push('style')
<style>
    .exchange-form {
        box-shadow: none;
    }

    .select2-container--default .select2-results__option[aria-disabled=true] {
        display: none;
    }
</style>
@endpush
