@extends($activeTemplate.'layouts.auth_master')
@section('content')

<div class="container main-container" id="main-container">
    <div class="card mb-4">
        <div class="card-header ">
            <div class="row">

                <div class="col-12 col-sm-auto">
                    <form action="{{ route('user.mastervirtualnew') }}" method="POST">
                        @csrf
                        <div class="row">
                            <div class="col-lg-12">
                                <div class="profile-personal-info">
                                    <h4 class="text-primary mb-4 mt-4">@lang('Get New Card')</h4>
                                    <div class="row mb-4 mb-sm-2">
                                        <div class="col-md-6">
                                            <h5 class="f-w-500">@lang('Name on card') <span class="pull-right d-none d-sm-block">:</span>
                                            </h5>
                                        </div>
                                        <div class="col-md-6">
                                            <span>{{ $user->firstname }} {{ $user->lastname }}</span>
                                            <input type="hidden" name="nameoncard" value="{{ $user->firstname }} {{ $user->lastname }}">

                                        </div>
                                    </div>

                                    <div class="row mb-4 mb-sm-2">
                                        <div class="col-md-6">
                                            <h5 class="f-w-500">@lang('Email') <span class="pull-right d-none d-sm-block">:</span>
                                            </h5>
                                        </div>
                                        <div class="col-md-6">
                                            <span>{{ $user->email }}</span>
                                            <input type="hidden" name="useremail" value="{{ $user->email }}">
                                        </div>
                                    </div>
                                    <div class="row mb-4 mb-sm-2">
                                        <div class="col-md-6">
                                            <h5 class="f-w-500">@lang('Card Pin') <span class="pull-right d-none d-sm-block">:</span>
                                            </h5>
                                        </div>
                                        <div class="col-md-6">
                                            <span>Enter 4 digit Pin</span>
                                            <input type="text" maxlength="4" name="pin" pattern="\d{4}" required>
                                        </div>
                                    </div>

                                </div>
                            </div>
                        </div>
                        <div class="row">
                            <div class="col-lg-12 mb-2">
                                <div class="form-group">
                                    <div class="mt-4">
                                        <p class="text-primary">*@lang('Virtual MasterCard Issuance Fee') {{ $general->cur_text }} {{ showAmount($general->bsiissue_fee) }} and Minimum balance {{ $general->cur_text }}10.00 will be debited from your wallet.</p>
                                        <button type="submit" class="btn btn-primary"> @lang('Proceed')</button>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
    <div class="row">
        <div class="card col-xl-12">
            <div class="card-header p-0 border-0 bg-none">
                <ul class="nav nav-tabs" role="tablist">
                    <li class="nav-item">
                        <a class="nav-link active" id="tabhome1230-tab" data-toggle="tab" href="#tabhome1230" role="tab" aria-controls="tabhome1230" aria-selected="true">
                            Issued Cards
                        </a>
                    </li>
                    <li class="nav-item">
                        <a class="nav-link" id="tabhome2231-tab" data-toggle="tab" href="#tabhome2231" role="tab" aria-controls="tabhome2231" aria-selected="false">
                            Pending Cards
                        </a>
                    </li>

                </ul>
            </div>
            <div class="card-body">
                <div class="tab-content">


                    <div class="tab-pane fade active show" id="tabhome1230" role="tabpanel" aria-labelledby="tabhome1230-tab">


                        <div class="custom--card">
                            <div class="card-header">
                                <h4 class="text-primary mb-2 mt-2">@lang('Your Virtual Mastercards')</h4>
                            </div>
                            <div class="card-body">
                                <div class="table-responsive--lg">
                                    <table class="table mx-0 datatable2" id="datatable2">
                                        <thead class="">
                                            <tr>
                                                <th class="desktop tablet mobile" data-priority="2" >@lang('Card ID')</th>
                                                <th class="desktop tablet mobile" data-priority="2" >@lang('Name on Card')</th>
                                                <th class="desktop tablet mobile" data-priority="2" >@lang('View')</th>

                                            </tr>
                                        </thead>
                                        <tbody>
                                            @forelse ($virtualcards->data as $item)

                                            <tr>
                                                <td data-label="@lang('Card ID')"><span class="text--base">{{__($item->cardid)}}</span></td>
                                                <td data-label="@lang('Name On Card')">{{$item->nameoncard}}</td>
                                                <td data-label="@lang('View')"><a href="{{ route('user.mastervirtualview',$item->cardid) }}"><i class="fa fa-cc-mastercard"></i> ****{{ $item->lastfour ?? "" }}</a></td>

                                            </tr>
                                            @empty
                                            <tr>
                                                <td colspan="100%" class="text-center">{{__("No Cards Found")}}</td>
                                            </tr>
                                            @endforelse

                                        </tbody>
                                    </table>
                                </div>
                            </div>
                        </div>
                    </div>

                    <div class="tab-pane fade" id="tabhome2231" role="tabpanel" aria-labelledby="tabhome2231-tab">


                        <div class="custom--card">
                            <div class="card-header">
                                <h4 class="text-primary mb-2 mt-2">@lang('Your Pending Applications')</h4>
                            </div>
                            <div class="card-body">
                                <div class="table-responsive--lg">
                                    <table class="table mx-0 datatable3" id="datatable3">
                                        <thead class="">
                                            <tr>

                                                <th class="desktop tablet mobile" data-priority="2" >@lang('Name on Card')</th>
                                                <th class="desktop tablet mobile" data-priority="2" >@lang('Status')</th>

                                            </tr>
                                        </thead>
                                        <tbody>
                                            @forelse ($pendingcards->data as $items)

                                            <tr>

                                                <td data-label="@lang('Name On Card')">{{$items->nameoncard ?? ""}}</td>
                                                <td data-label="@lang('View')"> {{ ucfirst($items->status ?? "" )}}</a></td>

                                            </tr>
                                            @empty
                                            <tr>
                                                <td colspan="100%" class="text-center">{{__("No Cards Found")}}</td>
                                            </tr>
                                            @endforelse

                                        </tbody>
                                    </table>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>

            </div>
        </div>
    </div>

</div><!-- comment -->


@endsection