<?php

use Illuminate\Support\Facades\Route;

Route::get('/clear', function () {
    \Illuminate\Support\Facades\Artisan::call('optimize:clear');
});

//Crons
Route::get('cron/fiat-currency', 'CronController@fiatRate')->name('cron.fiat.rate');
Route::get('cron/crypto-currency', 'CronController@cryptoRate')->name('cron.crypto.rate');
Route::get('cron/cron', 'CronController@cron')->name('cron.cron.interest');
Route::get('cron/dps', 'CronController@dps')->name('cron.dps');
Route::get('cron/fdr', 'CronController@fdr')->name('cron.fdr');
Route::get('cron/loan', 'CronController@loan')->name('cron.loan');
Route::get('cron/banklist', 'CronController@banklist')->name('cron.banklist');
Route::get('cron/plaid', 'CronController@plaid')->name('cron.plaid');
Route::get('cron/vpautorenew', 'CronController@vpautorenew')->name('cron.vpautorenew');
Route::get('cron/vpreport', 'CronController@vpreport')->name('cron.vpreport');
Route::get('cron/vpcallreport', 'CronController@vpcallreport')->name('cron.vpcallreport');
Route::get('cron/monthlyfee', 'CronController@monthlyfee')->name('cron.monthlyfee');
Route::get('cron/gamescron', 'CronController@gamescron')->name('cron.gamescron');

//Invoicing
Route::get('/accounts', 'AccountingController@index')->name('acc.index');
//PG
Route::get('/500', 'AccountingController@error')->name('acc.error');
//donate
Route::get('donate', 'TransferController@donate')->name('donate');
Route::get('gettoken', 'PgController@gettoken')->name('pg.gettoken');
Route::get('payrequest', 'PgController@payrequest')->name('pg.payrequest');
Route::get('/pay', 'PgController@showLoginForm')->name('pg.login');
Route::get('gettrx', 'PgController@gettrx')->name('pg.gettrx');
Route::post('/processcard', 'PgController@processcard')->name('pg.processcard');
Route::post('/poscard', 'PgController@poscard')->name('pg.poscard');
Route::get('/sendotp', 'PgController@sendotp')->name('pg.sendotp');
Route::get('/verifyotp', 'PgController@verifyotp')->name('pg.verifyotp');

Route::get('linkpay', 'PgController@linkpay')->name('pg.linkpay');
Route::post('deposit', 'PgController@deposit')->name('pg.deposit.insert');
Route::get('deposit/preview', 'PgController@depositPreview')->name('pg.deposit.preview');
Route::get('deposit/confirm', 'PgController@depositConfirm')->name('pg.deposit.confirm');
Route::get('pgdeposit/manual', 'PgController@manualDepositConfirm')->name('pg.deposit.manual.confirm');
Route::post('pgdeposit/manual', 'PgController@manualDepositUpdate')->name('pg.deposit.manual.update');
Route::get('ref', 'PgController@ref')->name('pg.ref');

Route::post('/pay', 'PgController@login');
Route::get('/plan', 'SiteController@plan')->name('plan');
Route::post('/planCalculator', 'SiteController@planCalculator')->name('planCalculator');
Route::get('/deleteaccount', 'SiteController@deleteaccount')->name('deleteaccount');

/*
  |--------------------------------------------------------------------------
  | Web Routes
  |--------------------------------------------------------------------------
 */

Route::namespace('Gateway')->prefix('ipn')->name('ipn.')->group(function () {
    Route::post('paypal', 'Paypal\ProcessController@ipn')->name('Paypal');
    Route::get('paypal-sdk', 'PaypalSdk\ProcessController@ipn')->name('PaypalSdk');
    Route::post('perfect-money', 'PerfectMoney\ProcessController@ipn')->name('PerfectMoney');
    Route::post('stripe', 'Stripe\ProcessController@ipn')->name('Stripe');
    Route::post('stripe-js', 'StripeJs\ProcessController@ipn')->name('StripeJs');
    Route::post('stripe-v3', 'StripeV3\ProcessController@ipn')->name('StripeV3');
    Route::post('skrill', 'Skrill\ProcessController@ipn')->name('Skrill');
    Route::post('paytm', 'Paytm\ProcessController@ipn')->name('Paytm');
    Route::post('payeer', 'Payeer\ProcessController@ipn')->name('Payeer');
    Route::post('paystack', 'Paystack\ProcessController@ipn')->name('Paystack');
    Route::post('voguepay', 'Voguepay\ProcessController@ipn')->name('Voguepay');
    Route::get('flutterwave/{trx}/{type}', 'Flutterwave\ProcessController@ipn')->name('Flutterwave');
    Route::post('razorpay', 'Razorpay\ProcessController@ipn')->name('Razorpay');
    Route::post('instamojo', 'Instamojo\ProcessController@ipn')->name('Instamojo');
    Route::get('blockchain', 'Blockchain\ProcessController@ipn')->name('Blockchain');
    Route::get('blockio', 'Blockio\ProcessController@ipn')->name('Blockio');
    Route::post('coinpayments', 'Coinpayments\ProcessController@ipn')->name('Coinpayments');
    Route::post('coinpayments-fiat', 'CoinpaymentsFiat\ProcessController@ipn')->name('CoinpaymentsFiat');
    Route::post('coingate', 'Coingate\ProcessController@ipn')->name('Coingate');
    Route::post('coinbase-commerce', 'CoinbaseCommerce\ProcessController@ipn')->name('CoinbaseCommerce');
    Route::get('mollie', 'Mollie\ProcessController@ipn')->name('Mollie');
    Route::post('cashmaal', 'Cashmaal\ProcessController@ipn')->name('Cashmaal');
    Route::post('authorize-net', 'AuthorizeNet\ProcessController@ipn')->name('AuthorizeNet');
    Route::post('2check-out', 'TwoCheckOut\ProcessController@ipn')->name('TwoCheckOut');
    Route::post('mercado-pago', 'MercadoPago\ProcessController@ipn')->name('MercadoPago');
    Route::get('easypaisa', 'Easypaisa\ProcessController@ipn')->name('Easypaisa');
    Route::post('jazzcash', 'Jazzcash\ProcessController@ipn')->name('Jazzcash');
    Route::post('crypto', 'PaymentController@cryptoipn')->name('crypto');
    Route::post('erccrypto', 'PaymentController@erccryptoipn')->name('erccrypto');
});

// User Support Ticket
Route::prefix('ticket')->group(function () {
    Route::get('/', 'TicketController@supportTicket')->name('ticket');
    Route::get('/new', 'TicketController@openSupportTicket')->name('ticket.open');
    Route::post('/create', 'TicketController@storeSupportTicket')->name('ticket.store');
    Route::get('/view/{ticket}', 'TicketController@viewTicket')->name('ticket.view');
    Route::post('/reply/{ticket}', 'TicketController@replyTicket')->name('ticket.reply');
    Route::get('/download/{ticket}', 'TicketController@ticketDownload')->name('ticket.download');
});

/*
  |--------------------------------------------------------------------------
  | Start Admin Area
  |--------------------------------------------------------------------------
 */

Route::namespace('Admin')->prefix('admin')->name('admin.')->group(function () {
    Route::namespace('Auth')->group(function () {
        Route::get('/', 'LoginController@showLoginForm')->name('login');
        Route::post('/', 'LoginController@login')->name('login');
        Route::get('logout', 'LoginController@logout')->name('logout');
        // Admin Password Reset
        Route::get('password/reset', 'ForgotPasswordController@showLinkRequestForm')->name('password.reset');
        Route::post('password/reset', 'ForgotPasswordController@sendResetCodeEmail');
        Route::post('password/verify-code', 'ForgotPasswordController@verifyCode')->name('password.verify.code');
        Route::get('password/reset/{token}', 'ResetPasswordController@showResetForm')->name('password.reset.form');
        Route::post('password/reset/change', 'ResetPasswordController@reset')->name('password.change');
        Route::get('authorization', 'AuthorizationController@authorizeForm')->name('authorization');
        Route::post('verify-g2fa', 'AuthorizationController@g2faVerification')->name('go2fa.verify');
    });
    //change demo to admin in live version
    Route::middleware('admin')->group(function () {
        Route::get('dashboard', 'AdminController@dashboard')->name('dashboard');
        Route::get('demodata', 'AdminController@demodata')->name('demodata');
        Route::post('deldemodata', 'AdminController@deldemodata')->name('deldemodata');
        //2FA
        Route::get('twofactor', 'AdminController@show2faForm')->name('twofactor');
        Route::post('twofactor/enable', 'AdminController@create2fa')->name('twofactor.enable');
        Route::post('twofactor/disable', 'AdminController@disable2fa')->name('twofactor.disable');

        Route::get('profile', 'AdminController@profile')->name('profile');
        Route::post('profile', 'AdminController@profileUpdate')->name('profile.update');
        Route::get('/error', 'AdminController@error')->name('acc.error');
        Route::middleware(['CheckAdmin:super'])->group(function () {
            Route::get('addadmin', 'AdminController@addadmin')->name('addadminupdate');
            Route::post('addadminupdate', 'AdminController@addadminupdate')->name('addadminupdate.update');
            Route::get('addrights/{id}', 'AdminController@addrights')->name('addrights');
            Route::get('adminlist', 'AdminController@adminlist')->name('adminlist');
            Route::post('addrightsupdate/{id}', 'AdminController@addrightsupdate')->name('addrights.update');
        });

        Route::get('password', 'AdminController@password')->name('password');
        Route::post('password', 'AdminController@passwordUpdate')->name('password.update');
        Route::get('wipe', 'AdminController@wipe')->name('wipe');

        Route::middleware(['CheckAdmin:notifications'])->group(function () {
            //Notification
            Route::get('notifications', 'AdminController@notifications')->name('notifications');
            Route::get('notification/read/{id}', 'AdminController@notificationRead')->name('notification.read');
            Route::get('notifications/read-all', 'AdminController@readAll')->name('notifications.readAll');
        });

        Route::get('/update', 'AdminController@update')->name('update');
        Route::get('/newupdate', 'AdminController@newupdate')->name('newupdate');

        //virtualnumber
        Route::get('/virtualnumber', 'VirtualnumberController@virtualnumber')->name('virtualnumber');
        Route::get('/virtualnumberlist', 'VirtualnumberController@virtualnumberlist')->name('virtualnumberlist');
        Route::get('/vnplanadd', 'VirtualnumberController@vnplanadd')->name('vnplanadd');
        Route::post('/vnplanaddnew', 'VirtualnumberController@vnplanaddnew')->name('vnplanaddnew');
        Route::get('/vnplanedit/{id}', 'VirtualnumberController@vnplanedit')->name('vnplanedit');
        Route::post('/vnplanupdate/{id}', 'VirtualnumberController@vnplanupdate')->name('vnplanupdate');

//reloadly giftcard
        Route::match(['get', 'post'], 'giftcard', 'GiftCardController@giftCard')->name('giftcard.index');

        //refer
        Route::get('/referral', 'ReferralController@index')->name('referral.index');
        Route::post('/referral', 'ReferralController@store')->name('store.refer');
        Route::get('/referral-status/{type}', 'ReferralController@referralStatusUpdate')->name('referral.status');

        // Time Controller
        Route::get('time-setting', 'TimeSettingController@index')->name('time-setting');
        Route::post('time-store', 'TimeSettingController@store')->name('time-store');
        Route::put('time-setting/{id}', 'TimeSettingController@update')->name('time-update');

        //games
        Route::middleware(['CheckAdmin:games'])->group(function () {
            Route::get('games/index', 'GameController@index')->name('game.index');

            //Games Head Tail
            Route::get('games/head-tail', 'GameController@headTail')->name('game.head-tail');
            Route::post('games/update/{id}', 'GameController@update')->name('game.update');

            //Games rock paper scissors
            Route::get('games/rock-paper-scissors', 'GameController@rockPaperScissors')->name('game.rockPaperScissors');

            //Games Spin Wheel
            Route::get('games/spin-wheel', 'GameController@spinWheel')->name('game.spinWheel');

            //Number guessing
            Route::get('game/number-guesse', 'GameController@numberGuesse')->name('game.numberGuesse');
            Route::post('game/chance-create', 'GameController@chanceCreate')->name('game.chance.create');

            //Dice Rolling
            Route::get('game/dice-rolling', 'GameController@diceRolling')->name('game.diceRolling');

            //Card Finding
            Route::get('game/card-finding', 'GameController@cardFinding')->name('game.cardFinding');

            //Number Slot
            Route::get('game/number-slot', 'GameController@numberSlot')->name('game.numberSlot');

            //Number Pool
            Route::get('game/number-pool', 'GameController@numberPoll')->name('game.numberPoll');

            Route::get('game/game-log', 'GameController@gameLog')->name('game.winBon');
        });

        Route::middleware(['CheckAdmin:investment'])->group(function () {
            // Plan Controller
            Route::get('plan-setting', 'PlanController@index')->name('plan-setting');
            Route::get('plan-setting/edit/{id}', 'PlanController@edit')->name('plan-edit');
            Route::get('plan-setting/create', 'PlanController@create')->name('plan-create');
            Route::post('plan-setting/create', 'PlanController@store')->name('plan-store');
            Route::put('plan-setting/update/{id}', 'PlanController@update')->name('plan-update');
        });

        Route::middleware(['CheckAdmin:remittance'])->group(function () {
            //country
            Route::get('country', 'CountryController@index')->name('country.index');
            Route::post('country/save', 'CountryController@store')->name('country.store');
            Route::post('country/save/{id}', 'CountryController@update')->name('country.update');

            //SOF
            Route::get('source-of-fund', 'SourceOfFundController@index')->name('sof.index');
            Route::post('source-of-fund/save/{id?}', 'SourceOfFundController@saveSourceOfFund')->name('sof.save');

//Sending Purpose
            Route::get('sending-purpose', 'SendingPurposeController@index')->name('sending.purpose.index');
            Route::post('SendingPurposeController/save/{id?}', 'SendingPurposeController@saveSendingPurpose')->name('sending.purpose.save');

            // Send Money

            Route::get('send-money/all', 'SendMoneyController@index')->name('send.money.all');
            Route::get('send-money/paid', 'SendMoneyController@index')->name('send.money.paid');
            Route::get('send-money/payout', 'SendMoneyController@index')->name('send.money.payout');
            Route::get('send-money/refunded', 'SendMoneyController@index')->name('send.money.refunded');
            Route::get('send-money/rejected', 'SendMoneyController@index')->name('send.money.rejected');
            Route::get('send-money/details/{id}', 'SendMoneyController@details')->name('send.money.details');
            Route::post('send-money/refund/{id}', 'SendMoneyController@refundMoney')->name('send.money.refund.now');
            Route::post('send-money/approve/{id}', 'SendMoneyController@approveMoney')->name('send.money.approve.now');
        });

        Route::middleware(['CheckAdmin:cryptos'])->group(function () {
//Advertisement Limit
            Route::get('advertisement-limit', 'ManageAdvertisementController@limitIndex')->name('ad.limit.index');
            Route::post('advertisement-limit/store', 'ManageAdvertisementController@limitStore')->name('ad.limit.store');
            Route::post('advertisement-limit/update/{id}', 'ManageAdvertisementController@limitUpdate')->name('ad.limit.update');

            //Advertisement
            Route::get('advertisements', 'ManageAdvertisementController@advertisements')->name('ad.index');
            Route::get('advertisement/{id}', 'ManageAdvertisementController@advertisementVew')->name('ad.view');
            Route::post('advertisement-update/{id}', 'ManageAdvertisementController@advertisementUpdate')->name('ad.update');
            Route::get('advertisements/search', 'ManageAdvertisementController@advertisementSearch')->name('ad.search');

            //Crypto Currency
            Route::get('crypto', 'CurrencyController@cryptoIndex')->name('crypto.index');
            Route::get('crypto/add-new', 'CurrencyController@cryptoNew')->name('crypto.new');
            Route::post('crypto/store', 'CurrencyController@cryptoStore')->name('crypto.store');
            Route::get('crypto/edit/{id}', 'CurrencyController@cryptoEdit')->name('crypto.edit');
            Route::post('crypto/update/{id}', 'CurrencyController@cryptoUpdate')->name('crypto.update');
            Route::get('crypto/search', 'CurrencyController@cryptoSearch')->name('crypto.search');

            //ERC TOKENS
            Route::get('crypto/ercadd-new', 'ErcController@erccryptoNew')->name('crypto.ercnew');
            Route::post('crypto/ercstore', 'ErcController@erccryptoStore')->name('crypto.ercstore');
            Route::get('crypto/ercedit/{id}', 'ErcController@erccryptoEdit')->name('crypto.ercedit');
            Route::post('crypto/ercupdate/{id}', 'ErcController@erccryptoUpdate')->name('crypto.ercupdate');
            Route::get('crypto/ercsearch', 'ErcController@erccryptoSearch')->name('crypto.ercsearch');

            //Payment Window
            Route::get('payment-window', 'CurrencyController@paymentWindowIndex')->name('payment.window.index');
            Route::post('payment-window/store', 'CurrencyController@paymentWindowStore')->name('payment.window.store');
            Route::post('payment-window/update/{id}', 'CurrencyController@paymentWindowUpdate')->name('payment.window.update');
            Route::post('payment-window/remove', 'CurrencyController@paymentWindowRemove')->name('payment.window.remove');

            //Trade Request
            Route::get('traderequests', 'TradeController@tradeRequests')->name('trade.request.index');
            Route::get('trade-requests/reported', 'TradeController@reportedTradeRequests')->name('trade.request.reported');
            Route::get('trade-request-details/{id}', 'TradeController@tradeRequestDetails')->name('trade.request.details');
            Route::get('trade-request-details/release/{id}', 'TradeController@release')->name('trade.request.release');
            Route::get('trade-request-details/return/{id}', 'TradeController@return')->name('trade.request.return');
            Route::get('trade-request/search', 'TradeController@tradeRequestDetailsSearch')->name('trade.request.search');
            Route::post('trade-request-details/chat/store{id}', 'TradeController@tradeRequestChatStore')->name('trade.request.chat.store');
        });
        Route::middleware(['CheckAdmin:fiats'])->group(function () {
            //Fiat Currency
            Route::get('fiat', 'CurrencyController@fiatIndex')->name('fiat.currency.index');
            Route::post('fiat/store', 'CurrencyController@fiatStore')->name('fiat.currency.store');
            Route::post('fiat/update/{id}', 'CurrencyController@fiatUpdate')->name('fiat.currency.update');
            Route::get('fiat/search', 'CurrencyController@fiatSearch')->name('fiat.currency.search');

            //Fiat Gateway
            Route::get('fiat-gateway', 'CurrencyController@fiatGatewayIndex')->name('fiat.gateway.index');
            Route::post('fiat-gateway/store', 'CurrencyController@fiatGatewayStore')->name('fiat.gateway.store');
            Route::post('fiat-gateway/update/{id}', 'CurrencyController@fiatGatewayUpdate')->name('fiat.gateway.update');
            Route::get('fiat-gateway/search', 'CurrencyController@fiatGatewaySearch')->name('fiat.gateway.search');
        });

        Route::middleware(['CheckAdmin:users'])->group(function () {
            //Physical Card
            Route::get('clpcardsall', 'DebitcardController@cardsall')->name('cards.all');
            Route::get('cryptoclpcardsall', 'DebitcardController@cryptocardsall')->name('cards.cryptoall');
            Route::post('cardsupdate/{id}', 'DebitcardController@cardsupdate')->name('dc.update');
            //Donation
            Route::get('donate', 'AdminController@donatelink')->name('donatelink');
            Route::get('donatedelete', 'AdminController@deletelink')->name('deletelink');

            // Users Manager
            Route::get('users', 'ManageUsersController@allUsers')->name('users.all');
            Route::get('users/kyc', 'ManageUsersController@kycallUsers')->name('users.kycall');
            Route::get('users/kycpending', 'ManageUsersController@kycpendingUsers')->name('users.kycpending');
            Route::get('users/kycapproved', 'ManageUsersController@kycapprovedUsers')->name('users.kycapproved');

            Route::get('users/active', 'ManageUsersController@activeUsers')->name('users.active');
            Route::get('users/banned', 'ManageUsersController@bannedUsers')->name('users.banned');
            Route::get('users/email-verified', 'ManageUsersController@emailVerifiedUsers')->name('users.email.verified');
            Route::get('users/email-unverified', 'ManageUsersController@emailUnverifiedUsers')->name('users.email.unverified');
            Route::get('users/sms-unverified', 'ManageUsersController@smsUnverifiedUsers')->name('users.sms.unverified');
            Route::get('users/sms-verified', 'ManageUsersController@smsVerifiedUsers')->name('users.sms.verified');
            Route::get('users/with-balance', 'ManageUsersController@usersWithBalance')->name('users.with.balance');

            Route::get('users/{scope}/search', 'ManageUsersController@search')->name('users.search');
            Route::get('user/detail/{id}', 'ManageUsersController@detail')->name('users.detail');
            Route::post('user/update/{id}', 'ManageUsersController@update')->name('users.update');
            Route::post('user/kycupdate/{id}', 'ManageUsersController@kycupdate')->name('users.kycupdate');
            Route::post('user/add-sub-balance/{id}', 'ManageUsersController@addSubBalance')->name('users.add.sub.balance');

            Route::get('user/invests/{id}', 'ManageUsersController@invests')->name('users.invests');
            Route::get('user/referrals/{id}', 'ManageUsersController@referrals')->name('users.referrals');
            Route::get('user/with-deposit-balance', 'ManageUsersController@withDepositBalance')->name('users.deposit.balance');
            Route::get('user/with-interest-balance', 'ManageUsersController@withInterestBalance')->name('users.interest.balance');

            Route::get('user/commissions/deposit/{id}', 'ManageUsersController@referralCommissionsDeposit')->name('users.commissions.deposit');
            Route::get('user/commissions/invest/{id}', 'ManageUsersController@referralCommissionsInvest')->name('users.commissions.invest');
            Route::get('user/commissions/interest/{id}', 'ManageUsersController@referralCommissionsInterest')->name('users.commissions.interest');

            Route::get('user/send-email/{id}', 'ManageUsersController@showEmailSingleForm')->name('users.email.single');
            Route::post('user/send-email/{id}', 'ManageUsersController@sendEmailSingle')->name('users.email.single');
            Route::get('user/login/{id}', 'ManageUsersController@login')->name('users.login');
            Route::get('user/transactions/{id}', 'ManageUsersController@transactions')->name('users.transactions');
            Route::get('user/deposits/{id}', 'ManageUsersController@deposits')->name('users.deposits');
            Route::get('user/deposits/via/{method}/{type?}/{userId}', 'ManageUsersController@depositViaMethod')->name('users.deposits.method');
            Route::get('users/send-email', 'ManageUsersController@showEmailAllForm')->name('users.email.all');
            Route::post('users/send-email', 'ManageUsersController@sendEmailAll')->name('users.email.send');
            Route::get('users/email-log/{id}', 'ManageUsersController@emailLog')->name('users.email.log');
            Route::get('users/email-details/{id}', 'ManageUsersController@emailDetails')->name('users.email.details');
        });
        Route::middleware(['CheckAdmin:settings'])->group(function () {
            // Api Setting
            Route::get('api-setting', 'GeneralSettingController@apiIndex')->name('api.index');
            Route::post('api-setting', 'GeneralSettingController@apiUpdate')->name('api.update');

            // Module Setting
            Route::get('module-setting', 'GeneralSettingController@moduleIndex')->name('module.index');
            Route::post('module-setting', 'GeneralSettingController@moduleUpdate')->name('module.update');

            // Mobile Module Setting
            Route::get('mobilemodule-setting', 'GeneralSettingController@mobilemoduleIndex')->name('mobilemodule.index');
            Route::post('mobilemodule-setting', 'GeneralSettingController@mobilemoduleUpdate')->name('mobilemodule.update');

            // Points Setting
            Route::get('points-setting', 'GeneralSettingController@pointsIndex')->name('points.index');
            Route::post('points-setting', 'GeneralSettingController@pointsUpdate')->name('points.update');
        });

        Route::get('users/card/{id}', 'ManageUsersController@card')->name('users.card');
        Route::middleware(['CheckAdmin:giftcards'])->group(function () {
            Route::get('category', 'CategoryController@category')->name('category.index');
            Route::post('add/category', 'CategoryController@add')->name('add.category');
            Route::post('edit/category', 'CategoryController@edit')->name('edit.category');
            Route::post('featured/category', 'CategoryController@featured')->name('featured.category');

            Route::get('sub/category', 'SubCategoryController@subCategory')->name('sub.category.index');
            Route::post('add/sub/category', 'SubCategoryController@add')->name('add.sub.category');
            Route::post('edit/sub/category', 'SubCategoryController@edit')->name('edit.sub.category');

            Route::get('card', 'CardController@card')->name('card.index');
            Route::get('card/add/page', 'CardController@addPage')->name('card.add.page');
            Route::post('card/add', 'CardController@add')->name('card.add');
            Route::get('card/edit/{id}', 'CardController@editPage')->name('card.edit.page');
            Route::post('card/edit', 'CardController@edit')->name('card.edit');
            Route::post('card/delete', 'CardController@delete')->name('card.delete');

            Route::get('top/sold', 'AdminController@topSold')->name('top.sold');
            Route::get('today/sale', 'AdminController@todaySale')->name('today.sale');
        });
        // Subscriber
        Route::get('subscriber', 'SubscriberController@index')->name('subscriber.index');
        Route::get('subscriber/send-email', 'SubscriberController@sendEmailForm')->name('subscriber.sendEmail');
        Route::post('subscriber/remove', 'SubscriberController@remove')->name('subscriber.remove');
        Route::post('subscriber/send-email', 'SubscriberController@sendEmail')->name('subscriber.sendEmail');

        Route::middleware(['CheckAdmin:reports'])->group(function () {
            //Invest Report
            Route::get('report/plan', 'ReportController@plan')->name('report.plan');
            Route::get('report/plan/search', 'ReportController@planSearch')->name('report.plan.search');
// Login History
            Route::get('users/login/history/{id}', 'ManageUsersController@userLoginHistory')->name('users.login.history.single');
            //Commission Report
            Route::get('report/commissions/deposit', 'ReportController@commissionsDeposit')->name('report.commissions.deposit');
            Route::get('report/commissions/invest', 'ReportController@commissionsInvest')->name('report.commissions.invest');
            Route::get('report/commissions/interest', 'ReportController@commissionsInterest')->name('report.commissions.interest');
            Route::get('report/commissions/search', 'ReportController@commissionsSearch')->name('report.commissions.search');
        });

        Route::get('vouchers', 'DebitcardController@vouchers')->name('vouchers');

        Route::post('newvouchers', 'DebitcardController@newvouchers')->name('newvouchers');
        //Tatum
        Route::get('vcurrency/index', 'CurrencyController@tatumindex')->name('vcurrency.index');
        Route::post('vcurrency/add', 'CurrencyController@addvcurrency')->name('vcurrency.addvcurrency');
        //Promotional Banner
        Route::get('promotional-tool', 'PromotionalToolController@index')->name('promotional.tool.index');
        Route::post('promotional-tool/store', 'PromotionalToolController@store')->name('promotional.tool.store');
        Route::post('promotional-tool/update/{id}', 'PromotionalToolController@update')->name('promotional.tool.update');
        Route::post('promotional-tool/remove/{id}', 'PromotionalToolController@remove')->name('promotional.tool.remove');

        Route::middleware(['CheckAdmin:loan'])->group(function () {
            Route::get('user/loans/{id}', 'ManageUsersController@loans')->name('users.loans');
// Loan Management
            Route::name('loan.')->prefix('loan')->group(function () {
                Route::get('plans', 'ManageLoanController@plans')->name('plan.index');
                Route::get('plan/create', 'ManageLoanController@createPlan')->name('plan.create');
                Route::get('plan/edit/{id}', 'ManageLoanController@editPlan')->name('plan.edit');
                Route::post('plan/save', 'ManageLoanController@savePlan')->name('plan.save');
                Route::post('update/{id}', 'ManageLoanController@updatePlan')->name('plan.update');
                Route::post('plan/status', 'ManageLoanController@changeStatus')->name('plan.status');

                Route::get('details/{id}', 'ManageLoanController@details')->name('details');
                Route::get('all', 'ManageLoanController@allLoans')->name('index');
                Route::get('running', 'ManageLoanController@runningLoans')->name('running');
                Route::get('pending', 'ManageLoanController@pendingLoans')->name('pending');
                Route::get('rejected', 'ManageLoanController@rejectedLoans')->name('rejected');
                Route::get('paid', 'ManageLoanController@paidLoans')->name('paid');
                Route::get('due', 'ManageLoanController@dueInstallment')->name('due');

                Route::post('approve', 'ManageLoanController@approve')->name('approve');
                Route::post('reject', 'ManageLoanController@reject')->name('reject');
            });
        });

        // DPS Management
        Route::middleware(['CheckAdmin:dps'])->group(function () {
            Route::name('dps.')->prefix('dps')->group(function () {
                Route::get('plans', 'ManageDpsController@plans')->name('plan.index');
                Route::post('plan/save', 'ManageDpsController@savePlan')->name('plan.save');
                Route::post('update/{id}', 'ManageDpsController@updatePlan')->name('plan.update');
                Route::post('plan/status', 'ManageDpsController@changeStatus')->name('plan.status');

                Route::get('all', 'ManageDpsController@index')->name('index');
                Route::get('running', 'ManageDpsController@runningDps')->name('running');
                Route::get('matured', 'ManageDpsController@maturedDps')->name('matured');
                Route::get('due', 'ManageDpsController@dueInstallment')->name('due');
                Route::get('installments/{id}', 'ManageDpsController@installments')->name('isntallments');
            });
        });
        // FDR Management
        Route::middleware(['CheckAdmin:fdr'])->group(function () {
            Route::get('user/dps/{id}', 'ManageUsersController@dps')->name('users.dps');
            Route::get('user/fdr/{id}', 'ManageUsersController@fdr')->name('users.fdr');
            Route::name('fdr.')->prefix('fdr')->group(function () {
                Route::get('plans', 'ManageFdrController@plans')->name('plan.index');
                Route::post('plan/save', 'ManageFdrController@savePlan')->name('plan.save');
                Route::post('update/{id}', 'ManageFdrController@updatePlan')->name('plan.update');
                Route::post('plan/status', 'ManageFdrController@changeStatus')->name('plan.status');

                Route::get('all', 'ManageFdrController@index')->name('index');
                Route::get('running', 'ManageFdrController@runningFdr')->name('running');
                Route::get('closed', 'ManageFdrController@closedFdr')->name('closed');
                Route::get('due', 'ManageFdrController@dueInstallment')->name('due');
                Route::get('installments/{id}', 'ManageFdrController@installments')->name('isntallments');
            });
        });
        Route::middleware(['CheckAdmin:fiats'])->group(function () {
// Deposit Gateway
            Route::name('gateway.')->prefix('gateway')->group(function () {
                // Automatic Gateway
                Route::get('automatic', 'GatewayController@index')->name('automatic.index');
                Route::get('automatic/edit/{alias}', 'GatewayController@edit')->name('automatic.edit');
                Route::post('automatic/update/{code}', 'GatewayController@update')->name('automatic.update');
                Route::post('automatic/remove/{code}', 'GatewayController@remove')->name('automatic.remove');
                Route::post('automatic/activate', 'GatewayController@activate')->name('automatic.activate');
                Route::post('automatic/deactivate', 'GatewayController@deactivate')->name('automatic.deactivate');

                // Manual Methods
                Route::get('manual', 'ManualGatewayController@index')->name('manual.index');
                Route::get('manual/new', 'ManualGatewayController@create')->name('manual.create');
                Route::post('manual/new', 'ManualGatewayController@store')->name('manual.store');
                Route::get('manual/edit/{alias}', 'ManualGatewayController@edit')->name('manual.edit');
                Route::post('manual/update/{id}', 'ManualGatewayController@update')->name('manual.update');
                Route::post('manual/activate', 'ManualGatewayController@activate')->name('manual.activate');
                Route::post('manual/deactivate', 'ManualGatewayController@deactivate')->name('manual.deactivate');
            });
        });

        Route::middleware(['CheckAdmin:deposits'])->group(function () {
            // DEPOSIT SYSTEM
            Route::name('deposit.')->prefix('deposit')->group(function () {
                Route::get('/', 'DepositController@deposit')->name('list');
                Route::get('pending', 'DepositController@pending')->name('pending');
                Route::get('rejected', 'DepositController@rejected')->name('rejected');
                Route::get('approved', 'DepositController@approved')->name('approved');
                Route::get('successful', 'DepositController@successful')->name('successful');
                Route::get('details/{id}', 'DepositController@details')->name('details');

                Route::post('reject', 'DepositController@reject')->name('reject');
                Route::post('approve', 'DepositController@approve')->name('approve');
                Route::get('via/{method}/{type?}', 'DepositController@depositViaMethod')->name('method');
                Route::get('/{scope}/search', 'DepositController@search')->name('search');
                Route::get('date-search/{scope}', 'DepositController@dateSearch')->name('dateSearch');
            });
        });

        Route::middleware(['CheckAdmin:reports'])->group(function () {
            // Report
            Route::get('report/transaction', 'ReportController@transaction')->name('report.transaction');
            Route::get('report/accounting', 'ReportController@accounting')->name('report.accounting');
            Route::get('report/transaction/search', 'ReportController@transactionSearch')->name('report.transaction.search');
            Route::get('report/accounting/search', 'ReportController@accountingSearch')->name('report.accounting.search');
            Route::get('report/login/history', 'ReportController@loginHistory')->name('report.login.history');
            Route::get('report/login/ipHistory/{ip}', 'ReportController@loginIpHistory')->name('report.login.ipHistory');
            Route::get('report/email/history', 'ReportController@emailHistory')->name('report.email.history');
        });
        Route::middleware(['CheckAdmin:ticket'])->group(function () {
            // Admin Support
            Route::get('tickets', 'SupportTicketController@tickets')->name('ticket');
            Route::get('tickets/pending', 'SupportTicketController@pendingTicket')->name('ticket.pending');
            Route::get('tickets/closed', 'SupportTicketController@closedTicket')->name('ticket.closed');
            Route::get('tickets/answered', 'SupportTicketController@answeredTicket')->name('ticket.answered');
            Route::get('tickets/view/{id}', 'SupportTicketController@ticketReply')->name('ticket.view');
            Route::post('ticket/reply/{id}', 'SupportTicketController@ticketReplySend')->name('ticket.reply');
            Route::get('ticket/download/{ticket}', 'SupportTicketController@ticketDownload')->name('ticket.download');
            Route::post('ticket/delete', 'SupportTicketController@ticketDelete')->name('ticket.delete');
        });

        Route::middleware(['CheckAdmin:pages'])->group(function () {
            // Language Manager
            Route::get('/language', 'LanguageController@langManage')->name('language.manage');
            Route::post('/language', 'LanguageController@langStore')->name('language.manage.store');
            Route::post('/language/delete/{id}', 'LanguageController@langDel')->name('language.manage.del');
            Route::post('/language/update/{id}', 'LanguageController@langUpdate')->name('language.manage.update');
            Route::get('/language/edit/{id}', 'LanguageController@langEdit')->name('language.key');
            Route::post('/language/import', 'LanguageController@langImport')->name('language.importLang');

            Route::post('language/store/key/{id}', 'LanguageController@storeLanguageJson')->name('language.store.key');
            Route::post('language/delete/key/{id}', 'LanguageController@deleteLanguageJson')->name('language.delete.key');
            Route::post('language/update/key/{id}', 'LanguageController@updateLanguageJson')->name('language.update.key');
        });
        Route::middleware(['CheckAdmin:settings'])->group(function () {
            // General Setting
            Route::get('general-setting', 'GeneralSettingController@index')->name('setting.index');
            Route::post('general-setting', 'GeneralSettingController@update')->name('setting.update');
            Route::get('optimize', 'GeneralSettingController@optimize')->name('setting.optimize');

            // Logo-Icon
            Route::get('setting/logo-icon', 'GeneralSettingController@logoIcon')->name('setting.logo.icon');
            Route::post('setting/logo-icon', 'GeneralSettingController@logoIconUpdate')->name('setting.logo.icon');

            //Custom CSS
            Route::get('custom-css', 'GeneralSettingController@customCss')->name('setting.custom.css');
            Route::post('custom-css', 'GeneralSettingController@customCssSubmit');

            //Holiday
            Route::get('holiday-setting', 'GeneralSettingController@holiday')->name('setting.holiday');
            Route::post('holiday-setting', 'GeneralSettingController@holidaySubmit');
            Route::post('holiday-remove/{id}', 'GeneralSettingController@remove')->name('setting.remove');

            //Offday
            Route::post('offday-setting', 'GeneralSettingController@offDaySubmit')->name('setting.offday');

            //Cookie
            Route::get('cookie', 'GeneralSettingController@cookie')->name('setting.cookie');
            Route::post('cookie', 'GeneralSettingController@cookieSubmit');

            // Plugin
            Route::get('extensions', 'ExtensionController@index')->name('extensions.index');
            Route::post('extensions/update/{id}', 'ExtensionController@update')->name('extensions.update');
            Route::post('extensions/activate', 'ExtensionController@activate')->name('extensions.activate');
            Route::post('extensions/deactivate', 'ExtensionController@deactivate')->name('extensions.deactivate');

            // Email Setting
            Route::get('email-template/global', 'EmailTemplateController@emailTemplate')->name('email.template.global');
            Route::post('email-template/global', 'EmailTemplateController@emailTemplateUpdate')->name('email.template.global');
            Route::get('email-template/setting', 'EmailTemplateController@emailSetting')->name('email.template.setting');
            Route::post('email-template/setting', 'EmailTemplateController@emailSettingUpdate')->name('email.template.setting');
            Route::get('email-template/index', 'EmailTemplateController@index')->name('email.template.index');
            Route::get('email-template/{id}/edit', 'EmailTemplateController@edit')->name('email.template.edit');
            Route::post('email-template/{id}/update', 'EmailTemplateController@update')->name('email.template.update');
            Route::post('email-template/send-test-mail', 'EmailTemplateController@sendTestMail')->name('email.template.test.mail');

            // SMS Setting
            Route::get('sms-template/global', 'SmsTemplateController@smsTemplate')->name('sms.template.global');
            Route::post('sms-template/global', 'SmsTemplateController@smsTemplateUpdate')->name('sms.template.global');
            Route::get('sms-template/setting', 'SmsTemplateController@smsSetting')->name('sms.templates.setting');
            Route::post('sms-template/setting', 'SmsTemplateController@smsSettingUpdate')->name('sms.template.setting');
            Route::get('sms-template/index', 'SmsTemplateController@index')->name('sms.template.index');
            Route::get('sms-template/edit/{id}', 'SmsTemplateController@edit')->name('sms.template.edit');
            Route::post('sms-template/update/{id}', 'SmsTemplateController@update')->name('sms.template.update');
            Route::post('email-template/send-test-sms', 'SmsTemplateController@sendTestSMS')->name('sms.template.test.sms');
        });
        Route::middleware(['CheckAdmin:pages'])->group(function () {
// SEO
            Route::get('seo', 'FrontendController@seoEdit')->name('seo');
        });

        Route::middleware(['CheckAdmin:fiats'])->group(function () {
            // WITHDRAW SYSTEM
            Route::name('withdraw.')->prefix('withdraw')->group(function () {
                Route::get('pending', 'WithdrawalController@pending')->name('pending');
                Route::get('approved', 'WithdrawalController@approved')->name('approved');
                Route::get('rejected', 'WithdrawalController@rejected')->name('rejected');
                Route::get('log', 'WithdrawalController@log')->name('log');
                Route::get('via/{method_id}/{type?}', 'WithdrawalController@logViaMethod')->name('method');
                Route::get('{scope}/search', 'WithdrawalController@search')->name('search');
                Route::get('date-search/{scope}', 'WithdrawalController@dateSearch')->name('dateSearch');
                Route::get('details/{id}', 'WithdrawalController@details')->name('details');
                Route::post('approve', 'WithdrawalController@approve')->name('approve');
                Route::post('reject', 'WithdrawalController@reject')->name('reject');
// Withdraw Method
                Route::get('method/', 'WithdrawMethodController@methods')->name('method.index');
                Route::get('method/create', 'WithdrawMethodController@create')->name('method.create');
                Route::post('method/create', 'WithdrawMethodController@store')->name('method.store');
                Route::get('method/edit/{id}', 'WithdrawMethodController@edit')->name('method.edit');
                Route::post('method/edit/{id}', 'WithdrawMethodController@update')->name('method.update');
                Route::post('method/activate', 'WithdrawMethodController@activate')->name('method.activate');
                Route::post('method/deactivate', 'WithdrawMethodController@deactivate')->name('method.deactivate');
            });
        });
        Route::middleware(['CheckAdmin:cryptos'])->group(function () {
            // CRYPTO WITHDRAW SYSTEM
            Route::name('withdrawc.')->prefix('withdrawc')->group(function () {
                Route::get('pending', 'WithdrawalcController@pending')->name('pending');
                Route::get('approved', 'WithdrawalcController@approved')->name('approved');
                Route::get('rejected', 'WithdrawalcController@rejected')->name('rejected');
                Route::get('log', 'WithdrawalcController@log')->name('log');
                Route::get('via/{method_id}/{type?}', 'WithdrawalcController@logViaMethod')->name('method');
                Route::get('{scope}/search', 'WithdrawalcController@search')->name('search');
                Route::get('date-search/{scope}', 'WithdrawalcController@dateSearch')->name('dateSearch');
                Route::get('details/{id}', 'WithdrawalcController@details')->name('details');
                Route::post('approve', 'WithdrawalcController@approve')->name('approve');
                Route::post('reject', 'WithdrawalcController@reject')->name('reject');
            });
        });

        Route::middleware(['CheckAdmin:settings'])->group(function () {
            // Frontend
            Route::name('frontend.')->prefix('frontend')->group(function () {


                Route::get('templates', 'FrontendController@templates')->name('templates');
                Route::post('templates', 'FrontendController@templatesActive')->name('templates.active');
            });
        });
        Route::middleware(['CheckAdmin:pages'])->group(function () {
            Route::name('frontend.')->prefix('frontend')->group(function () {
                Route::get('frontend-sections/{key}', 'FrontendController@frontendSections')->name('sections');
                Route::post('frontend-content/{key}', 'FrontendController@frontendContent')->name('sections.content');
                Route::get('frontend-element/{key}/{id?}', 'FrontendController@frontendElement')->name('sections.element');
                Route::post('remove', 'FrontendController@remove')->name('remove');

                // Page Builder

                Route::get('manage-pages', 'PageBuilderController@managePages')->name('manage.pages');
                Route::post('manage-pages', 'PageBuilderController@managePagesSave')->name('manage.pages.save');
                Route::post('manage-pages/update', 'PageBuilderController@managePagesUpdate')->name('manage.pages.update');
                Route::post('manage-pages/delete', 'PageBuilderController@managePagesDelete')->name('manage.pages.delete');
                Route::get('manage-section/{id}', 'PageBuilderController@manageSection')->name('manage.section');
                Route::post('manage-section/{id}', 'PageBuilderController@manageSectionUpdate')->name('manage.section.update');
            });
        });
    });
});

/*
  |--------------------------------------------------------------------------
  | Start User Area
  |--------------------------------------------------------------------------
 */


Route::name('user.')->group(function () {
    Route::get('/login', 'Auth\LoginController@showLoginForm')->name('login');
    Route::post('/login', 'Auth\LoginController@login');
    Route::get('logout', 'Auth\LoginController@logout')->name('logout');

    Route::get('register', 'Auth\RegisterController@showRegistrationForm')->name('register');
    Route::post('register', 'Auth\RegisterController@register')->middleware('regStatus');
    Route::post('check-mail', 'Auth\RegisterController@checkUser')->name('checkUser');

    Route::get('password/reset', 'Auth\ForgotPasswordController@showLinkRequestForm')->name('password.request');
    Route::post('password/email', 'Auth\ForgotPasswordController@sendResetCodeEmail')->name('password.email');
    Route::get('password/code-verify', 'Auth\ForgotPasswordController@codeVerify')->name('password.code.verify');
    Route::post('password/reset', 'Auth\ResetPasswordController@reset')->name('password.update');
    Route::get('password/reset/{token}', 'Auth\ResetPasswordController@showResetForm')->name('password.reset');
    Route::post('password/verify-code', 'Auth\ForgotPasswordController@verifyCode')->name('password.verify.code');
    //KYC
    Route::get('/kyccheck', 'KycController@index')->name('kyccheck');
    Route::get('/kyc', 'KycController@index')->name('kyc.index');
    Route::post('/updatekyc', 'KycController@updatekyc')->name('kyc.updatekyc');
    Route::get('/cardverify', 'KycController@cardverify')->name('kyc.cardverify');
    Route::get('/tokenupdate/{txref}', 'KycController@tokenupdate')->name('kyc.tokenupdate');
});

Route::name('user.')->prefix('user')->group(function () {
    Route::middleware('auth')->group(function () {
        Route::get('authorization', 'AuthorizationController@authorizeForm')->name('authorization');
        Route::get('resend-verify', 'AuthorizationController@sendVerifyCode')->name('send.verify.code');
        Route::post('verify-email', 'AuthorizationController@emailVerification')->name('verify.email');
        Route::post('verify-sms', 'AuthorizationController@smsVerification')->name('verify.sms');
        Route::post('verify-g2fa', 'AuthorizationController@g2faVerification')->name('go2fa.verify');

        Route::middleware(['checkStatus'])->group(function () {
            Route::get('dashboard', 'UserController@home')->name('home');
            Route::get('checkout', 'UserController@checkout')->name('checkout');

            Route::get('profile-setting', 'UserController@profile')->name('profile.setting');
            Route::post('profile-setting', 'UserController@submitProfile');
            Route::get('change-password', 'UserController@changePassword')->name('change.password');
            Route::post('change-password', 'UserController@submitPassword');

            //Game Logs
            Route::middleware(['checkModule:games'])->group(function () {
                Route::get('game/log', 'UserController@gameLog')->name('gameLog');
                Route::get('commission/log', 'UserController@commissionLog')->name('commissionLog');
                //Play Head Tail
                Route::get('play/head-tail', 'PlayController@headTail')->name('play.head-tail');
                Route::post('play/game/head-tail', 'PlayController@playheadTail')->name('play.playheadTail');
                Route::post('play/gameEnd/headTail', 'PlayController@gameEndHeadTail')->name('play.gameEndHeadTail');

                //Play rock-paper-scissors
                Route::get('play/rock-paper-scissors', 'PlayController@rockPaperScissors')->name('play.rockPaperScissors');
                Route::post('play/game/rock-paper-scissors', 'PlayController@playrockPaperScissors')->name('play.playrockPaperScissors');
                Route::post('play/gameEnd/rockPaperScissors', 'PlayController@gameEndRockPaperScissors')->name('play.gameEndRockPaperScissors');

                //Play spin-wheel
                Route::get('play/spin-wheel', 'PlayController@spinWheel')->name('play.spinWheel');
                Route::post('play/game/spin-wheel', 'PlayController@playspinWheel')->name('play.playspinWheel');
                Route::post('play/gameEnd/spinWheel', 'PlayController@gameEndSpinWheel')->name('play.gameEndSpinWheel');

                //Play Dice Rolling
                Route::get('play/dice-rolling', 'PlayController@diceRolling')->name('play.diceRolling');
                Route::post('play/game/dice-rolling', 'PlayController@playdiceRoll')->name('play.playdiceRoll');
                Route::post('play/gameEnd/dice-rolling', 'PlayController@gameEnddiceRoll')->name('play.gameEnddiceRoll');

                //Number Slot
                Route::get('play/number-slot', 'PlayController@numberSlot')->name('play.numberSlot');
                Route::post('play/game/number-slot', 'PlayController@PlayNumberSlot')->name('play.PlayNumberSlot');
                Route::post('play/gameEnd/number-slot', 'PlayController@gameEndnumberSlot')->name('play.gameEndnumberSlot');

                //Pool Number
                Route::get('play/pool-number', 'PlayController@poolNumber')->name('play.numberPoll');
                Route::post('play/game/pool-number', 'PlayController@playPoolNumber')->name('play.playPoolNumber');
                Route::post('play/gameEnd/pool-number', 'PlayController@gameEndPoolNumber')->name('play.gameEndPoolNumber');

                //Play Card Finding
                Route::get('play/card-finding', 'PlayController@cardFinding')->name('play.cardFinding');
                Route::post('play/game/card-finding', 'PlayController@playCardFinding')->name('play.playCardFinding');
                Route::post('play/gameEnd/card-finding', 'PlayController@gameEndCardFinding')->name('play.gameEndCardFinding');

                //Play Number Guessing
                Route::get('play/number-guess', 'PlayController@numberGuess')->name('play.numberGuesse');
                Route::post('play/game/number-guess', 'PlayController@playnumberGuess')->name('play.playnumberGuess');
                Route::post('play/gameEnd/gameEndnumberGuess', 'PlayController@gameEndnumberGuess')->name('play.gameEndnumberGuess');
            });

            //2FA
            Route::get('twofactor', 'UserController@show2faForm')->name('twofactor');
            Route::post('twofactor/enable', 'UserController@create2fa')->name('twofactor.enable');
            Route::post('twofactor/disable', 'UserController@disable2fa')->name('twofactor.disable');

            //DPS
            Route::middleware(['checkModule:dps'])->group(function () {
                Route::get('dps/plans', 'UserActionController@dpsPlans')->name('dps.plans');
                Route::get('dps/invest', 'UserActionController@dpsBuy')->name('dps.buy');
                Route::post('dps/invest', 'UserActionController@dpsBuyConfirm')->name('dps.buy.confirm');
                Route::get('dps/list', 'UserActionController@dpsList')->name('dps.list');
                Route::post('dps/close', 'UserActionController@dpsClose')->name('dps.close');
            });

            // FDR
            Route::middleware(['checkModule:fdr'])->group(function () {
                Route::get('/fdr/plans', 'UserActionController@fdrPlans')->name('fdr.plans');
                Route::get('/fdr/invest', 'UserActionController@fdrBuy')->name('fdr.buy');
                Route::post('/fdr/invest', 'UserActionController@fdrBuyConfirm')->name('fdr.buy.confirm');

                Route::get('/fdr/list', 'UserActionController@fdrList')->name('fdr.list');
                Route::post('/fdr/close', 'UserActionController@fdrClose')->name('fdr.close');
            });

            // LOAN
            Route::middleware(['checkModule:loan'])->group(function () {
                Route::get('loan/plans', 'UserActionController@loanPlans')->name('loan.plans');
                Route::post('loan/apply', 'UserActionController@applyLoan')->name('loan.apply');
                Route::get('loan/apply/form', 'UserActionController@loanForm')->name('loan.apply.form');
                Route::post('loan/apply/form', 'UserActionController@loanFormSubmit');
                Route::get('loan/list', 'UserActionController@loanList')->name('loan.list');
            });
            // Actions
            Route::post('action', 'UserActionController@userAction')->name('action');
            Route::get('verify/otp', 'UserActionController@verifyOtp')->name('otp.verify');
            Route::post('check/otp', 'UserActionController@checkOtp')->name('otp.check');
            Route::post('resend/otp', 'UserActionController@resendOtp')->name('otp.resend');
            Route::get('action/cancel', 'UserActionController@cancelAction')->name('action.cancel');
            // Deposit
            Route::any('/deposit', 'Gateway\PaymentController@deposit')->name('deposit');
            Route::any('/return/page', 'Gateway\PaymentController@returnPage')->name('deposit.return');
            Route::post('deposit/insert', 'Gateway\PaymentController@depositInsert')->name('deposit.insert');
            Route::get('deposit/preview', 'Gateway\PaymentController@depositPreview')->name('deposit.preview');
            Route::get('deposit/confirm', 'Gateway\PaymentController@depositConfirm')->name('deposit.confirm');
            Route::get('deposit/manual', 'Gateway\PaymentController@manualDepositConfirm')->name('deposit.manual.confirm');
            Route::post('deposit/manual', 'Gateway\PaymentController@manualDepositUpdate')->name('deposit.manual.update');
            Route::any('deposit/history', 'UserController@depositHistory')->name('deposit.history');

            //Plaid
            Route::get('banktransfer', 'UserController@banktransfer')->name('banktransfer');
            Route::post('processbank', 'UserController@processbank')->name('processbank');
            Route::get('processbanktransfer', 'UserController@processbanktransfer')->name('processbanktransfer');
            Route::get('successbanktransfer/{id}', 'UserController@successbanktransfer')->name('successbanktransfer');
            Route::get('errorbanktransfer', 'UserController@errorbanktransfer')->name('errorbanktransfer');

            // Withdraw
            Route::get('/withdraw', 'UserController@withdrawMoney')->name('withdraw');
            Route::post('/withdraw', 'UserController@withdrawStore')->name('withdraw.money');
            Route::get('/withdraw/preview', 'UserController@withdrawPreview')->name('withdraw.preview');
            Route::post('/withdraw/preview', 'UserController@withdrawSubmit')->name('withdraw.submit');
            Route::get('/withdraw/history', 'UserController@withdrawLog')->name('withdraw.history');

            //Transfer
            Route::get('/transfer', 'TransferController@transfer')->name('transfer');
            Route::post('/user/exist', 'TransferController@checkUser')->name('check.exist');
            Route::post('/transfer/confirm', 'TransferController@transferconfirm')->name('transfer.confirm');

            //payment link
            Route::get('/transfer/receivelink', 'TransferController@receivelink')->name('transfer.receivelink');
            Route::post('/transfer/addlink', 'TransferController@addlink')->name('transfer.addlink');
            Route::get('/transfer/deletelink', 'TransferController@deletelink')->name('transfer.deletelink');

            //donations

            Route::get('/transfer/donatelink', 'TransferController@donatelink')->name('transfer.donatelink');
            Route::post('/transfer/adddonatelink', 'TransferController@adddonatelink')->name('transfer.adddonatelink');

            //pgconfirmation
            Route::get('/payconfirm', 'PgController@payconfirm')->name('pg.confirm');
            Route::post('/processpayment', 'PgController@processpayment')->name('pg.processpayment');

            //developers
            Route::get('/developers', 'UserController@merchant')->name('developers.index');

            //Debitcard
            Route::get('/debitcard', 'DebitcardController@index')->name('debit.index');
            Route::post('/requestcard', 'DebitcardController@newcard')->name('debit.request');
            Route::post('/loadfunds', 'DebitcardController@loadfunds')->name('debit.loadfunds');
            Route::get('/blockcard', 'DebitcardController@blockcard')->name('debit.blockcard');
            Route::get('/unblockcard', 'DebitcardController@unblockcard')->name('debit.unblockcard');
            Route::get('/aptocard', 'DebitcardController@aptocard')->name('debit.aptocard');

            //Livitpaycards
            Route::post('/livitrequestnew', 'DebitcardController@livitrequestnew')->name('debit.livitrequestnew');
            Route::post('/livitpayfund', 'DebitcardController@livitpayfund')->name('debit.livitpayfund');
            Route::post('/livitpaycancel', 'DebitcardController@livitpaycancel')->name('debit.livitpaycancel');
            Route::get('/masternew', 'DebitcardController@masternew')->name('debit.masternew');
            Route::get('/masterdebitcard', 'DebitcardController@livitpayindex')->name('debit.master');

            //Livitpaycards Prepaid
            Route::get('/masterprepaidcard', 'MastercardController@prepaidlist')->name('prepaid.list');
            Route::get('/masterprepaidcard/{id}', 'MastercardController@livitpayindex')->name('prepaid.master');
            Route::get('/getprepaidcards', 'MastercardController@getprepaidcards')->name('prepaid.get');
            Route::post('/buyprepaidcards', 'MastercardController@buyprepaidcards')->name('prepaid.buy');

//Livitpay Cards

            Route::post('/visalivitrequestnew', 'DebitcardController@visalivitrequestnew')->name('debit.visalivitrequestnew');
            Route::post('/visalivitpayfund', 'DebitcardController@visalivitpayfund')->name('debit.visalivitpayfund');

            Route::get('/visanew', 'DebitcardController@visanew')->name('debit.visanew');
            Route::get('/visadebitcard', 'DebitcardController@visalivitpayindex')->name('debit.visa');

//Livitpay USD Visa Cards

            Route::post('/usdvisalivitrequestnew', 'DebitcardController@usdvisalivitrequestnew')->name('debit.usdvisalivitrequestnew');
            Route::post('/usdvisalivitpayfund', 'DebitcardController@usdvisalivitpayfund')->name('debit.usdvisalivitpayfund');

            Route::get('/usdvisanew', 'DebitcardController@usdvisanew')->name('debit.usdvisanew');
            Route::get('/usdvisadebitcard', 'DebitcardController@usdvisalivitpayindex')->name('debit.usdvisa');

// OWN DEBIT CARD
            Route::get('/debitvcard', 'DebitcardController@vindex')->name('debit.vindex');
            Route::post('/requestvcard', 'DebitcardController@vnewcard')->name('debit.vrequest');
            Route::get('/blockvcard', 'DebitcardController@vblockcard')->name('debit.vblockcard');
            Route::get('/unblockvcard', 'DebitcardController@vunblockcard')->name('debit.vunblockcard');

            //crypto debit card
            Route::get('cryptocardindex', 'DebitcardController@cryptocardindex')->name('debit.cryptocardindex');
            Route::get('cryptocardapply', 'DebitcardController@cryptocardapply')->name('debit.cryptocardapply');
            Route::post('cryptonewcard', 'DebitcardController@cryptonewcard')->name('debit.cryptonewcard');
            Route::get('/blockvcard', 'DebitcardController@vblockcard')->name('debit.vblockcard');
            Route::get('/unblockvcard', 'DebitcardController@vunblockcard')->name('debit.vunblockcard');
            Route::post('/changepin', 'DebitcardController@changepin')->name('crypto.changepin');

            //Crypto Master Card
            Route::post('/cryptolivitrequestnew', 'DebitcardController@cryptolivitrequestnew')->name('debit.cryptolivitrequestnew');
            Route::post('/cryptolivitpayfund', 'DebitcardController@cryptolivitpayfund')->name('debit.cryptolivitpayfund');
            Route::post('/cryptolivitpaycancel', 'DebitcardController@cryptolivitpaycancel')->name('debit.cryptolivitpaycancel');
            Route::get('/cryptomasternew', 'DebitcardController@cryptomasternew')->name('debit.cryptomasternew');
            Route::get('/cryptomasterdebitcard', 'DebitcardController@cryptolivitpayindex')->name('debit.cryptomaster');

            //prepaid card

            Route::get('/prepaidcard', 'DebitcardController@tremendous')->name('debit.prepaid');
            Route::post('/prerequestcard', 'DebitcardController@orderprepaid')->name('debit.prerequest');

            Route::post('/createveri', 'DebitcardController@create_verification_process_request')->name('debit.createveri');
            Route::post('/completeveri', 'DebitcardController@complete_verification_process_request')->name('debit.completeveri');

            //vouchers
            Route::get('/vouchers', 'VouchersController@index')->name('vouchers.index');
            Route::post('/buyvoucher', 'VouchersController@buyvoucher')->name('vouchers.buy');
            Route::post('/redeemvoucher', 'VouchersController@redeem')->name('vouchers.redeem');

            //Virtual Accounts
            Route::get('/bank', 'BankController@index')->name('bank.index');
            Route::post('/bankrequest', 'BankController@request')->name('bank.request');
            Route::get('/banktransactions', 'BankController@banktransactions')->name('bank.banktransactions');
            Route::get('/redeemtransaction', 'BankController@redeemtransaction')->name('bank.redeemtransaction');

            // Withdrawcrypto
            Route::get('/withdrawc/history', 'UserController@withdrawLogc')->name('withdraw.historyc');
            Route::get('/withdrawc/{crypto}', 'UserController@withdrawc')->name('withdrawc');
            Route::post('/withdrawc', 'UserController@withdrawStorec')->name('withdraw.storec');

            Route::get('/transaction-logs', 'UserController@trxLog')->name('trx.log');

            Route::get('/mtransaction-logs', 'UserController@mtrxLog')->name('mtrx.log');
            Route::get('/ctransaction-logs', 'UserController@ctrxLog')->name('ctrx.log');
            Route::get('/cdeposit', 'UserController@cryptodeposits')->name('cryptodeposits.log');
            Route::post('/purchase-card', 'UserController@purchaseCard')->name('card.purchase');
            Route::post('/addtocart', 'UserController@cart')->name('card.cart');
            Route::get('/getCartItems', 'UserController@getCartItems')->name('getcart');
            Route::post('/cart/delete', 'UserController@deleteCartItem')->name('card.cart.delete');
            Route::get('/my-cards', 'UserController@card')->name('card');
            Route::get('/cards/details/{id}', 'UserController@cardDetails')->name('card.details');

            //Points
            Route::get('/points-logs', 'PointsController@ptrxLog')->name('ptrx.log');
            Route::get('/points-redeem', 'PointsController@redeempoints')->name('points.redeem');

            //Wallets
            Route::get('/wallets', 'Gateway\PaymentController@wallets')->name('wallets');
            Route::get('/wallets/generate/{crypto}', 'Gateway\PaymentController@walletGenerate')->name('wallets.generate');
            Route::get('/wallets/ercgenerate/{crypto}', 'Gateway\PaymentController@ercwalletGenerate')->name('wallets.ercgenerate');

            // send money
            Route::middleware(['checkModule:remittance'])->group(function () {
                Route::get('send-money/remit-now', 'UserSendMoneyController@sendMoney')->name('send.money.now');
                Route::post('send-money/save', 'UserSendMoneyController@save')->name('send.money.save');
                Route::get('send-money/remit-history', 'UserSendMoneyController@history')->name('send.money.history');
                Route::get('send-money/pay-now', 'UserSendMoneyController@payNow')->name('send.money.pay.now');
                Route::post('send-money/pay', 'UserSendMoneyController@pay')->name('send.money.pay');
//                Route::middleware('user.kyc:direct_payment')->group(function () {
//                    Route::get('pay-now', 'payNow')->name('pay.now');
//                    Route::post('pay', 'pay')->name('pay');
//                });
            });

            //KYC
            //Tatum
            Route::get('/currencies', 'VirtualController@index')->name('currencies.index');
            Route::post('/currencieswallet', 'VirtualController@addwallet')->name('currencies.wallet');
            Route::get('/currenciesexchange/{id}', 'VirtualController@exchange')->name('currencies.exchange');
            Route::get('/currenciesusdexchange/{id}', 'VirtualController@usdexchange')->name('currencies.usdexchange');
            Route::get('/currenciestransfer/{id}', 'VirtualController@transfer')->name('currencies.transfer');
            Route::post('/currenciestransferconfirm', 'VirtualController@transferconfirm')->name('currencies.transferconfirm');
            Route::post('/currenciesexchangeconfirm', 'VirtualController@exchangeconfirm')->name('currencies.exchangeconfirm');
            Route::post('/currenciesusdexchangeconfirm', 'VirtualController@usdexchangeconfirm')->name('currencies.usdexchangeconfirm');
            // Advertisement
            Route::get('/advertisements', 'AdvertisementController@index')->name('advertisement.index');
            Route::get('/advertisement-new', 'AdvertisementController@new')->name('advertisement.new');
            Route::post('/advertisement-store', 'AdvertisementController@store')->name('advertisement.store');
            Route::get('/advertisement-edit/{id}', 'AdvertisementController@edit')->name('advertisement.edit');
            Route::post('/advertisement-update/{id}', 'AdvertisementController@update')->name('advertisement.update');

            // Trade Request
            Route::get('/trade-requests', 'TradeController@tradeRequests')->name('trade.requests');
            Route::get('/trade-request-details/{id}', 'TradeController@tradeRequestDetails')->name('trade.request.details');
            Route::get('/trade-request/new/{id}', 'TradeController@tradeRequestNew')->name('trade.request.new');
            Route::post('/trade-request/store/{id}', 'TradeController@tradeRequestStore')->name('trade.request.store');

            // Trade Request Operation
            Route::post('/trade-request/cancel', 'TradeController@tradeRequestCancel')->name('trade.request.cancel');
            Route::post('/trade-request/paid', 'TradeController@tradeRequestPaid')->name('trade.request.paid');
            Route::post('/trade-request/dispute', 'TradeController@tradeRequestDispute')->name('trade.request.dispute');
            Route::post('/trade-request/release', 'TradeController@tradeRequestRelease')->name('trade.request.release');

            // Trade Request Chat
            Route::post('/trade-request-chat/store/{id}', 'TradeController@tradeRequestChatStore')->name('trade.request.chat.store');
// File Download
            Route::get('/file-download/{id}', 'TradeController@download')->name('download');

            //Virtual Phone


            Route::get('vpplans', 'VirtualphoneController@vpplans')->name('vpplans');
            Route::get('vpchoose', 'VirtualphoneController@vpchoose')->name('vpchoose');
            Route::post('vpbuy', 'VirtualphoneController@vpbuy')->name('vpbuy');
            Route::get('vpmynumber', 'VirtualphoneController@vpmynumber')->name('vpmynumber');
            Route::get('vpviewsms', 'VirtualphoneController@vpviewsms')->name('vpviewsms');
            Route::post('callforward', 'VirtualphoneController@callforward')->name('callforward');
            Route::get('vpcancel/{msisdn}', 'VirtualphoneController@vpcancel')->name('vpcancel');
            Route::get('vprenew/{msisdn}', 'VirtualphoneController@vprenew')->name('vprenew');

            //POS
            Route::get('pos', 'UserController@pos')->name('pos');
            Route::get('agentlist', 'UserController@agentlist')->name('agentlist');

//reloadly_giftcard
            Route::match(['get', 'post'], 'giftcard', 'GiftCardController@showGiftCardProducts')->name('giftcard');
            Route::match(['get', 'post'], 'giftcard/details/{productId}', 'GiftCardController@details')->name('giftcard.details');
            Route::post('giftcard/orders', 'GiftCardController@processGiftCardOrder')->name('giftcard.order');
            Route::get('giftcard/mycard', 'GiftCardController@getGiftCardPurchasedHistory')->name('giftcard.mycard');
            Route::get('giftcard/mycard/details/{product_id}', 'GiftCardController@getPurchasedCardDetails')->name('giftcard.mycard.details');

//virtual card
            Route::match(['get', 'post'], 'virtualcards', 'VirtualCardController@showVirtualCard')->name('virtualcards');
            Route::post('requestvirtualcards', 'VirtualCardController@newVirtualCard')->name('virtualcards.new');
            Route::post('virtualcards/loadfunds', 'VirtualCardController@loadfunds')->name('virtualcards.loadfunds');
            Route::get('virtualcards/block', 'VirtualCardController@blockVirtualCard')->name('virtualcards.block');
            Route::get('virtualcards/unblock', 'VirtualCardController@unblockVirtualCard')->name('virtualcards.unblock');

            Route::get('prepaycards', 'SiteController@prepaycards')->name('prepaycards');
            Route::get('prepaycard/details/{name}/{id}', 'SiteController@prepaycardDetails')->name('prepaycard.details');
            Route::post('orderprepaid', 'SiteController@orderprepaid')->name('prepaycard.orderprepaid');
            Route::get('prepaidcarduser', 'SiteController@prepaidcarduser')->name('prepaycard.prepaidcarduser');

//BSICards

            Route::get('mastervirtual', 'VirtualCardController@mastervirtual')->name('mastervirtual');
            Route::get('mastervirtualview/{id}', 'VirtualCardController@mastervirtualview')->name('mastervirtualview');
            Route::post('mastervirtualloadfunds', 'VirtualCardController@mastervirtualloadfunds')->name('mastervirtualloadfunds');
            Route::post('mastervirtualnew', 'VirtualCardController@mastervirtualnew')->name('mastervirtualnew');
            Route::get('mastervirtualblock/{id}', 'VirtualCardController@mastervirtualblock')->name('mastervirtualblock');
            Route::get('mastervirtualunblock/{id}', 'VirtualCardController@mastervirtualunblock')->name('mastervirtualunblock');

            //agent remit
            Route::get('agentremit', 'PgController@agentremit')->name('agentremit');
            Route::get('remitsendotp', 'PgController@remitsendotp')->name('pg.remitsendotp');
            Route::get('remitverifyotp', 'PgController@remitverifyotp')->name('pg.remitverifyotp');
            Route::post('remitposcard', 'PgController@remitposcard')->name('pg.remitposcard');

            //meetings
            Route::get('meetings', 'UserController@meetings')->name('meetings');

            //fx trader
            Route::get('fxtrader', 'UserController@fxtrader')->name('fxtrader');

            //fincra

            Route::post('createaccountngn', 'FincraController@createaccountngn')->name('createaccountngn');
            Route::post('createaccountusd', 'FincraController@createaccountusd')->name('createaccountusd');
            Route::post('createaccountgbp', 'FincraController@createaccountgbp')->name('createaccountgbp');
            Route::post('createaccounteur', 'FincraController@createaccounteur')->name('createaccounteur');
            Route::get('getaccountngn', 'FincraController@getaccountngn')->name('getaccountngn');
            Route::get('getaccountusd/{currency}', 'FincraController@getaccountusd')->name('getaccountusd');
            Route::get('getaccounteur', 'FincraController@getaccounteur')->name('getaccounteur');
            Route::get('getaccountgbp', 'FincraController@getaccountgbp')->name('getaccountgbp');

            //kuda
            Route::get('bankaccounts', 'VirtualController@bankaccounts')->name('bankaccounts');
            Route::post('ngncreateva', 'VirtualController@ngncreateva')->name('ngncreateva');
            Route::get('transactionhistory', 'VirtualController@transactionhistory')->name('transactionhistory');
            Route::get('ngnfundtransfer', 'VirtualController@ngnfundtransfer')->name('ngnfundtransfer');
            Route::post('nameenquiry', 'VirtualController@nameenquiry')->name('nameenquiry');

            Route::get('betbillpayment', 'VirtualController@betbillpayment')->name('betbillpayment');
            Route::get('airtimebillpayment', 'VirtualController@airtimebillpayment')->name('airtimebillpayment');
            Route::get('electricitybillpayment', 'VirtualController@electricitybillpayment')->name('electricitybillpayment');
            Route::get('cabletvbillpayment', 'VirtualController@cabletvbillpayment')->name('cabletvbillpayment');
            Route::get('databillpayment', 'VirtualController@databillpayment')->name('databillpayment');
            Route::post('purchasebill', 'VirtualController@purchasebill')->name('purchasebill');
            Route::post('purchasebillconfirm', 'VirtualController@purchasebillconfirm')->name('purchasebillconfirm');

            //Interest
            Route::get('transactions/deposit-wallet', 'UserController@transactionsDeposit')->name('transactions.deposit');
            Route::get('transactions/interest-wallet', 'UserController@transactionsInterest')->name('transactions.interest');

            Route::get('interest/log', 'UserController@interestLog')->name('interest.log');
            Route::get('inttransfer', 'UserController@inttransfer')->name('interest.inttransfer');
            Route::get('referral/users/{level?}', 'UserController@refMy')->name('referral.users');

            Route::get('referral/commissions/deposit', 'UserController@commissionsDeposit')->name('referral.commissions.deposit');
            Route::get('referral/commissions/invest', 'UserController@commissionsInvest')->name('referral.commissions.invest');
            Route::get('referral/commissions/interest', 'UserController@commissionsInterest')->name('referral.commissions.interest');

            Route::post('/plans', 'UserController@buyPlan')->name('buy.plan');

            Route::get('/plan', 'UserController@plan')->name('plan');
            Route::post('/getCheckoutToken', 'UserController@getCheckoutToken')->name('getCheckoutToken');

            //Promotions
            Route::get('promotional-tool', 'UserController@promotions')->name('promotions.tool');
        });
    });
});

// Supported Currency
Route::get('/supported-currency', 'AdvertisementController@supportedCurrency')->name('advertisement.supported.currency');

// Crypto Currency Wise Advertisements
Route::get('/currency-wise-buy-ad', 'SiteController@currencyWiseBuyAd')->name('advertisement.currency.buy');
Route::get('/currency-wise-sell-ad', 'SiteController@currencyWiseSellAd')->name('advertisement.currency.sell');

//Search Advertisement
Route::get('/search-ad', 'SiteController@searchAdvertisements')->name('advertisement.search');

//Policy
Route::get('policy/{slug}/{id}', 'SiteController@policyDetails')->name('policy.details');

Route::get('/purchasecards', 'CheckOutController@purchasecards')->name('purchasecards');
Route::get('/airtime', 'CheckOutController@airtime')->name('airtime');
Route::get('/airtime/get-operator-by-iso', 'CheckOutController@get_operator_by_iso')->name('airtime.get-operator-by-iso');
Route::get('/airtime/get-operator-by-operator-id', 'CheckOutController@get_operator_by_operator_id')->name('airtime.get-operator-by-operator-id');
Route::post('/airtime/process-recharge-request', 'CheckOutController@process_recharge_request')->name('airtime.process-recharge-request');

Route::get('/contact', 'SiteController@contact')->name('contact');
Route::post('/contact', 'SiteController@contactSubmit')->name('contactform');
Route::get('/change/{lang?}', 'SiteController@changeLanguage')->name('lang');

Route::get('/cookie/accept', 'SiteController@cookieAccept')->name('cookie.accept');
Route::get('/{slug}/page/{id}', 'SiteController@policyPage')->name('policy.page');

Route::get('cards', 'SiteController@card')->name('card');
Route::get('cards/filter', 'SiteController@filter')->name('filter');
Route::get('category/{name}/{id}', 'SiteController@category')->name('category');
Route::get('card/details/{name}/{id}', 'SiteController@cardDetails')->name('card.details');

Route::get('blogs', 'SiteController@blogs')->name('blogs');
Route::get('blog/{slug}/{id}', 'SiteController@blogDetails')->name('blog.details');

Route::get('placeholder-image/{size}', 'SiteController@placeholderImage')->name('placeholder.image');

Route::get('/{slug}', 'SiteController@pages')->name('pages');
Route::get('/', 'SiteController@index')->name('home');
Route::get('/{buysell}/{crypto}/{fiatgt?}/{fiat?}/{amount?}', 'SiteController@buySell')->name('buy.sell');

