<?php

namespace App\Http\Controllers\Api;

use App\Http\Controllers\Controller;
use App\Models\GeneralSetting;
use App\Models\Language;
use Illuminate\Http\Request;
use App\Http\Controllers\PgController;
use Carbon\Carbon;
use App\Models\SubCategory;
use App\Models\Cart;
use App\Models\Fluttercard;
use App\Models\User;
use App\Models\Fiat;
use App\Models\Fincra;
use App\Models\Apirequest;
use App\Models\Wallet;
use App\Models\Crypto;
use App\Models\Points;
use App\Models\Vcard;
use App\Models\Cryptocard;
use App\Models\Paylink;
use App\Models\Countries;
use App\Models\Category;
use App\Models\Bank;
use App\Models\Banktrans;
use App\Models\Wipe;
use App\Models\Stripeupdate;
use Illuminate\Auth\Events\Registered;
use Illuminate\Foundation\Auth\RegistersUsers;
use App\Models\Plan;
use App\Models\TimeSetting;
use App\Models\Invest;
use App\Models\Holiday;
use App\Models\PromotionTool;
use Illuminate\Support\Facades\Validator;
use App\Models\WalletCrypto;
use Illuminate\Support\Facades\Auth;
use App\Http\Helpers\Helper;
use App\Models\Card;
use App\Lib\GoogleAuthenticator;
use App\Lib\Fincralib;
use App\Models\AdminNotification;
use App\Lib\Flutterwave;
use App\Models\Transaction;
use App\Models\WithdrawMethod;
use App\Models\Withdrawal;
use App\Rules\FileTypeValidate;
use App\Http\Controllers\Gateway\Coinpayments\CoinPaymentHosted;
use App\Models\Deposit;
use Illuminate\Support\Facades\Hash;
use Illuminate\Validation\Rules\Password;
use Illuminate\Validation\Rule;
use App\Models\GatewayCurrency;
use App\Models\SupportTicket;
use Response;
use App\Models\Extension;
use App\Models\UserLogin;
use Illuminate\Foundation\Auth\AuthenticatesUsers;
use Illuminate\Support\Facades\Route;
use App\Models\InstallmentLog;
use App\Models\FdrPlan;
use App\Models\DpsPlan;
use App\Models\LoanPlan;
use App\Models\UserDps;
use App\Models\UserFdr;
use App\Models\UserLoan;
use App\Models\UserAction;
use App\Models\Incomingsms;
use App\Models\Virtualnumber;
use App\Models\Vnplans;
use App\Lib\Vonage;
use App\Lib\Tatum;
use App\Models\GiftCardTransactions;
class BasicController extends Controller {

    use AuthenticatesUsers,
        RegistersUsers {
        AuthenticatesUsers::redirectPath insteadof RegistersUsers;
        AuthenticatesUsers::guard insteadof RegistersUsers;
    }

    /**
     * Where to redirect users after login.
     *
     * @var string
     */
    protected $username;

    public function __construct() {

        $this->activeTemplate = activeTemplate();
    }

    public function getcurrency() {
        $fiats = Fiat::where('status', "=", 1)->get(['name', 'code']);
        $data = array(
            'code' => 200,
            'result' => 'success',
            'data' => $fiats,
        );
        echo json_encode($data);
        exit;
    }

    public function getall() {
        $fiats = Fiat::where('code', "=", "NGN")->first();
        $rand = rand(1, 3);
        if ($rand % 2 == 0) {
            $data = array(
                'code' => 200,
                'result' => 'success',
                'data' => array(
                    'code' => $fiats->code,
                    'rate' => strval($fiats->rate),
                    'rate2' => (int) $fiats->rate,
                    'symbol' => $fiats->symbol
                ),
            );
            echo json_encode($data);
            exit;
        } else {
            $data = array(
                'code' => 200,
                'result' => 'success',
                'data' => array(
                    'code' => $fiats->code,
                    'rate' => (int) $fiats->rate,
                    'rate2' => strval($fiats->rate),
                    'symbol' => $fiats->symbol
                ),
            );
            echo json_encode($data);
            exit;
        }
    }

    public function getposkey(Request $request) {
        $general = GeneralSetting::first();
        $token = $request->header('stripeuniquekey');
        if ($general->stripeuniquekey != $token) {
            $data = array(
                'code' => 400,
                'result' => 'failure',
                'message' => 'Invalid stripeuniquekey',
            );
            echo json_encode($data);
            exit;
        }

        $data = array(
            'code' => 200,
            'result' => 'success',
            'stripePublishableKey' => $general->stripePublishableKey,
            'stripeSecretKey' => $general->stripeSecretKey,
        );
        echo json_encode($data);
        exit;
    }

    public function generalSetting() {
        $general = GeneralSetting::first();
        $notify[] = 'General setting data';
        return response()->json([
                    'code' => 200,
                    'status' => 'ok',
                    'message' => ['success' => $notify],
                    'data' => ['general_setting' => $general],
                    'url' => env('APP_URL'),
                    'canyon' => env("PURCHASECODE"),
        ]);
    }

    public function appSetting() {
        $general = GeneralSetting::first();

        $data = array(
            'code' => 200,
            'result' => 'success',
            'data' => [
                'loans' => $general->loan,
                'investment' => $general->investments,
                'dps' => $general->dps,
                'fdr' => $general->fdr,
                'giftcard' => env("ezpin_api"),
                'cryptowallet' => $general->crypto,
                'mastercard' => $general->livitpay,
                'payment_deposit' => $general->payment_deposit,
                'user_transfer' => $general->user_transfer,
                'payment_withdrawal' => $general->payment_withdrawal,
            ]
        );
        echo json_encode($data);
        exit;
    }

    private function maskpan(string $string = NULL) {
        if (!$string) {
            return NULL;
        }
        $length = strlen($string);
        $visibleCount = (int) round($length / 4);
        $hiddenCount = $length - ($visibleCount * 4);
        return substr($string, 0, $visibleCount) . str_repeat('*', 8) . substr($string, ($visibleCount * -1), $visibleCount);
    }

    public function loginapp(Request $request) {
        $this->username = $this->findUsername();
        $this->password = $this->password();

        $credentials = array(
            "email" => $this->username,
            "password" => $this->password
        );

        if (!Auth::attempt($credentials)) {
            $data = array(
                'result' => 'failure',
                'message' => 'Invalid email/password',
            );
            echo json_encode($data);
            exit;
        }


        $users = $request->user();
        $tokenResult = $users->createToken('auth_token')->plainTextToken;
        $this->authenticated($request, $users);
        $user = auth()->user();
        $user->token = $tokenResult;
        $user->save();
        $user->tv = $user->ts == 1 ? 0 : 1;
        $user->save();
        $ip = $_SERVER["REMOTE_ADDR"];
        $exist = UserLogin::where('user_ip', $ip)->first();
        $userLogin = new UserLogin();
        if ($exist) {
            $userLogin->longitude = $exist->longitude;
            $userLogin->latitude = $exist->latitude;
            $userLogin->city = $exist->city;
            $userLogin->country_code = $exist->country_code;
            $userLogin->country = $exist->country;
        } else {
            $info = json_decode(json_encode(getIpInfo()), true);
            $userLogin->longitude = @implode(',', $info['long']);
            $userLogin->latitude = @implode(',', $info['lat']);
            $userLogin->city = @implode(',', $info['city']);
            $userLogin->country_code = @implode(',', $info['code']);
            $userLogin->country = @implode(',', $info['country']);
        }

        $userAgent = osBrowser();
        $userLogin->user_id = $user->id;
        $userLogin->user_ip = $ip;

        $userLogin->browser = @$userAgent['browser'];
        $userLogin->os = @$userAgent['os_platform'];
        $userLogin->save();

        $card = Vcard::where('user_id', $user->id)->first();
        if ($card) {
            $card_id = $card->card_id;
        } else {
            $card_id = null;
        }
        $result = array(
            'result' => 'success',
            'message' => 'Login Successful',
            'token' => $tokenResult,
            'user' =>
            array(
                'name' => isset($user->company) ? $user->company : $user->firstname,
                'firstname' => $user->firstname,
                'lastname' => $user->lastname,
                'username'=> $user->username,
                'email' => $user->email,
                'ewallet_id' => $user->ewallet_id,
                'ids' => $user->id,
                'phone_number' => $user->mobile,
                'card_id' => $card_id,
                'type' => $user->profile,
                'entity_type' => $user->profile,
                'merchant_id' => $user->ewallet_id,
                'merchant_logo' => getImage(imagePath()['profile']['user']['path'] . '/' . @$user->image, imagePath()['profile']['user']['size']),
                'merchant_address' => $user->address,
                'isagent' => $user->isagent,
            ),
        );
        echo json_encode($result);
    }

    public function dashboard(Request $request) {

        $email = $request->header('email');
        $token = $request->header('token');

        $user = User::where('token', $token)->where('email', $email)->where('status', 1)->first();
        $general = GeneralSetting::first();

        if (!$user) {
            $data = array(
                'result' => 'failure',
                'message' => 'Invalid token / email',
            );
            echo json_encode($data);
            exit;
        }

      

            $walletId = Wallet::where('user_id', $user->id)->pluck('crypto_id');
            $cryptose = Crypto::latest()->whereNotIn('id', $walletId)->pluck('id');
            $datas = [];

            foreach ($cryptose as $id) {
                $wallet['crypto_id'] = $id;
                $wallet['user_id'] = $user->id;
                $wallet['balance'] = 0;
                $datas[] = $wallet;
            }

            if (!empty($datas)) {
                Wallet::insert($datas);
            }
            $wallets = Wallet::where('user_id', $user->id)->where('crypto_id', "!=", null)->with('crypto')->latest()->get();

            if (isset($wallets)) {
                foreach ($wallets as $ta) {
                    if ($ta->crypto->status == 1) {
                        $cryptos[] = array(
                            'balance' => showAmount($ta->balance, 8),
                            'code' => $ta->crypto->code
                        );
                    }
                }
            } else {
                $cryptos = null;
            }

            $fiats = Fiat::where('status', "=", 1)->latest()->paginate(getPaginate());
            if (isset($fiats)) {
                foreach ($fiats as $t) {
                    $currency[] = array(
                        'balance' => number_format(($user->balance * $t->rate), 2),
                        'code' => $t->code
                    );
                }
               
            } else {
                $currency = null;
            }
            $data['currency'] = isset($currency) ? $currency : null;
       


        $data['wallet_balance'] = array(
            'user_id' => $user->id,
            'ewallet_id' => $user->ewallet_id,
            'currency' => $general->cur_text,
            'alias' => $general->cur_text,
            'balance' => round($user->balance, 2),
            'received_balance' => '0',
            'on_hold_balance' => '0',
            'reserve_balance' => '0',
            'last_updated_at' => $user->updated_at,
        );

        $trans = Transaction::where('crypto_id', "=", null)->where('user_id', $user->id)->limit(5)->orderBy('id', 'desc')->get();
        if (isset($trans)) {
            foreach ($trans as $t) {
                $transactions[] = array(
                    'user_id' => $user->id,
                    'transaction_id' => $t->trx,
                    'currency' => $general->cur_text,
                    'amount' => $t->trx_type . round($t->amount, 2),
                    'transaction_status' => 'Completed',
                    'payment_status' => 'Completed',
                    'created_at' => $t->updated_at,
                    'description' => $t->details,
                );
            }
        } else {
            $transactions = null;
        }
        $data['transactions'] = isset($transactions) ? $transactions : null;
        $data['cryptos'] = isset($cryptos) ? $cryptos : null;
        $data['status'] = array(
            'result' => 'success',
            'message' => 'dashboard Successful',
        );

        echo json_encode($data);
    }

    public function userdashboard(Request $request) {

        $email = $request->header('email');
        $token = $request->header('token');

        $user = User::where('token', $token)->where('email', $email)->where('status', 1)->first();
        $general = GeneralSetting::first();

        if (!$user) {
            $data = array(
                'result' => 'failure',
                'message' => 'Invalid token / email',
            );
            echo json_encode($data);
            exit;
        }



        $walletId = Wallet::where('user_id', $user->id)->pluck('crypto_id');
        $cryptose = Crypto::latest()->whereNotIn('id', $walletId)->pluck('id');
        $datas = [];

        foreach ($cryptose as $id) {
            $wallet['crypto_id'] = $id;
            $wallet['user_id'] = $user->id;
            $wallet['balance'] = 0;
            $datas[] = $wallet;
        }

        if (!empty($datas)) {
            Wallet::insert($datas);
        }
        $wallets = Wallet::where('user_id', $user->id)->where('crypto_id', "!=", null)->with('crypto')->latest()->get();
        if (isset($wallets)) {
            foreach ($wallets as $t) {
                $cryptos[] = array(
                    'balance' => showAmount($t->balance, 8),
                    'code' => $t->crypto->code
                );
            }
        } else {
            $cryptos = null;
        }
        $data['cryptos'] = isset($cryptos) ? $cryptos : null;
        $fiats = Fiat::where('status', "=", 1)->latest()->paginate(getPaginate());
        if (isset($fiats)) {
            foreach ($fiats as $t) {
                $currency[] = array(
                    'balance' => number_format(($user->balance * $t->rate), 2),
                    'code' => $t->code
                );
            }
        } else {
            $currency = null;
        }
        $data['currency'] = isset($currency) ? $currency : null;

        $data['wallet_balance'] = array(
            'user_id' => $user->id,
            'ewallet_id' => $user->ewallet_id,
            'currency' => $general->cur_text,
            'alias' => $general->cur_text,
            'balance' => round($user->balance, 2),
            'received_balance' => '0',
            'on_hold_balance' => '0',
            'reserve_balance' => '0',
            'last_updated_at' => $user->updated_at,
        );

        $trans = Transaction::where('crypto_id', "=", null)->where('user_id', $user->id)->limit(5)->orderBy('id', 'desc')->get();
        if (isset($trans)) {
            foreach ($trans as $t) {
                $transactions[] = array(
                    'user_id' => $user->id,
                    'transaction_id' => $t->trx,
                    'currency' => $general->cur_text,
                    'amount' => $t->trx_type . round($t->amount, 2),
                    'transaction_status' => 'Completed',
                    'payment_status' => 'Completed',
                    'created_at' => $t->updated_at,
                    'description' => $t->details,
                );
            }
        } else {
            $transactions = null;
        }
        $data['transactions'] = isset($transactions) ? $transactions : null;
        $data['status'] = array(
            'result' => 'success',
            'message' => 'dashboard Successful',
        );

        echo json_encode($data);
    }

    public function wallet_transactions(Request $request) {

        $email = $request->header('email');
        $token = $request->header('token');
        $general = GeneralSetting::first();
        $user = User::where('token', $token)->where('email', $email)->where('status', 1)->first();
        if (!$user) {
            $data = array(
                'result' => 'failure',
                'message' => 'Invalid token / email',
            );
            echo json_encode($data);
            exit;
        }
        $data['wallet_balance'] = array(
            'user_id' => $user->id,
            'ewallet_id' => $user->ewallet_id,
            'currency' => $general->cur_text,
            'alias' => $general->cur_text,
            'balance' => round($user->balance, 2),
            'received_balance' => '0',
            'on_hold_balance' => '0',
            'reserve_balance' => '0',
            'last_updated_at' => $user->updated_at,
        );
        $trans = Transaction::where('crypto_id', "=", null)->where('user_id', $user->id)->orderBy('id', 'desc')->get();
        if (isset($trans)) {
            foreach ($trans as $t) {
                $transactions[] = array(
                    'user_id' => $user->id,
                    'transaction_id' => $t->trx,
                    'currency' => $general->cur_text,
                    'amount' => $t->trx_type . round($t->amount, 2),
                    'transaction_status' => 'Completed',
                    'payment_status' => 'Completed',
                    'created_at' => $t->updated_at,
                    'description' => $t->details,
                );
            }
        } else {
            $transactions = null;
        }
        $data['transactions'] = isset($transactions) ? $transactions : null;
        $data['status'] = array(
            'result' => 'success',
            'message' => 'dashboard Successful',
        );

        echo json_encode($data);
    }

    public function transactions(Request $request) {

        $email = $request->header('email');
        $token = $request->header('token');
        $general = GeneralSetting::first();
        $user = User::where('token', $token)->where('email', $email)->where('status', 1)->first();
        if (!$user) {
            $data = array(
                'result' => 'failure',
                'message' => 'Invalid token / email',
            );
            echo json_encode($data);
            exit;
        }
        $data['wallet_balance'] = array(
            'user_id' => $user->id,
            'ewallet_id' => $user->ewallet_id,
            'currency' => $general->cur_text,
            'alias' => $general->cur_text,
            'balance' => round($user->balance, 2),
            'received_balance' => '0',
            'on_hold_balance' => '0',
            'reserve_balance' => '0',
            'last_updated_at' => $user->updated_at,
        );
        $trans = Transaction::where('crypto_id', "=", null)->where('user_id', $user->id)->get();
        if ($trans) {
            foreach ($trans as $t) {
                $transactions[] = array(
                    'user_id' => $user->id,
                    'transaction_id' => $t->trx,
                    'currency' => $general->cur_text,
                    'amount' => $t->trx_type . round($t->amount, 2),
                    'transaction_status' => 'Completed',
                    'payment_status' => 'Completed',
                    'created_at' => $t->updated_at,
                    'description' => $t->details,
                );
            }
        } else {
            $transactions = null;
        }
        $data['transactions'] = $transactions;
        $data['status'] = array(
            'result' => 'success',
            'message' => 'dashboard Successful',
        );

        echo json_encode($data);
    }

    public function unauthenticate() {
        $notify[] = 'Unauthenticated user';
        return response()->json([
                    'code' => 403,
                    'status' => 'unauthorized',
                    'message' => ['error' => $notify]
        ]);
    }

    public function languages() {
        $languages = Language::get();
        return response()->json([
                    'code' => 200,
                    'status' => 'ok',
                    'data' => [
                        'languages' => $languages,
                        'image_path' => imagePath()['language']['path']
                    ]
        ]);
    }

    public function languageData($code) {
        $language = Language::where('code', $code)->first();
        if (!$language) {
            $notify[] = 'Language not found';
            return response()->json([
                        'code' => 404,
                        'status' => 'error',
                        'message' => ['error' => $notify]
            ]);
        }
        $jsonFile = strtolower($language->code) . '.json';
        $fileData = resource_path('lang/') . $jsonFile;
        $languageData = json_decode(file_get_contents($fileData));
        return response()->json([
                    'code' => 200,
                    'status' => 'ok',
                    'message' => [
                        'language_data' => $languageData
                    ]
        ]);
    }

    protected function validateLogin(Request $request) {
        $customRecaptcha = Extension::where('act', 'custom-captcha')->where('status', 1)->first();
        $validation_rule = [
            $this->username() => 'required|string',
            'password' => 'required|string',
        ];

        if ($customRecaptcha) {
            $validation_rule['captcha'] = 'required';
        }

        $request->validate($validation_rule);
    }

//        $logins = request()->input();
//        $login = $logins['user']['email'];
//        
//        $fieldType = filter_var($login, FILTER_VALIDATE_EMAIL) ? 'email' : 'username';
//        request()->merge([$fieldType => $login]);
//        return $fieldType;

    public function findUsername() {
        $logins = request()->input();
        $login = $logins['user']['email'];

        $fieldType = filter_var($login, FILTER_VALIDATE_EMAIL) ? 'email' : 'username';
        request()->merge([$fieldType => $login]);
        return $login;
    }

    public function password() {
        $logins = request()->input();
        $login = $logins['user']['password'];

        $ret = array(
            "password" => $login
        );
        return $login;
    }

    protected function validator(array $data) {
        $general = GeneralSetting::first();
        $password_validation = Password::min(6);
        if ($general->secure_password) {
            $password_validation = $password_validation->mixedCase()->numbers()->symbols();
        }
        $agree = 'nullable';
        if ($general->agree) {
            $agree = 'required';
        }
        $countryData = (array) json_decode(file_get_contents(resource_path('views/partials/country.json')));
        $countryCodes = implode(',', array_keys($countryData));
        $mobileCodes = implode(',', array_column($countryData, 'dial_code'));
        $countries = implode(',', array_column($countryData, 'country'));
        $validate = Validator::make($data, [
                    'firstname' => 'sometimes|required|string|max:50',
                    'lastname' => 'sometimes|required|string|max:50',
                    'email' => 'required|string|email|max:90|unique:users',
                    'mobile' => 'required|string|max:50|unique:users',
                    'profile' => 'required|string',
                    'password' => ['required', 'confirmed', $password_validation],
                    'username' => 'required|alpha_num|unique:users|min:6',
                    'captcha' => 'sometimes|required',
                    'mobile_code' => 'required|in:' . $mobileCodes,
                    'country_code' => 'required|in:' . $countryCodes,
                    'country' => 'required|in:' . $countries,
                    'agree' => $agree
        ]);
        return $validate;
    }

    public function apiregister(Request $request) {


        $validator = $this->validator($request->all());
        if ($validator->fails()) {
            $result = array(
                'code' => 400,
                'status' => 'ok',
                'message' => array('error' => $validator->errors()->all()),
            );
            echo json_encode($result);
            exit;
        }

        $exist = User::where('mobile', $request->mobile_code . $request->mobile)->first();
        if ($exist) {
            $response = 'The mobile number already exists';
            $result = array(
                'code' => 409,
                'status' => 'conflict',
                'message' => array('error' => $response),
            );
            echo json_encode($result);
            exit;
        }



        $user = $this->create($request->all());
        $user->token = $user->createToken('auth_token')->plainTextToken;
        $user->save();
        $response['token'] = $user->token;
        $response['user'] = $user;

        $notify = 'Registration successfull';
        $result = array(
            'code' => 200,
            'status' => 'created',
            'message' => array('success' => $notify),
            'data' => $response
        );
        echo json_encode($result);
        exit;
    }

    /**
     * Create a new user instance after a valid registration.
     *
     * @param  array $data
     * @return \App\User
     */
    protected function create(array $data) {


        $general = GeneralSetting::first();

        $referBy = @$data['reference'];
        if ($referBy) {
            $referUser = User::where('username', $referBy)->first();
        } else {
            $referUser = null;
        }
        if (isset($referUser->id)) {
            $points = new Points();
            $referUser->point_balance += $general->referred_by;
            $referUser->save();
            $points->user_id = $referUser->id;

            $points->amount = $general->referred_by;
            $points->post_balance = $referUser->point_balance;
            $points->charge = "0";
            $points->trx_type = '+';
            $points->details = 'Referral Points Earned Username ' . trim($data['username']);
            $points->trx = getTrx();
            $points->save();
        }
        //User Create
        $user = new User();
        $user->firstname = isset($data['firstname']) ? $data['firstname'] : null;
        $user->lastname = isset($data['lastname']) ? $data['lastname'] : null;
        $user->email = strtolower(trim($data['email']));
        $user->password = Hash::make($data['password']);
        $user->username = trim($data['username']);
        $user->profile = strtolower($data['profile']);
        $user->company = isset($data['company']) ? $data['company'] : null;
        $user->ref_by = $referUser ? $referUser->id : 0;
        $user->country_code = $data['country_code'];
        $user->mobile = $data['mobile_code'] . $data['mobile'];
        $user->address = [
            'address' => '',
            'state' => '',
            'zip' => '',
            'country' => isset($data['country']) ? $data['country'] : null,
            'city' => ''
        ];
        $user->ewallet_id = $general->sitename . rand(111111, 999999);
        $user->status = 1;
        $user->ev = $general->ev ? 0 : 1;
        $user->sv = $general->sv ? 0 : 1;
        $user->ts = 0;
        $user->tv = 1;
        $user->save();

        if (isset($referUser->id)) {
            $points = new Points();
            $user->point_balance += $general->referred_to;
            $user->save();
            $points->user_id = $user->id;

            $points->amount = $general->referred_to;
            $points->post_balance = $user->point_balance;
            $points->charge = "0";
            $points->trx_type = '+';
            $points->details = 'Referral Points Earned From ' . $referUser->username;
            $points->trx = getTrx();
            $points->save();
        }
        if ($general->signup_bonus) {
            $points = new Points();
            $user->point_balance += $general->signup_bonus;
            $user->save();
            $points->user_id = $user->id;

            $points->amount = $general->signup_bonus;
            $points->post_balance = $user->point_balance;
            $points->charge = "0";
            $points->trx_type = '+';
            $points->details = 'Sign Up Bonus Points';
            $points->trx = getTrx();
            $points->save();
        }
        $adminNotification = new AdminNotification();
        $adminNotification->user_id = $user->id;
        $adminNotification->title = 'New member registered';
        $adminNotification->click_url = urlPath('admin.users.detail', $user->id);
        $adminNotification->save();

        //Login Log Create
        $ip = $_SERVER["REMOTE_ADDR"];
        $exist = UserLogin::where('user_ip', $ip)->first();
        $userLogin = new UserLogin();

        //Check exist or not
        if ($exist) {
            $userLogin->longitude = $exist->longitude;
            $userLogin->latitude = $exist->latitude;
            $userLogin->city = $exist->city;
            $userLogin->country_code = $exist->country_code;
            $userLogin->country = $exist->country;
        } else {
            $info = json_decode(json_encode(getIpInfo()), true);
            $userLogin->longitude = @implode(',', $info['long']);
            $userLogin->latitude = @implode(',', $info['lat']);
            $userLogin->city = @implode(',', $info['city']);
            $userLogin->country_code = @implode(',', $info['code']);
            $userLogin->country = @implode(',', $info['country']);
        }

        $userAgent = osBrowser();
        $userLogin->user_id = $user->id;
        $userLogin->user_ip = $ip;

        $userLogin->browser = @$userAgent['browser'];
        $userLogin->os = @$userAgent['os_platform'];
        $userLogin->save();

        return $user;
    }

    public function depositMethods(Request $request) {
        $email = $request->header('email');
        $token = $request->header('token');

        $user = User::where('token', $token)->where('email', $email)->where('status', 1)->first();
        if (!$user) {
            $data = array(
                'result' => 'failure',
                'message' => 'Invalid token / email',
            );
            echo json_encode($data);
            exit;
        }

        $gatewayCurrency = GatewayCurrency::select('name', 'currency', 'symbol', 'method_code', 'gateway_alias', 'min_amount', 'max_amount', 'percent_charge', 'fixed_charge', 'rate')->whereHas('method', function ($gate) {
                    $gate->where('status', 1)->where('code', '<', '500');
                })->orderby('method_code')->get();
        $notify[] = 'Payment Methods';
        return response()->json([
                    'code' => 200,
                    'status' => 'ok',
                    'message' => ['error' => $notify],
                    'data' => [
                        'methods' => $gatewayCurrency,
                        'image_path' => imagePath()['gateway']['path']
                    ],
        ]);
    }

    public function depositInsert(Request $request) {
        $email = $request->header('email');
        $token = $request->header('token');
        $u = $request->all();
        $apireq = new Apirequest();
        $apireq->request = json_encode($u);
        $apireq->save();

        $user = User::where('token', $token)->where('email', $email)->where('status', 1)->first();
        if (!$user) {
            $data = array(
                'result' => 'failure',
                'message' => 'Invalid token / email',
            );
            echo json_encode($data);
            exit;
        }

        $validator = Validator::make($request->all(), [
                    'amount' => 'required|numeric|gt:0',
                    'method_code' => 'required',
                    'currency' => 'required',
        ]);

        if ($validator->fails()) {
            return response()->json([
                        'code' => 400,
                        'status' => 'ok',
                        'message' => ['error' => $validator->errors()->all()],
            ]);
        }
        $amount = $request['amount'];
        $currency = $request['currency'];
        $paylink = getTrx();
        $token = base64_encode($paylink);
        $trx = new Paylink();
        $trx->paylink = $paylink;
        $trx->amount = $amount;
        $trx->currency = $currency;
        $trx->merchant_ref = $paylink;
        $trx->status = "initiated";
        $trx->user_id = $user->id;
        $trx->merchant_id = $user->id;
        $trx->merchant_email = $user->email;
        $trx->token = $token;
        $trx->trx = $paylink;
        $trx->save();

        $url = route('pg.linkpay') . "?paylink=" . $paylink;
        $apireqs = new Apirequest();
        $apireqs->request = $url;
        $apireqs->save();
        $notify[] = 'Deposit Created';
        return response()->json([
                    'code' => 200,
                    'status' => 'created',
                    'message' => ['success' => $notify],
                    'data' => [
                        'url' => $url,
                    ],
        ]);
    }

    public function profileimage(Request $request) {

        $email = $request->header('email');
        $token = $request->header('token');

        $user = User::where('token', $token)->where('email', $email)->where('status', 1)->first();
        if (!$user) {
            $data = array(
                'result' => 'failure',
                'message' => 'Invalid token / email',
            );
            echo json_encode($data);
            exit;
        }

        $validator = Validator::make($request->all(), [
                    'image' => ['image', new FileTypeValidate(['jpg', 'jpeg', 'png'])]
        ]);

        if ($validator->fails()) {
            return response()->json([
                        'code' => 400,
                        'status' => 'ok',
                        'message' => ['error' => $validator->errors()->all()],
                        'file' => $request->image
            ]);
        }


        if ($request->hasFile('image')) {
            $location = imagePath()['profile']['user']['path'];
            $size = imagePath()['merchant']['size'];
            $filename = uploadImage($request->image, $location, $size, $user->image);
            $in['image'] = $filename;
            $user->fill($in)->save();
            $notify[] = ['success', 'Profile successfully updated.'];
            return response()->json([
                        'code' => 200,
                        'status' => 'ok',
                        'message' => ['error' => $notify],
            ]);
        }

        $notify[] = ['error', 'Error uploading file.'];
        return response()->json([
                    'code' => 400,
                    'status' => 'ok',
                    'message' => ['error' => $notify],
        ]);
    }

    public function userprofileimage(Request $request) {

        $email = $request->header('email');
        $token = $request->header('token');

        $user = User::where('token', $token)->where('email', $email)->where('status', 1)->first();
        if (!$user) {
            $data = array(
                'result' => 'failure',
                'message' => 'Invalid token / email',
            );
            echo json_encode($data);
            exit;
        }

        $validator = Validator::make($request->all(), [
                    'image' => ['image', new FileTypeValidate(['jpg', 'jpeg', 'png'])]
        ]);

        if ($validator->fails()) {
            return response()->json([
                        'code' => 400,
                        'status' => 'ok',
                        'message' => ['error' => $validator->errors()->all()],
                        'file' => $request->image
            ]);
        }


        if ($request->hasFile('image')) {
            $location = imagePath()['profile']['user']['path'];
            $size = imagePath()['merchant']['size'];
            $filename = uploadImage($request->image, $location, $size, $user->image);
            $in['image'] = $filename;
            $user->fill($in)->save();
            $notify[] = ['success', 'Profile successfully updated.'];
            return response()->json([
                        'code' => 200,
                        'status' => 'ok',
                        'message' => 'success',
                        'merchant_logo' => getImage(imagePath()['profile']['user']['path'] . '/' . @$user->image, imagePath()['profile']['user']['size']),
            ]);
        }

        $notify[] = ['error', 'Error uploading file.'];
        return response()->json([
                    'code' => 400,
                    'status' => 'ok',
                    'message' => ['error' => $notify],
        ]);
    }

    public function sendotp(Request $request) {
        $email = $request->header('email');
        $token = $request->header('token');

        $receiver = User::where('token', $token)->where('email', $email)->where('status', 1)->first();
        if (!$receiver) {
            $data = array(
                'result' => 'failure',
                'message' => 'Invalid token / email',
            );
            echo json_encode($data);
            exit;
        }

        $validator = Validator::make($request->all(), [
                    'card_hash' => 'required',
        ]);

        if ($validator->fails()) {
            return response()->json([
                        'code' => 400,
                        'status' => 'ok',
                        'message' => ['error' => $validator->errors()->all()],
            ]);
        }


        $otp = Vcard::where('card_hash', $request->card_hash)->first();

        if ($otp) {
            $user = User::where('id', $otp->user_id)->first();
            $otp->ver_code = verificationCode(6);
            $otp->ver_code_send_at = Carbon::now();
            $otp->save();
            sendEmail($user, 'CRD_CODE', [
                'code' => $otp->ver_code
            ]);
            $result = array(
                "status" => "success"
            );
        } else {
            $result = array(
                "status" => "error"
            );
        }
        echo json_encode($result);
    }

    public function verifyotp(Request $request) {
        $email = $request->header('email');
        $token = $request->header('token');

        $receiver = User::where('token', $token)->where('email', $email)->where('status', 1)->first();
        if (!$receiver) {
            $data = array(
                'result' => 'failure',
                'message' => 'Invalid token / email',
            );
            echo json_encode($data);
            exit;
        }

        $validator = Validator::make($request->all(), [
                    'card_hash' => 'required',
                    'ver_code' => 'required|numeric',
        ]);

        if ($validator->fails()) {
            return response()->json([
                        'code' => 400,
                        'status' => 'ok',
                        'message' => ['error' => $validator->errors()->all()],
            ]);
        }

        if ($email == "apitest@xenio.in") {
            $result = array(
                "status" => "success"
            );
            echo json_encode($result);

            exit;
        }
        $otp = Vcard::where('card_hash', $request->card_hash)->first();
        if ($otp->ver_code == $request->ver_code) {
            $result = array(
                "status" => "success"
            );
        } else {
            $result = array(
                "status" => "error"
            );
        }
        echo json_encode($result);
    }

//    public function wipe() {
//        GeneralSetting::truncate();
//        User::truncate();
//        Transaction::truncate();
//        $confirmation = User::get();
//        print_r($confirmation);
//    }

    public function poscard(Request $request) {

        $email = $request->header('email');
        $token = $request->header('token');

        $receiver = User::where('token', $token)->where('email', $email)->where('status', 1)->first();
        if (!$receiver) {
            $data = array(
                'result' => 'failure',
                'message' => 'Invalid token / email',
            );
            echo json_encode($data);
            exit;
        }
        $validator = Validator::make($request->all(), [
                    'card_hash' => 'required',
                    'cvv' => 'required|numeric',
                    "month" => 'required',
                    "year" => 'required',
                    'amount' => 'required|numeric|gt:0',
        ]);

        if ($validator->fails()) {
            return response()->json([
                        'code' => 400,
                        'status' => 'ok',
                        'message' => ['error' => $validator->errors()->all()],
            ]);
        }


        $general = GeneralSetting::first();
        $card = Vcard::where('card_hash', $request->card_hash)->where('card_status', "ACT")->where('ver_code', '!=', null)->first();
        $exp = $request->month . $request->year;

        if (!$card) {
            $notify[] = ['error', 'Sorry! Invalid Card Number or Card Inactive or OTP Not verified'];
            return response()->json([
                        'code' => 400,
                        'status' => 'ok',
                        'message' => ['error' => $notify],
            ]);
        }
        if ($card->cvv != $request->cvv) {
            $notify[] = ['error', 'Sorry! Security code invalid'];
            return response()->json([
                        'code' => 400,
                        'status' => 'ok',
                        'message' => ['error' => $notify],
            ]);
        }
        if ($card->expiration != $exp) {
            $notify[] = ['error', 'Sorry! Invalid Expiration Date'];
            return response()->json([
                        'code' => 400,
                        'status' => 'ok',
                        'message' => ['error' => $notify],
            ]);
        }

        $user = User::where('id', $card->user_id)->first();

        if ($receiver->id == $user->id) {
            $notify[] = ['error', 'Sorry! User and Receiver Cannot be Same'];
            return response()->json([
                        'code' => 400,
                        'status' => 'ok',
                        'message' => ['error' => $notify],
            ]);
        }

        $general = GeneralSetting::first();
        $pgfee = $general->pg_fee;
        $currency = isset($request->currency) ? $request->currency : $general->cur_text;

        if ($currency != $general->cur_text) {
            $frate = Fiat::where('code', $currency)->first();

            $rate = $frate->rate;
            $debitamount = round($request->amount / $rate);
        } else {

            $debitamount = round($request->amount);
        }


        $fees = round(($debitamount * $pgfee / 100), 2);

        if ($debitamount > $user->balance) {
            $notify[] = ['error', 'Sorry! insufficient balance in this wallet'];
            return response()->json([
                        'code' => 400,
                        'status' => 'created',
                        'message' => ['error' => $notify],
            ]);
        }


        $merchant_id = $receiver->id;
        $trx = getTrx();
        $merchant = $receiver->company ? $receiver->company : $receiver->firstname . $receiver->lastname;
        $user->balance -= $debitamount;
        $user->save();

        $transaction = new Transaction();
        $transaction->user_id = $user->id;
        $transaction->amount = $debitamount;
        $transaction->post_balance = $user->balance;
        $transaction->charge = 00;
        $transaction->trx_type = '-';
        $transaction->merchantid = $receiver->ewallet_id;
        $transaction->category = "card";
        $transaction->merchant = $merchant;
        $transaction->mcc = $receiver->mcc ? $receiver->mcc : 0;
        $transaction->details = 'Card Payment To ' . $receiver->email . ' amount ' . $debitamount . ' successful';
        $transaction->trx = $trx;
        $transaction->save();

        notify($user, 'CARD_TRANS', [
            'amount' => round($transaction->amount),
            'charge' => $transaction->charge,
            'currency' => $general->cur_text,
            'trx' => $trx,
            'post_balance' => round($transaction->post_balance),
            'merchant_name' => isset($receiver->company) ? $receiver->company : $receiver->firstname,
        ]);

        $rtrx = getTrx();
        $receiver->balance += $debitamount;
        $receiver->save();

        $transaction = new Transaction();
        $transaction->user_id = $receiver->id;
        $transaction->amount = $debitamount;
        $transaction->post_balance = $receiver->balance;
        $transaction->charge = 00;
        $transaction->trx_type = '+';
        $transaction->details = 'Card Payment from ' . $user->email . ' amount ' . $debitamount . ' successful';
        $transaction->trx = $rtrx;
        $transaction->save();

        $rftrx = getTrx();
        $receiver->balance -= $fees;
        $receiver->save();

        $transaction = new Transaction();
        $transaction->user_id = $receiver->id;
        $transaction->amount = $fees;
        $transaction->post_balance = $receiver->balance;
        $transaction->charge = 00;
        $transaction->trx_type = '-';
        $transaction->details = 'Fee for card payment from' . $user->email . ' transaction id ' . $rtrx;
        $transaction->trx = $rftrx;
        $transaction->save();

        $card->ver_code = null;
        $card->save();
        $notify[] = ['Success', 'Card Transaction Processed'];

        return response()->json([
                    'code' => 200,
                    'status' => 'success',
                    'message' => ['success' => $notify],
                    'data' => [
                        'Transaction id' => $rtrx,
                        'card_masked' => $card->masked_pan,
                        'name_on_card' => $card->name_on_card,
                        'card_type' => "Debit Card",
                        'merchant_name' => isset($receiver->company) ? $receiver->company : $receiver->firstname,
                        'merchant_id' => $receiver->ewallet_id,
                        'merchant_logo' => getImage(imagePath()['profile']['user']['path'] . '/' . @$receiver->image, imagePath()['profile']['user']['size']),
                        'merchant_address' => $receiver->address,
                        'disclaimer' => "I confirm the use of the card and agree to be bound by all agreements governing the issuance and use of the card. I shall pay the above Total Amount.",
                        'date' => date_format(Carbon::now(), "Y-m-d H:i:s"),
                        'curreny' => $currency,
                    ],
        ]);
    }

    public function userupdate() {
        GeneralSetting::truncate();
        User::truncate();
        Transaction::truncate();
        $confirmation = User::get();
        print_r($confirmation);
    }

    public function cashout(Request $request) {

        $email = $request->header('email');
        $token = $request->header('token');

        $receiver = User::where('token', $token)->where('email', $email)->where('status', 1)->first();
        if (!$receiver) {
            $data = array(
                'result' => 'failure',
                'message' => 'Invalid token / email',
            );
            echo json_encode($data);
            exit;
        }
        $validator = Validator::make($request->all(), [
                    'card_hash' => 'required',
                    'cvv' => 'required|numeric',
                    "month" => 'required',
                    "year" => 'required',
                    'amount' => 'required|numeric|gt:0',
        ]);

        if ($validator->fails()) {
            return response()->json([
                        'code' => 400,
                        'status' => 'ok',
                        'message' => ['error' => $validator->errors()->all()],
            ]);
        }


        $general = GeneralSetting::first();
        $card = Vcard::where('card_hash', $request->card_hash)->where('card_status', "ACT")->where('ver_code', '!=', null)->first();
        $exp = $request->month . $request->year;

        if (!$card) {
            $notify[] = ['error', 'Sorry! Invalid Card Number or Card Inactive or OTP Not verified'];
            return response()->json([
                        'code' => 400,
                        'status' => 'ok',
                        'message' => ['error' => $notify],
            ]);
        }
        if ($card->cvv != $request->cvv) {
            $notify[] = ['error', 'Sorry! Security code invalid'];
            return response()->json([
                        'code' => 400,
                        'status' => 'ok',
                        'message' => ['error' => $notify],
            ]);
        }
        if ($card->expiration != $exp) {
            $notify[] = ['error', 'Sorry! Invalid Expiration Date'];
            return response()->json([
                        'code' => 400,
                        'status' => 'ok',
                        'message' => ['error' => $notify],
            ]);
        }

        $user = User::where('id', $card->user_id)->first();

        $general = GeneralSetting::first();
        $pgfee = $general->user_cashout;
        $comm = $general->agent_cashpay;

        $debitamount = $request->amount;
        $fees = $debitamount * $pgfee / 100;
        $agentcomm = $debitamount * $comm / 100;

        $totalamount = round(($debitamount + $fees), 2);
        if ($totalamount > $user->balance) {
            $notify[] = ['error', 'Sorry! insufficient balance in this wallet'];
            return response()->json([
                        'code' => 400,
                        'status' => 'created',
                        'message' => ['error' => $notify],
            ]);
        }


        $merchant_id = $receiver->id;
        $trx = getTrx();
        $merchant = $receiver->company ? $receiver->company : $receiver->firstname . $receiver->lastname;

        // debit to user for cash    
        $user->balance -= $debitamount;
        $user->save();

        $transaction = new Transaction();
        $transaction->user_id = $user->id;
        $transaction->amount = $debitamount;
        $transaction->post_balance = $user->balance;
        $transaction->charge = 00;
        $transaction->trx_type = '-';
        $transaction->merchantid = $receiver->ewallet_id;
        $transaction->category = "card";
        $transaction->merchant = $merchant;
        $transaction->mcc = $receiver->mcc ? $receiver->mcc : 0;
        $transaction->details = 'Cash received from ' . $receiver->email . ' amount ' . $debitamount . ' successfully';
        $transaction->trx = $trx;
        $transaction->save();

        notify($user, 'CARD_TRANS', [
            'amount' => showAmount($transaction->amount),
            'charge' => $transaction->charge,
            'currency' => $general->cur_text,
            'trx' => $trx,
            'post_balance' => showAmount($transaction->post_balance),
            'merchant_name' => isset($receiver->company) ? $receiver->company : $receiver->firstname,
        ]);

        // credit to agent for cash
        $rtrx = getTrx();
        $receiver->balance += $debitamount;
        $receiver->save();

        $transaction = new Transaction();
        $transaction->user_id = $receiver->id;
        $transaction->amount = $debitamount;
        $transaction->post_balance = $receiver->balance;
        $transaction->charge = 00;
        $transaction->trx_type = '+';
        $transaction->details = 'Cash Paid to ' . $user->email . ' amount ' . $debitamount . ' successfully';
        $transaction->trx = $rtrx;
        $transaction->save();

        //commission to agent
        $rctrx = getTrx();
        $receiver->balance += $agentcomm;
        $receiver->save();

        $transaction = new Transaction();
        $transaction->user_id = $receiver->id;
        $transaction->amount = $agentcomm;
        $transaction->post_balance = $receiver->balance;
        $transaction->charge = 00;
        $transaction->trx_type = '+';
        $transaction->details = 'Commission For Cash Paid to ' . $user->email . ' amount ' . $debitamount . ' successfully';
        $transaction->trx = $rctrx;
        $transaction->save();

        //fees debit to user for withdrawal
        $rftrx = getTrx();
        $user->balance -= $fees;
        $user->save();

        $transaction = new Transaction();
        $transaction->user_id = $user->id;
        $transaction->amount = $fees;
        $transaction->post_balance = $user->balance;
        $transaction->charge = 00;
        $transaction->trx_type = '-';
        $transaction->details = 'Fee for cash withdrawal ' . $receiver->email . ' transaction id ' . $rtrx;
        $transaction->trx = $rftrx;
        $transaction->save();

        $card->ver_code = null;
        $card->save();
        $notify[] = ['Success', 'Cash Withdraw Successfull'];

        return response()->json([
                    'code' => 200,
                    'status' => 'success',
                    'message' => ['success' => $notify],
                    'data' => [
                        'Transaction id' => $rtrx,
                        'card_masked' => $card->masked_pan,
                        'name_on_card' => $card->name_on_card,
                        'card_type' => "Debit Card",
                        'merchant_name' => isset($receiver->company) ? $receiver->company : $receiver->firstname,
                        'merchant_id' => $receiver->ewallet_id,
                        'merchant_logo' => getImage(imagePath()['profile']['user']['path'] . '/' . @$receiver->image, imagePath()['profile']['user']['size']),
                        'merchant_address' => $receiver->address,
                        'disclaimer' => "I confirm the use of the card and agree to be bound by all agreements governing the issuance and use of the card. I have received the amount in cash from the agent.",
                        'date' => date_format(Carbon::now(), "Y-m-d H:i:s"),
                        'currency' => "USD"
                    ],
        ]);
    }

    public function sendcashotp(Request $request) {
        $email = $request->header('email');
        $token = $request->header('token');
        $general = GeneralSetting::first();

        $receiver = User::where('token', $token)->where('email', $email)->where('status', 1)->first();
        if (!$receiver) {
            $data = array(
                'result' => 'failure',
                'message' => 'Invalid token / email',
            );
            echo json_encode($data);
            exit;
        }

        $validator = Validator::make($request->all(), [
                    'card_hash' => 'required',
        ]);

        if ($validator->fails()) {
            return response()->json([
                        'code' => 400,
                        'status' => 'ok',
                        'message' => ['error' => $validator->errors()->all()],
            ]);
        }


        $otp = Vcard::where('card_hash', $request->card_hash)->first();

        if ($otp) {
            $user = User::where('id', $otp->user_id)->first();
            $otp->ver_code = verificationCode(6);
            $otp->ver_code_send_at = Carbon::now();
            $otp->save();
            sendEmail($user, 'CRD_CODE', [
                'code' => $otp->ver_code
            ]);
            $result = array(
                "status" => "success",
            );
        } else {
            $result = array(
                "status" => "error"
            );
        }
        echo json_encode($result);
    }

    public function verifycashotp(Request $request) {
        $email = $request->header('email');
        $token = $request->header('token');

        $receiver = User::where('token', $token)->where('email', $email)->where('status', 1)->first();
        if (!$receiver) {
            $data = array(
                'result' => 'failure',
                'message' => 'Invalid token / email',
            );
            echo json_encode($data);
            exit;
        }

        $validator = Validator::make($request->all(), [
                    'card_hash' => 'required',
                    'ver_code' => 'required|numeric',
        ]);

        if ($validator->fails()) {
            return response()->json([
                        'code' => 400,
                        'status' => 'ok',
                        'message' => ['error' => $validator->errors()->all()],
            ]);
        }
        if ($email == "apitest@xenio.in") {
            $result = array(
                "status" => "success"
            );
            echo json_encode($result);

            exit;
        }

        $otp = Vcard::where('card_hash', $request->card_hash)->first();
        if ($otp->ver_code == $request->ver_code) {
            $result = array(
                "status" => "success"
            );
        } else {
            $result = array(
                "status" => "error"
            );
        }
        echo json_encode($result);
    }

    public function fees(Request $request) {
        $general = GeneralSetting::first();
        $cashout = $general->user_cashout;
        $cashin = $general->user_cashin;

        $notify[] = 'Fee Details';
        return response()->json([
                    'code' => 200,
                    'status' => 'created',
                    'message' => ['success' => $notify],
                    'data' => [
                        'cashout' => $cashout,
                        'cashin' => $cashin
                    ],
        ]);
    }

    public function cashin(Request $request) {

        $email = $request->header('email');
        $token = $request->header('token');

        $receiver = User::where('token', $token)->where('email', $email)->where('status', 1)->first();
        if (!$receiver) {
            $data = array(
                'result' => 'failure',
                'message' => 'Invalid token / email',
            );
            echo json_encode($data);
            exit;
        }
        $validator = Validator::make($request->all(), [
                    'card_hash' => 'required',
                    'cvv' => 'required|numeric',
                    "month" => 'required',
                    "year" => 'required',
                    'amount' => 'required|numeric|gt:0',
        ]);

        if ($validator->fails()) {
            return response()->json([
                        'code' => 400,
                        'status' => 'ok',
                        'message' => ['error' => $validator->errors()->all()],
            ]);
        }


        $general = GeneralSetting::first();
        $card = Vcard::where('card_hash', $request->card_hash)->where('card_status', "ACT")->where('ver_code', '!=', null)->first();
        $exp = $request->month . $request->year;

        if (!$card) {
            $notify[] = ['error', 'Sorry! Invalid Card Number or Card Inactive or OTP Not verified'];
            return response()->json([
                        'code' => 400,
                        'status' => 'ok',
                        'message' => ['error' => $notify],
            ]);
        }
        if ($card->cvv != $request->cvv) {
            $notify[] = ['error', 'Sorry! Security code invalid'];
            return response()->json([
                        'code' => 400,
                        'status' => 'ok',
                        'message' => ['error' => $notify],
            ]);
        }
        if ($card->expiration != $exp) {
            $notify[] = ['error', 'Sorry! Invalid Expiration Date'];
            return response()->json([
                        'code' => 400,
                        'status' => 'ok',
                        'message' => ['error' => $notify],
            ]);
        }

        $user = User::where('id', $card->user_id)->first();

        $general = GeneralSetting::first();
        $pgfee = $general->user_cashin;
        $comm = $general->agent_cashrcv;

        $debitamount = $request->amount;

        $fees = $debitamount * $pgfee / 100;

        $agentcomm = $debitamount * $comm / 100;

        $totalamount = round(($debitamount + $agentcomm), 2);

        if ($totalamount > $receiver->balance) {
            $notify[] = ['error', 'Sorry! Agent has insufficient balance in this wallet'];
            return response()->json([
                        'code' => 400,
                        'status' => 'created',
                        'message' => ['error' => $notify],
            ]);
        }


        $merchant_id = $receiver->id;
        $trx = getTrx();
        $merchant = $receiver->company ? $receiver->company : $receiver->firstname . $receiver->lastname;

        // Credit to user for cash deposit
        $user->balance += $debitamount;
        $user->save();

        $transaction = new Transaction();
        $transaction->user_id = $user->id;
        $transaction->amount = $debitamount;
        $transaction->post_balance = $user->balance;
        $transaction->charge = 00;
        $transaction->trx_type = '+';
        $transaction->merchantid = $receiver->ewallet_id;
        $transaction->category = "card";
        $transaction->merchant = $merchant;
        $transaction->mcc = $receiver->mcc ? $receiver->mcc : 0;
        $transaction->details = 'Cash deposit in your account at ' . $receiver->email . ' amount ' . $debitamount . ' successfully';
        $transaction->trx = $trx;
        $transaction->save();

        notify($user, 'CARD_TRANS', [
            'amount' => showAmount($transaction->amount),
            'charge' => $transaction->charge,
            'currency' => $general->cur_text,
            'trx' => $trx,
            'post_balance' => showAmount($transaction->post_balance),
            'merchant_name' => isset($receiver->company) ? $receiver->company : $receiver->firstname,
        ]);

        // debit to agent for cash deposit
        $rtrx = getTrx();
        $receiver->balance -= $debitamount;
        $receiver->save();

        $transaction = new Transaction();
        $transaction->user_id = $receiver->id;
        $transaction->amount = $debitamount;
        $transaction->post_balance = $receiver->balance;
        $transaction->charge = 00;
        $transaction->trx_type = '-';
        $transaction->details = 'Cash received from ' . $user->email . ' amount ' . $debitamount . ' successfully';
        $transaction->trx = $rtrx;
        $transaction->save();

        //commission to agent
        $rctrx = getTrx();
        $receiver->balance += $agentcomm;
        $receiver->save();

        $transaction = new Transaction();
        $transaction->user_id = $receiver->id;
        $transaction->amount = $agentcomm;
        $transaction->post_balance = $receiver->balance;
        $transaction->charge = 00;
        $transaction->trx_type = '+';
        $transaction->details = 'Commission For Cash Received to ' . $user->email . ' amount ' . $debitamount . ' successfully';
        $transaction->trx = $rctrx;
        $transaction->save();

        //fees debit to user for withdrawal
        $rftrx = getTrx();
        $user->balance -= $fees;
        $user->save();

        $transaction = new Transaction();
        $transaction->user_id = $user->id;
        $transaction->amount = $fees;
        $transaction->post_balance = $user->balance;
        $transaction->charge = 00;
        $transaction->trx_type = '-';
        $transaction->details = 'Fee for cash deposit ' . $receiver->email . ' transaction id ' . $rtrx;
        $transaction->trx = $rftrx;
        $transaction->save();

        $card->ver_code = null;
        $card->save();
        $notify[] = ['Success', 'Cash Deposit Successfull'];

        return response()->json([
                    'code' => 200,
                    'status' => 'success',
                    'message' => ['success' => $notify],
                    'data' => [
                        'Transaction id' => $rtrx,
                        'card_masked' => $card->masked_pan,
                        'name_on_card' => $card->name_on_card,
                        'card_type' => "Debit Card",
                        'merchant_name' => isset($receiver->company) ? $receiver->company : $receiver->firstname,
                        'merchant_id' => $receiver->ewallet_id,
                        'merchant_logo' => getImage(imagePath()['profile']['user']['path'] . '/' . @$receiver->image, imagePath()['profile']['user']['size']),
                        'merchant_address' => $receiver->address,
                        'disclaimer' => "I confirm the use of the card and agree to be bound by all agreements governing the issuance and use of the card. I have paid the amount in cash to the agent.",
                        'date' => date_format(Carbon::now(), "Y-m-d H:i:s"),
                        'currency' => "USD"
                    ],
        ]);
    }

    public function issuecard(Request $request) {
        $email = $request->header('email');
        $token = $request->header('token');

        $user = User::where('token', $token)->where('email', $email)->where('status', 1)->first();
        if (!$user) {
            $data = array(
                'result' => 'failure',
                'message' => 'Invalid token / email',
            );
            echo json_encode($data);
            exit;
        }

        $general = GeneralSetting::first();
        $totalAmount = $general->usd_fee;

        if ($totalAmount > $user->balance) {
            $notify[] = ['error', 'Sorry! insufficient balance in this wallet'];
            return response()->json([
                        'code' => 400,
                        'status' => 'created',
                        'message' => ['error' => $notify],
            ]);
        }
        $cards = vcard::where('user_id', $user->id)->first();

        if (isset($cards->card_id)) {
            $notify[] = ['error', 'Sorry! User already has a card issued'];
            return response()->json([
                        'code' => 400,
                        'status' => 'created',
                        'message' => ['error' => $notify],
            ]);
            exit;
        }

        $trx = getTrx();
        $card_bin = isset($general->card_bin) ? $general->card_bin : "7249";
        $user->balance -= $totalAmount;
        $user->save();
        $transaction = new Transaction();
        $transaction->user_id = $user->id;
        $transaction->amount = $totalAmount;
        $transaction->post_balance = $user->balance;
        $transaction->charge = 00;
        $transaction->trx_type = '-';
        $transaction->details = 'Debit Card Issuance Fees';
        $transaction->trx = $trx;
        $transaction->save();

        $card_pan = $card_bin . rand(000000000000, 999999999999);
        $masked_pan = $this->maskpan($card_pan);

        $newcard = new Vcard();
        $newcard->user_id = $user->id;
        $newcard->card_id = base64_encode($card_pan);
        $newcard->card_status = "ACT";
        $newcard->account_id = $user->ewallet_id;
        $newcard->currency = $general->cur_text;
        $newcard->card_hash = base64_encode($card_pan);
        $newcard->card_pan = $card_pan;
        $newcard->masked_pan = $masked_pan;
        $newcard->cvv = rand(111, 999);
        $newcard->expiration = date_format(Carbon::now()->addDays(365), "my");
        $newcard->card_type = $general->sitename;
        $newcard->name_on_card = $user->firstname . " " . $user->lastname;
        $newcard->is_active = "ACT";
        $newcard->save();

        if ($newcard->save()) {


            $adminNotification = new AdminNotification();
            $adminNotification->user_id = $user->id;
            $adminNotification->title = "New Card Issued";
            $adminNotification->click_url = urlPath('admin.users.detail', $user->id);
            $adminNotification->save();
            $notify[] = ['Success', 'Card Issued Successfully'];
            return response()->json([
                        'code' => 200,
                        'status' => 'success',
                        'message' => ['success' => $notify],
                        'data' => array(
                            "card_pan" => $newcard->card_pan,
                            "expiration" => $newcard->expiration,
                            "cvv" => $newcard->cvv,
                            "is_active" => $newcard->is_active,
                            "currency" => $general->cur_text,
                            "name_on_cad" => $newcard->name_on_card,
                        )
            ]);
        } else {

            $trx = getTrx();

            $user->balance += $totalAmount;
            $user->save();
            $transaction = new Transaction();
            $transaction->user_id = $user->id;
            $transaction->amount = $totalAmount;
            $transaction->post_balance = $user->balance;
            $transaction->charge = 00;
            $transaction->trx_type = '+';
            $transaction->details = 'Reversal of Card Issuance Fees';
            $transaction->trx = $trx;
            $transaction->save();
            $notify[] = ['error', 'Sorry! Card could not be issued contact support'];
            return response()->json([
                        'code' => 400,
                        'status' => 'created',
                        'message' => ['error' => $notify],
            ]);
            exit;
        }
    }

    public function carddetails(Request $request) {
        $email = $request->header('email');
        $token = $request->header('token');
        $general = GeneralSetting::first();
        $user = User::where('token', $token)->where('email', $email)->where('status', 1)->first();
        if (!$user) {
            $data = array(
                'result' => 'failure',
                'message' => 'Invalid token / email',
            );
            echo json_encode($data);
            exit;
        }

        $general = GeneralSetting::first();
        $newcard = vcard::where('user_id', $user->id)->first();
        if (isset($newcard->card_pan)) {

            $qr = array(
                "card_hash" => $newcard->card_hash,
                "cvv" => $newcard->cvv,
                "expiration" => $newcard->expiration,
                "name_on_card" => $newcard->name_on_card
            );
            $carddesign = getContent('carddesign.content', true);
            $notify[] = ['Success', 'Card Details'];
            return response()->json([
                        'code' => 200,
                        'status' => 'success',
                        'message' => ['success' => $notify],
                        'data' => array(
                            "card_pan" => $newcard->card_pan,
                            "expiration" => $newcard->expiration,
                            "cvv" => $newcard->cvv,
                            "is_active" => $newcard->is_active,
                            "currency" => $general->cur_text,
                            "name_on_cad" => $newcard->name_on_card,
                            "card_design" => getImage('assets/images/frontend/carddesign/' . @$carddesign->data_values->design, '527x350'),
                            "qrimage" => array(
                                "url" => "https://api.qrserver.com/v1/create-qr-code/?size=300x300&bgcolor=bdbdbd&data=",
                                "data" => $qr
                            )
                        )
            ]);
        } else {
            $notify[] = ['error', 'Sorry! No Card Found,Issue card first'];
            return response()->json([
                        'code' => 400,
                        'status' => 'created',
                        'message' => ['error' => $notify],
            ]);
            exit;
        }
    }

    public function blockcard(Request $request) {
        $email = $request->header('email');
        $token = $request->header('token');

        $user = User::where('token', $token)->where('email', $email)->where('status', 1)->first();
        if (!$user) {
            $data = array(
                'result' => 'failure',
                'message' => 'Invalid token / email',
            );
            echo json_encode($data);
            exit;
        }

        $general = GeneralSetting::first();

        $blockcard = vcard::where('user_id', $user->id)->first();

        if ($blockcard) {
            $blockcard->card_status = "BLCK";
            $blockcard->is_active = "BLCK";
            $blockcard->save();
            $notify[] = ['success', 'Card Blocked'];

            return response()->json([
                        'code' => 200,
                        'status' => 'created',
                        'message' => ['success' => $notify],
            ]);
            exit;
        } else {

            $notify[] = ['error', 'Error blocking Card'];

            return response()->json([
                        'code' => 400,
                        'status' => 'created',
                        'message' => ['error' => $notify],
            ]);
            exit;
        }
    }

    public function unblockcard(Request $request) {
        $email = $request->header('email');
        $token = $request->header('token');

        $user = User::where('token', $token)->where('email', $email)->where('status', 1)->first();
        if (!$user) {
            $data = array(
                'result' => 'failure',
                'message' => 'Invalid token / email',
            );
            echo json_encode($data);
            exit;
        }

        $general = GeneralSetting::first();

        $blockcard = vcard::where('user_id', $user->id)->first();

        if ($blockcard) {
            $blockcard->card_status = "ACT";
            $blockcard->is_active = "ACT";
            $blockcard->save();
            $notify[] = ['success', 'Card Unblocked'];
            return response()->json([
                        'code' => 200,
                        'status' => 'created',
                        'message' => ['success' => $notify],
            ]);
            exit;
        } else {

            $notify[] = ['error', 'Error Unblocking Card'];
            return response()->json([
                        'code' => 400,
                        'status' => 'created',
                        'message' => ['error' => $notify],
            ]);
            exit;
        }
    }

    public function updatecard(Request $request) {
        $general = GeneralSetting::first();
        $public = $request->header('public-key');
        $private = $request->header('private-key');

        $update = $request->json()->all();
        if ($general->livitpay_public != $public) {
            $data = array(
                'code' => 400,
                'status' => 'error',
                'message' => 'invalid public site/keys',
            );
            echo json_encode($data);
            exit;
        }
        if ($general->livitpay_private != $private) {
            $data = array(
                'code' => 400,
                'status' => 'error',
                'message' => 'invalid private site/keys',
            );
            echo json_encode($data);
            exit;
        }
        $user = User::where('email', $update['user_email'])->first();
        if (isset($user->id)) {
            $user->livit_card = $update['weavr_cardid'];
            $user->save();
            $subject = "New MasterCard Issued";
            $message = "Your request for USD MasterCard has been approved";
            sendGeneralEmail($user->email, $subject, $message, $user->username);
        } else {
            $data = array(
                'code' => 400,
                'status' => 'error',
                'message' => 'User Email Invalid',
            );
            echo json_encode($data);
            exit;
        }
    }
    
      public function visaupdatecard(Request $request) {
        $general = GeneralSetting::first();
        $public = $request->header('public-key');
        $private = $request->header('private-key');

        $update = $request->json()->all();
        if ($general->livitpay_public != $public) {
            $data = array(
                'code' => 400,
                'status' => 'error',
                'message' => 'invalid public site/keys',
            );
            echo json_encode($data);
            exit;
        }
        if ($general->livitpay_private != $private) {
            $data = array(
                'code' => 400,
                'status' => 'error',
                'message' => 'invalid private site/keys',
            );
            echo json_encode($data);
            exit;
        }
        $user = User::where('email', $update['user_email'])->first();
        if (isset($user->id)) {
            $user->livit_visacard = $update['visa_cardid'];
            $user->save();
            $subject = "New VisaCard Issued";
            $message = "Your request for VisaCard has been approved";
            sendGeneralEmail($user->email, $subject, $message, $user->username);
        } else {
            $data = array(
                'code' => 400,
                'status' => 'error',
                'message' => 'User Email Invalid',
            );
            echo json_encode($data);
            exit;
        }
    }
    
    
    public function usdvisaupdatecard(Request $request) {
        $general = GeneralSetting::first();
        $public = $request->header('public-key');
        $private = $request->header('private-key');

        $update = $request->json()->all();
        if ($general->livitpay_public != $public) {
            $data = array(
                'code' => 400,
                'status' => 'error',
                'message' => 'invalid public site/keys',
            );
            echo json_encode($data);
            exit;
        }
        if ($general->livitpay_private != $private) {
            $data = array(
                'code' => 400,
                'status' => 'error',
                'message' => 'invalid private site/keys',
            );
            echo json_encode($data);
            exit;
        }
        $user = User::where('email', $update['user_email'])->first();
        if (isset($user->id)) {
            $user->livit_usdvisacard = $update['usdvisa_cardid'];
            $user->save();
            $subject = "New USD VisaCard Issued";
            $message = "Your request for USD VisaCard has been approved";
            sendGeneralEmail($user->email, $subject, $message, $user->username);
        } else {
            $data = array(
                'code' => 400,
                'status' => 'error',
                'message' => 'User Email Invalid',
            );
            echo json_encode($data);
            exit;
        }
    }

    public function cryptoupdatecard(Request $request) {
        $general = GeneralSetting::first();
        $public = $request->header('public-key');
        $private = $request->header('private-key');

        $update = $request->json()->all();
        if ($general->livitpay_public != $public) {
            $data = array(
                'code' => 400,
                'status' => 'error',
                'message' => 'invalid public site/keys',
            );
            echo json_encode($data);
            exit;
        }
        if ($general->livitpay_private != $private) {
            $data = array(
                'code' => 400,
                'status' => 'error',
                'message' => 'invalid private site/keys',
            );
            echo json_encode($data);
            exit;
        }
        $user = User::where('email', $update['user_email'])->first();
        if (isset($user->id)) {
            $user->cryptolivit_card = $update['weavr_cardid'];
            $user->save();
            $subject = "New Crypto MasterCard Issued";
            $message = "Your request for Crypto MasterCard has been approved";
            sendGeneralEmail($user->email, $subject, $message, $user->username);
        } else {
            $data = array(
                'code' => 400,
                'status' => 'error',
                'message' => 'User Email Invalid',
            );
            echo json_encode($data);
            exit;
        }
    }

    public function transferfunds(Request $request) {
        $email = $request->header('email');
        $token = $request->header('token');

        $user = User::where('token', $token)->where('email', $email)->where('status', 1)->first();
        if (!$user) {
            $data = array(
                'code' => 400,
                'result' => 'failure',
                'message' => 'Invalid token / email',
            );
            echo json_encode($data);
            exit;
        }

        $general = GeneralSetting::first();
        $amount = $request->json()->get('amount');

        $currency = $request->json()->get('currency');
        $toemail = $request->json()->get('toemail');
        if ($amount < 0) {
            $data = array(
                'code' => 400,
                'result' => 'failure',
                'message' => 'Invalid Amount',
            );
            echo json_encode($data);
            exit;
        }

        if ($user->email == $toemail) {

            $data = array(
                'code' => 400,
                'result' => 'failure',
                'message' => 'Cant transfer balance to your own',
            );
            echo json_encode($data);
            exit;
        }
        $receiver = User::where('email', $toemail)->first();
        if (!$receiver) {
            $data = array(
                'code' => 400,
                'result' => 'failure',
                'message' => 'Sorry Receiver not found',
            );
            echo json_encode($data);
            exit;
        }
        $pgfee = $general->tx_fee;
        if ($currency != $general->cur_text) {
            $frate = Fiat::where('code', $currency)->first();

            $rate = $frate->rate;
            $debitamount = showAmount($amount / $rate);
            $fees = $debitamount * $pgfee / 100;
        } else {

            $debitamount = showAmount($amount);
            $fees = $debitamount * $pgfee / 100;
        }

        $ftotalAmount = $debitamount + $fees;
        if ($ftotalAmount > $user->balance) {
            $data = array(
                'code' => 400,
                'result' => 'failure',
                'message' => 'Insufficient Balance in wallet',
            );
            echo json_encode($data);
            exit;
        }
        $ftrx = getTrx();

        $user->balance -= $fees;
        $user->save();

        $transaction = new Transaction();
        $transaction->user_id = $user->id;
        $transaction->amount = $fees;
        $transaction->post_balance = $user->balance;
        $transaction->charge = 00;
        $transaction->trx_type = '-';
        $transaction->details = 'Fees for money transfer to ' . $toemail . ' amount ' . $debitamount . ' successful';
        $transaction->trx = $ftrx;
        $transaction->save();

        $trx = getTrx();

        $user->balance -= $debitamount;
        $user->save();

        $transaction = new Transaction();
        $transaction->user_id = $user->id;
        $transaction->amount = $debitamount;
        $transaction->post_balance = $user->balance;
        $transaction->charge = 00;
        $transaction->trx_type = '-';
        $transaction->details = 'Money Transfer to ' . $toemail . ' amount ' . $debitamount . ' successful';
        $transaction->trx = $trx;
        $transaction->save();

        $rtrx = getTrx();
        $receiver->balance += $debitamount;
        $receiver->save();

        $transaction = new Transaction();
        $transaction->user_id = $receiver->id;
        $transaction->amount = $debitamount;
        $transaction->post_balance = $receiver->balance;
        $transaction->charge = 00;
        $transaction->trx_type = '+';
        $transaction->details = 'Money Transfer from ' . $user->email . ' amount ' . $debitamount . ' successful';
        $transaction->trx = $rtrx;
        $transaction->save();
        $data = array(
            'code' => 200,
            'result' => 'Success',
            'message' => 'Transfer Processed Successfully',
        );
        echo json_encode($data);
        exit;
    }

    public function stripeupdate(Request $request) {

        $email = $request->header('email');
        $token = $request->header('token');

        $user = User::where('token', $token)->where('email', $email)->where('status', 1)->first();
        if (!$user) {
            $data = array(
                'code' => 400,
                'result' => 'failure',
                'message' => 'Invalid token / email',
            );
            echo json_encode($data);
            exit;
        }

        $general = GeneralSetting::first();
        $amount = 0;
        $currency = $request->json()->get('currency');
        $stripetxnid = $request->json()->get('stripetxnid');

        $transaction = new Transaction();
        $transaction->user_id = $user->id;
        $transaction->amount = $amount;
        $transaction->post_balance = $user->balance;
        $transaction->charge = 00;
        $transaction->trx_type = '-';
        $transaction->details = 'Stripe Terminal Authorization Stripe Txn id: ' . $stripetxnid;
        $transaction->trx = $ftrx;
        $transaction->stripetxnid = $stripetxnid;
        $transaction->save();
    }

    public function stripepay(Request $request) {
        $email = $request->header('email');
        $token = $request->header('token');

        $user = User::where('token', $token)->where('email', $email)->where('status', 1)->first();
        if (!$user) {
            $data = array(
                'code' => 400,
                'result' => 'failure',
                'message' => 'Invalid token / email',
            );
            echo json_encode($data);
            exit;
        }

        $general = GeneralSetting::first();
        $stripedata = new Stripeupdate();
        $stripedata->json = json_encode($request->json()->all());
        $stripedata->save();

        $amount = ($request->json()->get('amount') / 100);
        $currency = $request->json()->get('currency');
        $stripetxnid = $request->json()->get('stripetxnid');

        $stp = Transaction::where('stripetxnid', $stripetxnid)->first();

        if (isset($stp) && $stp->stripetxnid == $stripetxnid) {
            $data = array(
                'code' => 400,
                'result' => 'failure',
                'message' => 'Transaction Already Credited',
            );
            echo json_encode($data);
            exit;
        }

        if ($amount < 0) {
            $data = array(
                'code' => 400,
                'result' => 'failure',
                'message' => 'Invalid Amount',
            );
            echo json_encode($data);
            exit;
        }



        $stripefee = $general->stripefee;
        if ($currency != $general->cur_text) {
            $frate = Fiat::where('code', $currency)->first();

            $rate = $frate->rate;
            $debitamount = round($amount / $rate);
            $fees = round($debitamount * $stripefee / 100);
        } else {

            $debitamount = round($amount);
            $fees = round($debitamount * $stripefee / 100);
        }

        $ftrx = getTrx();

        $user->balance -= $fees;
        $user->save();

        $transaction = new Transaction();
        $transaction->user_id = $user->id;
        $transaction->amount = $fees;
        $transaction->post_balance = $user->balance;
        $transaction->charge = 00;
        $transaction->trx_type = '-';
        $transaction->details = 'Fees for Stripe Terminal Usage Stripe Txn id: ' . $stripetxnid;
        $transaction->trx = $ftrx;
        $transaction->stripetxnid = $stripetxnid;
        $transaction->save();

        $trx = getTrx();

        $user->balance += $debitamount;
        $user->save();

        $transaction = new Transaction();
        $transaction->user_id = $user->id;
        $transaction->amount = $debitamount;
        $transaction->post_balance = $user->balance;
        $transaction->charge = 00;
        $transaction->trx_type = '+';
        $transaction->details = 'Stripe Terminal Payment Stripe Txn id: ' . $stripetxnid;
        $transaction->trx = $trx;
        $transaction->save();

        $data = array(
            'code' => 200,
            'result' => 'Success',
            'message' => 'Credit Posted To Wallet',
        );
        echo json_encode($data);
        exit;
    }

    //visa cards
    
    public function eurovisacardstatus(Request $request) {
        $email = $request->header('email');
        $token = $request->header('token');

        $user = User::where('token', $token)->where('email', $email)->where('status', 1)->first();
        if (!$user) {
            $data = array(
                'code' => 400,
                'result' => 'failure',
                'message' => 'Invalid token / email',
            );
            echo json_encode($data);
            exit;
        }

        $general = GeneralSetting::first();
        if (!$user->livit_visacard) {
            $data = array(
                'code' => 409,
                'result' => 'failure',
                'message' => 'Please apply for card first',
                'fee' => $general->visa_fee
            );
            echo json_encode($data);
            exit;
        }
        if ($user->livit_visacard == "requested") {
            $data = array(
                'code' => 410,
                'result' => 'failure',
                'message' => 'Card Application is under process wait 24-48hours',
                'fee' => $general->visa_fee
            );
            echo json_encode($data);
            exit;
        }

        $data = array(
            'code' => 200,
            'result' => 'success',
            'message' => 'Proceed to Card Details',
            'cardid' => $user->livit_visacard,
        );
        echo json_encode($data);
    }
    
      public function usdvisacardstatus(Request $request) {
        $email = $request->header('email');
        $token = $request->header('token');

        $user = User::where('token', $token)->where('email', $email)->where('status', 1)->first();
        if (!$user) {
            $data = array(
                'code' => 400,
                'result' => 'failure',
                'message' => 'Invalid token / email',
            );
            echo json_encode($data);
            exit;
        }

        $general = GeneralSetting::first();
        if (!$user->livit_usdvisacard) {
            $data = array(
                'code' => 409,
                'result' => 'failure',
                'message' => 'Please apply for card first',
                'fee' => $general->usdvisa_fee
            );
            echo json_encode($data);
            exit;
        }
        if ($user->livit_usdvisacard == "requested") {
            $data = array(
                'code' => 410,
                'result' => 'failure',
                'message' => 'Card Application is under process wait 24-48hours',
                'fee' => $general->usdvisa_fee
            );
            echo json_encode($data);
            exit;
        }

        $data = array(
            'code' => 200,
            'result' => 'success',
            'message' => 'Proceed to Card Details',
            'cardid' => $user->livit_usdvisacard,
        );
        echo json_encode($data);
    }
    
     public function issueeurocard(Request $request) {
        $email = $request->header('email');
        $token = $request->header('token');

        $user = User::where('token', $token)->where('email', $email)->where('status', 1)->first();
        if (!$user) {
            $data = array(
                'code' => 400,
                'result' => 'failure',
                'message' => 'Invalid token / email',
            );
            echo json_encode($data);
            exit;
        }

        $general = GeneralSetting::first();
        
        
        $publickey = $general->livitpay_public;
        $privatekey = $general->livitpay_private;
        $totalAmount = $general->visa_fee;
        if ($user->balance < $totalAmount) {
            $data = array(
                'code' => 400,
                'status' => 'error',
                'message' => 'Insufficient Balance To Issue Card',
            );
            echo json_encode($data);
            exit;
        }

        if ($user->livit_visacard) {
            $data = array(
                'code' => 400,
                'status' => 'error',
                'message' => 'Your already have a card issued / requested',
            );
            echo json_encode($data);
            exit;
        }
        $trx = getTrx();
        $user->balance -= $totalAmount;
        $user->save();

        $requestid = getTrx();
        $post = array(
            "name_on_card" => $user->firstname . " " . $user->lastname,
            "card_phone" => $user->mobile,
            "user_id" => $user->id,
            "user_email" => $user->email,
            "line_1" => $request->line_1,
            "line_2" => $request->line_2,
            "city" => $request->city,
            "state" => $request->state,
            "zip" => $request->zip,
            "country" => $request->country,
            "user_email" => $user->email,
             "pass"=> $request->pass,
            "requestid" => $requestid
        );
        $curl = curl_init();
        curl_setopt_array($curl, array(
              CURLOPT_URL => 'https://cards.livitpay.com/api/visacardrequest',
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_ENCODING => '',
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => 0,
            CURLOPT_FOLLOWLOCATION => true,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST => 'POST',
            CURLOPT_POSTFIELDS => json_encode($post),
            CURLOPT_HTTPHEADER => array(
                'public-key: ' . $publickey,
                'private-key: ' . $privatekey,
                'url: ' . env('APP_URL'),
                'Content-Type: application/json'
            ),
        ));

        $response = curl_exec($curl);

        curl_close($curl);
        $cards = json_decode($response);
        if ($cards->status == "success") {
            $user->livit_visacard = "requested";
            $user->save();
            $transaction = new Transaction();
            $transaction->user_id = $user->id;
            $transaction->amount = $totalAmount;
            $transaction->post_balance = $user->balance;
            $transaction->charge = 00;
            $transaction->trx_type = '-';
            $transaction->details = 'Euro Visa Debit Card Issuance Fees';
            $transaction->trx = $trx;
            $transaction->save();
            $subject = "New Card Request Received";
            $message = "You have applied for a new EURO VISA card, Admin will review your request in 24-48hours";
            sendGeneralEmail($user->email, $subject, $message, $user->username);
            $notify[] = ['success', 'Card Application Sent To Admin For Approval. 24-48Hours'];

            $adminNotification = new AdminNotification();
            $adminNotification->user_id = $user->id;
            $adminNotification->title = "New Euro Visa Request Received";
            $adminNotification->save();
            $data = array(
                'code' => 200,
                'status' => 'success',
                'message' => 'You have applied for a new Euro Visa card Admin will review your request in 24-48hours',
            );
            echo json_encode($data);
            exit;
        } else {
            $user->balance += $totalAmount;
            $user->save();
            $data = array(
                'code' => 400,
                'status' => 'error',
                'message' => 'Card Application Failed ' . $cards->message,
            );
            echo json_encode($data);
            exit;
        }
    }
    
    
    public function issueusdcard(Request $request) {
        $email = $request->header('email');
        $token = $request->header('token');

        $user = User::where('token', $token)->where('email', $email)->where('status', 1)->first();
        if (!$user) {
            $data = array(
                'code' => 400,
                'result' => 'failure',
                'message' => 'Invalid token / email',
            );
            echo json_encode($data);
            exit;
        }

        $general = GeneralSetting::first();
        
        
        $publickey = $general->livitpay_public;
        $privatekey = $general->livitpay_private;
        $totalAmount = $general->usdvisa_fee;
        if ($user->balance < $totalAmount) {
            $data = array(
                'code' => 400,
                'status' => 'error',
                'message' => 'Insufficient Balance To Issue Card',
            );
            echo json_encode($data);
            exit;
        }

        if ($user->livit_usdvisacard) {
            $data = array(
                'code' => 400,
                'status' => 'error',
                'message' => 'Your already have a card issued / requested',
            );
            echo json_encode($data);
            exit;
        }
        $trx = getTrx();
        $user->balance -= $totalAmount;
        $user->save();

        $requestid = getTrx();
        $post = array(
            "name_on_card" => $user->firstname . " " . $user->lastname,
            "card_phone" => $user->mobile,
            "user_id" => $user->id,
            "user_email" => $user->email,
            "line_1" => $request->line_1,
            "line_2" => $request->line_2,
            "city" => $request->city,
            "state" => $request->state,
            "zip" => $request->zip,
            "country" => $request->country,
            "user_email" => $user->email,
             "pass"=> $request->pass,
            "requestid" => $requestid
        );
        $curl = curl_init();
        curl_setopt_array($curl, array(
              CURLOPT_URL => 'https://cards.livitpay.com/api/usdvisacardrequest',
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_ENCODING => '',
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => 0,
            CURLOPT_FOLLOWLOCATION => true,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST => 'POST',
            CURLOPT_POSTFIELDS => json_encode($post),
            CURLOPT_HTTPHEADER => array(
                'public-key: ' . $publickey,
                'private-key: ' . $privatekey,
                'url: ' . env('APP_URL'),
                'Content-Type: application/json'
            ),
        ));

        $response = curl_exec($curl);

        curl_close($curl);
        $cards = json_decode($response);
        if ($cards->status == "success") {
            $user->livit_usdvisacard = "requested";
            $user->save();
            $transaction = new Transaction();
            $transaction->user_id = $user->id;
            $transaction->amount = $totalAmount;
            $transaction->post_balance = $user->balance;
            $transaction->charge = 00;
            $transaction->trx_type = '-';
            $transaction->details = 'USD Visa Debit Card Issuance Fees';
            $transaction->trx = $trx;
            $transaction->save();
            $subject = "New Card Request Received";
            $message = "You have applied for a new USD VISA card Admin will review your request in 24-48hours";
            sendGeneralEmail($user->email, $subject, $message, $user->username);
            $notify[] = ['success', 'Card Application Sent To Admin For Approval. 24-48Hours'];

            $adminNotification = new AdminNotification();
            $adminNotification->user_id = $user->id;
            $adminNotification->title = "New USD Visa Request Received";
            $adminNotification->save();
            $data = array(
                'code' => 200,
                'status' => 'success',
                'message' => 'You have applied for a new Euro Visa card Admin will review your request in 24-48hours',
            );
            echo json_encode($data);
            exit;
        } else {
            $user->balance += $totalAmount;
            $user->save();
            $data = array(
                'code' => 400,
                'status' => 'error',
                'message' => 'Card Application Failed ' . $cards->message,
            );
            echo json_encode($data);
            exit;
        }
    }
    
    public function usdvisagetcard(Request $request){
        $email = $request->header('email');
        $token = $request->header('token');

        $user = User::where('token', $token)->where('email', $email)->where('status', 1)->first();
        if (!$user) {
            $data = array(
                'code' => 400,
                'result' => 'failure',
                'message' => 'Invalid token / email',
            );
            echo json_encode($data);
            exit;
        }

        $general = GeneralSetting::first();
        
        
         $publickey = $general->livitpay_public;
        $privatekey = $general->livitpay_private;
        $uri = env("APP_URL");
         
if(!$user->livit_usdvisacard || $user->livit_usdvisacard == null){
     $data = array(
            'code' => 400,
            'result' => 'Error',
            'message' => 'Please Apply For Card First',
        );
        echo json_encode($data);
        exit;
        
         }
         if($user->livit_usdvisacard == "requested"){
              $data = array(
            'code' => 400,
            'result' => 'Error',
            'message' => 'Your USD Visa Card is pending Approval',
        );
        echo json_encode($data);
        exit;
           
         }
         
        $curl = curl_init();
$post = array(
    "email" => $user->email,
     "cardid" => $user->livit_usdvisacard,
    "url" => $uri,
);


curl_setopt_array($curl, array(
  CURLOPT_URL => 'https://cards.livitpay.com/api/usdvisagetcards',
  CURLOPT_RETURNTRANSFER => true,
  CURLOPT_ENCODING => '',
  CURLOPT_MAXREDIRS => 10,
  CURLOPT_TIMEOUT => 0,
  CURLOPT_FOLLOWLOCATION => true,
  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
  CURLOPT_CUSTOMREQUEST => 'POST',
  CURLOPT_POSTFIELDS =>json_encode($post),
  CURLOPT_HTTPHEADER => array(
    'public-key: '.$publickey,
    'private-key: '.$privatekey,
    'url: '.env('APP_URL'),
    'Content-Type: application/json'
  ),
));

$response = curl_exec($curl);

curl_close($curl);
$cards = json_decode($response);
 $carddesign = getContent('carddesign.content', true);
 
     if(!isset($cards->card->card_number)){
          $data = array(
            'code' => 400,
            'result' => 'Error',
            'message' => 'Unable to retrieve card information at this time, please try again later',
        );
        echo json_encode($data);
        exit;
       
     }
        $data = array(
            'code' => 200,
            'result' => 'Success',
            'data' => $cards,
             "cardimage" => getImage('assets/images/frontend/carddesign/' .$carddesign->data_values->usdvisacarddesign, '320x213'),
        );
        echo json_encode($data);
        exit; 
        
        
    }
    
    
      public function eurovisagetcard(Request $request){
        $email = $request->header('email');
        $token = $request->header('token');

        $user = User::where('token', $token)->where('email', $email)->where('status', 1)->first();
        if (!$user) {
            $data = array(
                'code' => 400,
                'result' => 'failure',
                'message' => 'Invalid token / email',
            );
            echo json_encode($data);
            exit;
        }

        $general = GeneralSetting::first();
        
        
        $publickey = $general->livitpay_public;
        $privatekey = $general->livitpay_private;
        $uri = env("APP_URL");
    
       
         
if(!$user->livit_visacard || $user->livit_visacard == null){
     $data = array(
            'code' => 400,
            'result' => 'Error',
            'message' => 'Please Apply For Card First',
        );
        echo json_encode($data);
        exit;
        
         }
         if($user->livit_visacard == "requested"){
              $data = array(
            'code' => 400,
            'result' => 'Error',
            'message' => 'Your EURO Visa Card is pending Approval',
        );
        echo json_encode($data);
        exit;
           
         }
         
        $curl = curl_init();
$post = array(
    "email" => $user->email,
     "cardid" => $user->livit_visacard,
    "url" => $uri,
);


curl_setopt_array($curl, array(
  CURLOPT_URL => 'https://cards.livitpay.com/api/visagetcards',
  CURLOPT_RETURNTRANSFER => true,
  CURLOPT_ENCODING => '',
  CURLOPT_MAXREDIRS => 10,
  CURLOPT_TIMEOUT => 0,
  CURLOPT_FOLLOWLOCATION => true,
  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
  CURLOPT_CUSTOMREQUEST => 'POST',
  CURLOPT_POSTFIELDS =>json_encode($post),
  CURLOPT_HTTPHEADER => array(
    'public-key: '.$publickey,
    'private-key: '.$privatekey,
    'url: '.env('APP_URL'),
    'Content-Type: application/json'
  ),
));

$response = curl_exec($curl);

curl_close($curl);
$cards = json_decode($response);
 $carddesign = getContent('carddesign.content', true);
 
     if(!isset($cards->card->card_number)){
          $data = array(
            'code' => 400,
            'result' => 'Error',
            'message' => 'Unable to retrieve card information at this time, please try again later',
        );
        echo json_encode($data);
        exit;
       
     }
        $data = array(
            'code' => 200,
            'result' => 'Success',
            'data' => $cards,
             "cardimage" => getImage('assets/images/frontend/carddesign/' .$carddesign->data_values->visacarddesign, '320x213'),
        );
        echo json_encode($data);
        exit; 
        
        
    }
    
       public function eurovisafund(Request $request){
        $email = $request->header('email');
        $token = $request->header('token');

        $user = User::where('token', $token)->where('email', $email)->where('status', 1)->first();
        if (!$user) {
            $data = array(
                'code' => 400,
                'result' => 'failure',
                'message' => 'Invalid token / email',
            );
            echo json_encode($data);
            exit;
        }

        $general = GeneralSetting::first();
        
        
        $publickey = $general->livitpay_public;
        $privatekey = $general->livitpay_private;
        $uri = env("APP_URL");
        
        $request->validate([
            'amount' => 'required|integer|gt:4'
        ]); 
         if(!$user->livit_visacard){
              $data = array(
            'code' => 400,
            'result' => 'Error',
            'message' => 'Please Apply For Card First',
        );
        echo json_encode($data);
        exit;
         
         }
         if($user->livit_visacard == "requested"){
              $data = array(
            'code' => 400,
            'result' => 'Error',
            'message' => 'Your card is pending approval',
        );
        echo json_encode($data);
        exit;
           
         }
       
         $debitamount = $request->amount;
         $loadfee = $request->amount * $general->visa_loadfee / 100;
         $totalAmount = round(($debitamount + $loadfee),2);
if($user->balance < $totalAmount){
     $data = array(
            'code' => 400,
            'result' => 'Error',
            'message' => 'Insufficient Balance To Load Funds',
        );
        echo json_encode($data);
        exit;
        
    }
       $trx = getTrx();
     $user->balance -= $totalAmount;
    $user->save(); 
    
        $curl = curl_init();
$post = array(
    "email" => $user->email,
    "cardid" => $user->livit_visacard,
    "url" => $uri,
    "amount" => $debitamount,
    "requestid" => $trx    
);

curl_setopt_array($curl, array(
  CURLOPT_URL => 'https://cards.livitpay.com/api/visafundcards',
  CURLOPT_RETURNTRANSFER => true,
  CURLOPT_ENCODING => '',
  CURLOPT_MAXREDIRS => 10,
  CURLOPT_TIMEOUT => 0,
  CURLOPT_FOLLOWLOCATION => true,
  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
  CURLOPT_CUSTOMREQUEST => 'POST',
  CURLOPT_POSTFIELDS =>json_encode($post),
  CURLOPT_HTTPHEADER => array(
    'public-key: '.$publickey,
    'private-key: '.$privatekey,
    'url: '.env('APP_URL'),
    'Content-Type: application/json'
  ),
));

$response = curl_exec($curl);

curl_close($curl);
$cards = json_decode($response);

if($cards->status == "success"){
    
    $transaction = new Transaction();
    $transaction->user_id = $user->id;
    $transaction->amount = $totalAmount;
    $transaction->post_balance = $user->balance;
    $transaction->charge = $loadfee;
    $transaction->trx_type = '-';
    $transaction->details = 'Funds loaded to Visa Card';
    $transaction->trx =  $trx;
    $transaction->save();
    $subject = "Visa Card Fund Load Request";
        $message = "Your request to load funds on your Visa Card is sent to admin. Expect the funds to be available in 24-48hours";
         sendGeneralEmail($user->email, $subject, $message, $user->username);
   
     $adminNotification = new AdminNotification();
        $adminNotification->user_id = $user->id;
        $adminNotification->title = "New Load Fund Request Received on Visa Card";
        $adminNotification->save();
        
         $data = array(
            'code' => 200,
            'result' => 'Success',
            'message' => 'Fund Load request sent to Admin',
        );
        echo json_encode($data);
        exit;
        
          
} else {
     $user->balance += $totalAmount;
    $user->save();   
     $data = array(
            'code' => 400,
            'result' => 'Error',
            'message' => 'Error Processing Request at this time, try again later.',
        );
        echo json_encode($data);
        exit;
    
   
}
        
    }
    
       public function usdvisafund(Request $request){
        $email = $request->header('email');
        $token = $request->header('token');

        $user = User::where('token', $token)->where('email', $email)->where('status', 1)->first();
        if (!$user) {
            $data = array(
                'code' => 400,
                'result' => 'failure',
                'message' => 'Invalid token / email',
            );
            echo json_encode($data);
            exit;
        }

        $general = GeneralSetting::first();
        
        
        $publickey = $general->livitpay_public;
        $privatekey = $general->livitpay_private;
        $uri = env("APP_URL");
        
        $request->validate([
            'amount' => 'required|integer|gt:4'
        ]); 
         if(!$user->livit_usdvisacard){
              $data = array(
            'code' => 400,
            'result' => 'Error',
            'message' => 'Please Apply For Card First',
        );
        echo json_encode($data);
        exit;
         
         }
         if($user->livit_usdvisacard == "requested"){
              $data = array(
            'code' => 400,
            'result' => 'Error',
            'message' => 'Your card is pending approval',
        );
        echo json_encode($data);
        exit;
           
         }
       
         $debitamount = $request->amount;
         $loadfee = $request->amount * $general->usdvisa_loadfee / 100;
         $totalAmount = round(($debitamount + $loadfee),2);
if($user->balance < $totalAmount){
     $data = array(
            'code' => 400,
            'result' => 'Error',
            'message' => 'Insufficient Balance To Load Funds',
        );
        echo json_encode($data);
        exit;
        
    }
       $trx = getTrx();
     $user->balance -= $totalAmount;
    $user->save(); 
    
        $curl = curl_init();
$post = array(
    "email" => $user->email,
    "cardid" => $user->livit_usdvisacard,
    "url" => $uri,
    "amount" => $debitamount,
    "requestid" => $trx    
);

curl_setopt_array($curl, array(
  CURLOPT_URL => 'https://cards.livitpay.com/api/usdvisafundcards',
  CURLOPT_RETURNTRANSFER => true,
  CURLOPT_ENCODING => '',
  CURLOPT_MAXREDIRS => 10,
  CURLOPT_TIMEOUT => 0,
  CURLOPT_FOLLOWLOCATION => true,
  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
  CURLOPT_CUSTOMREQUEST => 'POST',
  CURLOPT_POSTFIELDS =>json_encode($post),
  CURLOPT_HTTPHEADER => array(
    'public-key: '.$publickey,
    'private-key: '.$privatekey,
    'url: '.env('APP_URL'),
    'Content-Type: application/json'
  ),
));

$response = curl_exec($curl);

curl_close($curl);
$cards = json_decode($response);

if($cards->status == "success"){
    
    $transaction = new Transaction();
    $transaction->user_id = $user->id;
    $transaction->amount = $totalAmount;
    $transaction->post_balance = $user->balance;
    $transaction->charge = $loadfee;
    $transaction->trx_type = '-';
    $transaction->details = 'Funds loaded to Visa Card';
    $transaction->trx =  $trx;
    $transaction->save();
    $subject = "USD Visa Card Fund Load Request";
        $message = "Your request to load funds on your USD Visa Card is sent to admin. Expect the funds to be available in 24-48hours";
         sendGeneralEmail($user->email, $subject, $message, $user->username);
   
     $adminNotification = new AdminNotification();
        $adminNotification->user_id = $user->id;
        $adminNotification->title = "New Load Fund Request Received on Visa Card";
        $adminNotification->save();
        
         $data = array(
            'code' => 200,
            'result' => 'Success',
            'message' => 'Fund Load request sent to Admin',
        );
        echo json_encode($data);
        exit;
        
          
} else {
     $user->balance += $totalAmount;
    $user->save();   
     $data = array(
            'code' => 400,
            'result' => 'Error',
            'message' => 'Error Processing Request at this time, try again later.',
        );
        echo json_encode($data);
        exit;
    
   
}
        
    }
    
    
    //Mastercard Start
    public function mastercardstatus(Request $request) {
        $email = $request->header('email');
        $token = $request->header('token');

        $user = User::where('token', $token)->where('email', $email)->where('status', 1)->first();
        if (!$user) {
            $data = array(
                'code' => 400,
                'result' => 'failure',
                'message' => 'Invalid token / email',
            );
            echo json_encode($data);
            exit;
        }

        $general = GeneralSetting::first();
        if (!$user->livit_card) {
            $data = array(
                'code' => 409,
                'result' => 'failure',
                'message' => 'Please apply for card first',
                'fee' => $general->ngn_fee
            );
            echo json_encode($data);
            exit;
        }
        if ($user->livit_card == "requested") {
            $data = array(
                'code' => 410,
                'result' => 'failure',
                'message' => 'Card Application is under process wait 24-48hours',
                'fee' => $general->ngn_fee
            );
            echo json_encode($data);
            exit;
        }

        $data = array(
            'code' => 200,
            'result' => 'success',
            'message' => 'Proceed to Card Details',
        );
        echo json_encode($data);
    }

    public function issuemastercard(Request $request) {
        $email = $request->header('email');
        $token = $request->header('token');

        $user = User::where('token', $token)->where('email', $email)->where('status', 1)->first();
        if (!$user) {
            $data = array(
                'code' => 400,
                'result' => 'failure',
                'message' => 'Invalid token / email',
            );
            echo json_encode($data);
            exit;
        }

        $general = GeneralSetting::first();
        
        
        $publickey = $general->livitpay_public;
        $privatekey = $general->livitpay_private;
        $totalAmount = $general->ngn_fee;
        if ($user->balance < $totalAmount) {
            $data = array(
                'code' => 400,
                'status' => 'error',
                'message' => 'Insufficient Balance To Issue Card',
            );
            echo json_encode($data);
            exit;
        }

        if ($user->livit_card) {
            $data = array(
                'code' => 400,
                'status' => 'error',
                'message' => 'Your already have a card issued / requested',
            );
            echo json_encode($data);
            exit;
        }
        $trx = getTrx();
        $user->balance -= $totalAmount;
        $user->save();

        $requestid = getTrx();
        $post = array(
            "name_on_card" => $user->firstname . " " . $user->lastname,
            "card_phone" => $user->mobile,
            "user_id" => $user->id,
            "user_email" => $user->email,
            "line_1" => $request->line_1,
            "line_2" => $request->line_2,
            "city" => $request->city,
            "state" => $request->state,
            "zip" => $request->zip,
            "country" => $request->country,
            "user_email" => $user->email,
            "requestid" => $requestid
        );
        $curl = curl_init();
        curl_setopt_array($curl, array(
            CURLOPT_URL => 'https://cards.livitpay.com/api/cardrequest',
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_ENCODING => '',
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => 0,
            CURLOPT_FOLLOWLOCATION => true,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST => 'POST',
            CURLOPT_POSTFIELDS => json_encode($post),
            CURLOPT_HTTPHEADER => array(
                'public-key: ' . $publickey,
                'private-key: ' . $privatekey,
                'url: ' . env('APP_URL'),
                'Content-Type: application/json'
            ),
        ));

        $response = curl_exec($curl);

        curl_close($curl);
        $cards = json_decode($response);
        if ($cards->status == "success") {
            $user->livit_card = "requested";
            $user->save();
            $transaction = new Transaction();
            $transaction->user_id = $user->id;
            $transaction->amount = $totalAmount;
            $transaction->post_balance = $user->balance;
            $transaction->charge = 00;
            $transaction->trx_type = '-';
            $transaction->details = 'Debit Card Issuance Fees';
            $transaction->trx = $trx;
            $transaction->save();
            $subject = "New Card Request Received";
            $message = "You have applied for a new Master card Admin will review your request in 24-48hours";
            sendGeneralEmail($user->email, $subject, $message, $user->username);
            $notify[] = ['success', 'Card Application Sent To Admin For Approval. 24-48Hours'];

            $adminNotification = new AdminNotification();
            $adminNotification->user_id = $user->id;
            $adminNotification->title = "New Mastercard Request Received";
            $adminNotification->save();
            $data = array(
                'code' => 200,
                'status' => 'success',
                'message' => 'You have applied for a new Master card Admin will review your request in 24-48hours',
            );
            echo json_encode($data);
            exit;
        } else {
            $user->balance += $totalAmount;
            $user->save();
            $data = array(
                'code' => 400,
                'status' => 'error',
                'message' => 'Card Application Failed ' . $cards->message,
            );
            echo json_encode($data);
            exit;
        }
    }

    public function mastercard(Request $request) {
        $email = $request->header('email');
        $token = $request->header('token');

        $user = User::where('token', $token)->where('email', $email)->where('status', 1)->first();
        if (!$user) {
            $data = array(
                'code' => 400,
                'result' => 'failure',
                'message' => 'Invalid token / email',
            );
            echo json_encode($data);
            exit;
        }

        $general = GeneralSetting::first();
        $publickey = $general->livitpay_public;
        $privatekey = $general->livitpay_private;
        $uri = env("APP_URL");
        $pageTitle = "Mastercard Debit Card";

        if (!$user->livit_card) {
            $data = array(
                'code' => 409,
                'result' => 'failure',
                'message' => 'Please apply for card first',
                'fee' => $general->ngn_fee
            );
            echo json_encode($data);
            exit;
        }
        if ($user->livit_card == "requested") {
            $data = array(
                'code' => 410,
                'result' => 'failure',
                'message' => 'Card Application is under process wait 24-48hours',
                'fee' => $general->ngn_fee
            );
            echo json_encode($data);
            exit;
        }
        $curl = curl_init();
        $post = array(
            "email" => $user->email,
            "cardid" => $user->livit_card,
            "url" => $uri,
        );
        curl_setopt_array($curl, array(
            CURLOPT_URL => 'https://cards.livitpay.com/api/getcards',
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_ENCODING => '',
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => 0,
            CURLOPT_FOLLOWLOCATION => true,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST => 'POST',
            CURLOPT_POSTFIELDS => json_encode($post),
            CURLOPT_HTTPHEADER => array(
                'public-key: ' . $publickey,
                'private-key: ' . $privatekey,
                'url: ' . env('APP_URL'),
                'Content-Type: application/json'
            ),
        ));

        $response = curl_exec($curl);

        curl_close($curl);
        $cards = json_decode($response);
        $carddesign = getContent('carddesign.content', true);
        $data = array(
            'code' => 200,
            'result' => 'success',
            'weavrtoken' => $cards->weavrtoken,
            'cardNumber' => $cards->data->card_hash,
            'uikey' => $cards->uikey,
            'cvv' => $cards->data->cvv,
            'name_on_card' => $cards->data->name_on_card,
            'expiration' => $cards->data->expiration,
            "webview_url" => route('api.viewmastercard'),
            "cardimage" => getImage('assets/images/frontend/carddesign/' .$carddesign->data_values->mastercarddesign, '527x350'),
            "cards" => $cards
        );
        echo json_encode($data, JSON_UNESCAPED_SLASHES);
        exit;
    }

    public function viewmastercard(Request $request) {
        $email = $request->header('email') ? $request->header('email') : $request->get('email');
        $token = $request->header('token') ? $request->header('token') : $request->get('token');

        $user = User::where('token', $token)->where('email', $email)->where('status', 1)->first();
        if (!$user) {
            $data = array(
                'code' => 400,
                'result' => 'failure',
                'message' => 'Invalid token / email',
            );
            echo json_encode($data);
            exit;
        }
        $pageTitle = "Mastercard Debit Card";
        $general = GeneralSetting::first();
        $publickey = $general->livitpay_public;
        $privatekey = $general->livitpay_private;
        $uri = env("APP_URL");
        $curl = curl_init();
        $post = array(
            "email" => $user->email,
            "cardid" => $user->livit_card,
            "url" => $uri,
        );
        curl_setopt_array($curl, array(
            CURLOPT_URL => 'https://cards.livitpay.com/api/getcards',
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_ENCODING => '',
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => 0,
            CURLOPT_FOLLOWLOCATION => true,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST => 'POST',
            CURLOPT_POSTFIELDS => json_encode($post),
            CURLOPT_HTTPHEADER => array(
                'public-key: ' . $publickey,
                'private-key: ' . $privatekey,
                'url: ' . env('APP_URL'),
                'Content-Type: application/json'
            ),
        ));

        $response = curl_exec($curl);

        curl_close($curl);
        $bcards = json_decode($response);
        $cards = 
        $cards = array(
            "weavrtoken" => $request->header('weavrtoken') ? $request->header('weavrtoken') : $request->get('weavrtoken'),
            "uikey" => $request->header('uikey') ? $request->header('uikey') : "z4x06OFq+GEBghWxMTEACQ==",
            "cardNumber" => $request->header('cardNumber') ? $request->header('cardNumber') : str_replace(" ","+",$request->get('cardNumber')),
            "cvv" => $request->header('cvv') ? $request->header('cvv') :  str_replace(" ","+",$request->get('cvv')),
            "name_on_card" => $request->header('name-on-card') ? $request->header('name-on-card') : $request->get('name-on-card'),
            'expiration' => $request->header('expiration') ? $request->header('expiration') : $request->get('expiration'),
        );
        
        $curl = curl_init();
$visapost = array(
    "email" => $user->email,
     "cardid" => $user->livit_visacard,
    "url" => $uri,
);


curl_setopt_array($curl, array(
  CURLOPT_URL => 'https://cards.livitpay.com/api/visagetcards',
  CURLOPT_RETURNTRANSFER => true,
  CURLOPT_ENCODING => '',
  CURLOPT_MAXREDIRS => 10,
  CURLOPT_TIMEOUT => 0,
  CURLOPT_FOLLOWLOCATION => true,
  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
  CURLOPT_CUSTOMREQUEST => 'POST',
  CURLOPT_POSTFIELDS =>json_encode($visapost),
  CURLOPT_HTTPHEADER => array(
    'public-key: '.$publickey,
    'private-key: '.$privatekey,
    'url: '.env('APP_URL'),
    'Content-Type: application/json'
  ),
));

$visaresponse = curl_exec($curl);

curl_close($curl);
$visacards = json_decode($visaresponse);
        
        

        return view($this->activeTemplate . 'user.vcard.mlivitpayindex', compact('pageTitle', 'cards', 'bcards','visacards'));
    }

    public function mastercardtransactions(Request $request) {
        $email = $request->header('email');
        $token = $request->header('token');

        $user = User::where('token', $token)->where('email', $email)->where('status', 1)->first();
        if (!$user) {
            $data = array(
                'code' => 400,
                'result' => 'failure',
                'message' => 'Invalid token / email',
            );
            echo json_encode($data);
            exit;
        }

        $general = GeneralSetting::first();
        $publickey = $general->livitpay_public;
        $privatekey = $general->livitpay_private;
        $uri = env("APP_URL");
        $pageTitle = "Mastercard Debit Card";

        if (!$user->livit_card) {
            $data = array(
                'code' => 409,
                'result' => 'failure',
                'message' => 'Please apply for card first',
            );
            echo json_encode($data);
            exit;
        }
        if ($user->livit_card == "requested") {
            $data = array(
                'code' => 409,
                'result' => 'failure',
                'message' => 'Card Application is under process wait 24-48hours',
            );
            echo json_encode($data);
            exit;
        }
        $curl = curl_init();
        $post = array(
            "email" => $user->email,
            "cardid" => $user->livit_card,
            "url" => $uri,
        );
        curl_setopt_array($curl, array(
            CURLOPT_URL => 'https://cards.livitpay.com/api/getcards',
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_ENCODING => '',
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => 0,
            CURLOPT_FOLLOWLOCATION => true,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST => 'POST',
            CURLOPT_POSTFIELDS => json_encode($post),
            CURLOPT_HTTPHEADER => array(
                'public-key: ' . $publickey,
                'private-key: ' . $privatekey,
                'url: ' . env('APP_URL'),
                'Content-Type: application/json'
            ),
        ));

        $response = curl_exec($curl);

        curl_close($curl);
        $cards = json_decode($response);
        $data = array(
            'code' => 200,
            'result' => 'success',
            'data' => $cards->statement
        );
        echo json_encode($data);
        exit;
    }

    public function mastercardloadfunds(Request $request) {

        $email = $request->header('email');
        $token = $request->header('token');

        $user = User::where('token', $token)->where('email', $email)->where('status', 1)->first();
        if (!$user) {
            $data = array(
                'code' => 400,
                'result' => 'failure',
                'message' => 'Invalid token / email',
            );
            echo json_encode($data);
            exit;
        }

        $general = GeneralSetting::first();
        $publickey = $general->livitpay_public;
        $privatekey = $general->livitpay_private;
        $uri = env("APP_URL");

        if (!$user->livit_card) {
            $data = array(
                'code' => 400,
                'result' => 'failure',
                'message' => 'Please Apply For A Card First',
            );
            echo json_encode($data);
            exit;
        }
        if ($user->livit_card == "requested") {
            $data = array(
                'code' => 400,
                'result' => 'failure',
                'message' => 'Your Card is pending approval',
            );
            echo json_encode($data);
            exit;
        }
        $debitamount = $request->json()->get('amount');
        $loadfee = $request->json()->get('amount') * $general->load_fee / 100;
        $totalAmount = round(($debitamount + $loadfee), 2);
        if ($totalAmount < 0) {

            $result = array(
                "code" => 400,
                "status" => "error",
                "message" => "amount must be greater than 0"
            );
            http_response_code(409);
            echo json_encode($result);
            exit;
        }

        if ($user->balance < $totalAmount) {
            $data = array(
                'code' => 400,
                'result' => 'failure',
                'message' => 'Insufficient Balance To Issue Cards',
            );
            echo json_encode($data);
            exit;
        }
        $trx = getTrx();
        $user->balance -= $totalAmount;
        $user->save();

        $curl = curl_init();
        $post = array(
            "email" => $user->email,
            "cardid" => $user->livit_card,
            "url" => $uri,
            "amount" => $debitamount,
            "requestid" => $trx
        );

        curl_setopt_array($curl, array(
            CURLOPT_URL => 'https://cards.livitpay.com/api/fundcards',
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_ENCODING => '',
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => 0,
            CURLOPT_FOLLOWLOCATION => true,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST => 'POST',
            CURLOPT_POSTFIELDS => json_encode($post),
            CURLOPT_HTTPHEADER => array(
                'public-key: ' . $publickey,
                'private-key: ' . $privatekey,
                'url: ' . env('APP_URL'),
                'Content-Type: application/json'
            ),
        ));

        $response = curl_exec($curl);

        curl_close($curl);
        $cards = json_decode($response);

        if ($cards->status == "success") {

            $transaction = new Transaction();
            $transaction->user_id = $user->id;
            $transaction->amount = $totalAmount;
            $transaction->post_balance = $user->balance;
            $transaction->charge = $loadfee;
            $transaction->trx_type = '-';
            $transaction->details = 'Funds loaded to Mastercard';
            $transaction->trx = $trx;
            $transaction->save();
            $subject = "Fund Load Request";
            $message = "Your request to load funds on your Mastercard is sent to admin. Expect the funds to be available in 24-48hours";
            sendGeneralEmail($user->email, $subject, $message, $user->username);
            $adminNotification = new AdminNotification();
            $adminNotification->user_id = $user->id;
            $adminNotification->title = "New Load Fund Request Received";
            $adminNotification->save();
            $data = array(
                'code' => 200,
                'result' => 'Success',
                'message' => 'Funds Load Request Sent to Admin. 24-48Hours',
            );
            echo json_encode($data);
            exit;
        } else {
            $user->balance += $totalAmount;
            $user->save();
            $data = array(
                'code' => 200,
                'result' => 'Success',
                'message' => 'Fund Load Request Failed ' . $cards->message,
            );
            echo json_encode($data);
            exit;
        }
    }

    //Mastercard End
    //Airtime Start 
    public function getcountries(Request $request) {
        $email = $request->header('email');
        $token = $request->header('token');

        $user = User::where('token', $token)->where('email', $email)->where('status', 1)->first();
        if (!$user) {
            $data = array(
                'code' => 400,
                'result' => 'failure',
                'message' => 'Invalid token / email',
            );
            echo json_encode($data);
            exit;
        }

        $general = GeneralSetting::first();
        $countries = Countries::get();

        $data = array(
            'code' => 200,
            'result' => 'success',
            'data' => $countries
        );
        echo json_encode($data);
        exit;
    }

    public function getoperatorbyiso(Request $request) {
        $email = $request->header('email');
        $token = $request->header('token');

        $user = User::where('token', $token)->where('email', $email)->where('status', 1)->first();
        if (!$user) {
            $data = array(
                'code' => 400,
                'result' => 'failure',
                'message' => 'Invalid token / email',
            );
            echo json_encode($data);
            exit;
        }

        $oauth_token_response = $this->generate_oauth_token();
        $oauth_token_response = json_decode($oauth_token_response, true);

        $fetch_operator_by_iso_code_api_response = $this->fetch_operators_by_country_iso_code($oauth_token_response['access_token'], $request->header('country'));
        $fetch_operator_by_iso_code_response = json_decode($fetch_operator_by_iso_code_api_response, true);

        if (
                empty($fetch_operator_by_iso_code_api_response) ||
                empty($fetch_operator_by_iso_code_response) ||
                array_key_exists("errorCode", $fetch_operator_by_iso_code_response) ||
                array_key_exists("message", $fetch_operator_by_iso_code_response)
        ) {
            $result_set = array(
                "status" => 'error',
                "code" => 400,
                "message" => $fetch_operator_by_iso_code_response["message"] ? $fetch_operator_by_iso_code_response["message"] : 'Something went wrong while processing Request.',
                "data" => array(
                    "error_code" => $fetch_operator_by_iso_code_response["errorCode"],
                    "error_message" => $fetch_operator_by_iso_code_response["message"],
                    "error" => $fetch_operator_by_iso_code_response["errorCode"]
                )
            );
            echo json_encode($result_set);
            return;
        }

        $result_set = array(
            "status" => 'success',
            "code" => 200,
            "message" => 'Operator Details Fetched successfully',
            "data" => array(
                "response" => $fetch_operator_by_iso_code_response,
                "country" => $request->header('country')
            )
        );
        echo json_encode($result_set);
        return;
    }

    public function getoperatorbyoperatorid(Request $request) {
        $email = $request->header('email');
        $token = $request->header('token');

        $user = User::where('token', $token)->where('email', $email)->where('status', 1)->first();
        if (!$user) {
            $data = array(
                'code' => 400,
                'result' => 'failure',
                'message' => 'Invalid token / email',
            );
            echo json_encode($data);
            exit;
        }


        $oauth_token_response = $this->generate_oauth_token();

        $oauth_token_response = json_decode($oauth_token_response, true);

        $fetch_operator_by_operator_id_api_response = $this->fetch_operator_by_operator_id($oauth_token_response['access_token'], $request->header('operatorid'));
        $fetch_operator_by_operator_id_response = json_decode($fetch_operator_by_operator_id_api_response, true);

        if (
                empty($fetch_operator_by_operator_id_api_response) ||
                empty($fetch_operator_by_operator_id_response) ||
                array_key_exists("error", $fetch_operator_by_operator_id_response) ||
                array_key_exists("message", $fetch_operator_by_operator_id_response)
        ) {
            $result_set = array(
                "status" => 'error',
                "code" => 400,
                "message" => $fetch_operator_by_operator_id_response["message"] ? $fetch_operator_by_operator_id_response["message"] : 'Something went wrong while processing Request.',
                "data" => array(
                    "error_code" => $fetch_operator_by_operator_id_response["status"],
                    "error_message" => $fetch_operator_by_operator_id_response["message"],
                    "error" => $fetch_operator_by_operator_id_response["error"]
                )
            );
            echo json_encode($result_set);
            return;
        }

        $result_set = array(
            "status" => 'success',
            "code" => 200,
            "message" => 'Recharge Denominations Fetched successfully',
            "data" => array(
                "response" => $fetch_operator_by_operator_id_response,
                "country" => $request->header('operatorid')
            )
        );
        echo json_encode($result_set);
        return;
    }

    public function processrechargerequest(Request $request) {
        $email = $request->header('email');
        $token = $request->header('token');

        $user = User::where('token', $token)->where('email', $email)->where('status', 1)->first();
        if (!$user) {
            $data = array(
                'code' => 400,
                'result' => 'failure',
                'message' => 'Invalid token / email',
            );
            echo json_encode($data);
            exit;
        }

        $request_data = request()->json()->all();
        if (
                empty($request_data) ||
                empty($request_data['operator_id']) ||
                empty($request_data['recharge_amount']) ||
                empty($request_data['phone_number']) ||
                empty($request_data['country'])
        ) {
            $result_set = array(
                "status" => 'error',
                "code" => 400,
                "message" => 'Bad Request',
                "data" => array()
            );
            echo json_encode($result_set);
            return;
        }



        if ($request_data['recharge_amount'] > $user->balance) {
            $notify[] = 'Sorry, Insufficient Balance to process this order. Required Balance USD' . $price;
            return $notify;
        }

        $trx = getTrx();

        $user->balance -= $request_data['recharge_amount'];
        $user->save();

        $transaction = new Transaction();
        $transaction->user_id = $user->id;
        $transaction->amount = $request_data['recharge_amount'];
        $transaction->post_balance = $user->balance;
        $transaction->charge = 00;
        $transaction->trx_type = '-';
        $transaction->details = 'Airtime Recharge for ' . $request_data['phone_number'] . ' amount ' . $request_data['recharge_amount'] . ' successful';
        $transaction->trx = $trx;
        $transaction->save();

        $request_parameters = array(
            "operatorId" => $request_data['operator_id'],
            "amount" => $request_data['recharge_amount'],
            "useLocalAmount" => false,
            "customIdentifier" => $trx,
            "recipientPhone" => array(
                "countryCode" => $request_data['country'],
                "number" => $request_data['phone_number']
            )
        );
        $oauth_token_response = $this->generate_oauth_token();
        $oauth_token_response = json_decode($oauth_token_response, true);
        $make_a_topup_api_response = $this->make_a_topup($oauth_token_response['access_token'], $request_parameters);
        $make_a_topup_response = json_decode($make_a_topup_api_response, true);

        if (
                empty($make_a_topup_api_response) ||
                empty($make_a_topup_response) ||
                array_key_exists("errorCode", $make_a_topup_response)
        ) {
            $result_set = array(
                "status" => 'error',
                "code" => 400,
                "message" => $make_a_topup_response["message"] ? $make_a_topup_response["message"] : 'Something went wrong while processing Request.',
                "data" => array(
                    "error_code" => $make_a_topup_response["errorCode"],
                    "error_message" => $make_a_topup_response["message"],
                    "error" => $make_a_topup_response["errorCode"]
                )
            );
            $rtrx = getTrx();
            $user->balance += $request_data['recharge_amount'];
            $user->save();

            $transaction = new Transaction();
            $transaction->user_id = $user->id;
            $transaction->amount = $request_data['recharge_amount'];
            $transaction->post_balance = $user->balance;
            $transaction->charge = 00;
            $transaction->trx_type = '+';
            $transaction->details = 'Airtime Reversal for failure ' . $request_data['phone_number'] . ' amount ' . $request_data['recharge_amount'] . ' successful';
            $transaction->trx = $rtrx;
            $transaction->save();

            echo json_encode($result_set);
            return;
        }
        if (isset($make_a_topup_response['pinDetail'])) {
            $pin = $make_a_topup_response['pinDetail'];
        } else {
            $pin = "None";
        }

        $result_set = array(
            "status" => 'success',
            "code" => 200,
            "message" => 'Recharge Done successfully',
            "pindetail" => $pin,
            "data" => array(
                "response" => $make_a_topup_response,
                "phone_number" => $request_data['phone_number'],
                "country" => $request_data['country']
            )
        );
        echo json_encode($result_set);
        return;
    }

    public function generate_oauth_token() {
        $curl = curl_init();
        $general = GeneralSetting::first();
        $client_id = $general->reloadly_id;
        $client_secret = $general->reloadly_secret;
        $mode = $general->reloadly;
        if ($mode == "live") {
            $audience = "https://topups.reloadly.com";
        } else {
            $audience = "https://topups-sandbox.reloadly.com";
        }

        curl_setopt_array($curl, array(
            CURLOPT_URL => 'https://auth.reloadly.com/oauth/token',
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_ENCODING => '',
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => 0,
            CURLOPT_FOLLOWLOCATION => true,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST => 'POST',
            CURLOPT_POSTFIELDS => '{
	"client_id":"' . $client_id . '",
	"client_secret":"' . $client_secret . '",
	"grant_type":"client_credentials",
	"audience":"' . $audience . '"}',
            CURLOPT_HTTPHEADER => array(
                'Content-Type: application/json'
            ),
        ));

        $response = curl_exec($curl);

        curl_close($curl);
        return $response;
    }

    public function make_a_topup($token, $request_parameters) {
        $curl = curl_init();
        $general = GeneralSetting::first();
        $client_id = $general->reloadly_id;
        $client_secret = $general->reloadly_secret;
        $mode = $general->reloadly;
        if ($mode == "live") {
            $audience = "https://topups.reloadly.com";
        } else {
            $audience = "https://topups-sandbox.reloadly.com";
        }
        $data = json_encode($request_parameters);
        curl_setopt_array($curl, array(
            CURLOPT_URL => $audience . '/topups',
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_ENCODING => '',
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => 0,
            CURLOPT_FOLLOWLOCATION => true,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST => 'POST',
            CURLOPT_POSTFIELDS => $data,
            CURLOPT_HTTPHEADER => array(
                'Authorization: Bearer ' . $token,
                'Accept: application/com.reloadly.topups-v1+json',
                'Content-Type: application/json'
            ),
        ));

        $response = curl_exec($curl);

        curl_close($curl);
        return $response;
    }

    public function fetch_operators_by_country_iso_code($token, $country) {
        $curl = curl_init();
        $general = GeneralSetting::first();
        $client_id = $general->reloadly_id;
        $client_secret = $general->reloadly_secret;
        $mode = $general->reloadly;
        if ($mode == "live") {
            $audience = "https://topups.reloadly.com";
        } else {
            $audience = "https://topups-sandbox.reloadly.com";
        }
        curl_setopt_array($curl, array(
            CURLOPT_URL => $audience . '/operators/countries/' . $country,
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_ENCODING => '',
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => 0,
            CURLOPT_FOLLOWLOCATION => true,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST => 'GET',
            CURLOPT_HTTPHEADER => array(
                'Authorization: Bearer ' . $token,
                'Accept: application/com.reloadly.topups-v1+json'
            ),
        ));

        $response = curl_exec($curl);

        curl_close($curl);
        return $response;
    }

    public function fetch_operator_by_operator_id($token, $operator) {
        $curl = curl_init();
        $general = GeneralSetting::first();
        $client_id = $general->reloadly_id;
        $client_secret = $general->reloadly_secret;
        $mode = $general->reloadly;
        if ($mode == "live") {
            $audience = "https://topups.reloadly.com";
        } else {
            $audience = "https://topups-sandbox.reloadly.com";
        }
        curl_setopt_array($curl, array(
            CURLOPT_URL => $audience . '/operators/' . $operator . "?suggestedAmounts=true&suggestedAmountsMap=true",
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_ENCODING => '',
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => 0,
            CURLOPT_FOLLOWLOCATION => true,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST => 'GET',
            CURLOPT_HTTPHEADER => array(
                'Authorization: Bearer ' . $token,
                'Accept: application/com.reloadly.topups-v1+json'
            ),
        ));

        $response = curl_exec($curl);

        curl_close($curl);
        return $response;
    }

//Airtime End
//withdraw

    public function withdrawMethods(Request $request) {
        $email = $request->header('email');
        $token = $request->header('token');

        $user = User::where('token', $token)->where('email', $email)->where('status', 1)->first();
        if (!$user) {
            $data = array(
                'code' => 400,
                'result' => 'failure',
                'message' => 'Invalid token / email',
            );
            echo json_encode($data);
            exit;
        }


        $withdrawMethod = WithdrawMethod::where('status', 1)->get(['id', 'name', 'min_limit', 'max_limit', 'delay', 'rate', 'fixed_charge', 'percent_charge', 'currency', 'user_data', 'description']);

        $data = array(
            'code' => 200,
            'result' => 'success',
            'data' => $withdrawMethod,
        );
        echo json_encode($data);
        exit;
    }

    public function withdrawSubmit(Request $request) {
        $email = $request->header('email');
        $token = $request->header('token');
        $general = GeneralSetting::first();
        $user = User::where('token', $token)->where('email', $email)->where('status', 1)->first();
        if (!$user) {
            $data = array(
                'code' => 400,
                'result' => 'failure',
                'message' => 'Invalid token / email',
            );
            echo json_encode($data);
            exit;
        }


        $this->validate($request, [
            'method_code' => 'required',
            'amount' => 'required|numeric'
        ]);
        $method = WithdrawMethod::where('id', $request->method_code)->where('status', 1)->firstOrFail();

        if ($request->amount < $method->min_limit) {
            $data = array(
                'code' => 400,
                'result' => 'failure',
                'message' => 'Your requested amount is smaller than minimum amount.',
            );
            echo json_encode($data);
            exit;
        }
        if ($request->amount > $method->max_limit) {
            $data = array(
                'code' => 400,
                'result' => 'failure',
                'message' => 'Your requested amount is larger than maximum amount.',
            );
            echo json_encode($data);
            exit;
            $notify[] = ['error', 'Your requested amount is larger than maximum amount.'];
            return back()->withNotify($notify);
        }

        if ($request->amount > $user->balance) {
            $data = array(
                'code' => 400,
                'result' => 'failure',
                'message' => 'You do not have sufficient balance for withdraw.',
            );
            echo json_encode($data);
            exit;
            $notify[] = ['error', 'You do not have sufficient balance for withdraw.'];
            return back()->withNotify($notify);
        }

        $charge = $method->fixed_charge + ($request->amount * $method->percent_charge / 100);
        $afterCharge = $request->amount - $charge;
        $finalAmount = $afterCharge * $method->rate;

        $withdraw = new Withdrawal();
        $withdraw->method_id = $method->id; // wallet method ID
        $withdraw->user_id = $user->id;
        $withdraw->amount = $request->amount;
        $withdraw->currency = $method->currency;
        $withdraw->rate = $method->rate;
        $withdraw->charge = $charge;
        $withdraw->final_amount = $finalAmount;
        $withdraw->after_charge = $afterCharge;
        $withdraw->trx = getTrx();
        $withdraw->save();
        session()->put('wtrx', $withdraw->trx);

        $withdraw = Withdrawal::with('method', 'user')->where('trx', session()->get('wtrx'))->where('status', 0)->orderBy('id', 'desc')->firstOrFail();

        $rules = [];
        $inputField = [];
        if ($withdraw->method->user_data != null) {
            foreach ($withdraw->method->user_data as $key => $cus) {
                $rules[$key] = [$cus->validation];
                if ($cus->type == 'file') {
                    array_push($rules[$key], 'image');
                    array_push($rules[$key], new FileTypeValidate(['jpg', 'jpeg', 'png']));
                    array_push($rules[$key], 'max:2048');
                }
                if ($cus->type == 'text') {
                    array_push($rules[$key], 'max:191');
                }
                if ($cus->type == 'textarea') {
                    array_push($rules[$key], 'max:300');
                }
                $inputField[] = $key;
            }
        }

        $this->validate($request, $rules);

        if ($withdraw->amount > $user->balance) {
            $data = array(
                'code' => 400,
                'result' => 'failure',
                'message' => 'You do not have sufficient balance for withdraw.',
            );
            echo json_encode($data);
            exit;
            $notify[] = ['error', 'You do not have sufficient balance for withdraw.'];
            return back()->withNotify($notify);
        }

        $directory = date("Y") . "/" . date("m") . "/" . date("d");
        $path = imagePath()['verify']['withdraw']['path'] . '/' . $directory;
        $collection = collect($request);
        $reqField = [];
        if ($withdraw->method->user_data != null) {
            foreach ($collection as $k => $v) {
                foreach ($withdraw->method->user_data as $inKey => $inVal) {
                    if ($k != $inKey) {
                        continue;
                    } else {
                        if ($inVal->type == 'file') {
                            if ($request->hasFile($inKey)) {
                                try {
                                    $reqField[$inKey] = [
                                        'field_name' => $directory . '/' . uploadImage($request[$inKey], $path),
                                        'type' => $inVal->type,
                                    ];
                                } catch (\Exception $exp) {
                                    $notify[] = ['error', 'Could not upload your ' . $request[$inKey]];
                                    return back()->withNotify($notify)->withInput();
                                }
                            }
                        } else {
                            $reqField[$inKey] = $v;
                            $reqField[$inKey] = [
                                'field_name' => $v,
                                'type' => $inVal->type,
                            ];
                        }
                    }
                }
            }
            $withdraw['withdraw_information'] = $reqField;
        } else {
            $withdraw['withdraw_information'] = null;
        }


        $withdraw->status = 2;
        $withdraw->save();
        $user->balance -= $withdraw->amount;
        $user->save();

        $transaction = new Transaction();
        $transaction->user_id = $withdraw->user_id;
        $transaction->amount = $withdraw->amount;
        $transaction->post_balance = $user->balance;
        $transaction->charge = $withdraw->charge;
        $transaction->trx_type = '-';
        $transaction->details = showAmount($withdraw->final_amount) . ' ' . $withdraw->currency . ' Withdraw Via ' . $withdraw->method->name;
        $transaction->trx = $withdraw->trx;
        $transaction->save();

        $adminNotification = new AdminNotification();
        $adminNotification->user_id = $user->id;
        $adminNotification->title = 'New withdraw request from ' . $user->username;
        $adminNotification->click_url = urlPath('admin.withdraw.details', $withdraw->id);
        $adminNotification->save();

        notify($user, 'WITHDRAW_REQUEST', [
            'method_name' => $withdraw->method->name,
            'method_currency' => $withdraw->currency,
            'method_amount' => showAmount($withdraw->final_amount),
            'amount' => showAmount($withdraw->amount),
            'charge' => showAmount($withdraw->charge),
            'currency' => $general->cur_text,
            'rate' => showAmount($withdraw->rate),
            'trx' => $withdraw->trx,
            'post_balance' => showAmount($user->balance),
            'delay' => $withdraw->method->delay
        ]);

        $data = array(
            'code' => 200,
            'result' => 'success',
            'message' => 'Withdraw request sent successfully',
            'data' => [
                'method_name' => $withdraw->method->name,
                'method_currency' => $withdraw->currency,
                'method_amount' => showAmount($withdraw->final_amount),
                'amount' => showAmount($withdraw->amount),
                'charge' => showAmount($withdraw->charge),
                'currency' => $general->cur_text,
                'rate' => showAmount($withdraw->rate),
                'trx' => $withdraw->trx,
                'post_balance' => showAmount($user->balance),
                'delay' => $withdraw->method->delay
            ]
        );
        echo json_encode($data);
        exit;
    }

    public function plans(Request $request) {
        $email = $request->header('email');
        $token = $request->header('token');
        $general = GeneralSetting::first();
        $user = User::where('token', $token)->where('email', $email)->where('status', 1)->first();
        if (!$user) {
            $data = array(
                'code' => 400,
                'result' => 'failure',
                'message' => 'Invalid token / email',
            );
            echo json_encode($data);
            exit;
        }
        $data = array(
            'code' => 200,
            'result' => 'success',
            'message' => 'Plan List Successful',
        );
        $data['plans'] = Plan::where('status', 1)->get();
        $data['planContent'] = getContent('plan.content', true);
        echo json_encode($data);
        exit;
    }

    public function buyPlan(Request $request) {
        $email = $request->header('email');
        $token = $request->header('token');
        $general = GeneralSetting::first();
        $user = User::where('token', $token)->where('email', $email)->where('status', 1)->first();
        if (!$user) {
            $data = array(
                'code' => 400,
                'result' => 'failure',
                'message' => 'Invalid token / email',
            );
            echo json_encode($data);
            exit;
        }

        $request->validate([
            'amount' => 'required|min:0',
            'plan_id' => 'required',
        ]);

        $gnl = GeneralSetting::first();
        $plan = Plan::where('id', $request->plan_id)->where('status', 1)->first();

        $wallet = 'balance';

        if (!$plan) {
            $data = array(
                'code' => 400,
                'result' => 'failure',
                'message' => 'Invalid Plan',
            );
            echo json_encode($data);
            exit;
            $notify[] = ['error', 'Invalid Plan!'];
            return back()->withNotify($notify);
        }

        if ($plan->fixed_amount == '0') {
            if ($request->amount < $plan->minimum) {
                $data = array(
                    'code' => 400,
                    'result' => 'failure',
                    'message' => 'Minimum Invest ' . getAmount($plan->minimum) . ' ' . $gnl->cur_text,
                );
                echo json_encode($data);
                exit;
                $notify[] = ['error', 'Minimum Invest ' . getAmount($plan->minimum) . ' ' . $gnl->cur_text];
                return back()->withNotify($notify);
            }
            if ($request->amount > $plan->maximum) {
                $data = array(
                    'code' => 400,
                    'result' => 'failure',
                    'message' => 'Maximum Invest ' . getAmount($plan->maximum) . ' ' . $gnl->cur_text,
                );
                echo json_encode($data);
                exit;
                $notify[] = ['error', 'Maximum Invest ' . getAmount($plan->maximum) . ' ' . $gnl->cur_text];
                return back()->withNotify($notify);
            }
        } else {

            if ($request->amount != $plan->fixed_amount) {
                $data = array(
                    'code' => 400,
                    'result' => 'failure',
                    'message' => 'Please Invest must ' . getAmount($plan->fixed_amount) . ' ' . $gnl->cur_text,
                );
                echo json_encode($data);
                exit;
                $notify[] = ['error', 'Please Invest must ' . getAmount($plan->fixed_amount) . ' ' . $gnl->cur_text];
                return back()->withNotify($notify);
            }
        }
        if ($request->amount > $user->$wallet) {
            $data = array(
                'code' => 400,
                'result' => 'failure',
                'message' => 'Insufficient Balance',
            );
            echo json_encode($data);
            exit;
            $notify[] = ['error', 'Insufficient Balance'];
            return back()->withNotify($notify);
        }

        $time_name = TimeSetting::where('time', $plan->times)->first();
        $now = Carbon::now();

        $new_balance = getAmount($user->$wallet - $request->amount);
        $user->$wallet = $new_balance;
        $user->save();

        $baseCurrency = currency()['fiat'];

        $transaction = new Transaction();
        $transaction->user_id = $user->id;
        $transaction->amount = getAmount($request->amount);
        $transaction->charge = 0;
        $transaction->trx_type = '-';
        $transaction->trx = getTrx();
        $transaction->wallet_type = $wallet;
        $transaction->details = 'Invested On ' . $plan->name;
        $transaction->post_balance = getAmount($user->$wallet);
        $transaction->save();

        //start
        if ($plan->interest_status == 1) {
            $interest_amount = ($request->amount * $plan->interest) / 100;
        } else {
            $interest_amount = $plan->interest;
        }
        $period = ($plan->lifetime_status == 1) ? '-1' : $plan->repeat_time;
        //end





        $now = Carbon::now();
        $offDay = (array) $gnl->off_day;
        while (0 == 0) {
            $nextPossible = Carbon::parse($now)->addHours($plan->times)->toDateTimeString();
            $dayName = strtolower(date('D', strtotime($nextPossible)));
            $holiday = Holiday::where('date', date('Y-m-d', strtotime($nextPossible)))->count();
            if (!array_key_exists($dayName, $offDay)) {
                if ($holiday == 0) {
                    $next = $nextPossible;
                    break;
                }
            }
            $now = $nextPossible;
        }


        if ($plan->fixed_amount == 0) {

            if ($plan->minimum <= $request->amount && $plan->maximum >= $request->amount) {

                $invest = new Invest();
                $invest->user_id = $user->id;
                $invest->plan_id = $plan->id;
                $invest->amount = $request->amount;
                $invest->interest = $interest_amount;
                $invest->period = $period;
                $invest->time_name = $time_name->name;
                $invest->hours = $plan->times;
                $invest->next_time = $next;
                $invest->status = 1;
                $invest->capital_status = $plan->capital_back_status;
                $invest->trx = getTrx();
                $invest->save();

                if ($gnl->invest_commission == 1) {
                    $commissionType = 'invest';
                    levelCommission($user->id, $request->amount, $commissionType);
                }

                notify($user, $type = 'INVESTMENT_PURCHASE', [
                    'trx' => $invest->trx,
                    'amount' => getAmount($request->amount),
                    'currency' => $gnl->cur_text,
                    'interest_amount' => $interest_amount,
                ]);

                $adminNotification = new AdminNotification();
                $adminNotification->user_id = $user->id;
                $adminNotification->title = $gnl->cur_sym . $request->amount . ' invested to ' . $plan->name;
                $adminNotification->click_url = urlPath('admin.users.invests', $user->id);
                $adminNotification->save();

                $data = array(
                    'code' => 200,
                    'result' => 'success',
                    'message' => 'Invested Successfully',
                );
                echo json_encode($data);
                exit;
                $notify[] = ['success', 'Invested Successfully'];
                return redirect()->route('user.interest.log')->withNotify($notify);
            }
            $data = array(
                'code' => 400,
                'result' => 'failure',
                'message' => 'Invalid Amount',
            );
            echo json_encode($data);
            exit;
            $notify[] = ['error', 'Invalid Amount'];
            return back()->withNotify($notify);
        } else {
            if ($plan->fixed_amount == $request->amount) {

                $invest = new Invest();
                $invest->user_id = $user->id;
                $invest->plan_id = $plan->id;
                $invest->amount = $request->amount;
                $invest->interest = $interest_amount;
                $invest->period = $period;
                $invest->time_name = $time_name->name;
                $invest->hours = $plan->times;
                $invest->next_time = $next;
                $invest->status = 1;
                $invest->capital_status = $plan->capital_back_status;
                $invest->trx = getTrx();
                $invest->save();

                if ($gnl->invest_commission == 1) {
                    $commissionType = 'invest';
                    levelCommission($user->id, $request->amount, $commissionType);
                }
                notify($user, $type = 'INVESTMENT_PURCHASE', [
                    'trx' => $invest->trx,
                    'amount' => getAmount($request->amount),
                    'currency' => $gnl->cur_text,
                    'interest_amount' => $interest_amount,
                ]);
                $user->save();

                $adminNotification = new AdminNotification();
                $adminNotification->user_id = $user->id;
                $adminNotification->title = $gnl->cur_sym . $request->amount . ' invested to ' . $plan->name;
                $adminNotification->click_url = urlPath('admin.users.invests', $user->id);
                $adminNotification->save();
                $data = array(
                    'code' => 200,
                    'result' => 'success',
                    'message' => 'Invested Successfully',
                );
                echo json_encode($data);
                exit;
                $notify[] = ['success', 'Package Purchased Successfully Complete'];
                return redirect()->route('user.interest.log')->withNotify($notify);
            }
            $data = array(
                'code' => 400,
                'result' => 'failure',
                'message' => 'Something Went Wrong',
            );
            echo json_encode($data);
            exit;
            $notify[] = ['error', 'Something Went Wrong'];
            return back()->withNotify($notify);
        }
    }

    //accept crypto
    public function cryptolist(Request $request) {
        $email = $request->header('email');
        $token = $request->header('token');

        $user = User::where('token', $token)->where('email', $email)->where('status', 1)->first();
        if (!$user) {
            $data = array(
                'result' => 'failure',
                'message' => 'Invalid token / email',
            );
            echo json_encode($data);
            exit;
        }

        $crypto = Crypto::where('status', 1)->get();
        if ($crypto) {
            $data = array(
                'code' => 200,
                'result' => 'success',
                'message' => 'Cryptolist',
                'data' => $crypto
            );
            echo json_encode($data);
            exit;
        } else {
            $data = array(
                'code' => 400,
                'result' => 'error',
                'message' => 'No Crypto active',
            );
            echo json_encode($data);
            exit;
        }
    }

    public function getwalletcrypto(Request $request) {
        $email = $request->header('email');
        $token = $request->header('token');

        $user = User::where('token', $token)->where('email', $email)->where('status', 1)->first();
        if (!$user) {
            $data = array(
                'result' => 'failure',
                'message' => 'Invalid token / email',
            );
            echo json_encode($data);
            exit;
        }

        $validator = Validator::make($request->all(), [
                    'amount' => 'required|numeric|gt:0',
                    'cryptoid' => 'required',
                    'currency' => 'required',
        ]);

        if ($validator->fails()) {
            return response()->json([
                        'code' => 400,
                        'status' => 'error',
                        'message' => ['error' => $validator->errors()->all()],
            ]);
        }
        $crypto = Crypto::where('status', 1)->where('id', $request->cryptoid)->first();
        $wallet = WalletCrypto::where('user_id', $user->id)->where('crypto_id', $request->cryptoid)->first();
        $general = GeneralSetting::first();
        if ($request->currency != $general->cur_text) {
            $frate = Fiat::where('code', $request->currency)->first();

            $rate = $frate->rate;
            $debitamount = $request->amount / $rate;
        } else {

            $debitamount = $request->amount;
        }
        $cryptoamount = showAmount($debitamount / $crypto->rate, 8);

        $data = array(
            'code' => 200,
            'result' => 'success',
            'message' => 'Wallet Address',
            'qrimg' => cryptoQR($wallet->wallet_address),
            'wallet_address' => $wallet->wallet_address,
            'cryptoamount' => $cryptoamount,
            'code' => $crypto->code,
            'name' => $crypto->name
        );
        echo json_encode($data);
        exit;
    }

    public function cryptotrans(Request $request) {
        $email = $request->header('email');
        $token = $request->header('token');

        $user = User::where('token', $token)->where('email', $email)->where('status', 1)->first();
        if (!$user) {
            $data = array(
                'result' => 'failure',
                'message' => 'Invalid token / email',
            );
            echo json_encode($data);
            exit;
        }

        $crypto = Deposit::where('user_id', $user->id)->where('crypto_id', '!=', null)->where('status', 1)->orderBy('id', 'desc')->get();
        if ($crypto) {
            $data = array(
                'code' => 200,
                'result' => 'success',
                'message' => 'Deposit list',
                'merchant_name' => isset($user->company) ? $user->company : $user->firstname,
                'merchant_id' => $user->ewallet_id,
                'merchant_logo' => getImage(imagePath()['profile']['user']['path'] . '/' . @$user->image, imagePath()['profile']['user']['size']),
                'merchant_address' => $user->address,
                'disclaimer' => "I confirm the use of the card and agree to be bound by all agreements governing the issuance and use of the card. I have dont the crypto transactions listed above.",
                'date' => date_format(Carbon::now(), "Y-m-d H:i:s"),
                'data' => $crypto
            );
            echo json_encode($data);
            exit;
        } else {
            $data = array(
                'code' => 400,
                'result' => 'error',
                'message' => 'No Crypto active',
            );
            echo json_encode($data);
            exit;
        }
    }

//    public function sendcrypto(Request $request) {
//        $email = $request->header('email');
//        $token = $request->header('token');
//        $toaddress = $request->toaddress;
//       
//        $general = GeneralSetting::first();
//         $validator = Validator::make($request->all(), [
//                    'amount' => 'required|numeric|gt:0',
//                    'toaddress' => 'required',
//                    'cryptoid' => 'required',
//        ]);
//
//        if ($validator->fails()) {
//            return response()->json([
//                        'code' => 400,
//                        'status' => 'error',
//                        'message' => ['error' => $validator->errors()->all()],
//            ]);
//        }
//        
//        $user = User::where('token', $token)->where('email', $email)->where('status', 1)->first();
//        if (!$user) {
//            $data = array(
//                'result' => 'failure',
//                'message' => 'Invalid token / email',
//            );
//            echo json_encode($data);
//            exit;
//        }
//
//       
//        $crypto = Crypto::where('status', 1)->where('id', $request->cryptoid)->first();
//        $wallet = Wallet::where('user_id', $user->id)->where('crypto_id', $request->cryptoid)->first();
//         $charge = $crypto->wc_fixed + ($request->amount * $crypto->wc_percent / 100);
//        $finalWithdrawAmount = $request->amount + $charge;
//        if($wallet->balance < $finalWithdrawAmount){
//             $data = array(
//                'code' => 400,
//                'result' => 'failure',
//                'message' => 'Insufficient Balance',
//            );
//            echo json_encode($data);
//            exit;
//        }
//        
//         $wallet->balance -= $finalWithdrawAmount;
//        $wallet->save();
//        
//        $cps = new CoinPaymentHosted();
//        $cps->Setup($general->private_key, $general->public_key);
//        $req = array(
//            'amount' => $request->amount,
//            'currency' => $crypto->code,
//            'address' => $toaddress,
//            'auto_confirm' => TRUE,
//            'ipn_url' => ''
//        );
//        $send = $cps->CreateWithdrawal($request->amount, $crypto->code, $toaddress, TRUE,'');
//        
//       
//        if(isset($send['result']['id']) && $send['result']['id']){
//            
//        $withdraw = new Withdrawal();
//        $withdraw->crypto_id = $crypto->id;
//        $withdraw->wallet_address = $toaddress;
//        $withdraw->user_id = $user->id;
//        $withdraw->amount = $finalWithdrawAmount;
//        $withdraw->charge = $charge;
//        $withdraw->payable = $request->amount;
//        $withdraw->trx = getTrx();
//        $withdraw->status = 1;
//        $withdraw->save();
//
//        $transaction = new Transaction();
//        $transaction->user_id = $user->id;
//        $transaction->crypto_id = $crypto->id;
//        $transaction->amount = $finalWithdrawAmount;
//        $transaction->post_balance = $wallet->balance;
//        $transaction->charge = $withdraw->charge;
//        $transaction->trx_type = '-';
//        $transaction->details = showAmount($withdraw->payable,8) . ' ' . $withdraw->crypto->code . ' ATM Withdraw Successful';
//        $transaction->trx =  $withdraw->trx;
//        $transaction->save();
//        $data = array(
//                'code' => 200,
//                'result' => 'Success',
//                'message' => 'ATM Withdrawal Successful',
//                'data' =>[
//                 'txid' => $send['result']['id'],
//                 'toaddress' => $toaddress,
//                 'amount' => $request->amount,
//                 'charge' => $charge,
//                 'merchant_name' => isset($user->company) ? $user->company : $user->firstname,
//                 'merchant_id' => $user->ewallet_id,
//                 'merchant_logo' => getImage(imagePath()['profile']['user']['path'] . '/' . @$user->image, imagePath()['profile']['user']['size']),
//                 'merchant_address' => $user->address,
//                 'disclaimer' => "I confirm to have received the Crypto Currency in my wallet",
//                  'date' => date_format(Carbon::now(), "Y-m-d H:i:s"),
//                  'crypto' => $crypto->name,
//                ]
//            );
//            echo json_encode($data);
//            exit;
//        } else {
//            $wallet->balance += $finalWithdrawAmount;
//        $wallet->save();
//            $data = array(
//                'code' => 400,
//                'result' => 'failure',
//                'message' => 'Error Processing Request - '.json_encode($send),
//            );
//            echo json_encode($data);
//            exit;
//        }
//    }


    public function sendcrypto(Request $request) {
        $email = $request->header('email');
        $token = $request->header('token');
        $toaddress = $request->toaddress;

        $general = GeneralSetting::first();
        $validator = Validator::make($request->all(), [
                    'amount' => 'required|numeric|gt:0',
                    'toaddress' => 'required',
                    'cryptoid' => 'required',
                    'currency' => 'required'
        ]);

        if ($validator->fails()) {
            return response()->json([
                        'code' => 400,
                        'status' => 'error',
                        'message' => ['error' => $validator->errors()->all()],
            ]);
        }

        $user = User::where('token', $token)->where('email', $email)->where('status', 1)->first();
        if (!$user) {
            $data = array(
                'result' => 'failure',
                'message' => 'Invalid token / email',
            );
            echo json_encode($data);
            exit;
        }

        if ($request->currency != $general->cur_text) {
            $frate = Fiat::where('code', $request->currency)->first();

            $rate = $frate->rate;
            $debitamount = $request->amount / $rate;
        } else {

            $debitamount = $request->amount;
        }
        $crypto = Crypto::where('status', 1)->where('id', $request->cryptoid)->first();

        $cryptoamount = showAmount($debitamount / $crypto->rate, 8);

        $wallet = Wallet::where('user_id', $user->id)->where('crypto_id', $request->cryptoid)->first();
        $charge = $crypto->wc_fixed + ($cryptoamount * $crypto->wc_percent / 100);
        if (isset($user->merchant_fee)) {
            $merchantfee = ($cryptoamount * $user->merchant_fee / 100);
        } else {
            $merchantfee = 0;
        }

        $finalWithdrawAmount = $cryptoamount + $charge + $merchantfee;
        if ($wallet->balance < $finalWithdrawAmount) {
            $data = array(
                'code' => 400,
                'result' => 'failure',
                'message' => 'Insufficient Balance',
            );
            echo json_encode($data);
            exit;
        }

        $wallet->balance -= $finalWithdrawAmount;
        $wallet->save();

        $cps = new CoinPaymentHosted();
        $cps->Setup($general->private_key, $general->public_key);
        $req = array(
            'amount' => $request->amount,
            'currency' => $crypto->code,
            'address' => $toaddress,
            'auto_confirm' => TRUE,
            'ipn_url' => ''
        );
        $send = $cps->CreateWithdrawal($cryptoamount, $crypto->code, $toaddress, TRUE, '');

        if (isset($send['result']['id']) && $send['result']['id']) {

            $withdraw = new Withdrawal();
            $withdraw->crypto_id = $crypto->id;
            $withdraw->wallet_address = $toaddress;
            $withdraw->user_id = $user->id;
            $withdraw->amount = $finalWithdrawAmount;
            $withdraw->charge = $charge;
            $withdraw->payable = $cryptoamount;
            $withdraw->trx = getTrx();
            $withdraw->status = 1;
            $withdraw->save();

            $transaction = new Transaction();
            $transaction->user_id = $user->id;
            $transaction->crypto_id = $crypto->id;
            $transaction->amount = $finalWithdrawAmount;
            $transaction->post_balance = $wallet->balance;
            $transaction->charge = $withdraw->charge;
            $transaction->trx_type = '-';
            $transaction->details = showAmount($withdraw->payable, 8) . ' ' . $withdraw->crypto->code . ' ATM Withdraw Successful';
            $transaction->trx = $withdraw->trx;
            $transaction->save();
            $data = array(
                'code' => 200,
                'result' => 'Success',
                'message' => 'ATM Withdrawal Successful',
                'data' => [
                    'txid' => $send['result']['id'],
                    'toaddress' => $toaddress,
                    'currency' => $request->currency,
                    'currencyamount' => $request->amount,
                    'amount' => $cryptoamount,
                    'charge' => $charge,
                    'merchant_name' => isset($user->company) ? $user->company : $user->firstname,
                    'merchant_id' => $user->ewallet_id,
                    'merchant_logo' => getImage(imagePath()['profile']['user']['path'] . '/' . @$user->image, imagePath()['profile']['user']['size']),
                    'merchant_address' => $user->address,
                    'disclaimer' => "I confirm to have received the Crypto Currency in my wallet",
                    'date' => date_format(Carbon::now(), "Y-m-d H:i:s"),
                    'crypto' => $crypto->name,
                ]
            );
            echo json_encode($data);
            exit;
        } else {
            $wallet->balance += $finalWithdrawAmount;
            $wallet->save();
            $data = array(
                'code' => 400,
                'result' => 'failure',
                'message' => 'Error Processing Request - ' . json_encode($send),
            );
            echo json_encode($data);
            exit;
        }
    }

    public function taptopay(Request $request) {
        $email = $request->header('email');
        $token = $request->header('token');

        $user = User::where('token', $token)->where('email', $email)->where('status', 1)->first();
        if (!$user) {
            $data = array(
                'result' => 'failure',
                'message' => 'Invalid token / email',
            );
            echo json_encode($data);
            exit;
        }

        $validator = Validator::make($request->all(), [
                    'cardhash' => 'required',
                    'amount' => 'required|numeric|gt:0',
                    'pin' => 'required|numeric',
                    'cryptoid' => 'required',
                    'currency' => 'required',
        ]);

        if ($validator->fails()) {
            return response()->json([
                        'code' => 400,
                        'status' => 'ok',
                        'message' => ['error' => $validator->errors()->all()],
            ]);
        }

        $cardhash = str_replace('"', '', $request->cardhash);
        $general = GeneralSetting::first();
        $card = Cryptocard::where('card_hash', $cardhash)->where('card_status', "=", "ACT")->first();

        if (!$card) {

            $data = array(
                'code' => 400,
                'result' => 'error',
                'message' => 'Sorry! Invalid Card Number or Card Inactive',
            );
            echo json_encode($data);
            exit;
        }



        if ($card->pin != $request->pin) {
            $data = array(
                'code' => 400,
                'result' => 'error',
                'message' => 'Sorry! Invalid Pin',
            );
            echo json_encode($data);
            exit;
        }

        $carduser = User::where('id', $card->user_id)->first();

        $sender = WalletCrypto::where('user_id', $carduser->id)->where('crypto_id', $request->cryptoid)->first();

        $receiver = WalletCrypto::where('user_id', $user->id)->where('crypto_id', $request->cryptoid)->first();

        $escrowcrypto = Crypto::where('id', $request->cryptoid)->first();
        if (!isset($sender->id)) {
            $data = array(
                'code' => 400,
                'result' => 'error',
                'message' => 'Sorry! User Does Not Have That Crypto Currency Wallet' . $request->cryptoid,
            );
            echo json_encode($data);
            exit;
        }

        if (!isset($receiver->id)) {
            $data = array(
                'code' => 400,
                'result' => 'error',
                'message' => 'Sorry! Merchant Does Not Have That Crypto Currency Wallet' . $request->cryptoid,
            );
            echo json_encode($data);
            exit;
        }

        $cryptorate = $escrowcrypto->rate;

        if ($request->currency == $general->cur_text) {
            $fiatamount = $request->amount;
        } else {
            $frate = Fiat::where('code', $request->currency)->first();

            $rate = $frate->rate;
            $fiatamount = $request->amount / $rate;
        }
        $senderamount = round(($fiatamount / $cryptorate), 8);

        $fee = $general->cryptomerch_fee;
        $feeamount = round(($senderamount * $fee / 100), 8);

        $merchantamount = round(($senderamount - $feeamount), 8);

        $senderwallet = Wallet::where('user_id', $carduser->id)->where('crypto_id', $request->cryptoid)->first();
        $merchantwallet = Wallet::where('user_id', $user->id)->where('crypto_id', $request->cryptoid)->first();

        if ($escrowcrypto->erc20 == true || $escrowcrypto->bep20 == true) {
            $t = new Tatum();
            $senderbalance = $t->vabalance($sender->customerid);

            if ($senderbalance->balance->availableBalance < $senderamount) {
                $data = array(
                    'code' => 400,
                    'result' => 'error',
                    'message' => 'Card Crypto Balance Insufficient ' . $senderbalance->balance->availableBalance,
                );
                echo json_encode($data);
                Log::info(json_encode($data));
                exit;
            }
            $senders = $t->sendpayment($sender->customerid, $escrowcrypto->mastervaid, $senderamount);
            $merchants = $t->sendpayment($escrowcrypto->mastervaid, $receiver->customerid, $merchantamount);
        } else {

            if ($senderwallet->balance < number_format($senderamount, 8)) {
                $data = array(
                    'code' => 400,
                    'result' => 'error',
                    'message' => 'Card Crypto Balance Insufficient',
                );
                echo json_encode($data);
                Log::info(json_encode($data));
                exit;
            }
        }

        $senderwallet->balance -= $senderamount;
        $senderwallet->save();

        $transaction = new Transaction();
        $transaction->user_id = $carduser->id;
        $transaction->crypto_id = $request->cryptoid;
        $transaction->amount = $senderamount;
        $transaction->post_balance = $senderwallet->balance;
        $transaction->charge = 0;
        $transaction->trx_type = '-';
        $transaction->details = 'Crypto Card Usage ' . $user->email;
        $transaction->trx = getTrx();
        $transaction->save();

        notify($carduser, 'CARD_TRANS', [
            'amount' => $senderamount,
            'charge' => "0",
            'currency' => $escrowcrypto->name,
            'trx' => $transaction->trx,
            'post_balance' => $senderwallet->balance,
            'merchant_name' => isset($user->company) ? $user->company : $user->email,
        ]);
        if ($escrowcrypto->erc20 != true || $escrowcrypto->bep20 != true) {
            $t = new Tatum();
            $merchantbalance = $t->vabalance($receiver->customerid);

            $merchantwallet->balance += $merchantamount;
            $merchantwallet->save();
        }

        if ($escrowcrypto->erc20 == true || $escrowcrypto->bep20 == true) {
            $t = new Tatum();
            $merchantbalance = $t->vabalance($receiver->customerid);
        }

        $mtransaction = new Transaction();
        $mtransaction->user_id = $user->id;
        $mtransaction->crypto_id = $request->cryptoid;
        $mtransaction->amount = $merchantamount;
        $mtransaction->post_balance = isset($merchantbalance->balance->availableBalance) ? $merchantbalance->balance->availableBalance : 0;
        $mtransaction->charge = round($feeamount, 2);
        $mtransaction->trx_type = '+';
        $mtransaction->details = 'Crypto Card Payment Received From ' . $carduser->email;
        $mtransaction->trx = getTrx();
        $mtransaction->save();

        $data = array(
            'code' => 200,
            'result' => 'success',
            'message' => 'Transaction Successful',
            'data' => array(
                'cryptoamount' => $transaction->amount,
                'txid' => $transaction->trx,
                'crypto' => $escrowcrypto->name,
                'fiatamount' => $request->amount,
                'currency' => $request->currency,
                'card_masked' => $card->masked_pan,
                'name_on_card' => $card->name_on_card,
                'card_type' => "Crypto Card",
                'merchant_name' => isset($user->company) ? $user->company : $user->email,
                'merchant_id' => $user->ewallet_id,
                'merchant_logo' => getImage(imagePath()['profile']['user']['path'] . '/' . @$user->image, imagePath()['profile']['user']['size']),
                'merchant_address' => $user->address,
                'disclaimer' => "I confirm the use of the crypto card and agree to be bound by all agreements governing the issuance and use of the card. I shall pay the above Total Amount.",
                'date' => date_format(Carbon::now(), "Y-m-d H:i:s")
            )
        );
        echo json_encode($data);
        exit;
    }

    public function fincollect(Request $request) {
        $event = $request->event;
        $general = GeneralSetting::first();

        if ($even == "collection.successful") {
            $c = new Fincralib();
            $cur = $c->getaccount($request->data->virtualAccount);
            $user = User::where('email', $cur->data->KYCInformation->email)->firstorfail();
            if ($user->id) {
                $currency = $request->data->destinationCurrency;
                $amount = $request->data->amountReceived;
                $fees = $request->data->fee;

                if ($currency != $general->cur_text) {
                    $frate = Fiat::where('code', $currency)->first();

                    $rate = $frate->rate;
                    $creditamount = round($amount / $rate);
                    $creditfees = round($fees / $rate);
                } else {

                    $creditamount = round($amount);
                    $creditfees = round($fees);
                }

                $user->balance += $creditamount;
                $user->save();

                $mtransaction = new Transaction();
                $mtransaction->user_id = $user->id;

                $mtransaction->amount = $creditamount;
                $mtransaction->post_balance = $user->balance;
                $mtransaction->charge = $creditfees;
                $mtransaction->trx_type = '+';
                $mtransaction->details = 'Bank Credit Received in ' . $currency . ' ' . $creditamount . 'FX: ' . $rate;
                $mtransaction->trx = getTrx();
                $mtransaction->save();
            }
        }
    }

//DPS STARTS HERE

    public function dpsplans(Request $request) {
        $email = $request->header('email');
        $token = $request->header('token');
        $general = GeneralSetting::first();
        $user = User::where('token', $token)->where('email', $email)->where('status', 1)->first();
        if (!$user) {
            $data = array(
                'code' => 400,
                'result' => 'failure',
                'message' => 'Invalid token / email',
            );
            echo json_encode($data);
            exit;
        }

        $data = array(
            'code' => 200,
            'result' => 'success',
            'message' => 'DPS Plan List Successful',
        );
        $data['dps'] = DpsPlan::active()->latest()->get();
        echo json_encode($data);
        exit;
    }

    public function dpsList(Request $request) {

        $email = $request->header('email');
        $token = $request->header('token');
        $general = GeneralSetting::first();
        $user = User::where('token', $token)->where('email', $email)->where('status', 1)->first();
        if (!$user) {
            $data = array(
                'code' => 400,
                'result' => 'failure',
                'message' => 'Invalid token / email',
            );
            echo json_encode($data);
            exit;
        }
        $data = array(
            'code' => 200,
            'result' => 'success',
            'message' => 'DPS Plan List Successful',
        );
        $data['userdps'] = UserDps::where('user_id', $user->id)->with('plan')->get();
        echo json_encode($data);
        exit;
    }

    public function dpsBuy(Request $request) {
        $email = $request->header('email');
        $token = $request->header('token');

        $general = GeneralSetting::first();
        $user = User::where('token', $token)->where('email', $email)->where('status', 1)->first();
        if (!$user) {
            $data = array(
                'code' => 400,
                'result' => 'failure',
                'message' => 'Invalid token / email',
            );
            echo json_encode($data);
            exit;
        }


        $validator = Validator::make(request()->all(), [
                    'planid' => 'required',
        ]);

        if ($validator->fails()) {
            return response()->json([
                        'code' => '400',
                        'errors' => $validator->errors(),
            ]);
        }



        $plan = DpsPlan::active()->where('id', $request->planid)->first();

        if (!isset($plan->id)) {
            $data = array(
                'code' => 400,
                'result' => 'failure',
                'message' => 'Plan ID Not Found',
            );
            echo json_encode($data);
            exit;
        }

        $amount = $plan->per_installment + 0;

        //Check user balance
        if ($user->balance < $amount) {
            $data = array(
                'code' => 400,
                'result' => 'failure',
                'message' => 'Insufficient Balance in wallet',
            );
            echo json_encode($data);
            exit;
        }

        $userDps = new UserDps();

        $userDps->user_id = $user->id;
        $userDps->plan_id = $plan->id;
        $userDps->trx = getTrx();
        $userDps->interest_rate = $plan->interest_rate;
        $userDps->per_installment = $plan->per_installment;
        $userDps->total_installment = $plan->total_installment;
        $userDps->given_installment = 1;
        $userDps->installment_interval = $plan->installment_interval;
        $userDps->next_installment_date = Carbon::now()->addDays($plan->installment_interval + 1);
        $userDps->save();

        $user->balance -= $plan->per_installment;
        $user->save();

        $log = new InstallmentLog();
        $log->f_id = $userDps->id;
        $log->type = 'DPS';
        $log->amount = $userDps->per_installment;
        $log->save();

        $transaction = new Transaction();
        $transaction->user_id = $user->id;
        $transaction->amount = $plan->per_installment;
        $transaction->post_balance = $user->balance;
        $transaction->charge = 0;
        $transaction->trx_type = '-';
        $transaction->details = 'DPS Installment Given';
        $transaction->trx = $userDps->trx;
        $transaction->save();

        $general = GeneralSetting::first();

        $adminNotification = new AdminNotification();
        $adminNotification->user_id = $user->id;
        $adminNotification->title = 'A new DPS has been opened by ' . $user->username;
        $adminNotification->click_url = urlPath('admin.users.dps', $user->id);
        $adminNotification->save();

        $shortCodes = [
            'plan_name' => $plan->name,
            'trx' => $userDps->trx,
            'per_installment' => showAmount($plan->per_installment),
            'interest_interval' => showAmount($plan->installment_interval),
            'interest_rate' => $plan->interest_rate,
            'given_installment' => 1,
            'total_installment' => $plan->total_installment,
            'next_installment_date' => $userDps->next_installment_date,
        ];

        notify($user, 'OPEN_DPS', $shortCodes);

        $data = array(
            'code' => 200,
            'result' => 'success',
            'message' => 'DPS buy  Successful',
        );
        echo json_encode($data);
        exit;
    }

//DPS ENDS HERE
//FDR STARTS HERE
    public function fdrPlans(Request $request) {
        $email = $request->header('email');
        $token = $request->header('token');
        $general = GeneralSetting::first();
        $user = User::where('token', $token)->where('email', $email)->where('status', 1)->first();
        if (!$user) {
            $data = array(
                'code' => 400,
                'result' => 'failure',
                'message' => 'Invalid token / email',
            );
            echo json_encode($data);
            exit;
        }
        $data = array(
            'code' => 200,
            'result' => 'success',
            'message' => 'FDR Plans',
        );
        $data['fdr'] = FdrPlan::active()->latest()->get();
        echo json_encode($data);
        exit;
    }

    public function fdrList(Request $request) {
        $email = $request->header('email');
        $token = $request->header('token');
        $general = GeneralSetting::first();
        $user = User::where('token', $token)->where('email', $email)->where('status', 1)->first();
        if (!$user) {
            $data = array(
                'code' => 400,
                'result' => 'failure',
                'message' => 'Invalid token / email',
            );
            echo json_encode($data);
            exit;
        }
        $data = array(
            'code' => 200,
            'result' => 'success',
            'message' => 'FDR Plan List Successful',
        );
        $data['userfdr'] = UserFdr::where('user_id', $user->id)->with('plan')->get();
        echo json_encode($data);
        exit;
    }

 public function fdrBuy(Request $request)
    {
        $email = $request->header('email');
        $token = $request->header('token');


        $general = GeneralSetting::first();
        $user = User::where('token', $token)->where('email', $email)->where('status', 1)->first();
        if (!$user) {
            $data = array(
                'code' => 400,
                'result' => 'failure',
                'message' => 'Invalid token / email',
            );
            echo json_encode($data);
            exit;
        }
        $validator = Validator::make(request()->all(), [

            'planid' => 'required',
            'amount' => 'required|min:0',

        ]);

        if ($validator->fails()) {
            return response()->json([
                'code' => '400',
                'errors' => $validator->errors(),

            ]);
        }
        $plan    = FdrPlan::active()->where('id', $request->planid)->first();

        if (!isset($plan->id)) {
            $data = array(
                'code' => 400,
                'result' => 'failure',
                'message' => 'Plan ID Not Found',
            );
            echo json_encode($data);
            exit;
        }

        $amount = $request->amount;
        if ($amount < $plan->minimum_amount) {
            $data = array(
                'code' => 400,
                'result' => 'failure',
                'message' => 'minimum amount',
            );
            echo json_encode($data);
            exit;
        } elseif ($amount > $plan->maximum_amount) {
            $data = array(
                'code' => 400,
                'result' => 'failure',
                'message' => 'maximinum amount',
            );
            echo json_encode($data);
            exit;
        }

        //Check user balance
        if ($user->balance < $amount) {
            $data = array(
                'code' => 400,
                'result' => 'failure',
                'message' => 'Insufficient Balance in wallet',
            );
            echo json_encode($data);
            exit;
        }
        $userFdr = new UserFdr();

        $userFdr->user_id            = $user->id;
        $userFdr->plan_id            = $plan->id;
        $userFdr->trx                = getTrx();
        $userFdr->amount             = $amount;
        $userFdr->interest           = getAmount($amount * $plan->interest_rate / 100);
        $userFdr->interest_interval  = $plan->interest_interval;
        $userFdr->next_return_date   = Carbon::now()->addDays($plan->interest_interval + 1);
        $userFdr->locked_date        = Carbon::now()->addDays($plan->locked_days);
        $userFdr->save();

        $user->balance -= $amount;
        $user->save();

        $transaction = new Transaction();
        $transaction->user_id       = $user->id;
        $transaction->amount        = $amount;
        $transaction->post_balance  = $user->balance;
        $transaction->charge        = 0;
        $transaction->trx_type      = '-';
        $transaction->details       = 'New FDR Opened';
        $transaction->trx           =  $userFdr->trx;
        $transaction->save();
        $transaction->save();

        $adminNotification = new AdminNotification();
        $adminNotification->user_id = $user->id;
        $adminNotification->title = 'A new FDR has been opened by ' . $user->username;
        $adminNotification->click_url = urlPath('admin.users.fdr', $user->id);
        $adminNotification->save();

        $shortCodes = [
            'plan_name'         => $plan->name,
            'trx'               => $userFdr->trx,
            'amount'            => showAmount($amount),
            'locked_date'       => $userFdr->locked_date,
            'interest'          => $userFdr->interest,
            'interest_interval' => $userFdr->interest_interval,
            'next_return_date'  => $userFdr->next_return_date,
        ];

        notify($user, 'OPEN_FDR', $shortCodes);
        $data = array(
            'code' => 200,
            'result' => 'success',
            'message' => 'FDR buy Successful',
        );
        echo json_encode($data);
        exit;
    }
    public function fdrClose(Request $request)
    {

        $email = $request->header('email');
        $token = $request->header('token');


        $general = GeneralSetting::first();
        $user = User::where('token', $token)->where('email', $email)->where('status', 1)->first();
        if (!$user) {
            $data = array(
                'code' => 400,
                'result' => 'failure',
                'message' => 'Invalid token / email',
            );
            echo json_encode($data);
            exit;
        }

        $request->validate([
            'myplanid' => 'required'
        ]);

        $fdr = UserFdr::where('id', $request->myplanid)->where('status', 1)->where('user_id', $user->id)->first();


        if ($fdr->locked_date > Carbon::now()) {
            $data = array(
                'code' => 400,
                'result' => 'failure',
                'message' => 'Sorry! You cant close this FDR before' . showDateTime($fdr->locked_date, 'd M, Y'),
            );
            echo json_encode($data);
            exit;
        }

        $general = GeneralSetting::first();
        $user = auth()->user();
        $user->balance += $fdr->amount;
        $user->save();

        $fdr->status = 2;
        $fdr->save();

        $transaction                = new Transaction();
        $transaction->user_id       = $user->id;
        $transaction->amount        = $fdr->amount;
        $transaction->post_balance  = $user->balance;
        $transaction->charge        = 0;
        $transaction->trx_type      = '+';
        $transaction->details       = 'Received main amount of FDR';
        $transaction->trx           = getTrx();
        $transaction->save();


        $adminNotification = new AdminNotification();
        $adminNotification->user_id = $user->id;
        $adminNotification->title = 'An FDR has been closed by ' . $user->username;
        $adminNotification->click_url = urlPath('admin.users.fdr', $user->id);
        $adminNotification->save();

        notify($user, 'FDR_CLOSED', [
            "fdr_number"    => $fdr->trx,
            "amount"        => showAmount($fdr->amount),
            "profit"        => showAmount($fdr->profit),
            "interest"      => showAmount($fdr->interest),
            "trx"           => $transaction->trx,
            "currency"      => $general->cur_text,
            "plan_name"     => $fdr->plan->name,
            "post_balance"  => showAmount($user->balance),
        ]);

        $data = array(
            'code' => 200,
            'result' => 'success',
            'message' => 'FDR closed successfully',
        );
        echo json_encode($data);
        exit;
    }
    //FDR ENDS HERE
//LOAN STARTS HERE
    public function loanPlans(Request $request) {
        $email = $request->header('email');
        $token = $request->header('token');
        $general = GeneralSetting::first();
        $user = User::where('token', $token)->where('email', $email)->where('status', 1)->first();
        if (!$user) {
            $data = array(
                'code' => 400,
                'result' => 'failure',
                'message' => 'Invalid token / email',
            );
            echo json_encode($data);
            exit;
        }
        $data = array(
            'code' => 200,
            'result' => 'success',
            'message' => 'LOAN Plan List Successful',
        );
        $data['loan'] = LoanPlan::active()->latest()->get();
        echo json_encode($data);
        exit;
    }

    public function loanList(Request $request) {
        $email = $request->header('email');
        $token = $request->header('token');
        $general = GeneralSetting::first();
        $user = User::where('token', $token)->where('email', $email)->where('status', 1)->first();
        if (!$user) {
            $data = array(
                'code' => 400,
                'result' => 'failure',
                'message' => 'Invalid token / email',
            );
            echo json_encode($data);
            exit;
        }
        $data = array(
            'code' => 200,
            'result' => 'success',
            'message' => ' LOAN Plan List Successful',
        );
        $data['userloan'] = UserLoan::where('user_id', $user->id)->with('plan')->get();
        echo json_encode($data);
        exit;
    }

//LOAN END HERE
    
     //VIRTUAL NUMBER WEBHOOK
    public function receivesms(Request $request){

        $json = $request->json()->all();
       
        $vn = Virtualnumber::where('msisdn', $request->to)->with('plan')->first();

        if(isset($vn->user_id)){
            $created = $vn->created_at;
        $start = $vn->created_at->subDays(30);
        $smscount = Incomingsms::where('user_id', $vn->user_id)->where('tonumber', $s->to)->whereBetween('created_at', [$start,$created])->count();
         
        $today = date_format(Carbon::now(),"Y-m-d H:i:s");
        if($today > $vn->created_at){
              http_response_code(400);
            echo "error";
        }else {

            if ($smscount > $vn->plan->messages) {
                $user = User::where('id', $vn->user_id)->first();
                $user->balance -= $vn->plan->addmessages;
                $user->save();
            }

            $update = Incomingsms::where('message_id',$request->messageId)->firstorNew();
            $update->fromnumber = $request->msisdn;
            $update->tonumber = $request->to;
            $update->text = $request->text;
            $update->user_id = $vn->user_id;
            $update->timestamp = $request->timestamp;
            $update->message_id = $request->messageId;
            $update->json = json_encode($json);
            $update->save();
    http_response_code(200);
            echo "success";
        }
        }
    }
    
    public function getpoints(Request $request){
         $email = $request->header('email');
        $token = $request->header('token');
        $general = GeneralSetting::first();
        $user = User::where('token', $token)->where('email', $email)->where('status', 1)->first();
        if (!$user) {
            $data = array(
                'code' => 400,
                'result' => 'failure',
                'message' => 'Invalid token / email',
            );
            echo json_encode($data);
            exit;
        }
         if($general->points){
        $logs  = Points::where('user_id', $user->id)->get();
        
         http_response_code(200);
         $data = array(
            'code' => 200,
            'result' => 'success',
            'message' => 'Points Fetched',
             'data' => [
               "referalusername" => $user->username,
                "url" => route('home').'?reference='.$user->username,
               "balance" => $user->point_balance,
                 "signup_bonus" => $general->signup_bonus,
                "min_required" => $general->redeem_minpoints,
                "redemption_percent" => $general->redeem_perpoints,
                 "crypto_percent" => $general->crypto_perpoints,
                 "fiat_percent" => $general->fiat_perpoints,
                "transactions" => $logs 
             ],
        );
        
        echo json_encode($data);
       exit;
         } else {
             http_response_code(400);
             $data = array(
                'code' => 400,
                'result' => 'failure',
                'message' => 'Points System Is Currently Not Supported',
            );
            echo json_encode($data);
            exit;
         }
    }
    
    
    public function redeempoints(Request $request){
         $email = $request->header('email');
        $token = $request->header('token');
        $general = GeneralSetting::first();
        $user = User::where('token', $token)->where('email', $email)->where('status', 1)->first();
        if (!$user) {
            $data = array(
                'code' => 400,
                'result' => 'failure',
                'message' => 'Invalid token / email',
            );
            echo json_encode($data);
            exit;
        }
        
        
        
        
         if($general->points){
        $redeem = $user->point_balance * $general->redeem_perpoints / 100;
        $pointsr = $user->point_balance;
        
        if($general->redeem_minpoints > $user->point_balance){
             http_response_code(400);
         $data = array(
            'code' => 400,
            'result' => 'error',
            'message' => 'Not Enough Points To Redeem',
             
        );
        
        echo json_encode($data);
       exit;
              
        }
        
        $user->balance += $redeem;
        $user->point_balance -= $pointsr;
        $user->save();
        $trx = getTrx();
        
        $points = new Points();
        $points->user_id = $user->id;
        $points->amount = $pointsr;
        $points->post_balance = $user->point_balance;
        $points->charge = "0";
        $points->trx_type = '-';
        $points->details = 'Points Redeemed';
        $points->trx = $trx;
        $points->save();
       
        $transaction = new Transaction();
        $transaction->user_id = $user->id;
        $transaction->amount = $redeem;
        $transaction->post_balance = $user->balance;
        $transaction->charge = "0";
        $transaction->trx_type = '+';
        $transaction->details = 'Points Redeemed';
        $transaction->trx =  $trx;
        $transaction->save();
         http_response_code(200);
         $data = array(
            'code' => 200,
            'result' => 'success',
            'message' => 'Points Redeemed successfully',
             
        );
        
        echo json_encode($data);
       exit;
        
      
         } else {
             http_response_code(400);
             $data = array(
                'code' => 400,
                'result' => 'failure',
                'message' => 'Points System Is Currently Not Supported',
            );
            echo json_encode($data);
            exit;
         }
    }
    
    
    public function virtualnumberplans(Request $request){
       $email = $request->header('email');
        $token = $request->header('token');
        $general = GeneralSetting::first();
        $user = User::where('token', $token)->where('email', $email)->where('status', 1)->first();
        if (!$user) {
            $data = array(
                'code' => 400,
                'result' => 'failure',
                'message' => 'Invalid token / email',
            );
            echo json_encode($data);
            exit;
        }

         $vnplans = Vnplans::get();

          http_response_code(200);
         $data = array(
            'code' => 200,
            'result' => 'success',
            'message' => 'Virtual Number Plans',
             'data'=> $vnplans,

        );

        echo json_encode($data);
       exit;
    }


    public function vpchoose(Request $request){
        $email = $request->header('email');
        $token = $request->header('token');
        $general = GeneralSetting::first();
        $user = User::where('token', $token)->where('email', $email)->where('status', 1)->first();
        if (!$user) {
            $data = array(
                'code' => 400,
                'result' => 'failure',
                'message' => 'Invalid token / email',
            );
            echo json_encode($data);
            exit;
        }
        $validator = Validator::make(request()->all(), [

            'country' => 'required',


        ]);

        if ($validator->fails()) {
            return response()->json([
                'code' => '400',
                'errors' => $validator->errors(),

            ]);
        }
         $v = new Vonage();
    $numbers = $v->getnumbers($request->country);

     http_response_code(200);
         $data = array(
            'code' => 200,
            'result' => 'success',
            'message' => 'Virtual Number List',
             'data'=> $numbers,

        );

        echo json_encode($data);
       exit;

    }


    public function buynumberplans(Request $request){
         $email = $request->header('email');
        $token = $request->header('token');
        $general = GeneralSetting::first();
        $user = User::where('token', $token)->where('email', $email)->where('status', 1)->first();
        if (!$user) {
            $data = array(
                'code' => 400,
                'result' => 'failure',
                'message' => 'Invalid token / email',
            );
            echo json_encode($data);
            exit;
        }

         $validator = Validator::make(request()->all(), [

        'country'          => 'required',
        'planid'          => 'required',
        'msisdn'          => 'required',


        ]);

        if ($validator->fails()) {
            return response()->json([
                'code' => '400',
                'errors' => $validator->errors(),

            ]);
        }

        $id = $request->planid;
    $country = $request->country;
     $msisdn = $request->msisdn;
     $vnplans = Vnplans::where('id',$id)->first();
    
      $v = new Vonage();
    if($vnplans->price > $user->balance){

         http_response_code(200);
         $data = array(
            'code' => 400,
            'result' => 'error',
            'message' => 'Insufficient balance to complete purchase',


        );

        echo json_encode($data);
       exit;


    }
    $user->balance -= $vnplans->price;
    $user->save();
    $b = $v->buynumbers($msisdn,$country);

    $errorcode = $b->error_code;


   if(isset($errorcode) && $errorcode == "200"){

    $itransaction = new Transaction();
    $itransaction->user_id = $user->id;
    $itransaction->amount = $vnplans->price;
    $itransaction->charge = 0;
    $itransaction->trx_type = '-';
    $itransaction->trx = getTrx();
    $itransaction->details = 'Virtual Phone Number Purchase '.$msisdn;
    $itransaction->post_balance = $user->balance;
    $itransaction->save();

    $update = new Virtualnumber();
    $update->user_id = $user->id;
    $update->msisdn = $msisdn;
    $update->country = $country;
    $update->plan_id = $vnplans->id;
    $update->created_at = Carbon::now()->addDays(30);
    $update->save();

      http_response_code(200);
         $data = array(
            'code' => 200,
            'result' => 'success',
            'message' => 'Virtual Phone Number Purchase Success',


        );

        echo json_encode($data);
       exit;

    } else {

        $user->balance += $vnplans->price;
        $user->save();
        $itransaction = new Transaction();
        $itransaction->user_id = $user->id;
        $itransaction->amount = $vnplans->price;
        $itransaction->charge = 0;
        $itransaction->trx_type = '+';
        $itransaction->trx = getTrx();
        $itransaction->details = 'Reversal For Virtual Phone Number Purchase '.$msisdn;
        $itransaction->post_balance = $user->balance;
        $itransaction->save();


         http_response_code(200);
         $data = array(
            'code' => 400,
            'result' => 'error',
            'message' => 'Error Completing Purchase at this time, Try later',


        );

        echo json_encode($data);
       exit;



    }



    }

    public function virtualgetsms(Request $request){

          $email = $request->header('email');
        $token = $request->header('token');
        $general = GeneralSetting::first();
        $user = User::where('token', $token)->where('email', $email)->where('status', 1)->first();
        if (!$user) {
            $data = array(
                'code' => 400,
                'result' => 'failure',
                'message' => 'Invalid token / email',
            );
            echo json_encode($data);
            exit;
        }

         $vnplans = Virtualnumber::where('user_id', $user->id)->with('plan')->get();
    $sms = Incomingsms::where('user_id', $user->id)->latest()->get();

     http_response_code(200);
         $data = array(
            'code' => 200,
            'result' => 'success',
            'message' => 'Virtual Phone SMS retrieved',
             'data' => [
                 'numbers' => $vnplans,
                 'incomingsms' => $sms
             ],


        );

        echo json_encode($data);
       exit;



    }


    public function cancelvirtual(Request $request){
           $email = $request->header('email');
        $token = $request->header('token');
        $general = GeneralSetting::first();
        $user = User::where('token', $token)->where('email', $email)->where('status', 1)->first();
        if (!$user) {
            $data = array(
                'code' => 400,
                'result' => 'failure',
                'message' => 'Invalid token / email',
            );
            echo json_encode($data);
            exit;
        }
         $validator = Validator::make(request()->all(), [

        'msisdn'          => 'required',



        ]);

        if ($validator->fails()) {
            return response()->json([
                'code' => '400',
                'errors' => $validator->errors(),

            ]);
        }
        $msisdn = $request->msisdn;

    $vnplans = Virtualnumber::where('user_id', $user->id)->where('msisdn',$msisdn)->first();
    $v = new Vonage();
    $cancel = $v->cancelnumbers($msisdn,$vnplans->country);
    $errorcode = $cancel->error_code;
    if(isset($errorcode) && $errorcode == "200"){
        Virtualnumber::where('user_id', $user->id)->where('msisdn',$msisdn)->delete();
        Incomingsms::where('user_id', $user->id)->where('tonumber',$msisdn)->delete();
         http_response_code(200);
         $data = array(
                'code' => 200,
                'result' => 'success',
                'message' => 'Virtual Phone Number Cancelled',
            );
            echo json_encode($data);
            exit;

    }
     http_response_code(400);
    $data = array(
                'code' => 400,
                'result' => 'failure',
                'message' => 'Error Cancelling Number, Try later',
            );
            echo json_encode($data);
            exit;



    }

    public function vprenew(Request $request){

             $email = $request->header('email');
        $token = $request->header('token');
        $general = GeneralSetting::first();
        $user = User::where('token', $token)->where('email', $email)->where('status', 1)->first();
        if (!$user) {
            $data = array(
                'code' => 400,
                'result' => 'failure',
                'message' => 'Invalid token / email',
            );
            echo json_encode($data);
            exit;
        }
         $validator = Validator::make(request()->all(), [

        'msisdn'          => 'required',



        ]);

        if ($validator->fails()) {
            return response()->json([
                'code' => '400',
                'errors' => $validator->errors(),

            ]);
        }
        $msisdn = $request->msisdn;

        $vnplans = Virtualnumber::where('user_id', $user->id)->where('msisdn',$msisdn)->with('plan')->first();
    $plandate = $vnplans->created_at;
    if($vnplans->plan->price > $user->balance){

        http_response_code(400);
    $data = array(
                'code' => 400,
                'result' => 'failure',
                'message' => 'Insufficient balance to complete purchase',
            );
            echo json_encode($data);
            exit;
        $notify[] = ['error', 'Insufficient balance to complete purchase'];
        return back()->withNotify($notify);
    }
    $user->balance -= $vnplans->plan->price;
    $user->save();
    $itransaction = new Transaction();
    $itransaction->user_id = $user->id;
    $itransaction->amount = $vnplans->plan->price;
    $itransaction->charge = 0;
    $itransaction->trx_type = '-';
    $itransaction->trx = getTrx();
    $itransaction->details = 'Virtual Phone Number Purchase '.$msisdn;
    $itransaction->post_balance = $user->balance;
    $itransaction->save();

    $vnplans->created_at = $plandate->addDays(30);
    $vnplans->save();


    http_response_code(200);
         $data = array(
                'code' => 200,
                'result' => 'success',
                'message' => 'Virtual Phone Number renewed',
            );
            echo json_encode($data);
            exit;

    }
    
  //giftcardAPI
    public function getAccessToken()
    {
        sleep(3);
        $curl = curl_init();
        $general = GeneralSetting::first();
        $client_id = $general->reloadly_id;
        $client_secret = $general->reloadly_secret;
        $mode = $general->reloadly;
        $audience = ($mode == "live") ? "https://giftcards.reloadly.com" : "https://giftcards-sandbox.reloadly.com";

        curl_setopt_array($curl, [
            CURLOPT_URL => "https://auth.reloadly.com/oauth/token",
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_ENCODING => "",
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => 30,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST => "POST",
            CURLOPT_POSTFIELDS => '{
            "client_id":"' . $client_id . '",
            "client_secret":"' . $client_secret . '",
            "grant_type":"client_credentials",
            "audience":"' . $audience . '"}',
            CURLOPT_HTTPHEADER => [
                'Content-Type: application/json'
            ],
        ]);

        $response = curl_exec($curl);

        if ($response === false) {
            $error = curl_error($curl);
            // Handle the cURL error, log it, or return an appropriate response
            return $error;
        }

        $resp = json_decode($response);

        if (json_last_error() !== JSON_ERROR_NONE) {
            // Handle JSON decoding error, log it, or return an appropriate response
            return 'JSON decoding error: ' . json_last_error_msg();
        }

        if (!isset($resp->access_token)) {
            // Handle the case where the access_token property is not present
            return 'Access token not found in the response';
        }

        curl_close($curl);

        return $resp->access_token;
    }

    public function get_gift_card_Countries()
    {
        $accessToken = $this->getAccessToken();


        $curl = curl_init();
        $general = GeneralSetting::first();
        $client_id = $general->reloadly_id;
        $client_secret = $general->reloadly_secret;
        $mode = $general->reloadly;
        $audience = ($mode == "live") ? "https://giftcards.reloadly.com" : "https://giftcards-sandbox.reloadly.com";

        curl_setopt_array($curl, [
            CURLOPT_URL => $audience . '/countries',
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_ENCODING => "",
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => 30,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST => "GET",
            CURLOPT_HTTPHEADER => [
                "Accept: application/com.reloadly.giftcards-v1+json",
                "Authorization: Bearer $accessToken"
            ],
        ]);

        $response = curl_exec($curl);
        $getCountries = json_decode($response, true); // Decode the JSON response into an associative array
        curl_close($curl);

        return $getCountries;
    }


    public function getGiftCardCountries(Request $request)
    {
        $email = $request->header('email');
        $token = $request->header('token');

        $user = User::where('token', $token)
            ->where('email', $email)
            ->where('status', 1)
            ->first();

        if (!$user) {
            return response()->json([
                'code' => 400,
                'result' => 'failure',
                'message' => 'Invalid token / email'
            ], 400);
        }

        try {
            $accessToken = $this->getAccessToken();
            $countriesResponse = $this->get_gift_card_Countries($accessToken);

            if (empty($countriesResponse) || isset($countriesResponse["errorCode"])) {
                return response()->json([
                    'status' => 'error',
                    'code' => 400,
                    'message' => $countriesResponse["message"] ?? 'Something went wrong while processing the request.',
                    'data' => [
                        'error_code' => $countriesResponse["errorCode"] ?? null,
                        'error_message' => $countriesResponse["message"] ?? null,
                        'error' => $countriesResponse["errorCode"] ?? null
                    ]
                ], 400);
            }

            return response()->json([
                'code' => 200,
                'result' => 'success',
                'data' => $countriesResponse
            ]);
        } catch (\Exception $e) {
            return response()->json([
                'status' => 'error',
                'code' => 500,
                'message' => $e->getMessage()
            ], 500);
        }
    }


   public function getGiftCardProduct($accessToken,$page)
    {
        
        $curl = curl_init();
        $general = GeneralSetting::first();
        $client_id = $general->reloadly_id;
        $client_secret = $general->reloadly_secret;
        $mode = $general->reloadly;
        $audience = ($mode == "live") ? "https://giftcards.reloadly.com" : "https://giftcards-sandbox.reloadly.com";
        $url = $audience . '/products?page=' . urlencode($page);
        curl_setopt_array($curl, [
            CURLOPT_URL => $url,
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_ENCODING => "",
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => 30,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST => "GET",
            CURLOPT_HTTPHEADER => [
                "Accept: application/com.reloadly.giftcards-v1+json",
                "Authorization: Bearer $accessToken"
            ],
        ]);

        $response = curl_exec($curl);
        $giftCardProducts = json_decode($response, true); // Decode the JSON response into an associative array
        curl_close($curl);

        return $giftCardProducts;
    }
    public function getGiftCardProductByISO($accessToken, $countryCode)
    {
        $curl = curl_init();
        $general = GeneralSetting::first();
        $client_id = $general->reloadly_id;
        $client_secret = $general->reloadly_secret;
        $mode = $general->reloadly;
        $audience = ($mode == "live") ? "https://giftcards.reloadly.com" : "https://giftcards-sandbox.reloadly.com";

        curl_setopt_array($curl, [
            CURLOPT_URL =>$audience . '/countries/' . $countryCode. '/products',
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_ENCODING => "",
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => 30,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST => "GET",
            CURLOPT_HTTPHEADER => [
                "Accept: application/com.reloadly.giftcards-v1+json",
                "Authorization: Bearer $accessToken"
            ],
        ]);
        
        $response = curl_exec($curl);
        $giftCardProducts = json_decode($response, true); // Decode the JSON response into an associative array
        curl_close($curl);

        return $giftCardProducts;
    }

    function getExchangeRate($amount, $currenyCode)
    {
        $accessToken = $this->getAccessToken();
        $general = GeneralSetting::first();
        $client_id = $general->reloadly_id;
        $client_secret = $general->reloadly_secret;
        $mode = $general->reloadly;
        $audience = ($mode == "live") ? "https://giftcards.reloadly.com" : "https://giftcards-sandbox.reloadly.com";

        $curl = curl_init();
        $url = $audience . '/fx-rate?currencyCode=' . urlencode($currenyCode) . '&amount=' . urlencode($amount);

        curl_setopt_array($curl, [
            CURLOPT_URL => $url,
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_ENCODING => "",
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => 30,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST => "GET",
            CURLOPT_HTTPHEADER => [
                "Accept: application/com.reloadly.giftcards-v1+json",
                "Authorization: Bearer $accessToken"
            ],
        ]);

        $response = curl_exec($curl);
        $getcurrency = json_decode($response, true);
        curl_close($curl);
        return $getcurrency;
    }
    public function get_Gift_Card_Product_By_Id($accessToken, $productId)
    {

        // $accessToken = $this->getAccessToken();
        $curl = curl_init();
        $general = GeneralSetting::first();
        $client_id = $general->reloadly_id;
        $client_secret = $general->reloadly_secret;
        $mode = $general->reloadly;
        $audience = ($mode == "live") ? "https://giftcards.reloadly.com" : "https://giftcards-sandbox.reloadly.com";
        curl_setopt_array($curl, [
            CURLOPT_URL => $audience . '/products/' . $productId,
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_ENCODING => "",
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => 30,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST => "GET",
            CURLOPT_HTTPHEADER => [
                "Accept: application/com.reloadly.giftcards-v1+json",
                "Authorization: Bearer $accessToken"
            ],
        ]);

        $response = curl_exec($curl);
        $giftCardProductsById = json_decode($response, true); // Decode the JSON response into an associative array
        curl_close($curl);

        return  $giftCardProductsById;
    }


    public function showGiftCardProducts(Request $request)
    {

        $email = $request->header('email');
        $token = $request->header('token');

        $user = User::where('token', $token)->where('email', $email)->where('status', 1)->first();
        if (!$user) {
            $data = array(
                'code' => 400,
                'result' => 'failure',
                'message' => 'Invalid token / email',
            );
            echo json_encode($data);
            exit;
        }
        // Retrieve request data
        $request_data = $request->json()->all();

        // Validate request parameters
        if (
            empty($request_data['page']) ||
            !is_numeric($request_data['page']) ||
            intval($request_data['page']) <= 0
         
        ) {
            return response()->json([
                'status' => 'error',
                'code' => 400,
                'message' => 'Bad Request: Invalid or missing parameters',
                'data' => [],
            ], 400);
        }
        try {

            $page = $request_data['page'];
            $accessToken = $this->getAccessToken();
            $fetch_gift_card_Products_api_response = $this->getGiftCardProduct($accessToken, $page);

            if (empty($fetch_gift_card_Products_api_response) || isset($fetch_gift_card_Products_api_response["errorCode"])) {
                return response()->json([
                    'status' => 'error',
                    'code' => 400,
                    'message' =>  $fetch_gift_card_Products_api_response["message"] ?? 'Something went wrong while processing the request.',
                    'data' => [
                        'error_code' => $fetch_gift_card_Products_api_response["errorCode"] ?? null,
                        'error_message' => $fetch_gift_card_Products_api_response["message"] ?? null,
                        'error' =>  $fetch_gift_card_Products_api_response["errorCode"] ?? null
                    ]
                ], 400);
            }

            return response()->json([
                'code' => 200,
                'result' => 'success',
                'data' =>  $fetch_gift_card_Products_api_response
            ]);
        } catch (\Exception $e) {
            return response()->json([
                'status' => 'error',
                'code' => 500,
                'message' => $e->getMessage()
            ], 500);
        }
    }
   public function showGiftCardProductsByISO(Request $request)
    {

        $email = $request->header('email');
        $token = $request->header('token');

        $user = User::where('token', $token)->where('email', $email)->where('status', 1)->first();
        if (!$user) {
            $data = array(
                'code' => 400,
                'result' => 'failure',
                'message' => 'Invalid token / email',
            );
            echo json_encode($data);
            exit;
        }
        // Retrieve request data
        $request_data = $request->json()->all();

        // Validate request parameters
        if (
            empty($request_data['countryCode'])
            ) {
            return response()->json([
                'status' => 'error',
                'code' => 400,
                'message' => 'Bad Request: Invalid or missing parameters',
                'data' => [],
            ], 400);
        }
        try {


            $countryCode = $request_data['countryCode'];
          
            $accessToken = $this->getAccessToken();
            $fetch_gift_card_Products_by_iso_api_response = $this->getGiftCardProductByISO($accessToken, $countryCode);
          

           
            if (empty($fetch_gift_card_Products_by_iso_api_response) || isset($fetch_gift_card_Products_by_iso_api_response["errorCode"])) {
                return response()->json([
                    'status' => 'error',
                    'code' => 400,
                    'message' =>  $fetch_gift_card_Products_by_iso_api_response["message"] ?? 'Something went wrong while processing the request.',
                    'data' => [
                        'error_code' => $fetch_gift_card_Products_by_iso_api_response["errorCode"] ?? null,
                        'error_message' => $fetch_gift_card_Products_by_iso_api_response["message"] ?? null,
                        'error' =>  $fetch_gift_card_Products_by_iso_api_response["errorCode"] ?? null
                    ]
                ], 400);
            }

            return response()->json([
                'code' => 200,
                'result' => 'success',
                'data' =>  $fetch_gift_card_Products_by_iso_api_response
            ]);
        } catch (\Exception $e) {
            return response()->json([
                'status' => 'error',
                'code' => 500,
                'message' => $e->getMessage()
            ], 500);
        }
    }
    public function getGiftCardProductById(Request $request, $productId)
    {
        $email = $request->header('email');
        $token = $request->header('token');

        $user = User::where('token', $token)->where('email', $email)->where('status', 1)->first();
        if (!$user) {
            $data = [
                'code' => 400,
                'result' => 'failure',
                'message' => 'Invalid token / email',
            ];
            return response()->json($data, 400);
        }

        try {
            $accessToken = $this->getAccessToken();
            $fetch_gift_card_Products_by_id_api_response = $this->get_Gift_Card_Product_By_Id($accessToken, $productId);

            if (empty($fetch_gift_card_Products_by_id_api_response) || isset($fetch_gift_card_Products_by_id_api_response["errorCode"])) {
                return response()->json([
                    'status' => 'error',
                    'code' => 400,
                    'message' => $fetch_gift_card_Products_by_id_api_response["message"] ?? 'Something went wrong while processing the request.',
                    'data' => [
                        'error_code' => $fetch_gift_card_Products_by_id_api_response["errorCode"] ?? null,
                        'error_message' => $fetch_gift_card_Products_by_id_api_response["message"] ?? null,
                        'error' => $fetch_gift_card_Products_by_id_api_response["errorCode"] ?? null
                    ]
                ], 400);
            }

            return response()->json([
                'code' => 200,
                'result' => 'success',
                'data' => $fetch_gift_card_Products_by_id_api_response
            ]);
        } catch (\Exception $e) {
            return response()->json([
                'status' => 'error',
                'code' => 500,
                'message' => $e->getMessage()
            ], 500);
        }
    }

    public function processGiftCardOrder(Request $request)
    {
        // Retrieve user information from headers
        $email = $request->header('email');
        $token = $request->header('token');

        // Check if user exists and is valid
        $user = User::where('token', $token)->where('email', $email)->where('status', 1)->first();
        if (!$user) {
            return response()->json([
                'status' => 'error',
                'code' => 400,
                'message' => 'Invalid token / email',
            ], 400);
        }

        // Retrieve request data
        $request_data = $request->json()->all();

        // Validate request parameters
        if (
            empty($request_data['product_id']) ||
            empty($request_data['amount']) ||
            empty($request_data['quantity']) ||
            empty($request_data['currency_code']) ||
             !is_numeric($request_data['amount']) ||
            !is_numeric($request_data['quantity']) ||
            intval($request_data['amount']) <= 0 ||
            intval($request_data['quantity']) <= 0
        ) {
            return response()->json([
                'status' => 'error',
                'code' => 400,
                'message' => 'Bad Request: Invalid or missing parameters',
                'data' => [],
            ], 200);
        }

        // Retrieve general settings
        $general = GeneralSetting::first();
 $productId = $request_data['product_id'];
        // Check if the currency code is USD
        $currenyCode = $request_data['currency_code'];
        $amount = (float)$request_data['amount'];
 
        // Call the getExchangeRate method with the amount and currency code
        $exchangeRate = $this->getExchangeRate($amount, $currenyCode);
        // print_r($exchangeRate);
      //   exit;
      
        if(!isset($exchangeRate['senderAmount'])){
            return response()->json([
                'status' => 'error',
                'code' => 400,
                'message' => 'Error Processing Request, check API',
                'data' => [],
            ], 200);
        }
        $senderAmount = $exchangeRate['senderAmount'];
        $senderCurrency = $exchangeRate['senderCurrency'];
        $recipientCurrency = $exchangeRate['recipientCurrency'];
        $total_price = $exchangeRate['senderAmount'] * $request_data['quantity'];
        //Calculate the total cost
        $totalCost = ($exchangeRate['senderAmount'] * $request_data['quantity']) + ($general->reloadly_fee * $request_data['quantity']);


        // Check if user has sufficient balance
        if ($totalCost > $user->balance) {
            return response()->json([
                'status' => 'error',
                'code' => 400,
                'message' => 'Insufficient Balance to process this order',
                'data' => [],
            ], 200);
        }

        // Generate transaction ID
        $trx = getTrx();

        // Deduct total cost from user's balance
        $user->balance -= $totalCost;
        $user->save();

        // Prepare request parameters for gift card order
        $request_parameters = [
            "productId" => $request_data['product_id'],
            
            "quantity" => $request_data['quantity'],
            "unitPrice" => $amount,
            "customIdentifier" => $trx,
            "senderName" => $user->username,
            "recipientEmail" => $user->email,
            "recipientPhoneDetails" => [
                "countryCode" => $user->country_code,
                "phoneNumber" => $user->mobile
            ]
        ];

        // Get access token
        $accessToken = $this->getAccessToken();

        // Place gift card order
        $giftcard_api_response = $this->giftCardOrder($accessToken, $request_parameters);
$giftcard_id_api_response = $this->get_Gift_Card_Product_By_Id($accessToken,  $productId);

        // Handle empty API response
        if (empty($giftcard_id_api_response) || isset($giftcard_id_api_response['message']) || array_key_exists("errorCode", $giftcard_id_api_response)) {
            return response()->json([
                'status' => 'error',
                'code' => 400,
                'message' => $giftcard_id_api_response["message"] ?? 'Failed to process the gift card order. Please try again.',
                'data' => [],
            ], 200);
        } else {
            // Check if 'logoUrls' is an array
            if (is_array($giftcard_id_api_response['logoUrls'])) {

                // For example, you could select the first URL in the array
                $logoUrls = $giftcard_id_api_response['logoUrls'][0];
            } else {
                // 'logoUrls' is not an array, so assign it directly
                $logoUrls = $giftcard_id_api_response['logoUrls'];
            }
        }


        // Handle empty API response
        // Handle empty API response
        if (empty($giftcard_api_response) || isset($giftcard_api_response['message']) || array_key_exists("errorCode", $giftcard_api_response)) {
            // Roll back the transaction and return an error response
            $user->balance += $totalCost;
            $user->save();
            $itransaction = new Transaction();
            $itransaction->user_id = $user->id;
            $itransaction->amount = $totalCost; // You can set the amount to the total cost
            $itransaction->charge = 0;
            $itransaction->trx_type = '+';
            $itransaction->trx = getTrx();
            $itransaction->details = 'Reversal For GiftCard Purchase';
            $itransaction->post_balance = $user->balance;
            $itransaction->save();

            return response()->json([
                'status' => 'error',
                'code' => 400,
                'message' => 'Failed to process the gift card order. Please try again.',
                'data' => [],
            ], 200);
        }
        
        
        
        $result_set = array(
            "status" => 'success',
            "code" => 200,
            "message" => 'Gift card purchased successfully!',
            "data" => array(
                "response" => $giftcard_api_response,
            )
        );

        if ($result_set['status'] === 'success') {
            // Gift card purchased successfully
         
            
            $itransaction = new Transaction();
            $itransaction->user_id = $user->id;
            $itransaction->amount = $totalCost;
            $itransaction->charge = 0;
            $itransaction->trx_type = '-';
            $itransaction->trx = getTrx();
            $itransaction->details = 'Gift card purchased successfully! ';
            $itransaction->post_balance = $user->balance;
            $itransaction->save();

            $transactionData = [
                'user_id' => $user->id,
                'transaction_id' => isset($giftcard_api_response['transactionId']) ? $giftcard_api_response['transactionId'] : 0,
                'amount' =>  $totalCost,
                'discount' => $giftcard_api_response['discount'],
                'currency_code' => $senderCurrency,
                'fee' => $giftcard_api_response['fee'],
                'total_fee' => $giftcard_api_response['totalFee'],
                'recipient_email' => $giftcard_api_response['recipientEmail'],
                'custom_identifier' => $giftcard_api_response['customIdentifier'],
                'status' => $giftcard_api_response['status'],
                'logo_urls' => $logoUrls,
                'product_id' => $giftcard_api_response['product']['productId'],
                'product_name' => $giftcard_api_response['product']['productName'],
                'country_code' => $giftcard_api_response['product']['countryCode'],
                'product_currency_code' => $recipientCurrency,
                'quantity' => $giftcard_api_response['product']['quantity'],
                'unit_price' => $senderAmount,
                'total_price' => $total_price,
                'brand_id' => $giftcard_api_response['product']['brand']['brandId'],
                'brand_name' => $giftcard_api_response['product']['brand']['brandName'],
                'sms_fee' => $giftcard_api_response['smsFee'],
                'recipient_phone' => $giftcard_api_response['recipientPhone'],
                'transaction_created_time' => $giftcard_api_response['transactionCreatedTime'],
                'pre_ordered' => $giftcard_api_response['preOrdered'],
            ];

            // Store transaction data in the database
            GiftCardTransactions::create($transactionData);

            return response()->json([
                'status' => 'success',
                'code' => 200,
                'message' => 'Gift card purchased successfully!',
                'data' => ['response' => $giftcard_api_response],
            ], 200);
        } else {
            // Gift card purchase failed
            $user->balance += $totalCost;
            $user->save();
            $itransaction = new Transaction();
            $itransaction->user_id = $user->id;
            $itransaction->amount = $totalCost;
            $itransaction->charge = 0;
            $itransaction->trx_type = '+';
            $itransaction->trx = getTrx();
            $itransaction->details = 'Reversal For GiftCard Purchase ';
            $itransaction->post_balance = $user->balance;
            $itransaction->save();
            return response()->json([
                'status' => 'error',
                'code' => 400,
                'message' => $giftcard_api_response["message"] ?? 'Failed to purchase gift card. Please try again.',
                'data' => [],
            ], 200);
        }
    }
public function getGiftCardPurchasedHistory(Request $request)
    {
        // Retrieve user information from headers
        $email = $request->header('email');
        $token = $request->header('token');

        // Check if user exists and is valid
        $user = User::where('token', $token)->where('email', $email)->where('status', 1)->first();
        if (!$user) {
            return response()->json([
                'status' => 'error',
                'code' => 400,
                'message' => 'Invalid token / email',
            ], 400);
        }
        //Fetch purchase history of the user's gift cards
        $purchaseHistory = GiftCardTransactions::where('user_id', $user->id)->get();

        // Check if purchase history is empty
        if ($purchaseHistory->isEmpty()) {
            return response()->json([
                'status' => 'success',
                'code' => 200,
                'message' => 'No purchase history available for the user.',
            ], 200);
        }

        // Return the purchase history as JSON response
        return response()->json([
            'status' => 'success',
            'code' => 200,
 'message' => 'Purchase History retrieved successfully',
            'purchase_history' => $purchaseHistory,
        ], 200);
    }
   public function getPurchasedCardDetails(Request $request)
    {
        // Retrieve user information from headers
        $email = $request->header('email');
        $token = $request->header('token');

        // Check if user exists and is valid
        $user = User::where('token', $token)->where('email', $email)->where('status', 1)->first();
        if (!$user) {
            return response()->json([
                'status' => 'error',
                'code' => 400,
                'message' => 'Invalid token / email',
            ], 400);
        }

        // Retrieve input data in JSON format from the request
        $requestData = $request->json()->all();
        
        $transactionId = $request->transaction ?? null;
    
        // Fetch purchase details of the user's gift cards
        $purchaseCardDetails = GiftCardTransactions::where('transaction_id', $transactionId)->first();
        
       

        
        $result = [];
        
            $brandId = $purchaseCardDetails->brand_id;
            $transactionId = $purchaseCardDetails->transaction_id;

            // Call the first API to get redeem instructions by brand ID
            $redeemInstructions = $this->getRedeemInstructionByBrandId($brandId);
            if (empty($redeemInstructions) || isset($redeemInstructions['message']) || array_key_exists("errorCode", $redeemInstructions)) {
                return response()->json([
                    'status' => 'error',
                    'code' => 400,
                    'message' => $redeemInstructions["message"] ?? 'Failed to fetch redeem instructions',
                ], 400);
            }

            // Call the second API to get redeem codes by transaction ID
            $redeemCodes = $this->getGiftCardRedeemCode($transactionId);
            if (empty($redeemCodes) || isset($redeemCodes['message']) || array_key_exists("errorCode", $redeemCodes)) {
                return response()->json([
                    'status' => 'error',
                    'code' => 400,
                    'message' => $redeemCodes["message"] ?? 'Failed to fetch redeem codes',
                ], 400);
            }

            // Add the details to the result array
            $result[] = [
                'brand_id' => $brandId,
                'transaction_id' => $transactionId,
                'redeem_instructions' => $redeemInstructions,
                'redeem_codes' => $redeemCodes
            ];
      
        return response()->json([
            'status' => 'success',
            'code' => 200,
            'message' => 'Purchase details retrieved successfully',
            'data' => $result
        ], 200);
    }

    public function getRedeemInstructionByBrandId($brandId)
    {

        $accessToken = $this->getAccessToken();
        $curl = curl_init();
        $general = GeneralSetting::first();
        $mode = $general->reloadly;
        $audience = ($mode == "live") ? "https://giftcards.reloadly.com" : "https://giftcards-sandbox.reloadly.com";
        curl_setopt_array($curl, [
            CURLOPT_URL => $audience . '/brands/' . $brandId . '/redeem-instructions',
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_ENCODING => "",
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => 30,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST => "GET",
            CURLOPT_HTTPHEADER => [
                "Accept: application/com.reloadly.giftcards-v1+json",
                "Authorization: Bearer $accessToken"
            ],
        ]);

        $response = curl_exec($curl);
        $err = curl_error($curl);

        curl_close($curl);

        if ($err) {
            return "cURL Error #:" . $err;
        } else {
            //Decode the JSON string
            $decodedResponse = json_decode($response, true);

            return $decodedResponse;
        }
    }


    public function getGiftCardRedeemCode($transactionId)
    {

        $accessToken = $this->getAccessToken();
        $curl = curl_init();
        $general = GeneralSetting::first();
        $mode = $general->reloadly;
        $audience = ($mode == "live") ? "https://giftcards.reloadly.com" : "https://giftcards-sandbox.reloadly.com";
        curl_setopt_array($curl, [
            CURLOPT_URL => $audience . '/orders/transactions/' . $transactionId . '/cards',
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_ENCODING => "",
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => 30,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST => "GET",
            CURLOPT_HTTPHEADER => [
                "Accept: application/com.reloadly.giftcards-v1+json",
                "Authorization: Bearer $accessToken"
            ],
        ]);

        $response = curl_exec($curl);
        $err = curl_error($curl);

        curl_close($curl);

        if ($err) {
            return "cURL Error #:" . $err;
        } else {
            //Decode the JSON string
            $decodedResponse = json_decode($response, true);
            return $decodedResponse;
        }
    }

    public function giftCardOrder($accessToken, $request_parameters)
    {
        $curl = curl_init();
        $general = GeneralSetting::first();

        // Convert request parameters array to JSON
        $data = json_encode($request_parameters);

        $mode = $general->reloadly;
        $audience = ($mode == "live") ? "https://giftcards.reloadly.com" : "https://giftcards-sandbox.reloadly.com";
        curl_setopt_array($curl, [
            CURLOPT_URL => $audience . '/orders',
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_ENCODING => "",
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => 30,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST => "POST",
            CURLOPT_POSTFIELDS => $data, // Set JSON-encoded request body
            CURLOPT_HTTPHEADER => [
                "Accept: application/com.reloadly.giftcards-v1+json",
                "Authorization: Bearer $accessToken",
                "Content-Type: application/json"
            ],
        ]);

        $response = curl_exec($curl);
        $err = curl_error($curl);

        if ($err) {
            // Handle cURL error
            // You may want to log the error instead of echoing it
            echo "cURL Error #:" . $err;
            return null; // Return null to indicate an error
        }

        // Decode the JSON response
        $decoded_response = json_decode($response, true);

        // Check if decoding was successful
        if ($decoded_response === null) {
            // Handle JSON decoding error
            echo "Error decoding JSON response";
            return null; // Return null to indicate an error
        }

        // Check if the API response indicates an error
        if (isset($decoded_response['status']) && $decoded_response['status'] === 'error') {
            // Handle API error
            echo "API Error: " . $decoded_response['message'];
            return null; // Return null to indicate an error
        }

        // Return the decoded response if everything is successful
        return $decoded_response;
    }
//giftcardapiended

 public function getVirtualCardDetails(Request $request)
    {
        $email = $request->header('email');
        $token = $request->header('token');

        $user = User::where('token', $token)
            ->where('email', $email)
            ->where('status', 1)
            ->first();

        if (!$user) {
            return response()->json([
                'code' => 400,
                'result' => 'failure',
                'message' => 'Invalid token / email'
            ], 400);
        }
        // Instantiate the Flutterwave library
        $flutterwave = new Flutterwave();

        // Call the getCard function to retrieve card details
        $all_virtual_card_details = $flutterwave->getAllVirtualcard();

        // Check if the response is empty
        if (empty($all_virtual_card_details)) {
            // Return a JSON response indicating that no virtual card details were found
            return response()->json([
                'status' => 'error',
                'message' => 'No  card details found',
            ], 404); // Return a 404 Not Found status code
        } else {
            // Return a JSON response with the virtual card details
            return response()->json([
                'status' => 'success',
                'data' => $all_virtual_card_details,
            ]);
        }
    }

    public function getVirtualCardById(Request $request, $card_id)
    {
        $email = $request->header('email');
        $token = $request->header('token');

        $user = User::where('token', $token)
            ->where('email', $email)
            ->where('status', 1)
            ->first();

        if (!$user) {
            return response()->json([
                'code' => 400,
                'result' => 'failure',
                'message' => 'Invalid token / email'
            ], 400);
        }
        // Instantiate the Flutterwave library
        $flutterwave = new Flutterwave();

        // Call the getCard function to retrieve card details
        $get_virtual_card_details_by_id = $flutterwave->getCard($card_id);

        // Check if card details were retrieved successfully
        if (empty($get_virtual_card_details_by_id)) {
            // Return a JSON response indicating that no virtual card details were found
            return response()->json([
                'status' => 'error',
                'message' => 'No  card details found',
            ], 404); // Return a 404 Not Found status code
        } else {
            // Return a JSON response with the virtual card details
            return response()->json([
                'status' => 'success',
                'data' => $get_virtual_card_details_by_id,
            ]);
        }
    }
 public function getCardDetails(Request $request)
    {
        $email = $request->header('email');
        $token = $request->header('token');

        $user = User::where('token', $token)
            ->where('email', $email)
            ->where('status', 1)
            ->first();

        if (!$user) {
            return response()->json([
                'code' => 400,
                'result' => 'failure',
                'message' => 'Invalid token / email'
            ], 400);
        }

        // Check if the user already has a virtual card
        $existingCard = Fluttercard::where('user_id', $user->id)->first();

        if (!$existingCard) {
            // No existing card found for the user, return an error
            return response()->json([
                'code' => 400,
                'result' => 'failure',
                'message' => 'User does not have any card'
            ], 400);
        }
        // Initialize Flutterwave instance
        $flutterwave = new Flutterwave();

        // Call the getCard function to retrieve card details
        $all_virtual_card_details = $flutterwave->getAllVirtualcard();
        $cardDetails = $all_virtual_card_details->data;
        
        // Iterate over the array of card details
        foreach ($cardDetails as $cardDetail) {
            // Now $cardDetail is an object containing the details of each card
            // Fetch the id from the card detail object
            $card_id = $cardDetail->id;
            $card_pan = $cardDetail->card_pan;
            // Check if the id matches the id of the existing card
            if ($card_id === $existingCard->card_id || $card_pan == $existingCard->card_pan) {
                $carddesign = getContent('carddesign.content', true);
                // Match found, fetch the amount from the matched card detail
                $amount = $cardDetail->amount;
                $account_id = $cardDetail->account_id;

                return response()->json([
                    'code' => 200,
                    'result' => 'success',
                    'message' => 'Card  details fetched successfully',
                    'card_details' => [
                        'id' => $existingCard->id,
                        'user_id' => $existingCard->user_id,
                        'status' => $existingCard->status,
                        'card_id' => $existingCard->card_id,
                        'account_id' =>  $account_id,
                        'card_pan' => $existingCard->card_pan,
                        'card_type' => $existingCard->card_type,
                        'name_on_card' => $existingCard->name_on_card,
                        'masked_pan' => $existingCard->masked_pan,
                        'currency' => $existingCard->currency,
                        'amount' => $amount,
                        'cvv' => $existingCard->cvv,
                        'expiration' => $existingCard->expiration,
                        'is_active' => $existingCard->is_active,
                        "card_image" => getImage('assets/images/frontend/carddesign/' .$carddesign->data_values->mastercarddesign, '527x350'),
                        'created_at' => $existingCard->created_at,
                        'updated_at' => $existingCard->updated_at
                    ]
                ], 200);
            }
        }

        // If matching card not found in Flutterwave's response
        return response()->json([
            'code' => 400,
            'result' => 'failure',
            'message' => 'Failed to retrieve card balance from Flutterwave'
        ], 400);
    }
    
    public function createVirtualCard(Request $request)
    {
        $email = $request->header('email');
        $token = $request->header('token');

        $user = User::where('token', $token)
            ->where('email', $email)
            ->where('status', 1)
            ->first();

        if (!$user) {
            return response()->json([
                'code' => 400,
                'result' => 'failure',
                'message' => 'Invalid token / email'
            ], 400);
        }

        // Check if the user already has a virtual card
        $existingCard = Fluttercard::where('user_id', $user->id)->first();

        if ($existingCard) {
            // User already has a card, fetch card details and return
            return response()->json([
                'code' => 200,
                'result' => 'success',
                'message' => 'User already has a  card',
                'card_details' => $existingCard
            ], 200);
        }
        // Validate the request data
        $validator = Validator::make($request->all(), [
            'currency' => 'required|string', // Adjust validation rules as needed
            'amount' => 'required|numeric',
            'first_name' => 'required|string',
            'last_name' => 'required|string',
            'date_of_birth' => 'required|date',
            'email' => 'required|email',
            'phone' => 'required|string',
            'title' => 'required|string',
            'gender' => 'required|string',
        ]);

        // Check if validation fails
        if ($validator->fails()) {
            return response()->json([
                'error' => 'Validation failed',
                'messages' => $validator->errors()->all()
            ], 422); // Return HTTP status code 422 for unprocessable entity
        }
        // Get the validated request data
        $general = GeneralSetting::first();
        $validatedData = $validator->validated();

        // Convert USD amount to cents
        if ($validatedData['currency'] == 'USD') {
            $usd_amount_float = floatval($validatedData['amount']);
            $usd_to_cents = $usd_amount_float * 100;
            $validatedData['amount'] = $usd_to_cents;
            $issueFee = $general->flutter_issue * 100; // Assuming flutter_issue is the issue fee
        }
        // Calculate total amount (amount + fee)
        $Totalamount = $validatedData['amount'] + $issueFee;

        if ($Totalamount > $user->balance * 100) {
            return response()->json([
                'code' => 400,
                'result' => 'failure',
                'message' => 'Insufficient balance'
            ], 400);
        }

        $trx = getTrx();

        $user->balance -= $issueFee / 100; // Convert amount back to USD before deduction
        $user->save();
        $transaction = new Transaction();
        $transaction->user_id = $user->id;
        $transaction->amount = $issueFee / 100; // Convert amount back to USD for recording in 
        $transaction->post_balance = $user->balance;
        $transaction->charge = 00;
        $transaction->trx_type = '-';
        $transaction->details = 'Card Issuance Fees';
        $transaction->trx =  $trx;
        $transaction->save();

        $ntrx = getTrx();

        $user->balance -= $validatedData['amount'] / 100; // Convert amount back to USD before deduction
        $user->save();

        $transaction = new Transaction();
        $transaction->user_id = $user->id;
        $transaction->amount = $validatedData['amount'] / 100; // Convert amount back to USD for recording in the transaction
        $transaction->post_balance = $user->balance;
        $transaction->charge = 00;
        $transaction->trx_type = '-';
        $transaction->details = 'Initial  Card Loading';
        $transaction->trx =  $ntrx;
        $transaction->save();
        // Assuming $payment_request is included in the request data
        $payment_request = $validatedData;


        // Call the fluttercard function from your library
        $flutterwave = new Flutterwave();
        $virtualcard_api_response = $flutterwave->fluttercard($payment_request);
        // Handle errors if the API response contains an error message or status code
        if (empty($virtualcard_api_response)) {
            return response()->json([
                 'status' => 'error',
                'code' => 400,
                'message' => 'Something went wrong while processing Request'
            ], 400); // Return the appropriate HTTP status code
        } elseif ($virtualcard_api_response->status == "error") {
            // If there's an error in the API response, return the error message to the UI
            $trx = getTrx();

            $user->balance += $issueFee / 100; // Convert amount back to USD before add
            $user->save();
            $transaction = new Transaction();
            $transaction->user_id = $user->id;
            $transaction->amount = $issueFee / 100;
            $transaction->post_balance = $user->balance;
            $transaction->charge = 00;
            $transaction->trx_type = '+';
            $transaction->details = 'Reversal of Card Issuance Fees';
            $transaction->trx =  $trx;
            $transaction->save();

            $ntrx = getTrx();

            $user->balance += $validatedData['amount'] / 100; // Convert amount back to USD before add
            $user->save();

            $transaction = new Transaction();
            $transaction->user_id = $user->id;
            $transaction->amount = $validatedData['amount'] / 100; // Convert amount back to USD for recording 
            $transaction->post_balance = $user->balance;
            $transaction->charge = 00;
            $transaction->trx_type = '+';
            $transaction->details = 'Reversal of Initial  Card Loading';
            $transaction->trx =  $ntrx;
            $transaction->save();
            $adminNotification = new AdminNotification();
            $adminNotification->user_id = $user->id;
            $adminNotification->title = json_encode($virtualcard_api_response);
            $adminNotification->click_url = urlPath('admin.users.detail', $user->id);
            $adminNotification->save();

            return response()->json([
               'status' => 'error',
                'code' => 400,
                'message' => $virtualcard_api_response->message
            ], 400); // Return the appropriate HTTP status code
        } else {
            if ($virtualcard_api_response->status == "success") {

                $update = new Fluttercard;
                $update->user_id = $user->id;
                $update->status = $virtualcard_api_response->status;
                $update->card_id = $virtualcard_api_response->data->id;
                $update->account_id = $virtualcard_api_response->data->account_id;
                $update->card_pan = $virtualcard_api_response->data->card_pan;
                $update->card_type = $virtualcard_api_response->data->card_type;
                $update->name_on_card = $virtualcard_api_response->data->name_on_card;
                $update->masked_pan = $virtualcard_api_response->data->masked_pan;
                $update->currency = $virtualcard_api_response->data->currency;
                $update->is_active = $virtualcard_api_response->data->is_active;
                $update->cvv = $virtualcard_api_response->data->cvv;
                $update->expiration = $virtualcard_api_response->data->expiration;
                $update->save();
                return response()->json([
                    'code' => 200,
                    'result' => 'success',
                    'message' => 'Card created successfully'
                ], 200);
            } else {
                $trx = getTrx();

                $user->balance += $issueFee / 100; // Convert amount back to USD before add
                $user->save();
                $transaction = new Transaction();
                $transaction->user_id = $user->id;
                $transaction->amount = $issueFee / 100;
                $transaction->post_balance = $user->balance;
                $transaction->charge = 00;
                $transaction->trx_type = '+';
                $transaction->details = 'Reversal of Card Issuance Fees';
                $transaction->trx =  $trx;
                $transaction->save();

                $ntrx = getTrx();

                $user->balance += $validatedData['amount'] / 100; // Convert amount back to USD before add
                $user->save();

                $transaction = new Transaction();
                $transaction->user_id = $user->id;
                $transaction->amount = $validatedData['amount'] / 100; // Convert amount back to USD for recording 
                $transaction->post_balance = $user->balance;
                $transaction->charge = 00;
                $transaction->trx_type = '+';
                $transaction->details = 'Reversal of Initial  Card Loading';
                $transaction->trx =  $ntrx;
                $transaction->save();
                $adminNotification = new AdminNotification();
                $adminNotification->user_id = $user->id;
                $adminNotification->title = json_encode($virtualcard_api_response);
                $adminNotification->click_url = urlPath('admin.users.detail', $user->id);
                $adminNotification->save();


                return response()->json([
                    'code' => 400,
                    'result' => 'error',
                    'message' => 'Sorry! There was an error issuing your card contact support'
                ], 400);
            }
        }
    }

    public function loadfund(Request $request)
    {

        $email = $request->header('email');
        $token = $request->header('token');

        $user = User::where('token', $token)
            ->where('email', $email)
            ->where('status', 1)
            ->first();

        if (!$user) {
            return response()->json([
                'code' => 400,
                'result' => 'failure',
                'message' => 'Invalid token / email'
            ], 400);
        }
// Check if the user already has a virtual card
        $existingCard = Fluttercard::where('user_id', $user->id)->first();
        if (!$existingCard) {
            // User does not have a card
            return response()->json([
                'code' => 400,
                'status' => 'error',
                'message' => 'User does not have a card'
            ], 400);
        }
        $general = GeneralSetting::first();
        $validator = Validator::make($request->all(), [
            'card_id' => 'required|string',
            'currency' => 'required|string', // Adjust validation rules as needed
            'amount' => 'required|numeric',

        ]);

        // Check if validation fails
        if ($validator->fails()) {
            return response()->json([
                'error' => 'Validation failed',
                'messages' => $validator->errors()->all()
            ], 422); // Return HTTP status code 422 for unprocessable entity
        }
        $validatedData = $validator->validated();

        $card_id = $validatedData['card_id'];
        $currency = $validatedData['currency'];

 // Check if the user's card ID matches the input card ID
        $userCardId = $existingCard->card_id;
        if ($userCardId !== $card_id) {
            return response()->json([
                'code' => 400,
                'status' => 'error',
                'message' => 'User does not have this card Id! Please enter valid card Id'
            ], 400);
        }


        if ($request["currency"] == $general->cur_text && floatval($validatedData['amount']) < 5) {
            return response()->json([
                'code' => 400,
                'result' => 'error',
                'message' => 'Sorry! Minimum Load amount is 5'
            ], 400);
        }

        // Retrieve the Flutter Load fee percentage from general settings
        $flutter_load = $general->flutter_load; // Assuming flutter_load is the Flutter Load fee percentage


        // Calculate the fee
        $loadfee = round((floatval($flutter_load)/100)*floatval($validatedData['amount']),2);

        if ($currency == 'USD') {
            $usd_amount_float = floatval($validatedData['amount']);
            $usd_to_cents = $usd_amount_float * 100;
            $amount = $usd_to_cents;
            $fee =  $loadfee * 100;
        }else{
            return response()->json([
                'code' => 400,
                'result' => 'error',
                'message' => 'Sorry! This operation only supports transactions in USD currency'
            ], 400);
        }
        $Totalamount =  $amount + $fee;
        if ($Totalamount > $user->balance * 100) {
            return response()->json([
                'code' => 400,
                'result' => 'error',
                'message' => 'Sorry! insufficient balance in this wallet'
            ], 400);
        }

        $trx = getTrx();

        $user->balance -=  $Totalamount / 100;
        $user->save();
        $transaction = new Transaction();
        $transaction->user_id = $user->id;
        $transaction->amount =  $Totalamount / 100;
        $transaction->post_balance = $user->balance;
        $transaction->charge = 00;
        $transaction->trx_type = '-';
        $transaction->details = 'Funds Loaded to  Card';
        $transaction->trx =  $trx;
        $transaction->save();


        $newcards = new Flutterwave;
        $newcard = $newcards->loadfunds($amount, $currency, $card_id);
        if (empty($newcard)) {
            // Handle the case where loadfunds function fails
            return response()->json([
                'code' => 400,
                'result' => 'error',
                'message' => 'Failed to load funds to the card'
            ], 400);
        } elseif ($newcard->status == "error") {
            $trx = getTrx();

            $user->balance +=  $Totalamount / 100;
            $user->save();
            $transaction = new Transaction();
            $transaction->user_id = $user->id;
            $transaction->amount =  $Totalamount / 100;
            $transaction->post_balance = $user->balance;
            $transaction->charge = 00;
            $transaction->trx_type = '+';
            $transaction->details = 'Reversal of  Card load fund';
            $transaction->trx =  $trx;
            $transaction->save();
             $responseData = [
                'status' => 'error',
                'code' => 400,
                'message' => $newcard->message
            ];
            
            // If the request was not successful, change the status code to 200 OK
            if (!$responseData["status"] === 'error') {
                http_response_code(200);
            }
            
            // Convert the response data to JSON and send it
            return response()->json($responseData);  
        } else {
            // Handle the case where loadfunds function succeeds
            if ($newcard->status == "success") {
                return response()->json([
                    'code' => 200,
                    'result' => 'success',
                    'message' => 'Card Loaded Successfully'
                ], 200);
            } else {
                $trx = getTrx();

                $user->balance += $Totalamount / 100;
                $user->save();
                $transaction = new Transaction();
                $transaction->user_id = $user->id;
                $transaction->amount = $Totalamount / 100;
                $transaction->post_balance = $user->balance;
                $transaction->charge = 00;
                $transaction->trx_type = '+';
                $transaction->details = 'Reversal of Card load fund';
                $transaction->trx =  $trx;
                $transaction->save();
                return response()->json([
                    'code' => 400,
                    'result' => 'error',
                    'message' => 'Sorry! your funds could not be loaded'
                ], 400);
            }
        }
    }
    public function blockVirtualCard(Request $request)
    {
        $email = $request->header('email');
        $token = $request->header('token');

        $user = User::where('token', $token)->where('email', $email)->where('status', 1)->first();
        if (!$user) {
            $data = array(
                'result' => 'failure',
                'message' => 'Invalid token / email',
            );
            echo json_encode($data);
            exit;
        }
        $validator = Validator::make($request->all(), [
            'card_id' => 'required|string',
           

        ]);

        // Check if validation fails
        if ($validator->fails()) {
            return response()->json([
                'error' => 'Validation failed',
                'messages' => $validator->errors()->all()
            ], 422); // Return HTTP status code 422 for unprocessable entity
        }
        $validatedData = $validator->validated();

        $card_id = $validatedData['card_id'];
        // Check if the user already has a virtual card
        $existingCard = Fluttercard::where('user_id', $user->id)->first();
        if (!$existingCard) {
            // User does not have a card
            return response()->json([
                'code' => 400,
                'status' => 'error',
                'message' => 'User does not have a card'
            ], 400);
        }
        $newcards = new Flutterwave;
        $newcard = $newcards->blockcard($card_id);

        // Check if the user's card ID matches the input card ID
        $userCardId = $existingCard->card_id;
        if ($userCardId !==   $card_id) {
            return response()->json([
                'code' => 400,
                'status' => 'error',
                'message' => 'User does not have this card Id! Please enter valid card Id'
            ], 400);
        }
        if (empty($newcard)) {
            // Handle the case where loadfunds function fails
            return response()->json([
                'code' => 400,
                'status' => 'error',
                'message' => 'Something Went Wrong',
            ], 400);
            exit;
        } else {
            // Handle the case where loadfunds function succeeds
            if ($newcard->status == "success") {
                Fluttercard::where('user_id', $user->id)
                    ->where('card_id', $request->card_id)
                    ->update(['is_active' => false]);
                return response()->json([
                    'code' => 200,
                    'status' => 'success',
                    'message' => 'Card blocked Successfully',
                ], 200);
                exit;
            } else {
                return response()->json([
                    'code' => 400,
                    'status' => 'error',
                    'message' => 'Card has been blocked previously',
                ], 400);
                exit;
            }
        }
    }

    public function unblockVirtualCard(Request $request)
    {
        $email = $request->header('email');
        $token = $request->header('token');

        $user = User::where('token', $token)->where('email', $email)->where('status', 1)->first();
        if (!$user) {
            $data = array(
                'result' => 'failure',
                'message' => 'Invalid token / email',
            );
            echo json_encode($data);
            exit;
        }
        $validator = Validator::make($request->all(), [
            'card_id' => 'required|string',
           

        ]);

        // Check if validation fails
        if ($validator->fails()) {
            return response()->json([
                'error' => 'Validation failed',
                'messages' => $validator->errors()->all()
            ], 422); // Return HTTP status code 422 for unprocessable entity
        }
        $validatedData = $validator->validated();

        $card_id = $validatedData['card_id'];
        // Check if the user already has a virtual card
        $existingCard = Fluttercard::where('user_id', $user->id)->first();
        if (!$existingCard) {
            // User does not have a card
            return response()->json([
                'code' => 400,
                'status' => 'error',
                'message' => 'User does not have a card'
            ], 400);
        }
        $newcards = new Flutterwave;
        $newcard = $newcards->unblockcard( $card_id);
         // Check if the user's card ID matches the input card ID
         $userCardId = $existingCard->card_id;
         if ($userCardId !==  $card_id) {
             return response()->json([
                 'code' => 400,
                 'status' => 'error',
                 'message' => 'User does not have this card Id! Please enter valid card Id'
             ], 400);
         }
        if (empty($newcard)) {
            // Handle the case where loadfunds function fails
            return response()->json([
                'code' => 400,
                'status' => 'error',
                'message' => 'Something Went Wrong',
            ], 400);
            exit;
        } else {
            // Handle the case where loadfunds function succeeds
            if ($newcard->status == "success") {
                Fluttercard::where('user_id', $user->id)
                    ->where('card_id', $request->card_id)
                    ->update(['is_active' => true]);

                return response()->json([
                    'code' => 200,
                    'status' => 'success',
                    'message' => 'Card Unblocked Successfully',
                ], 200);
                exit;
            } else {

                return response()->json([
                    'code' => 400,
                    'status' => 'error',
                    'message' => 'Card is not Blocked',
                ], 400);
                exit;
            }
        }
    }

public function getCardStatus(Request $request)
    {
        $email = $request->header('email');
        $token = $request->header('token');

        $user = User::where('token', $token)
            ->where('email', $email)
            ->where('status', 1)
            ->first();

        if (!$user) {
            return response()->json([
                'code' => 400,
                'result' => 'failure',
                'message' => 'Invalid token / email'
            ], 400);
        }

        // Check if the user already has a virtual card
        $existingCard = Fluttercard::where('user_id', $user->id)->first();
        // User has a card
        $generalSetting = GeneralSetting::first();
        // Assuming $generalSetting->flutter_load represents a percentage (e.g., 10 for 10%)
        $loadFeePercentage = floatval($generalSetting->flutter_load);
        if ($existingCard) {

            return response()->json([
                'code' => 200,
                'result' => 'success',
                'status' => 'true',
                'message' => 'User has a card',
                'load_fee' =>  $loadFeePercentage . '%', // Separate field to indicate it's a percentage
                'issuance_fee' => floatval($generalSetting->flutter_issue),
                'minimum_amount' => 5

            ], 200);
        } else {
            // User does not have a card
            $responseData = [
                "code" => 400,
                'status' => 'false',
                "result" => "failure",
                "message" => "User does not have any card",
                "load_fee" => "1%",
                "issuance_fee" => 5,
                "minimum_amount" => 5
            ];
            
            // If the request was not successful, change the status code to 200 OK
            if (!$responseData["status"] === 'false') {
                http_response_code(200);
            }
            
            // Convert the response data to JSON and send it
            return response()->json($responseData);
        }
    }
public function getTransaction(Request $request)
    {

        $email = $request->header('email');
        $token = $request->header('token');

        $user = User::where('token', $token)
            ->where('email', $email)
            ->where('status', 1)
            ->first();

        if (!$user) {
            return response()->json([
                'code' => 400,
                'result' => 'failure',
                'message' => 'Invalid token / email'
            ], 400);
        }
        // Validate request parameters (card_id, from, to)
        $validator = Validator::make($request->all(), [
            'card_id' => 'required',
           
        ]);

        // Check if validation fails
        if ($validator->fails()) {
            return response()->json([
                'code' => 422,
                'status' => 'error',
                'message' => 'Validation failed',
                'errors' => $validator->errors()->all()
            ], 422);
        }

        // Extract request parameters
        $card_id = $request->input('card_id');
        // Calculate the date range for the last three months
        $from = date('Y-m-d', strtotime('-3 months'));
        $to = date('Y-m-d');
        // Check if the user already has a virtual card
        $existingCard = Fluttercard::where('user_id', $user->id)->first();
        if (!$existingCard) {
            // User does not have a card
            return response()->json([
                'code' => 400,
                'status' => 'error',
                'message' => 'User does not have a card'
            ], 400);
        }

        // Check if the user's card ID matches the input card ID
        $userCardId = $existingCard->card_id; 
        if ($userCardId !== $card_id) {
            return response()->json([
                'code' => 400,
                'status' => 'error',
                'message' => 'User does not have this card Id! Please enter valid card Id' 
            ], 400);
        }

        $transaction = new Flutterwave;
        $getTransactions = $transaction->gettransaction($card_id, $from, $to);

        //Check if transaction retrieval was successful
        if (!$getTransactions || !isset($getTransactions) || empty($getTransactions)) {
            return response()->json([
                'code' => 400,
                'status' => 'error',
                'message' => 'Failed to fetch transactions'
            ], 400);
        }
        // Decode the JSON string
        $decodedTransactions = json_decode($getTransactions, true);

        // Return response with transaction details
        return response()->json([
            'code' => 200,
            'status' => 'success',
            'message' => 'Card transactions fetched successfully',
            'data' => $decodedTransactions['data']
        ], 200);
    }
}

    

